import 'package:flutter/material.dart';

class SMapArgentinaColors {
  /// Buenos Aires
  final Color? arB;

  /// Catamarca
  final Color? arK;

  /// Chaco
  final Color? arH;

  /// Chubut
  final Color? arU;

  /// Ciudad de Buenos Aires
  final Color? arC;

  /// Córdoba
  final Color? arX;

  /// Corrientes
  final Color? arW;

  /// Entre Ríos
  final Color? arE;

  /// Formosa
  final Color? arP;

  /// Jujuy
  final Color? arY;

  /// La Pampa
  final Color? arL;

  /// La Rioja
  final Color? arF;

  /// Mendoza
  final Color? arM;

  /// Misiones
  final Color? arN;

  /// Neuquén
  final Color? arQ;

  /// Río Negro
  final Color? arR;

  /// Salta
  final Color? arA;

  /// Santa Cruz
  final Color? arZ;

  /// Santiago del Estero
  final Color? arG;

  /// Santa Fe
  final Color? arS;

  /// San Juan
  final Color? arJ;

  /// San Luis
  final Color? arD;

  /// Tierra del Fuego
  final Color? arV;

  /// Tucumán
  final Color? arT;
  SMapArgentinaColors({
    this.arB,
    this.arK,
    this.arH,
    this.arU,
    this.arC,
    this.arX,
    this.arW,
    this.arE,
    this.arP,
    this.arY,
    this.arL,
    this.arF,
    this.arM,
    this.arN,
    this.arQ,
    this.arR,
    this.arA,
    this.arZ,
    this.arG,
    this.arS,
    this.arJ,
    this.arD,
    this.arV,
    this.arT,
  });
  Map<String, Color?> toMap() {
    return {
      "AR-B": arB,
      "AR-K": arK,
      "AR-H": arH,
      "AR-U": arU,
      "AR-C": arC,
      "AR-X": arX,
      "AR-W": arW,
      "AR-E": arE,
      "AR-P": arP,
      "AR-Y": arY,
      "AR-L": arL,
      "AR-F": arF,
      "AR-M": arM,
      "AR-N": arN,
      "AR-Q": arQ,
      "AR-R": arR,
      "AR-A": arA,
      "AR-Z": arZ,
      "AR-G": arG,
      "AR-S": arS,
      "AR-J": arJ,
      "AR-D": arD,
      "AR-V": arV,
      "AR-T": arT,
    };
  }

  static SMapArgentinaColors fromMap(Map<String, Color?> map) {
    return SMapArgentinaColors(
      arB: map["AR-B"],
      arK: map["AR-K"],
      arH: map["AR-H"],
      arU: map["AR-U"],
      arC: map["AR-C"],
      arX: map["AR-X"],
      arW: map["AR-W"],
      arE: map["AR-E"],
      arP: map["AR-P"],
      arY: map["AR-Y"],
      arL: map["AR-L"],
      arF: map["AR-F"],
      arM: map["AR-M"],
      arN: map["AR-N"],
      arQ: map["AR-Q"],
      arR: map["AR-R"],
      arA: map["AR-A"],
      arZ: map["AR-Z"],
      arG: map["AR-G"],
      arS: map["AR-S"],
      arJ: map["AR-J"],
      arD: map["AR-D"],
      arV: map["AR-V"],
      arT: map["AR-T"],
    );
  }
}

class SMapArgentina {
  static const String instructions =
      """{"n": "Argentina", "w": 361.54608, "h": 792.5788, "g": {"a": "-73.584888,-21.778101","b": "-53.646671,-55.053654"}, "i":[{"n": "Buenos Aires", "u": "AR-B", "i": ["m0.7571096,0.3300997", "l0.7555883,0.3304025", "l0.7539288,0.3320301", "l0.7539288,0.3332792", "l0.7573032,0.3342002", "l0.7624201,0.3330647", "l0.7632775,0.3326988", "l0.7632775,0.3326988", "l0.7643009,0.3333801", "l0.7690583,0.3350077", "l0.7724050,0.3358404", "l0.7741199,0.3360675", "l0.7767475,0.3364839", "l0.7800942,0.3370517", "l0.7878940,0.3387045", "l0.7908535,0.3394741", "l0.8058447,0.3441424", "l0.8139211,0.3471579", "l0.8150552,0.3477761", "l0.8212784,0.3517505", "l0.8239337,0.3539333", "l0.8245699,0.3546272", "l0.8242103,0.3559268", "l0.8236018,0.3564441", "l0.8217486,0.3578572", "l0.8190381,0.3592450", "l0.8151935,0.3620208", "l0.8129531,0.3637241", "l0.8119020,0.3646325", "l0.8115425,0.3651877", "l0.8113212,0.3660204", "l0.8113212,0.3681527", "l0.8114595,0.3688214", "l0.8118744,0.3697298", "l0.8124276,0.3704111", "l0.8151935,0.3734518", "l0.8186232,0.3757986", "l0.8197019,0.3763664", "l0.8234082,0.3779940", "l0.8254826,0.3788141", "l0.8280549,0.3796342", "l0.8340569,0.3811735", "l0.8355781,0.3810599", "l0.8371270,0.3806183", "l0.8422440,0.3793818", "l0.8434886,0.3796846", "l0.8458396,0.3823216", "l0.8460886,0.3829525", "l0.8472226,0.3872044", "l0.8477481,0.3954938", "l0.8476098,0.3962634", "l0.8468353,0.3969195", "l0.8455630,0.3977396", "l0.8438205,0.3987238", "l0.8396993,0.4014617", "l0.8334484,0.4062688", "l0.8294378,0.4096880", "l0.8290783,0.4102431", "l0.8265890,0.4120347", "l0.8247358,0.4131955", "l0.8214997,0.4151133", "l0.8201997,0.4157063", "l0.8170466,0.4170185", "l0.8142254,0.4183685", "l0.8101319,0.4207153", "l0.8065085,0.4228854", "l0.8056234,0.4237181", "l0.8049043,0.4244499", "l0.8044341,0.4252826", "l0.8041022,0.4259766", "l0.8036320,0.4274780", "l0.8043788,0.4285126", "l0.8040192,0.4302537", "l0.8030788,0.4310612", "l0.8017788,0.4317804", "l0.7993725,0.4327898", "l0.7984045,0.4331557", "l0.7969385,0.4336856", "l0.7888344,0.4362721", "l0.7725433,0.4403979", "l0.7711603,0.4407385", "l0.7655456,0.4418488", "l0.7477055,0.4444605", "l0.7422014,0.4451923", "l0.7289251,0.4478419", "l0.7272932,0.4480438", "l0.7255507,0.4481826", "l0.7219550,0.4483971", "l0.7171700,0.4488513", "l0.7057745,0.4500751", "l0.6968406,0.4511476", "l0.6909769,0.4521191", "l0.6860536,0.4522705", "l0.6849749,0.4523336", "l0.6570117,0.4547813", "l0.6452843,0.4555257", "l0.6391440,0.4560808", "l0.6373461,0.4561818", "l0.6255911,0.4567495", "l0.6221890,0.4568379", "l0.6147211,0.4566234", "l0.6122594,0.4563584", "l0.6107105,0.4562953", "l0.6090787,0.4563963", "l0.6075574,0.4565729", "l0.6049575,0.4571280", "l0.6032149,0.4572542", "l0.5985129,0.4570271", "l0.5893025,0.4564593", "l0.5813090,0.4555383", "l0.5790410,0.4552103", "l0.5757496,0.4544154", "l0.5749751,0.4535700", "l0.5745602,0.4529013", "l0.5697752,0.4515008", "l0.5625839,0.4507312", "l0.5609244,0.4510971", "l0.5604265,0.4516144", "l0.5610903,0.4527499", "l0.5618371,0.4533808", "l0.5639392,0.4546425", "l0.5662349,0.4555762", "l0.5644094,0.4579482", "l0.5633307,0.4591720", "l0.5626945,0.4617837", "l0.5638009,0.4644964", "l0.5659306,0.4648244", "l0.5677561,0.4649632", "l0.5689731,0.4649885", "l0.5719326,0.4652787", "l0.5766070,0.4664773", "l0.5790133,0.4676128", "l0.5790133,0.4682563", "l0.5774091,0.4689628", "l0.5734539,0.4677642", "l0.5720156,0.4670955", "l0.5706603,0.4659474", "l0.5672583,0.4661492", "l0.5664838,0.4668053", "l0.5729007,0.4696063", "l0.5768006,0.4718143", "l0.5755560,0.4757508", "l0.5748921,0.4780093", "l0.5747262,0.4787789", "l0.5743666,0.4815294", "l0.5715731,0.4822360", "l0.5670923,0.4817817", "l0.5647413,0.4831696", "l0.5631094,0.4867907", "l0.5630818,0.4894277", "l0.5633030,0.4900838", "l0.5626115,0.4916861", "l0.5617541,0.4925946", "l0.5608414,0.4929983", "l0.5590712,0.4933011", "l0.5564436,0.4946385", "l0.5557521,0.4953829", "l0.5580755,0.4988021", "l0.5591265,0.5000260", "l0.5653774,0.5029910", "l0.5668710,0.5030162", "l0.5678391,0.5043158", "l0.5670646,0.5052368", "l0.5647966,0.5051990", "l0.5633860,0.5044924", "l0.5633030,0.5064228", "l0.5638839,0.5066373", "l0.5672306,0.5056406", "l0.5704667,0.5051359", "l0.5702454,0.5057794", "l0.5689455,0.5061326", "l0.5662625,0.5097285", "l0.5641881,0.5122519", "l0.5607307,0.5133496", "l0.5504969,0.5158478", "l0.5438864,0.5177151", "l0.5425588,0.5177656", "l0.5416184,0.5177277", "l0.5416184,0.5177277", "l0.5409269,0.5170842", "l0.5394610,0.5158604", "l0.5381610,0.5149393", "l0.5348419,0.5127692", "l0.5338462,0.5122014", "l0.5299739,0.5105108", "l0.5256868,0.5091481", "l0.5241656,0.5087570", "l0.5215933,0.5084037", "l0.5202656,0.5083154", "l0.5177763,0.5082523", "l0.5120509,0.5078107", "l0.5110275,0.5075836", "l0.5106956,0.5059308", "l0.5107786,0.4771765", "l0.5107509,0.4685212", "l0.5106956,0.4664268", "l0.5106956,0.4664268", "l0.5107786,0.4659852", "l0.5108063,0.4604085", "l0.5106403,0.3728210", "l0.5108616,0.3451518", "l0.5109169,0.3429186", "l0.5109169,0.3429186", "l0.5110275,0.3321689", "l0.5110275,0.3256711", "l0.5121062,0.3257089", "l0.5163104,0.3257216", "l0.5257974,0.3257342", "l0.5363355,0.3257216", "l0.5374972,0.3257342", "l0.5374972,0.3257342", "l0.5647690,0.3257089", "l0.5858451,0.3256459", "l0.5947790,0.3255954", "l0.6140573,0.3157667", "l0.6340271,0.3053450", "l0.6335292,0.3044240", "l0.6337228,0.3038310", "l0.6344419,0.3033894", "l0.6354653,0.3031244", "l0.6366823,0.3029604", "l0.6380653,0.3029099", "l0.6468332,0.3036543", "l0.6479119,0.3039319", "l0.6492948,0.3044618", "l0.6500693,0.3048530", "l0.6512033,0.3052946", "l0.6521990,0.3054460", "l0.6533607,0.3054712", "l0.6565138,0.3050170", "l0.6586712,0.3031623", "l0.6591691,0.3025819", "l0.6595840,0.3015473", "l0.6596946,0.3006893", "l0.6630413,0.2985066", "l0.6663604,0.2965636", "l0.6669689,0.2955542", "l0.6657796,0.2949360", "l0.6657796,0.2949360", "l0.6673562,0.2952893", "l0.6684072,0.2955921", "l0.6693199,0.2959453", "l0.6728879,0.2976991", "l0.6738007,0.2982164", "l0.6751007,0.2988473", "l0.6768432,0.2994907", "l0.6778112,0.2998188", "l0.6824026,0.3012066", "l0.6863579,0.3019763", "l0.6878791,0.3024431", "l0.6903961,0.3035660", "l0.6910046,0.3041086", "l0.6926088,0.3048025", "l0.6942960,0.3052062", "l0.7004916,0.3065563", "l0.7030086,0.3059002", "l0.7045575,0.3057235", "l0.7056915,0.3059633", "l0.7071574,0.3067960", "l0.7079319,0.3073638", "l0.7086787,0.3077801", "l0.7100063,0.3081460", "l0.7189402,0.3097484", "l0.7256890,0.3105811", "l0.7291187,0.3106442", "l0.7305846,0.3109849", "l0.7334888,0.3117797", "l0.7439992,0.3150602", "l0.7479268,0.3165868", "l0.7508586,0.3167635", "l0.7523522,0.3164733", "l0.7536245,0.3160191", "l0.7547309,0.3157919", "l0.7583542,0.3155144", "l0.7583542,0.3155396", "l0.7583542,0.3155396", "l0.7595436,0.3158046", "l0.7609265,0.3161578", "l0.7615074,0.3166373", "l0.7618946,0.3203593", "l0.7601797,0.3216967", "l0.7590734,0.3224537", "l0.7569989,0.3230089", "l0.7558096,0.3242454", "l0.7560862,0.3261884", "l0.7569436,0.3287118", "l0.7571096,0.3300997", "c", "m0.5855962,0.4640170", "l0.5850706,0.4639539", "l0.5771878,0.4617585", "l0.5754177,0.4601435", "l0.5753070,0.4597272", "l0.5756113,0.4594370", "l0.5762751,0.4594496", "l0.5823601,0.4602697", "l0.5830239,0.4603959", "l0.5857345,0.4610015", "l0.5863983,0.4617080", "l0.5872557,0.4632852", "l0.5870621,0.4637898", "l0.5862876,0.4639917", "l0.5855962,0.4640170", "c"]}, {"n": "Catamarca", "u": "AR-K", "i": ["m0.4214954,0.1536125", "l0.4217443,0.1538396", "l0.4233209,0.1566910", "l0.4252017,0.1609682", "l0.4259761,0.1628734", "l0.4260868,0.1634538", "l0.4263357,0.1654977", "l0.4263634,0.1665576", "l0.4263080,0.1672010", "l0.4259761,0.1684375", "l0.4250081,0.1692829", "l0.4233209,0.1701030", "l0.4209145,0.1714530", "l0.4209145,0.1721469", "l0.4209975,0.1728156", "l0.4225188,0.1730680", "l0.4237358,0.1733582", "l0.4249527,0.1739764", "l0.4254506,0.1749731", "l0.4262251,0.1798181", "l0.4264187,0.1831616", "l0.4273038,0.1875397", "l0.4276357,0.1885238", "l0.4280782,0.1893061", "l0.4302909,0.1917790", "l0.4347440,0.1956651", "l0.4355738,0.1961824", "l0.4358504,0.1963338", "l0.4358504,0.1963338", "l0.4327526,0.1966618", "l0.4316462,0.1968006", "l0.4336100,0.2042951", "l0.4328909,0.2047620", "l0.4235698,0.2094934", "l0.4235698,0.2094934", "l0.4205273,0.2076387", "l0.4177338,0.2061625", "l0.4043468,0.1989960", "l0.3959938,0.1944286", "l0.3922045,0.1919683", "l0.3922045,0.1902145", "l0.3917620,0.1894954", "l0.3899918,0.1880570", "l0.3893280,0.1876406", "l0.3738666,0.1810924", "l0.3715709,0.1803480", "l0.3700773,0.1799569", "l0.3687220,0.1796793", "l0.3673944,0.1794900", "l0.3659285,0.1791872", "l0.3631072,0.1785564", "l0.3619456,0.1781526", "l0.3607839,0.1771811", "l0.3601477,0.1742035", "l0.3549755,0.1687908", "l0.3543947,0.1683618", "l0.3536755,0.1679833", "l0.3526521,0.1675417", "l0.3512415,0.1671380", "l0.3323504,0.1634790", "l0.3313271,0.1633528", "l0.3287271,0.1631384", "l0.3273442,0.1633781", "l0.3264867,0.1639711", "l0.3254634,0.1645136", "l0.3244676,0.1648417", "l0.3224485,0.1650561", "l0.3208996,0.1650309", "l0.3115509,0.1645515", "l0.3097807,0.1635547", "l0.3048021,0.1620659", "l0.3033362,0.1620911", "l0.3010128,0.1634916", "l0.2992703,0.1648921", "l0.2979150,0.1655987", "l0.2963384,0.1658258", "l0.2950661,0.1657753", "l0.2901152,0.1652075", "l0.2876259,0.1647029", "l0.2864089,0.1640215", "l0.2852748,0.1633024", "l0.2839195,0.1622930", "l0.2833940,0.1614603", "l0.2829791,0.1600850", "l0.2787750,0.1592902", "l0.2727453,0.1588990", "l0.2687624,0.1581672", "l0.2612945,0.1562621", "l0.2590265,0.1562747", "l0.2573669,0.1556564", "l0.2572563,0.1517704", "l0.2581690,0.1503068", "l0.2580861,0.1495876", "l0.2572839,0.1492218", "l0.2547117,0.1491334", "l0.2469948,0.1494867", "l0.2420715,0.1498400", "l0.2404673,0.1502185", "l0.2375631,0.1505844", "l0.2359035,0.1506853", "l0.2308419,0.1503699", "l0.2290441,0.1502816", "l0.2273016,0.1502059", "l0.2235400,0.1501302", "l0.2235400,0.1501302", "l0.2238995,0.1490704", "l0.2258910,0.1464460", "l0.2273016,0.1457016", "l0.2344100,0.1396076", "l0.2360972,0.1374248", "l0.2356823,0.1364407", "l0.2362354,0.1356584", "l0.2372035,0.1348005", "l0.2392226,0.1333369", "l0.2404673,0.1330089", "l0.2426523,0.1329458", "l0.2448374,0.1331098", "l0.2472990,0.1338416", "l0.2590541,0.1319995", "l0.2600222,0.1317976", "l0.2619307,0.1313308", "l0.2634796,0.1309018", "l0.2652497,0.1280882", "l0.2648348,0.1275457", "l0.2578095,0.1225746", "l0.2525543,0.1197231", "l0.2511990,0.1187390", "l0.2507011,0.1182217", "l0.2504245,0.1177170", "l0.2503415,0.1164931", "l0.2503415,0.1159758", "l0.2505628,0.1145880", "l0.2507564,0.1137805", "l0.2513926,0.1126071", "l0.2523606,0.1120519", "l0.2536330,0.1115725", "l0.2556244,0.1109290", "l0.2586392,0.1096547", "l0.2596350,0.1089355", "l0.2568967,0.1025135", "l0.2549606,0.0984129", "l0.2545734,0.0977947", "l0.2519458,0.0952460", "l0.2497607,0.0922432", "l0.2496224,0.0916376", "l0.2497330,0.0908679", "l0.2499543,0.0903633", "l0.2509777,0.0884202", "l0.2516138,0.0876380", "l0.2526372,0.0866034", "l0.2528862,0.0865024", "l0.2538819,0.0847108", "l0.2547670,0.0840169", "l0.2553202,0.0838024", "l0.2553202,0.0838024", "l0.2560116,0.0839033", "l0.2606307,0.0843197", "l0.2893407,0.0868431", "l0.3067659,0.0867674", "l0.3238038,0.0866791", "l0.3401226,0.0865781", "l0.3511862,0.0864772", "l0.3526245,0.0870576", "l0.3563308,0.0918394", "l0.3550585,0.0951073", "l0.3541457,0.0956246", "l0.3520990,0.0963059", "l0.3508266,0.0965582", "l0.3465948,0.0966718", "l0.3426672,0.0967222", "l0.3396248,0.0978704", "l0.3390716,0.0983625", "l0.3389056,0.0993087", "l0.3389609,0.1000279", "l0.3392929,0.1008102", "l0.3399290,0.1017943", "l0.3404269,0.1022359", "l0.3410354,0.1026396", "l0.3417268,0.1030055", "l0.3468438,0.1060336", "l0.3488352,0.1073584", "l0.3510756,0.1092888", "l0.3523479,0.1106767", "l0.3533713,0.1116987", "l0.3542840,0.1123169", "l0.3580180,0.1141085", "l0.3589307,0.1144997", "l0.3600094,0.1147520", "l0.3610328,0.1146889", "l0.3617796,0.1143104", "l0.3624987,0.1135155", "l0.3630243,0.1127964", "l0.3641583,0.1115977", "l0.3650434,0.1109921", "l0.3663987,0.1107019", "l0.3722071,0.1107272", "l0.3722071,0.1107272", "l0.3718198,0.1119258", "l0.3695518,0.1142599", "l0.3689433,0.1150043", "l0.3691092,0.1188147", "l0.3703262,0.1191553", "l0.3729815,0.1192815", "l0.3755538,0.1194455", "l0.3767431,0.1195969", "l0.3787069,0.1200259", "l0.3864791,0.1227260", "l0.3870876,0.1231171", "l0.3873642,0.1237227", "l0.3864238,0.1279494", "l0.3858706,0.1286686", "l0.3851515,0.1292616", "l0.3836855,0.1302079", "l0.3821919,0.1307883", "l0.3791218,0.1322392", "l0.3781261,0.1328070", "l0.3727326,0.1361379", "l0.3704092,0.1386361", "l0.3728432,0.1390777", "l0.3749729,0.1392038", "l0.3779878,0.1401375", "l0.3805877,0.1412856", "l0.3819154,0.1443390", "l0.3834919,0.1471778", "l0.3881386,0.1507863", "l0.3896046,0.1508998", "l0.3915960,0.1504330", "l0.3949151,0.1513540", "l0.3954683,0.1521741", "l0.3956342,0.1528681", "l0.3958831,0.1534863", "l0.3967129,0.1545840", "l0.3974874,0.1551896", "l0.4016362,0.1572336", "l0.4028532,0.1565901", "l0.4036277,0.1557952", "l0.4046787,0.1551265", "l0.4076935,0.1538774", "l0.4094637,0.1532971", "l0.4128381,0.1523129", "l0.4138615,0.1524770", "l0.4154657,0.1531709", "l0.4169870,0.1536882", "l0.4179550,0.1539027", "l0.4191167,0.1540162", "l0.4202784,0.1539027", "c"]}, {"n": "Chaco", "u": "AR-H", "i": ["m0.7377206,0.1559214", "l0.6976981,0.1559593", "l0.6744645,0.1559593", "l0.6607733,0.1559971", "l0.6212210,0.1559971", "l0.6065340,0.1559845", "l0.5947790,0.1559466", "l0.5947790,0.1559466", "l0.5948343,0.1546345", "l0.5948066,0.1413361", "l0.5948619,0.1254891", "l0.5947790,0.1103739", "l0.5945577,0.0968736", "l0.5945024,0.0963690", "l0.5925939,0.0963563", "l0.5839643,0.0963942", "l0.5715454,0.0964194", "l0.5428630,0.0964194", "l0.5301399,0.0963942", "l0.5253549,0.0963690", "l0.5101978,0.0963059", "l0.5101978,0.0963059", "l0.5241932,0.0880670", "l0.5255485,0.0872973", "l0.5479246,0.0740747", "l0.5635243,0.0645740", "l0.5634137,0.0613567", "l0.5632477,0.0576851", "l0.5632477,0.0576851", "l0.5707156,0.0591992", "l0.5807282,0.0613314", "l0.5852919,0.0627319", "l0.5894408,0.0631861", "l0.5952492,0.0649778", "l0.5976555,0.0668703", "l0.6027447,0.0679932", "l0.6076957,0.0702012", "l0.6091893,0.0704409", "l0.6136700,0.0708321", "l0.6156892,0.0708321", "l0.6172934,0.0708952", "l0.6186210,0.0710213", "l0.6201146,0.0714503", "l0.6230188,0.0732798", "l0.6252038,0.0756644", "l0.6280527,0.0770901", "l0.6331143,0.0788313", "l0.6399461,0.0814682", "l0.6469438,0.0832472", "l0.6551309,0.0848875", "l0.6606903,0.0883950", "l0.6654200,0.0908932", "l0.6685731,0.0921423", "l0.6689604,0.0930128", "l0.6689880,0.0937699", "l0.6692923,0.0944386", "l0.6713944,0.0964825", "l0.6791389,0.0980975", "l0.6862749,0.0999648", "l0.6872153,0.1003307", "l0.6903684,0.1021728", "l0.6955683,0.1052514", "l0.6972279,0.1082164", "l0.6981959,0.1084561", "l0.7025660,0.1088977", "l0.7045298,0.1088977", "l0.7080978,0.1090996", "l0.7092319,0.1094024", "l0.7098957,0.1099575", "l0.7100340,0.1110047", "l0.7110574,0.1127333", "l0.7129658,0.1134903", "l0.7166998,0.1137300", "l0.7178615,0.1136165", "l0.7199359,0.1132253", "l0.7263251,0.1138814", "l0.7317739,0.1148025", "l0.7329909,0.1152188", "l0.7340973,0.1157487", "l0.7351207,0.1163291", "l0.7357568,0.1168843", "l0.7370568,0.1175908", "l0.7442205,0.1200890", "l0.7472077,0.1210858", "l0.7535416,0.1239877", "l0.7573585,0.1259812", "l0.7615903,0.1271041", "l0.7627244,0.1272555", "l0.7629733,0.1273817", "l0.7629733,0.1273817", "l0.7608989,0.1279620", "l0.7570543,0.1299808", "l0.7516608,0.1334378", "l0.7503055,0.1335009", "l0.7491991,0.1336523", "l0.7479821,0.1343589", "l0.7478991,0.1352421", "l0.7498353,0.1361126", "l0.7506374,0.1366678", "l0.7503608,0.1384090", "l0.7503608,0.1384090", "l0.7475949,0.1392543", "l0.7466268,0.1394940", "l0.7444418,0.1398599", "l0.7433907,0.1401501", "l0.7421184,0.1406296", "l0.7379696,0.1424338", "l0.7376930,0.1430773", "l0.7381355,0.1438721", "l0.7387163,0.1448563", "l0.7396568,0.1484269", "l0.7396844,0.1490704", "l0.7393248,0.1515938", "l0.7391589,0.1523508", "l0.7378313,0.1542686", "c"]}, {"n": "Chubut", "u": "AR-U", "i": ["m0.0970554,0.6733968", "l0.0973873,0.6733211", "l0.0990745,0.6726650", "l0.0978575,0.6702551", "l0.0968065,0.6695990", "l0.0945661,0.6691196", "l0.0930725,0.6688925", "l0.0916066,0.6684761", "l0.0896705,0.6645522", "l0.0901960,0.6621424", "l0.0917725,0.6590007", "l0.0936533,0.6583573", "l0.0956725,0.6579914", "l0.0968065,0.6578778", "l0.0978299,0.6577895", "l0.0989915,0.6578273", "l0.1059616,0.6563638", "l0.1143976,0.6507744", "l0.1128763,0.6483772", "l0.1044127,0.6433556", "l0.1018681,0.6408953", "l0.1001809,0.6401256", "l0.0922427,0.6389018", "l0.0889513,0.6386873", "l0.0825621,0.6384097", "l0.0759239,0.6377536", "l0.0751771,0.6340694", "l0.0754814,0.6334134", "l0.0768920,0.6330096", "l0.0783026,0.6331736", "l0.0795749,0.6335017", "l0.0805706,0.6337162", "l0.0817047,0.6339433", "l0.0872365,0.6342461", "l0.0886194,0.6340064", "l0.0895322,0.6333124", "l0.0907215,0.6330601", "l0.0935704,0.6333377", "l0.0946214,0.6335395", "l0.0956171,0.6337540", "l0.0966129,0.6339307", "l0.0978575,0.6338423", "l0.0988809,0.6336657", "l0.1015362,0.6330222", "l0.1033893,0.6326816", "l0.1047446,0.6326816", "l0.1057403,0.6327951", "l0.1071786,0.6332493", "l0.1095296,0.6340694", "l0.1108572,0.6343723", "l0.1123508,0.6345994", "l0.1140657,0.6345994", "l0.1154486,0.6344227", "l0.1180486,0.6327825", "l0.1183252,0.6318236", "l0.1179656,0.6309152", "l0.1177443,0.6301077", "l0.1198464,0.6278240", "l0.1221144,0.6276474", "l0.1232761,0.6270796", "l0.1239123,0.6260072", "l0.1212570,0.6233323", "l0.1195698,0.6226510", "l0.1092807,0.6217047", "l0.1052978,0.6217678", "l0.1020340,0.6220076", "l0.0979958,0.6220076", "l0.0903619,0.6219445", "l0.0879003,0.6217047", "l0.0866280,0.6208089", "l0.0871535,0.6201655", "l0.0894215,0.6194084", "l0.0895875,0.6158252", "l0.0892832,0.6150177", "l0.0883705,0.6141345", "l0.0903343,0.6116490", "l0.0919661,0.6108541", "l0.0965299,0.6076115", "l0.0969724,0.6070311", "l0.0968618,0.6063372", "l0.0943725,0.6047727", "l0.0914959,0.6032839", "l0.0888960,0.6015049", "l0.0889237,0.6005964", "l0.0899747,0.6003189", "l0.0909704,0.6001422", "l0.0941512,0.5991707", "l0.0947874,0.5984515", "l0.0942065,0.5964202", "l0.0868492,0.5932407", "l0.0825068,0.5917645", "l0.0827834,0.5896827", "l0.0844982,0.5877397", "l0.0895322,0.5869826", "l0.0913576,0.5871845", "l0.0922981,0.5868817", "l0.0926300,0.5862887", "l0.0923257,0.5830840", "l0.0875130,0.5817340", "l0.0858812,0.5815447", "l0.0827280,0.5813933", "l0.0813174,0.5813681", "l0.0792983,0.5813807", "l0.0766154,0.5808508", "l0.0753431,0.5803587", "l0.0733516,0.5788068", "l0.0724112,0.5777722", "l0.0725772,0.5762203", "l0.0729368,0.5756147", "l0.0735729,0.5749208", "l0.0740431,0.5739114", "l0.0741538,0.5730787", "l0.0739048,0.5701515", "l0.0737112,0.5689150", "l0.0728538,0.5673001", "l0.0723006,0.5648902", "l0.0724942,0.5642215", "l0.0729644,0.5635528", "l0.0736836,0.5629219", "l0.0770303,0.5580392", "l0.0764218,0.5574461", "l0.0738218,0.5564116", "l0.0727431,0.5554653", "l0.0773622,0.5512764", "l0.0783856,0.5508096", "l0.0795749,0.5505194", "l0.0811791,0.5506708", "l0.0818706,0.5512007", "l0.0823961,0.5519956", "l0.0839174,0.5521091", "l0.0904449,0.5507086", "l0.0929619,0.5496236", "l0.0927129,0.5476049", "l0.0913023,0.5466964", "l0.0913023,0.5466964", "l0.1093637,0.5467090", "l0.1177167,0.5466838", "l0.1494415,0.5466838", "l0.1511011,0.5467090", "l0.1844855,0.5466838", "l0.2162103,0.5467090", "l0.2379226,0.5467090", "l0.2679880,0.5466838", "l0.2913875,0.5466964", "l0.3498033,0.5466838", "l0.3848749,0.5467090", "l0.4232932,0.5466838", "l0.4268336,0.5470119", "l0.4268336,0.5470119", "l0.4292676,0.5495353", "l0.4302633,0.5501409", "l0.4318122,0.5509105", "l0.4332504,0.5515161", "l0.4361270,0.5525129", "l0.4430970,0.5537115", "l0.4498182,0.5545947", "l0.4508692,0.5546073", "l0.4530543,0.5542540", "l0.4550181,0.5544054", "l0.4567882,0.5548597", "l0.4560138,0.5554274", "l0.4546585,0.5559700", "l0.4533032,0.5566260", "l0.4524181,0.5572821", "l0.4499565,0.5592252", "l0.4502331,0.5600579", "l0.4574244,0.5604112", "l0.4732730,0.5601210", "l0.4743794,0.5599696", "l0.4769240,0.5588971", "l0.4776984,0.5583167", "l0.4778091,0.5562475", "l0.4768963,0.5552634", "l0.4758730,0.5548975", "l0.4745177,0.5546830", "l0.4729411,0.5545947", "l0.4689029,0.5546578", "l0.4676029,0.5547335", "l0.4653902,0.5547461", "l0.4636200,0.5542667", "l0.4652242,0.5537620", "l0.4719730,0.5531564", "l0.4793856,0.5517811", "l0.4851664,0.5501283", "l0.4864663,0.5498507", "l0.4876557,0.5497245", "l0.4914173,0.5494596", "l0.4925513,0.5494596", "l0.4934641,0.5497750", "l0.4952619,0.5517559", "l0.4958427,0.5525760", "l0.4964789,0.5533708", "l0.4975023,0.5541910", "l0.4992725,0.5550868", "l0.4999086,0.5556545", "l0.5003788,0.5561971", "l0.5007660,0.5569036", "l0.5011256,0.5656346", "l0.4986640,0.5702777", "l0.4958704,0.5718674", "l0.4942385,0.5721576", "l0.4925237,0.5722712", "l0.4881535,0.5727128", "l0.4768687,0.5740376", "l0.4751262,0.5741259", "l0.4731900,0.5736338", "l0.4676306,0.5706057", "l0.4674923,0.5698109", "l0.4687922,0.5680066", "l0.4700922,0.5665809", "l0.4642009,0.5636537", "l0.4632605,0.5633383", "l0.4601073,0.5625687", "l0.4573138,0.5623037", "l0.4552947,0.5623163", "l0.4538841,0.5623416", "l0.4490714,0.5626822", "l0.4432630,0.5639187", "l0.4422396,0.5645622", "l0.4410779,0.5653192", "l0.4389482,0.5660636", "l0.4379801,0.5662655", "l0.4361823,0.5663285", "l0.4335270,0.5666566", "l0.4322824,0.5670730", "l0.4290186,0.5696342", "l0.4294888,0.5706940", "l0.4304845,0.5711987", "l0.4329462,0.5714384", "l0.4396950,0.5726623", "l0.4434843,0.5736717", "l0.4460842,0.5747315", "l0.4471629,0.5750974", "l0.4486288,0.5754759", "l0.4503160,0.5757535", "l0.4593052,0.5768890", "l0.4605222,0.5768259", "l0.4639243,0.5760941", "l0.4651966,0.5773180", "l0.4617945,0.5785545", "l0.4604116,0.5790087", "l0.4504267,0.5812293", "l0.4447842,0.5817466", "l0.4415205,0.5822386", "l0.4399716,0.5826171", "l0.4383950,0.5830966", "l0.4334717,0.5849513", "l0.4282718,0.5873107", "l0.4278016,0.5878658", "l0.4233209,0.5919411", "l0.4171806,0.5954991", "l0.4157423,0.5965590", "l0.4135849,0.5983127", "l0.4131147,0.6000413", "l0.4131977,0.6007731", "l0.4141104,0.6035236", "l0.4150232,0.6043058", "l0.4157423,0.6050881", "l0.4163785,0.6061353", "l0.4170146,0.6080279", "l0.4183976,0.6077629", "l0.4194209,0.6076620", "l0.4185082,0.6125069", "l0.4171529,0.6127845", "l0.4152444,0.6131504", "l0.4143040,0.6149168", "l0.4144976,0.6155602", "l0.4164891,0.6180458", "l0.4174572,0.6189164", "l0.4137785,0.6218561", "l0.4129764,0.6225753", "l0.4105424,0.6255782", "l0.4000597,0.6286063", "l0.3986767,0.6291993", "l0.3979299,0.6296282", "l0.3954406,0.6316722", "l0.3939194,0.6337162", "l0.3938364,0.6346751", "l0.3942513,0.6354321", "l0.3964640,0.6361513", "l0.3985108,0.6362522", "l0.4030468,0.6374508", "l0.3993405,0.6415766", "l0.3954683,0.6422831", "l0.3936428,0.6417154", "l0.3923981,0.6412738", "l0.3877514,0.6404789", "l0.3742538,0.6396714", "l0.3707135,0.6397723", "l0.3621392,0.6419425", "l0.3539245,0.6436332", "l0.3531777,0.6445164", "l0.3514628,0.6459925", "l0.3455161,0.6473173", "l0.3383248,0.6476580", "l0.3371078,0.6477716", "l0.3324334,0.6491216", "l0.3302484,0.6500174", "l0.3278697,0.6518216", "l0.3246889,0.6545595", "l0.3206507,0.6579535", "l0.3198762,0.6583951", "l0.3171933,0.6594045", "l0.3148146,0.6602372", "l0.3137913,0.6609942", "l0.3132657,0.6617512", "l0.3106658,0.6667223", "l0.3088680,0.6674794", "l0.3028660,0.6710752", "l0.3004873,0.6734220", "l0.3004873,0.6734220", "l0.2980256,0.6733968", "l0.2512819,0.6734220", "l0.2496224,0.6733968", "l0.2012192,0.6733968", "l0.1995320,0.6734220", "l0.1343674,0.6733968", "l0.1243825,0.6734220", "l0.1026978,0.6734220", "c"]}, {"n": "Ciudad de Buenos Aires", "u": "AR-C", "i": ["m0.7633052,0.3326988", "l0.7624478,0.3330521", "l0.7573308,0.3342002", "l0.7539565,0.3332792", "l0.7539565,0.3320301", "l0.7555883,0.3304025", "l0.7571096,0.3300997", "l0.7571096,0.3300997", "l0.7574415,0.3303268", "l0.7592393,0.3310081", "l0.7606223,0.3311216", "l0.7621435,0.3313992", "c"]}, {"n": "Córdoba", "u": "AR-X", "i": ["m0.4256166,0.3429060", "l0.4256719,0.3378339", "l0.4257272,0.3176593", "l0.4256995,0.3152746", "l0.4256166,0.3142148", "l0.4245655,0.3055469", "l0.4234315,0.2934724", "l0.4241506,0.2926901", "l0.4254506,0.2916429", "l0.4277740,0.2900406", "l0.4296548,0.2879714", "l0.4315356,0.2843250", "l0.4344398,0.2794170", "l0.4358780,0.2777389", "l0.4362929,0.2759347", "l0.4342738,0.2694495", "l0.4328079,0.2688313", "l0.4311484,0.2689575", "l0.4299867,0.2691089", "l0.4289080,0.2693360", "l0.4271378,0.2695505", "l0.4216337,0.2698785", "l0.4201677,0.2697524", "l0.4180103,0.2659420", "l0.4178997,0.2649705", "l0.4174848,0.2640999", "l0.4144423,0.2625606", "l0.3980959,0.2580816", "l0.3962427,0.2579302", "l0.3919003,0.2579302", "l0.3919003,0.2579302", "l0.3918449,0.2578293", "l0.3917620,0.2531609", "l0.3915407,0.2396607", "l0.3915130,0.2359639", "l0.3958002,0.2302989", "l0.3968236,0.2289993", "l0.4037660,0.2184515", "l0.4054532,0.2174673", "l0.4098233,0.2116130", "l0.4131424,0.2111714", "l0.4141934,0.2110579", "l0.4226294,0.2099476", "l0.4235698,0.2094934", "l0.4235698,0.2094934", "l0.4328909,0.2047620", "l0.4336100,0.2042951", "l0.4316462,0.1968006", "l0.4327526,0.1966618", "l0.4358504,0.1963338", "l0.4358504,0.1963338", "l0.4368738,0.1962329", "l0.4664966,0.1927632", "l0.4778644,0.1943655", "l0.4778091,0.1951983", "l0.4797176,0.1964221", "l0.4892599,0.1987058", "l0.4912237,0.1988572", "l0.4926343,0.1988698", "l0.4940172,0.1988572", "l0.4955938,0.1987689", "l0.4968938,0.1986049", "l0.4983874,0.1984408", "l0.5001022,0.1984408", "l0.5049979,0.1989329", "l0.5072659,0.1994376", "l0.5096169,0.2005731", "l0.5105850,0.2019231", "l0.5176933,0.2021629", "l0.5204039,0.2021881", "l0.5485884,0.2020241", "l0.5673136,0.2018727", "l0.5723752,0.2079289", "l0.5758879,0.2120420", "l0.5758879,0.2120420", "l0.5732326,0.2198015", "l0.5711029,0.2198646", "l0.5707710,0.2227791", "l0.5799261,0.2257189", "l0.5879195,0.2271320", "l0.5828303,0.2358251", "l0.5736475,0.2514198", "l0.5680051,0.2535899", "l0.5690008,0.2567316", "l0.5696093,0.2588134", "l0.5694433,0.2622074", "l0.5692220,0.2630275", "l0.5693603,0.2646551", "l0.5731496,0.2666864", "l0.5749475,0.2670523", "l0.5758049,0.2673299", "l0.5768283,0.2678724", "l0.5775751,0.2687682", "l0.5779346,0.2699164", "l0.5785984,0.2707996", "l0.5797325,0.2714809", "l0.5808941,0.2718973", "l0.5823048,0.2723262", "l0.5835494,0.2728183", "l0.5846558,0.2734996", "l0.5855132,0.2744585", "l0.5866749,0.2764520", "l0.5886387,0.2792151", "l0.5932301,0.2825334", "l0.5936726,0.2834797", "l0.5923173,0.2875045", "l0.5919854,0.2881732", "l0.5910727,0.2889303", "l0.5898833,0.2895359", "l0.5875323,0.2902046", "l0.5855409,0.2902172", "l0.5834941,0.2915420", "l0.5642158,0.3059507", "l0.5435268,0.3212930", "l0.5381057,0.3252421", "l0.5374695,0.3257594", "l0.5374695,0.3257594", "l0.5363355,0.3257342", "l0.5257698,0.3257468", "l0.5163104,0.3257342", "l0.5121062,0.3257216", "l0.5110275,0.3256711", "l0.5110275,0.3321689", "l0.5109169,0.3429060", "l0.5109169,0.3429060", "l0.5098105,0.3428934", "l0.4492927,0.3428429", "l0.4312313,0.3428176", "l0.4288250,0.3428303", "c"]}, {"n": "Corrientes", "u": "AR-W", "i": ["m0.6979470,0.2168112", "l0.6969789,0.2150827", "l0.6989151,0.2130766", "l0.7020129,0.2084840", "l0.7018193,0.2074999", "l0.7009342,0.2067807", "l0.6995789,0.2059858", "l0.6981959,0.2052540", "l0.6974768,0.2041437", "l0.6975874,0.2032227", "l0.6978917,0.2025918", "l0.6988321,0.2015446", "l0.6999938,0.1997530", "l0.7007129,0.1983273", "l0.7011001,0.1966745", "l0.7013214,0.1944791", "l0.7012384,0.1927884", "l0.7017086,0.1921323", "l0.7060511,0.1879308", "l0.7070468,0.1875776", "l0.7106425,0.1870476", "l0.7120254,0.1866691", "l0.7205720,0.1826191", "l0.7212082,0.1817863", "l0.7256890,0.1731815", "l0.7263251,0.1722479", "l0.7276251,0.1668982", "l0.7276251,0.1657753", "l0.7269060,0.1626589", "l0.7267953,0.1615486", "l0.7270719,0.1605519", "l0.7276251,0.1600724", "l0.7286485,0.1595551", "l0.7306123,0.1591135", "l0.7323824,0.1592271", "l0.7334335,0.1592271", "l0.7346781,0.1590000", "l0.7360058,0.1584574", "l0.7370568,0.1573724", "l0.7374994,0.1568172", "l0.7376930,0.1563125", "l0.7377206,0.1559214", "l0.7377206,0.1559214", "l0.7378313,0.1542686", "l0.7391589,0.1523508", "l0.7393248,0.1515938", "l0.7396844,0.1490704", "l0.7396568,0.1484269", "l0.7387163,0.1448563", "l0.7381355,0.1438721", "l0.7376930,0.1430773", "l0.7379696,0.1424338", "l0.7421184,0.1406296", "l0.7433907,0.1401501", "l0.7444418,0.1398599", "l0.7466268,0.1394940", "l0.7475949,0.1392543", "l0.7503608,0.1384090", "l0.7503608,0.1384090", "l0.7525458,0.1380052", "l0.7541501,0.1378033", "l0.7553117,0.1376772", "l0.7566117,0.1376141", "l0.7661264,0.1372987", "l0.7728199,0.1371725", "l0.7800942,0.1372103", "l0.7838558,0.1373491", "l0.7911025,0.1377781", "l0.7942003,0.1381566", "l0.7955003,0.1384720", "l0.7965513,0.1388632", "l0.7984321,0.1395193", "l0.7998427,0.1398094", "l0.8100489,0.1409828", "l0.8134786,0.1411973", "l0.8145296,0.1411847", "l0.8158849,0.1413235", "l0.8172679,0.1416137", "l0.8188721,0.1420553", "l0.8203657,0.1423707", "l0.8225231,0.1426861", "l0.8246528,0.1428375", "l0.8268656,0.1428880", "l0.8285251,0.1424969", "l0.8308208,0.1418282", "l0.8325080,0.1413992", "l0.8349420,0.1410207", "l0.8367398,0.1410333", "l0.8376526,0.1412478", "l0.8389802,0.1417903", "l0.8411376,0.1428249", "l0.8424376,0.1431403", "l0.8442077,0.1432287", "l0.8454801,0.1426735", "l0.8459503,0.1424338", "l0.8471396,0.1421057", "l0.8485502,0.1419165", "l0.8504310,0.1417651", "l0.8518969,0.1417777", "l0.8533076,0.1418786", "l0.8547735,0.1421184", "l0.8556032,0.1424590", "l0.8561011,0.1431530", "l0.8579819,0.1443011", "l0.8598904,0.1450077", "l0.8609138,0.1452600", "l0.8625457,0.1452600", "l0.8635414,0.1448941", "l0.8670817,0.1422824", "l0.8673860,0.1417777", "l0.8672477,0.1411721", "l0.8674136,0.1402637", "l0.8736369,0.1382575", "l0.8759049,0.1380935", "l0.8776198,0.1380431", "l0.8790581,0.1381061", "l0.8825984,0.1387875", "l0.8825984,0.1387875", "l0.8809942,0.1393174", "l0.8803027,0.1400870", "l0.8799432,0.1406548", "l0.8798878,0.1415632", "l0.8803857,0.1425978", "l0.8822942,0.1443011", "l0.8833176,0.1450707", "l0.8843133,0.1456637", "l0.8874387,0.1488685", "l0.8878260,0.1493732", "l0.8883515,0.1503068", "l0.8887111,0.1521489", "l0.8888494,0.1534106", "l0.8891813,0.1539279", "l0.8933025,0.1572714", "l0.8947407,0.1580285", "l0.8995810,0.1595677", "l0.8995810,0.1595677", "l0.8991938,0.1600219", "l0.8969534,0.1609808", "l0.8954045,0.1613089", "l0.8934684,0.1615360", "l0.8923620,0.1620154", "l0.8925003,0.1625454", "l0.8949897,0.1631762", "l0.8968428,0.1637314", "l0.8975066,0.1645893", "l0.8960130,0.1664566", "l0.8948514,0.1659393", "l0.8942429,0.1653085", "l0.8892089,0.1650435", "l0.8873834,0.1651318", "l0.8862218,0.1654725", "l0.8819069,0.1685384", "l0.8803027,0.1704184", "l0.8775368,0.1721091", "l0.8723369,0.1747586", "l0.8670541,0.1760077", "l0.8660583,0.1765503", "l0.8657264,0.1774461", "l0.8601670,0.1830102", "l0.8594478,0.1836158", "l0.8550501,0.1842214", "l0.8522012,0.1850542", "l0.8511778,0.1854705", "l0.8495459,0.1863411", "l0.8485779,0.1870224", "l0.8480523,0.1878173", "l0.8480247,0.1886626", "l0.8459779,0.1907444", "l0.8401142,0.1939744", "l0.8351079,0.1963716", "l0.8284974,0.2002198", "l0.8269209,0.2010526", "l0.8255379,0.2016960", "l0.8234912,0.2020745", "l0.8210018,0.2020998", "l0.8193423,0.2021755", "l0.8178487,0.2024531", "l0.8167147,0.2028316", "l0.8158573,0.2033615", "l0.8147786,0.2046610", "l0.8147786,0.2055947", "l0.8144467,0.2073611", "l0.8134786,0.2079289", "l0.8063702,0.2113985", "l0.8040192,0.2122186", "l0.8029958,0.2124710", "l0.8015576,0.2126855", "l0.8002853,0.2127864", "l0.7992066,0.2141869", "l0.7994278,0.2152594", "l0.7991236,0.2157893", "l0.7972428,0.2172655", "l0.7933705,0.2189183", "l0.7908259,0.2197258", "l0.7872302,0.2210758", "l0.7865387,0.2214922", "l0.7861792,0.2220221", "l0.7861792,0.2236875", "l0.7870919,0.2243058", "l0.7883642,0.2248609", "l0.7899685,0.2267409", "l0.7903557,0.2276493", "l0.7903557,0.2276493", "l0.7894706,0.2274474", "l0.7873132,0.2266778", "l0.7862898,0.2262236", "l0.7842707,0.2253025", "l0.7817537,0.2240787", "l0.7810346,0.2236875", "l0.7800942,0.2228800", "l0.7789325,0.2218076", "l0.7783517,0.2211515", "l0.7747284,0.2181234", "l0.7691412,0.2145023", "l0.7681455,0.2141112", "l0.7660434,0.2137453", "l0.7519373,0.2120294", "l0.7501395,0.2119032", "l0.7484247,0.2119789", "l0.7463502,0.2122186", "l0.7433077,0.2129631", "l0.7415099,0.2134299", "l0.7370015,0.2139219", "l0.7344015,0.2137832", "l0.7317463,0.2133542", "l0.7292017,0.2133416", "l0.7241677,0.2148808", "l0.7230337,0.2157136", "l0.7185529,0.2168996", "l0.7164509,0.2167229", "l0.7152892,0.2164832", "l0.7140445,0.2161804", "l0.7118318,0.2160038", "l0.7106701,0.2159659", "l0.7049171,0.2161299", "l0.7019575,0.2167103", "l0.7005193,0.2168112", "c"]}, {"n": "Entre Ríos", "u": "AR-E", "i": ["m0.6656966,0.2949360", "l0.6653370,0.2946584", "l0.6630413,0.2932074", "l0.6616307,0.2927911", "l0.6575649,0.2918196", "l0.6545777,0.2912770", "l0.6536373,0.2909490", "l0.6459757,0.2839718", "l0.6454779,0.2833157", "l0.6450907,0.2824451", "l0.6433205,0.2774109", "l0.6431545,0.2741683", "l0.6442056,0.2722127", "l0.6464460,0.2696767", "l0.6449524,0.2652481", "l0.6479119,0.2539937", "l0.6489906,0.2534638", "l0.6508990,0.2531988", "l0.6539415,0.2530474", "l0.6556564,0.2529969", "l0.6587542,0.2527824", "l0.6607180,0.2521137", "l0.6630690,0.2509782", "l0.6731922,0.2456286", "l0.6750453,0.2442659", "l0.6757645,0.2434584", "l0.6763730,0.2425626", "l0.6772857,0.2415280", "l0.6787240,0.2404682", "l0.6810750,0.2396986", "l0.6837579,0.2379700", "l0.6864685,0.2357873", "l0.6911429,0.2324564", "l0.6929131,0.2313966", "l0.6935769,0.2309550", "l0.6962045,0.2289362", "l0.7012108,0.2247852", "l0.7016810,0.2234226", "l0.7016256,0.2202305", "l0.7013491,0.2193094", "l0.7003533,0.2187290", "l0.6981683,0.2171267", "l0.6979470,0.2168112", "l0.6979470,0.2168112", "l0.7005193,0.2168112", "l0.7019575,0.2167103", "l0.7049171,0.2161299", "l0.7106701,0.2159659", "l0.7118318,0.2160038", "l0.7140445,0.2161804", "l0.7152892,0.2164832", "l0.7164509,0.2167229", "l0.7185529,0.2168996", "l0.7230337,0.2157136", "l0.7241677,0.2148808", "l0.7292017,0.2133416", "l0.7317463,0.2133542", "l0.7344015,0.2137832", "l0.7370015,0.2139219", "l0.7415099,0.2134299", "l0.7433077,0.2129631", "l0.7463502,0.2122186", "l0.7484247,0.2119789", "l0.7501395,0.2119032", "l0.7519373,0.2120294", "l0.7660434,0.2137453", "l0.7681455,0.2141112", "l0.7691412,0.2145023", "l0.7747284,0.2181234", "l0.7783517,0.2211515", "l0.7789325,0.2218076", "l0.7800942,0.2228800", "l0.7810346,0.2236875", "l0.7817537,0.2240787", "l0.7842707,0.2253025", "l0.7862898,0.2262236", "l0.7873132,0.2266778", "l0.7894706,0.2274474", "l0.7903557,0.2276493", "l0.7903557,0.2276493", "l0.7905216,0.2281035", "l0.7907706,0.2291760", "l0.7908259,0.2312325", "l0.7879770,0.2360649", "l0.7846303,0.2415154", "l0.7804261,0.2454267", "l0.7787113,0.2458431", "l0.7772453,0.2462847", "l0.7766921,0.2469786", "l0.7773836,0.2474707", "l0.7788772,0.2478113", "l0.7800112,0.2482529", "l0.7811729,0.2489090", "l0.7817537,0.2497796", "l0.7815878,0.2508142", "l0.7786283,0.2553437", "l0.7774666,0.2559745", "l0.7757517,0.2563657", "l0.7736773,0.2565549", "l0.7725156,0.2567442", "l0.7714093,0.2572489", "l0.7706348,0.2581699", "l0.7726263,0.2596840", "l0.7733454,0.2608069", "l0.7730688,0.2627751", "l0.7725710,0.2637088", "l0.7717135,0.2643775", "l0.7715199,0.2652102", "l0.7724880,0.2662701", "l0.7736497,0.2669514", "l0.7755581,0.2678346", "l0.7757794,0.2689070", "l0.7755581,0.2697397", "l0.7738709,0.2705094", "l0.7731241,0.2709257", "l0.7717965,0.2718594", "l0.7706625,0.2730959", "l0.7706348,0.2730454", "l0.7699987,0.2734744", "l0.7695838,0.2740800", "l0.7693902,0.2750263", "l0.7694178,0.2763637", "l0.7706901,0.2799974", "l0.7731241,0.2864447", "l0.7733177,0.2891952", "l0.7729029,0.2897756", "l0.7721837,0.2901667", "l0.7712157,0.2904317", "l0.7695561,0.2905452", "l0.7684221,0.2904948", "l0.7673434,0.2903812", "l0.7622542,0.2901667", "l0.7604563,0.2901667", "l0.7593223,0.2906083", "l0.7592670,0.2950748", "l0.7578287,0.2970809", "l0.7569989,0.2975603", "l0.7552288,0.2990870", "l0.7543160,0.3011562", "l0.7540118,0.3020268", "l0.7531267,0.3059507", "l0.7530990,0.3066446", "l0.7532373,0.3080198", "l0.7539841,0.3089787", "l0.7561692,0.3105180", "l0.7572755,0.3110858", "l0.7585755,0.3147195", "l0.7581883,0.3155270", "l0.7581883,0.3155270", "l0.7581883,0.3155144", "l0.7545650,0.3157919", "l0.7534586,0.3160191", "l0.7521863,0.3164733", "l0.7506927,0.3167635", "l0.7477608,0.3165868", "l0.7438333,0.3150602", "l0.7333505,0.3117797", "l0.7304187,0.3109849", "l0.7289804,0.3106442", "l0.7255230,0.3105685", "l0.7187742,0.3097358", "l0.7098404,0.3081460", "l0.7085127,0.3077675", "l0.7077936,0.3073638", "l0.7070191,0.3067834", "l0.7055532,0.3059633", "l0.7044192,0.3057235", "l0.7028980,0.3059002", "l0.7003810,0.3065689", "l0.6941854,0.3052189", "l0.6924982,0.3048151", "l0.6908940,0.3041212", "l0.6902855,0.3035786", "l0.6877685,0.3024557", "l0.6862472,0.3019763", "l0.6823197,0.3012066", "l0.6777006,0.2998188", "l0.6767602,0.2994907", "l0.6750177,0.2988473", "l0.6737177,0.2982164", "l0.6728050,0.2976991", "l0.6692370,0.2959453", "l0.6683242,0.2955921", "l0.6673008,0.2952893", "c"]}, {"n": "Formosa", "u": "AR-P", "i": ["m0.5632477,0.0576851", "l0.5632477,0.0526635", "l0.5633583,0.0348230", "l0.5633307,0.0252972", "l0.5631924,0.0172727", "l0.5631647,0.0169195", "l0.5631647,0.0169195", "l0.5644370,0.0171844", "l0.5659583,0.0175503", "l0.5677008,0.0182695", "l0.5682263,0.0186985", "l0.5683646,0.0193798", "l0.5725135,0.0239598", "l0.5751411,0.0254360", "l0.5781559,0.0269248", "l0.5789580,0.0274799", "l0.5800367,0.0287416", "l0.5798984,0.0293599", "l0.5807282,0.0301043", "l0.5843239,0.0316562", "l0.5858174,0.0318076", "l0.5875046,0.0321861", "l0.5924003,0.0342048", "l0.5929811,0.0346212", "l0.5930641,0.0357567", "l0.5967151,0.0370436", "l0.5986512,0.0369806", "l0.6005873,0.0373086", "l0.6077787,0.0403114", "l0.6121211,0.0412451", "l0.6155785,0.0420652", "l0.6212210,0.0436928", "l0.6247890,0.0450176", "l0.6286059,0.0486387", "l0.6291314,0.0494336", "l0.6298229,0.0500518", "l0.6310399,0.0503168", "l0.6365994,0.0510107", "l0.6423248,0.0515785", "l0.6437630,0.0515785", "l0.6497097,0.0521210", "l0.6507884,0.0527392", "l0.6515352,0.0534079", "l0.6575925,0.0544678", "l0.6664434,0.0557042", "l0.6723071,0.0557926", "l0.6734688,0.0556916", "l0.6746581,0.0555528", "l0.6760687,0.0553510", "l0.6771198,0.0551617", "l0.6785580,0.0549851", "l0.6813239,0.0558178", "l0.6969789,0.0605618", "l0.7038107,0.0626184", "l0.7069638,0.0635899", "l0.7113616,0.0655960", "l0.7126616,0.0665044", "l0.7135743,0.0669334", "l0.7160360,0.0675895", "l0.7254400,0.0699236", "l0.7276251,0.0701760", "l0.7310548,0.0710844", "l0.7336271,0.0718541", "l0.7365036,0.0729644", "l0.7401823,0.0742513", "l0.7470970,0.0752733", "l0.7503608,0.0754247", "l0.7517991,0.0753742", "l0.7539565,0.0755508", "l0.7581330,0.0762069", "l0.7630009,0.0789196", "l0.7665413,0.0791846", "l0.7715476,0.0791089", "l0.7741752,0.0799290", "l0.7776602,0.0805850", "l0.7838835,0.0816701", "l0.7852664,0.0816827", "l0.7867047,0.0818594", "l0.7877557,0.0821748", "l0.7926237,0.0840295", "l0.7938131,0.0855814", "l0.7953620,0.0865403", "l0.7970492,0.0871081", "l0.7972428,0.0874109", "l0.7990959,0.0894296", "l0.8012810,0.0901614", "l0.8028852,0.0907796", "l0.8029958,0.0914988", "l0.8018618,0.0935301", "l0.7932322,0.0982111", "l0.7910195,0.0990185", "l0.7901344,0.0991700", "l0.7903833,0.1006840", "l0.7879770,0.1024882", "l0.7856260,0.1037752", "l0.7861239,0.1042420", "l0.7876728,0.1048602", "l0.7805091,0.1075477", "l0.7782410,0.1079262", "l0.7734007,0.1101468", "l0.7740645,0.1114211", "l0.7725433,0.1125188", "l0.7701370,0.1155595", "l0.7697774,0.1186254", "l0.7714923,0.1193825", "l0.7722114,0.1201142", "l0.7715476,0.1215526", "l0.7647988,0.1270662", "l0.7629733,0.1273817", "l0.7629733,0.1273817", "l0.7627244,0.1272555", "l0.7615903,0.1271041", "l0.7573585,0.1259812", "l0.7535416,0.1239877", "l0.7472077,0.1210858", "l0.7442205,0.1200890", "l0.7370568,0.1175908", "l0.7357568,0.1168843", "l0.7351207,0.1163291", "l0.7340973,0.1157487", "l0.7329909,0.1152188", "l0.7317739,0.1148025", "l0.7263251,0.1138814", "l0.7199359,0.1132253", "l0.7178615,0.1136165", "l0.7166998,0.1137300", "l0.7129658,0.1134903", "l0.7110574,0.1127333", "l0.7100340,0.1110047", "l0.7098957,0.1099575", "l0.7092319,0.1094024", "l0.7080978,0.1090996", "l0.7045298,0.1088977", "l0.7025660,0.1088977", "l0.6981959,0.1084561", "l0.6972279,0.1082164", "l0.6955683,0.1052514", "l0.6903684,0.1021728", "l0.6872153,0.1003307", "l0.6862749,0.0999648", "l0.6791389,0.0980975", "l0.6713944,0.0964825", "l0.6692923,0.0944386", "l0.6689880,0.0937699", "l0.6689604,0.0930128", "l0.6685731,0.0921423", "l0.6654200,0.0908932", "l0.6606903,0.0883950", "l0.6551309,0.0848875", "l0.6469438,0.0832472", "l0.6399461,0.0814682", "l0.6331143,0.0788313", "l0.6280527,0.0770901", "l0.6252038,0.0756644", "l0.6230188,0.0732798", "l0.6201146,0.0714503", "l0.6186210,0.0710213", "l0.6172934,0.0708952", "l0.6156892,0.0708321", "l0.6136700,0.0708321", "l0.6091893,0.0704409", "l0.6076957,0.0702012", "l0.6027447,0.0679932", "l0.5976555,0.0668703", "l0.5952492,0.0649778", "l0.5894408,0.0631861", "l0.5852919,0.0627319", "l0.5807282,0.0613314", "l0.5707156,0.0591992", "c"]}, {"n": "Jujuy", "u": "AR-Y", "i": ["m0.4204443,0.0076964", "l0.4187848,0.0095511", "l0.4181210,0.0108633", "l0.4179827,0.0120114", "l0.4180380,0.0131217", "l0.4146359,0.0165283", "l0.4139721,0.0170709", "l0.4133360,0.0174746", "l0.4129764,0.0180045", "l0.4132253,0.0192158", "l0.4155763,0.0232658", "l0.4164338,0.0259911", "l0.4181486,0.0284262", "l0.4195592,0.0292337", "l0.4205550,0.0295491", "l0.4218549,0.0296753", "l0.4232379,0.0296627", "l0.4253676,0.0296627", "l0.4264187,0.0297131", "l0.4277186,0.0298393", "l0.4288527,0.0303566", "l0.4295441,0.0311262", "l0.4295995,0.0318202", "l0.4294335,0.0326403", "l0.4291846,0.0335866", "l0.4286314,0.0343941", "l0.4277463,0.0358955", "l0.4282718,0.0366273", "l0.4298207,0.0369806", "l0.4312313,0.0371320", "l0.4320888,0.0374221", "l0.4330292,0.0381539", "l0.4356291,0.0407152", "l0.4359057,0.0418255", "l0.4394461,0.0425068", "l0.4409673,0.0421914", "l0.4417694,0.0417876", "l0.4425439,0.0414596", "l0.4463608,0.0410685", "l0.4522522,0.0424690", "l0.4540777,0.0432260", "l0.4563180,0.0445634", "l0.4599967,0.0435540", "l0.4614626,0.0424311", "l0.4709773,0.0425194", "l0.4712262,0.0476293", "l0.4713369,0.0506070", "l0.4713092,0.0513387", "l0.4716411,0.0560575", "l0.4718071,0.0575085", "l0.4721390,0.0591739", "l0.4718624,0.0599814", "l0.4710879,0.0609151", "l0.4695114,0.0621642", "l0.4669391,0.0638296", "l0.4662476,0.0642207", "l0.4649200,0.0648642", "l0.4637030,0.0651670", "l0.4623200,0.0651670", "l0.4594988,0.0653437", "l0.4538564,0.0670343", "l0.4529436,0.0673876", "l0.4518649,0.0679428", "l0.4507862,0.0687124", "l0.4490437,0.0700877", "l0.4486012,0.0700120", "l0.4461119,0.0689774", "l0.4446459,0.0682708", "l0.4433460,0.0676526", "l0.4390035,0.0660250", "l0.4379801,0.0664413", "l0.4371504,0.0670470", "l0.4364589,0.0678418", "l0.4359334,0.0685484", "l0.4352142,0.0693180", "l0.4344121,0.0696461", "l0.4328356,0.0696082", "l0.4280229,0.0687503", "l0.4264740,0.0682834", "l0.4238740,0.0673624", "l0.4157146,0.0672362", "l0.4140274,0.0670343", "l0.4033511,0.0656212", "l0.4006682,0.0648516", "l0.3925641,0.0595272", "l0.3920662,0.0590225", "l0.3919279,0.0584800", "l0.3920939,0.0578491", "l0.3922598,0.0570669", "l0.3915130,0.0564234", "l0.3856217,0.0544047", "l0.3841004,0.0542280", "l0.3831600,0.0545687", "l0.3821366,0.0546696", "l0.3798963,0.0534584", "l0.3785410,0.0513261", "l0.3787346,0.0491686", "l0.3794537,0.0483990", "l0.3805877,0.0478186", "l0.3806430,0.0436676", "l0.3801452,0.0430998", "l0.3784027,0.0423176", "l0.3744198,0.0411442", "l0.3713496,0.0403619", "l0.3669795,0.0396427", "l0.3630796,0.0390876", "l0.3612817,0.0393778", "l0.3605903,0.0402231", "l0.3596222,0.0420905", "l0.3594839,0.0427465", "l0.3595392,0.0434909", "l0.3607009,0.0450176", "l0.3613371,0.0462667", "l0.3614200,0.0470489", "l0.3613924,0.0481466", "l0.3609222,0.0491686", "l0.3549755,0.0578618", "l0.3537308,0.0587197", "l0.3478118,0.0583538", "l0.3454331,0.0580889", "l0.3440502,0.0578239", "l0.3377163,0.0564991", "l0.3367759,0.0562720", "l0.3331526,0.0544552", "l0.3296675,0.0524995", "l0.3262101,0.0507584", "l0.3248549,0.0503798", "l0.3228911,0.0502789", "l0.3188805,0.0489415", "l0.3176912,0.0484368", "l0.3171933,0.0481214", "l0.3171933,0.0481214", "l0.3221996,0.0396554", "l0.3228081,0.0388226", "l0.3250761,0.0359333", "l0.3273718,0.0330314", "l0.3297228,0.0300412", "l0.3245229,0.0275178", "l0.3205677,0.0255747", "l0.3235272,0.0230513", "l0.3291420,0.0209569", "l0.3286441,0.0182316", "l0.3334568,0.0171087", "l0.3372737,0.0164905", "l0.3410630,0.0158470", "l0.3412290,0.0145727", "l0.3429438,0.0109516", "l0.3453502,0.0101820", "l0.3489735,0.0100810", "l0.3518224,0.0097530", "l0.3550308,0.0093240", "l0.3597052,0.0086679", "l0.3625541,0.0082389", "l0.3644902,0.0072548", "l0.3652646,0.0062328", "l0.3657348,0.0048323", "l0.3680305,0.0004037", "l0.3686944,0.0000000", "l0.3701050,0.0001893", "l0.3759687,0.0012617", "l0.3835749,0.0037473", "l0.3865067,0.0055136", "l0.3892450,0.0071286", "l0.3923981,0.0080749", "l0.3970172,0.0080497", "l0.3999490,0.0078226", "c"]}, {"n": "La Pampa", "u": "AR-L", "i": ["m0.5106956,0.4664268", "l0.5078191,0.4665151", "l0.5065468,0.4664268", "l0.5047766,0.4660861", "l0.4947640,0.4627931", "l0.4860238,0.4598155", "l0.4807686,0.4575318", "l0.4720007,0.4552355", "l0.4695390,0.4546425", "l0.4672433,0.4541883", "l0.4623477,0.4533556", "l0.4605775,0.4531032", "l0.4571755,0.4526742", "l0.4552670,0.4526364", "l0.4526671,0.4525733", "l0.4398333,0.4514882", "l0.4280782,0.4510845", "l0.4216613,0.4511476", "l0.4206379,0.4512359", "l0.4189231,0.4515892", "l0.4173189,0.4517910", "l0.4112339,0.4521696", "l0.4102658,0.4518667", "l0.4087722,0.4513242", "l0.4052042,0.4507438", "l0.4019128,0.4504536", "l0.4005299,0.4504915", "l0.3977363,0.4512107", "l0.3962704,0.4516270", "l0.3910428,0.4509709", "l0.3876961,0.4501382", "l0.3804218,0.4491793", "l0.3766048,0.4489144", "l0.3733687,0.4488008", "l0.3702156,0.4487125", "l0.3675050,0.4486872", "l0.3658731,0.4489774", "l0.3607286,0.4493433", "l0.3517117,0.4481447", "l0.3507437,0.4472111", "l0.3506607,0.4460377", "l0.3501075,0.4454321", "l0.3494714,0.4449526", "l0.3480054,0.4442208", "l0.3465672,0.4437287", "l0.3400396,0.4422526", "l0.3387397,0.4420633", "l0.3347015,0.4415839", "l0.3313271,0.4409656", "l0.3268186,0.4398175", "l0.3259336,0.4395147", "l0.3229187,0.4377987", "l0.3223655,0.4364487", "l0.3211762,0.4343921", "l0.3171933,0.4340136", "l0.3161699,0.4340893", "l0.3152019,0.4344300", "l0.3133487,0.4349347", "l0.3118551,0.4351996", "l0.3036404,0.4355529", "l0.3024787,0.4354898", "l0.3011234,0.4352375", "l0.3000724,0.4348842", "l0.2973895,0.4336856", "l0.2963108,0.4329033", "l0.2958959,0.4321211", "l0.2952321,0.4313767", "l0.2944576,0.4307710", "l0.2932683,0.4302033", "l0.2920236,0.4298248", "l0.2905577,0.4296734", "l0.2883450,0.4298374", "l0.2861876,0.4286262", "l0.2858280,0.4266200", "l0.2863535,0.4256864", "l0.2890365,0.4243742", "l0.2902535,0.4241219", "l0.2915534,0.4238821", "l0.2923832,0.4235289", "l0.2931300,0.4229106", "l0.2940704,0.4218129", "l0.2941810,0.4204629", "l0.2933513,0.4193274", "l0.2920236,0.4181792", "l0.2910003,0.4174853", "l0.2897279,0.4169554", "l0.2880407,0.4165390", "l0.2851919,0.4160596", "l0.2840855,0.4158956", "l0.2764516,0.4154540", "l0.2695092,0.4152016", "l0.2671582,0.4152773", "l0.2671582,0.4152773", "l0.2672965,0.3780444", "l0.2672412,0.3753822", "l0.2648902,0.3753822", "l0.2651668,0.3707644", "l0.2808217,0.3708275", "l0.3078722,0.3708149", "l0.3375227,0.3707896", "l0.3489458,0.3708022", "l0.3489458,0.3708022", "l0.4255612,0.3708653", "l0.4256166,0.3640143", "l0.4255612,0.3625507", "l0.4255889,0.3499084", "l0.4256719,0.3436251", "l0.4256166,0.3429060", "l0.4256166,0.3429060", "l0.4288250,0.3428303", "l0.4312313,0.3428176", "l0.4492927,0.3428429", "l0.5098105,0.3428934", "l0.5109169,0.3429060", "l0.5109169,0.3429060", "l0.5108616,0.3451518", "l0.5106403,0.3728210", "l0.5108063,0.4604085", "l0.5107786,0.4659852", "c"]}, {"n": "La Rioja", "u": "AR-F", "i": ["m0.4235698,0.2094934", "l0.4226294,0.2099476", "l0.4141934,0.2110579", "l0.4131424,0.2111714", "l0.4098233,0.2116130", "l0.4054532,0.2174673", "l0.4037660,0.2184515", "l0.3968236,0.2289993", "l0.3958002,0.2302989", "l0.3915130,0.2359639", "l0.3915407,0.2396607", "l0.3917620,0.2531609", "l0.3918449,0.2578293", "l0.3919003,0.2579302", "l0.3919003,0.2579302", "l0.3863961,0.2584601", "l0.3834643,0.2582961", "l0.3822196,0.2578923", "l0.3807260,0.2575769", "l0.3794260,0.2574381", "l0.3769921,0.2575517", "l0.3748900,0.2577914", "l0.3735070,0.2580311", "l0.3718475,0.2584727", "l0.3698837,0.2588891", "l0.3683901,0.2590657", "l0.3667859,0.2591667", "l0.3616690,0.2593054", "l0.3509649,0.2588008", "l0.3483927,0.2583087", "l0.3468161,0.2579428", "l0.3449076,0.2576778", "l0.3438566,0.2576652", "l0.3432757,0.2576905", "l0.3432757,0.2576905", "l0.3421970,0.2563026", "l0.3412013,0.2553563", "l0.3371908,0.2522399", "l0.3317419,0.2504483", "l0.3275101,0.2485053", "l0.3243570,0.2438370", "l0.3254080,0.2406575", "l0.3258782,0.2393074", "l0.3267633,0.2365443", "l0.3233060,0.2353205", "l0.3256846,0.2315732", "l0.3209273,0.2272834", "l0.3196826,0.2265642", "l0.3182444,0.2262362", "l0.3168614,0.2259586", "l0.3143998,0.2243184", "l0.3108041,0.2221735", "l0.3078446,0.2210758", "l0.3013724,0.2178837", "l0.3001830,0.2157262", "l0.2996299,0.2152594", "l0.2984129,0.2146285", "l0.2971405,0.2140860", "l0.2901981,0.2114238", "l0.2862982,0.2100107", "l0.2846387,0.2095817", "l0.2835876,0.2091401", "l0.2791345,0.2070961", "l0.2782771,0.2061120", "l0.2777793,0.2056199", "l0.2755389,0.2046737", "l0.2710581,0.2029830", "l0.2639221,0.2004091", "l0.2606307,0.1995511", "l0.2561223,0.1987815", "l0.2451416,0.1975072", "l0.2436204,0.1975450", "l0.2418502,0.1977343", "l0.2405779,0.1979866", "l0.2385588,0.1983399", "l0.2306760,0.1984030", "l0.2289058,0.1981128", "l0.2283526,0.1974819", "l0.2282420,0.1967502", "l0.2284356,0.1958543", "l0.2286569,0.1952487", "l0.2300952,0.1926496", "l0.2316164,0.1887762", "l0.2320313,0.1867827", "l0.2335802,0.1866818", "l0.2343823,0.1861518", "l0.2350461,0.1844990", "l0.2338568,0.1800452", "l0.2277995,0.1774208", "l0.2240655,0.1755409", "l0.2232357,0.1737619", "l0.2217421,0.1719198", "l0.2121445,0.1682861", "l0.2074701,0.1679328", "l0.1967384,0.1662800", "l0.1967384,0.1662800", "l0.1992554,0.1654347", "l0.2029064,0.1640342", "l0.2095722,0.1605771", "l0.2120062,0.1591892", "l0.2126423,0.1585962", "l0.2132232,0.1574607", "l0.2147444,0.1558583", "l0.2165976,0.1554293", "l0.2184507,0.1553410", "l0.2198890,0.1551770", "l0.2206634,0.1546976", "l0.2213273,0.1540162", "l0.2217975,0.1534358", "l0.2235400,0.1501302", "l0.2235400,0.1501302", "l0.2273016,0.1502059", "l0.2290441,0.1502816", "l0.2308419,0.1503699", "l0.2359035,0.1506853", "l0.2375631,0.1505844", "l0.2404673,0.1502185", "l0.2420715,0.1498400", "l0.2469948,0.1494867", "l0.2547117,0.1491334", "l0.2572839,0.1492218", "l0.2580861,0.1495876", "l0.2581690,0.1503068", "l0.2572563,0.1517704", "l0.2573669,0.1556564", "l0.2590265,0.1562747", "l0.2612945,0.1562621", "l0.2687624,0.1581672", "l0.2727453,0.1588990", "l0.2787750,0.1592902", "l0.2829791,0.1600850", "l0.2833940,0.1614603", "l0.2839195,0.1622930", "l0.2852748,0.1633024", "l0.2864089,0.1640215", "l0.2876259,0.1647029", "l0.2901152,0.1652075", "l0.2950661,0.1657753", "l0.2963384,0.1658258", "l0.2979150,0.1655987", "l0.2992703,0.1648921", "l0.3010128,0.1634916", "l0.3033362,0.1620911", "l0.3048021,0.1620659", "l0.3097807,0.1635547", "l0.3115509,0.1645515", "l0.3208996,0.1650309", "l0.3224485,0.1650561", "l0.3244676,0.1648417", "l0.3254634,0.1645136", "l0.3264867,0.1639711", "l0.3273442,0.1633781", "l0.3287271,0.1631384", "l0.3313271,0.1633528", "l0.3323504,0.1634790", "l0.3512415,0.1671380", "l0.3526521,0.1675417", "l0.3536755,0.1679833", "l0.3543947,0.1683618", "l0.3549755,0.1687908", "l0.3601477,0.1742035", "l0.3607839,0.1771811", "l0.3619456,0.1781526", "l0.3631072,0.1785564", "l0.3659285,0.1791872", "l0.3673944,0.1794900", "l0.3687220,0.1796793", "l0.3700773,0.1799569", "l0.3715709,0.1803480", "l0.3738666,0.1810924", "l0.3893280,0.1876406", "l0.3899918,0.1880570", "l0.3917620,0.1894954", "l0.3922045,0.1902145", "l0.3922045,0.1919683", "l0.3959938,0.1944286", "l0.4043468,0.1989960", "l0.4177338,0.2061625", "l0.4205273,0.2076387", "c"]}, {"n": "Mendoza", "u": "AR-M", "i": ["m0.1582094,0.3746252", "l0.1596200,0.3729219", "l0.1590669,0.3699821", "l0.1588456,0.3677868", "l0.1593158,0.3671685", "l0.1606711,0.3661087", "l0.1622476,0.3654905", "l0.1606987,0.3633582", "l0.1589839,0.3615918", "l0.1585137,0.3605446", "l0.1592328,0.3599768", "l0.1596200,0.3572011", "l0.1583201,0.3529870", "l0.1527606,0.3514099", "l0.1519032,0.3511070", "l0.1510458,0.3502996", "l0.1511564,0.3495804", "l0.1524010,0.3486846", "l0.1535904,0.3485458", "l0.1553052,0.3484953", "l0.1568818,0.3483565", "l0.1603668,0.3475490", "l0.1612796,0.3468677", "l0.1615562,0.3456312", "l0.1613349,0.3450509", "l0.1612796,0.3440289", "l0.1613349,0.3429691", "l0.1614455,0.3427672", "l0.1645710,0.3387802", "l0.1678071,0.3334810", "l0.1719560,0.3298852", "l0.1771835,0.3262515", "l0.1768516,0.3250024", "l0.1768516,0.3233748", "l0.1770729,0.3230972", "l0.1779856,0.3228449", "l0.1801707,0.3226556", "l0.1816089,0.3226808", "l0.1827430,0.3228196", "l0.1850663,0.3228953", "l0.1886067,0.3216967", "l0.1870578,0.3179116", "l0.1852599,0.3122844", "l0.1842642,0.3105180", "l0.1842365,0.3091680", "l0.1860067,0.3030740", "l0.1890215,0.2998692", "l0.1903215,0.2991879", "l0.1907364,0.2984814", "l0.1892981,0.2955416", "l0.1857025,0.2946205", "l0.1843472,0.2944061", "l0.1831025,0.2945070", "l0.1816919,0.2951631", "l0.1806962,0.2959958", "l0.1794515,0.2960715", "l0.1746942,0.2928289", "l0.1744176,0.2921224", "l0.1749155,0.2912896", "l0.1752197,0.2900532", "l0.1744729,0.2893719", "l0.1758835,0.2881228", "l0.1784005,0.2865835", "l0.1798111,0.2846026", "l0.1772112,0.2840096", "l0.1722049,0.2814357", "l0.1709049,0.2778903", "l0.1712368,0.2766286", "l0.1718453,0.2756067", "l0.1721219,0.2746099", "l0.1717347,0.2737898", "l0.1679177,0.2701813", "l0.1672263,0.2693234", "l0.1672263,0.2693234", "l0.1713475,0.2689323", "l0.1782069,0.2690080", "l0.1807792,0.2692098", "l0.1828536,0.2689953", "l0.1839046,0.2687556", "l0.1852599,0.2685159", "l0.1879705,0.2682383", "l0.1905151,0.2680995", "l0.1925342,0.2680617", "l0.1961576,0.2679607", "l0.1978724,0.2672920", "l0.1982043,0.2665981", "l0.1980660,0.2655509", "l0.1980660,0.2649453", "l0.1985916,0.2644658", "l0.1995873,0.2640873", "l0.2074148,0.2623714", "l0.2097105,0.2622957", "l0.2170124,0.2609330", "l0.2203315,0.2598354", "l0.2224613,0.2599994", "l0.2233464,0.2602770", "l0.2243421,0.2607690", "l0.2252548,0.2613494", "l0.2259463,0.2620181", "l0.2267761,0.2625480", "l0.2286292,0.2631789", "l0.2329993,0.2629013", "l0.2358482,0.2632167", "l0.2368163,0.2634691", "l0.2381716,0.2640747", "l0.2391673,0.2643270", "l0.2416013,0.2648443", "l0.2429013,0.2650841", "l0.2513373,0.2660051", "l0.2529968,0.2660934", "l0.2545734,0.2658537", "l0.2555138,0.2652607", "l0.2557350,0.2639359", "l0.2562052,0.2632546", "l0.2574776,0.2628256", "l0.2587775,0.2628761", "l0.2609349,0.2634817", "l0.2620689,0.2636079", "l0.2683199,0.2638981", "l0.2738793,0.2633177", "l0.2750134,0.2631536", "l0.2766729,0.2628508", "l0.2785537,0.2628256", "l0.2795494,0.2630275", "l0.2803515,0.2633303", "l0.2812090,0.2637088", "l0.2819558,0.2642639", "l0.2828132,0.2653490", "l0.2877088,0.2673173", "l0.2887046,0.2675570", "l0.2916917,0.2677967", "l0.2960895,0.2681121", "l0.2984129,0.2680238", "l0.2994362,0.2678977", "l0.3010958,0.2679229", "l0.3058808,0.2686799", "l0.3068765,0.2690080", "l0.3103339,0.2708248", "l0.3111913,0.2713547", "l0.3116892,0.2717080", "l0.3116892,0.2717080", "l0.3131551,0.2722884", "l0.3147593,0.2742188", "l0.3160870,0.2762880", "l0.3172763,0.2792530", "l0.3198209,0.2819657", "l0.3191018,0.2837825", "l0.3185209,0.2861419", "l0.3189912,0.2867223", "l0.3199039,0.2873910", "l0.3204018,0.2898892", "l0.3206783,0.2930056", "l0.3201252,0.2939014", "l0.3220890,0.2996674", "l0.3239974,0.3015221", "l0.3268740,0.3036039", "l0.3307186,0.3074142", "l0.3326824,0.3102783", "l0.3339270,0.3110984", "l0.3369418,0.3120573", "l0.3378269,0.3125872", "l0.3414503,0.3155018", "l0.3425290,0.3175836", "l0.3418375,0.3196654", "l0.3398184,0.3206117", "l0.3386014,0.3217346", "l0.3392099,0.3259739", "l0.3422247,0.3313866", "l0.3426119,0.3319165", "l0.3467331,0.3350582", "l0.3501905,0.3376068", "l0.3511586,0.3387423", "l0.3523756,0.3404078", "l0.3527628,0.3411017", "l0.3544223,0.3464009", "l0.3544776,0.3527599", "l0.3538691,0.3563305", "l0.3536202,0.3570749", "l0.3514075,0.3625002", "l0.3509649,0.3633960", "l0.3493054,0.3664746", "l0.3480054,0.3699443", "l0.3488352,0.3707392", "l0.3489458,0.3708022", "l0.3489458,0.3708022", "l0.3375227,0.3707896", "l0.3078722,0.3708149", "l0.2808217,0.3708275", "l0.2651668,0.3707644", "l0.2648902,0.3753822", "l0.2672412,0.3753822", "l0.2672965,0.3780444", "l0.2671582,0.4152773", "l0.2671582,0.4152773", "l0.2627051,0.4148988", "l0.2561223,0.4135109", "l0.2500649,0.4118076", "l0.2410481,0.4096627", "l0.2398035,0.4096880", "l0.2380886,0.4099403", "l0.2369822,0.4101422", "l0.2358759,0.4101422", "l0.2315611,0.4096627", "l0.2297079,0.4093473", "l0.2282420,0.4087417", "l0.2275505,0.4077954", "l0.2272739,0.4067103", "l0.2266654,0.4059786", "l0.2256144,0.4053351", "l0.2235676,0.4047421", "l0.2165422,0.4034425", "l0.2152699,0.4034047", "l0.2131955,0.4034930", "l0.2098488,0.4037075", "l0.2081339,0.4040355", "l0.2065573,0.4041996", "l0.2022425,0.4039851", "l0.2001405,0.4037958", "l0.1979001,0.4034552", "l0.1951895,0.4026224", "l0.1934470,0.4020547", "l0.1919257,0.4013481", "l0.1889109,0.3991780", "l0.1901002,0.3978784", "l0.1903215,0.3969448", "l0.1902662,0.3959354", "l0.1898790,0.3948251", "l0.1884131,0.3946232", "l0.1859791,0.3940302", "l0.1840429,0.3932732", "l0.1831578,0.3927938", "l0.1828259,0.3918979", "l0.1819408,0.3908507", "l0.1758006,0.3879993", "l0.1728410,0.3875577", "l0.1713751,0.3872170", "l0.1691071,0.3857156", "l0.1685262,0.3850721", "l0.1682773,0.3844791", "l0.1680560,0.3837347", "l0.1670050,0.3818043", "l0.1661752,0.3810978", "l0.1651518,0.3809211", "l0.1636306,0.3812996", "l0.1622200,0.3813879", "l0.1610860,0.3807319", "l0.1603115,0.3796468", "l0.1603945,0.3786627", "l0.1613072,0.3780697", "l0.1615562,0.3766313", "l0.1607541,0.3755967", "l0.1592052,0.3748397", "c"]}, {"n": "Misiones", "u": "AR-N", "i": ["m0.8825984,0.1387875", "l0.8847005,0.1386487", "l0.8862494,0.1388001", "l0.8874941,0.1394688", "l0.8879089,0.1403141", "l0.8886281,0.1406926", "l0.8929982,0.1416011", "l0.8942982,0.1414749", "l0.9008810,0.1390524", "l0.9016555,0.1383963", "l0.9024576,0.1368444", "l0.9023746,0.1363145", "l0.9018214,0.1357972", "l0.9022363,0.1345608", "l0.9035086,0.1331729", "l0.9100361,0.1299555", "l0.9108659,0.1296401", "l0.9119446,0.1294509", "l0.9173658,0.1287191", "l0.9183615,0.1286812", "l0.9244465,0.1270662", "l0.9281528,0.1252872", "l0.9292315,0.1250854", "l0.9313336,0.1250475", "l0.9327995,0.1247825", "l0.9334910,0.1244040", "l0.9339335,0.1236975", "l0.9345144,0.1223601", "l0.9355654,0.1218428", "l0.9371420,0.1215273", "l0.9388568,0.1215778", "l0.9463247,0.1157487", "l0.9480396,0.1121403", "l0.9475971,0.1109543", "l0.9489247,0.1103360", "l0.9490077,0.1096547", "l0.9479290,0.1088977", "l0.9479566,0.1043051", "l0.9507778,0.1034850", "l0.9503906,0.0993971", "l0.9498098,0.0960283", "l0.9510544,0.0941358", "l0.9536820,0.0940600", "l0.9575543,0.0953218", "l0.9583841,0.0956372", "l0.9618138,0.0943250", "l0.9653541,0.0936815", "l0.9670966,0.0936185", "l0.9721582,0.0938456", "l0.9732369,0.0931895", "l0.9756709,0.0921927", "l0.9866239,0.0956624", "l0.9879792,0.0969620", "l0.9898047,0.0998891", "l0.9897770,0.1004317", "l0.9893345,0.1019078", "l0.9897217,0.1036742", "l0.9941471,0.1071313", "l0.9978534,0.1098061", "l0.9983790,0.1104117", "l0.9985726,0.1112318", "l0.9985726,0.1115725", "l0.9983790,0.1119384", "l0.9976322,0.1127585", "l0.9965258,0.1133894", "l0.9955024,0.1141338", "l0.9956131,0.1178558", "l0.9947833,0.1215652", "l0.9942854,0.1225619", "l0.9952258,0.1247699", "l0.9961386,0.1273186", "l0.9958067,0.1280504", "l0.9943684,0.1297410", "l0.9937876,0.1303719", "l0.9906898,0.1336019", "l0.9891132,0.1346743", "l0.9881728,0.1341192", "l0.9860707,0.1342706", "l0.9807602,0.1351916", "l0.9797368,0.1360496", "l0.9786028,0.1366930", "l0.9774964,0.1371599", "l0.9764454,0.1375384", "l0.9753390,0.1377402", "l0.9737625,0.1377150", "l0.9693094,0.1400492", "l0.9670137,0.1411595", "l0.9631137,0.1419922", "l0.9584670,0.1423076", "l0.9545118,0.1428628", "l0.9466843,0.1445030", "l0.9423972,0.1447553", "l0.9414844,0.1444777", "l0.9413461,0.1439352", "l0.9402951,0.1439983", "l0.9360356,0.1474554", "l0.9358696,0.1485026", "l0.9355377,0.1489946", "l0.9298676,0.1516568", "l0.9277656,0.1519597", "l0.9219572,0.1522372", "l0.9148488,0.1539279", "l0.9121935,0.1552527", "l0.9119446,0.1557700", "l0.9118893,0.1566027", "l0.9085149,0.1581672", "l0.9017938,0.1593659", "l0.8995810,0.1595677", "l0.8995810,0.1595677", "l0.8947407,0.1580285", "l0.8933025,0.1572714", "l0.8891813,0.1539279", "l0.8888494,0.1534106", "l0.8887111,0.1521489", "l0.8883515,0.1503068", "l0.8878260,0.1493732", "l0.8874387,0.1488685", "l0.8843133,0.1456637", "l0.8833176,0.1450707", "l0.8822942,0.1443011", "l0.8803857,0.1425978", "l0.8798878,0.1415632", "l0.8799432,0.1406548", "l0.8803027,0.1400870", "l0.8809942,0.1393174", "c"]}, {"n": "Neuquén", "u": "AR-Q", "i": ["m0.0952022,0.4735428", "l0.0959767,0.4735302", "l0.0980511,0.4748676", "l0.0993511,0.4751452", "l0.1039701,0.4750316", "l0.1046893,0.4744891", "l0.1050489,0.4733788", "l0.1068190,0.4696568", "l0.1091700,0.4665656", "l0.1099445,0.4639160", "l0.1092254,0.4606734", "l0.1087275,0.4588061", "l0.1082296,0.4580239", "l0.1082020,0.4572795", "l0.1083956,0.4557149", "l0.1088105,0.4549832", "l0.1096402,0.4543397", "l0.1112998,0.4536205", "l0.1126274,0.4532294", "l0.1174124,0.4519298", "l0.1244655,0.4500247", "l0.1267058,0.4495200", "l0.1280611,0.4494317", "l0.1296377,0.4495074", "l0.1320717,0.4495326", "l0.1332057,0.4492929", "l0.1362759,0.4478167", "l0.1379077,0.4448390", "l0.1381013,0.4439054", "l0.1371886,0.4429086", "l0.1353354,0.4422399", "l0.1340078,0.4418740", "l0.1318781,0.4408521", "l0.1307994,0.4398175", "l0.1292228,0.4360324", "l0.1286973,0.4343669", "l0.1293334,0.4322472", "l0.1294441,0.4298122", "l0.1246038,0.4243994", "l0.1231655,0.4230999", "l0.1225017,0.4217625", "l0.1213123,0.4204503", "l0.1203719,0.4190372", "l0.1202336,0.4179521", "l0.1205655,0.4170185", "l0.1214783,0.4165138", "l0.1231931,0.4159208", "l0.1239123,0.4122240", "l0.1234421,0.4115301", "l0.1220868,0.4106973", "l0.1210081,0.4099277", "l0.1195422,0.4077323", "l0.1202060,0.4067734", "l0.1219485,0.4058398", "l0.1228612,0.4045781", "l0.1237187,0.4023701", "l0.1219208,0.3983957", "l0.1200400,0.3946989", "l0.1225017,0.3917592", "l0.1266229,0.3862329", "l0.1276462,0.3844413", "l0.1285313,0.3842142", "l0.1302739,0.3844413", "l0.1317398,0.3845296", "l0.1440480,0.3824856", "l0.1445735,0.3818169", "l0.1434672,0.3804921", "l0.1441587,0.3784103", "l0.1499671,0.3754327", "l0.1541989,0.3753570", "l0.1560520,0.3754201", "l0.1574903,0.3750542", "l0.1582094,0.3746252", "l0.1582094,0.3746252", "l0.1592052,0.3748397", "l0.1607541,0.3755967", "l0.1615562,0.3766313", "l0.1613072,0.3780697", "l0.1603945,0.3786627", "l0.1603115,0.3796468", "l0.1610860,0.3807319", "l0.1622200,0.3813879", "l0.1636306,0.3812996", "l0.1651518,0.3809211", "l0.1661752,0.3810978", "l0.1670050,0.3818043", "l0.1680560,0.3837347", "l0.1682773,0.3844791", "l0.1685262,0.3850721", "l0.1691071,0.3857156", "l0.1713751,0.3872170", "l0.1728410,0.3875577", "l0.1758006,0.3879993", "l0.1819408,0.3908507", "l0.1828259,0.3918979", "l0.1831578,0.3927938", "l0.1840429,0.3932732", "l0.1859791,0.3940302", "l0.1884131,0.3946232", "l0.1898790,0.3948251", "l0.1902662,0.3959354", "l0.1903215,0.3969448", "l0.1901002,0.3978784", "l0.1889109,0.3991780", "l0.1919257,0.4013481", "l0.1934470,0.4020547", "l0.1951895,0.4026224", "l0.1979001,0.4034552", "l0.2001405,0.4037958", "l0.2022425,0.4039851", "l0.2065573,0.4041996", "l0.2081339,0.4040355", "l0.2098488,0.4037075", "l0.2131955,0.4034930", "l0.2152699,0.4034047", "l0.2165422,0.4034425", "l0.2235676,0.4047421", "l0.2256144,0.4053351", "l0.2266654,0.4059786", "l0.2272739,0.4067103", "l0.2275505,0.4077954", "l0.2282420,0.4087417", "l0.2297079,0.4093473", "l0.2315611,0.4096627", "l0.2358759,0.4101422", "l0.2369822,0.4101422", "l0.2380886,0.4099403", "l0.2398035,0.4096880", "l0.2410481,0.4096627", "l0.2500649,0.4118076", "l0.2561223,0.4135109", "l0.2627051,0.4148988", "l0.2671582,0.4152773", "l0.2671582,0.4152773", "l0.2671305,0.4158199", "l0.2670476,0.4404862", "l0.2669369,0.4559799", "l0.2555414,0.4586295", "l0.2542138,0.4587556", "l0.2524713,0.4589701", "l0.2489309,0.4603832", "l0.2477692,0.4611403", "l0.2469395,0.4623389", "l0.2464416,0.4628940", "l0.2456118,0.4633609", "l0.2403843,0.4651777", "l0.2392779,0.4657076", "l0.2353780,0.4685086", "l0.2325291,0.4708049", "l0.2309249,0.4713979", "l0.2267761,0.4722937", "l0.2251995,0.4723694", "l0.2229868,0.4723947", "l0.2182018,0.4737573", "l0.2168188,0.4742115", "l0.2156295,0.4748298", "l0.2145785,0.4755363", "l0.2137487,0.4763690", "l0.2128359,0.4773027", "l0.2120338,0.4777821", "l0.2111211,0.4781985", "l0.2060871,0.4800784", "l0.2047042,0.4804317", "l0.2021319,0.4805957", "l0.2003894,0.4808229", "l0.1916492,0.4824757", "l0.1852599,0.4838005", "l0.1837663,0.4842042", "l0.1822728,0.4847341", "l0.1811387,0.4853902", "l0.1801430,0.4862734", "l0.1789813,0.4879641", "l0.1788984,0.4885950", "l0.1793132,0.4891627", "l0.1799771,0.4896422", "l0.1799217,0.4918123", "l0.1762708,0.4968970", "l0.1753027,0.4976666", "l0.1704347,0.5005054", "l0.1693007,0.5007704", "l0.1600902,0.5019942", "l0.1579328,0.5018428", "l0.1567158,0.5015148", "l0.1556925,0.5012877", "l0.1540882,0.5013003", "l0.1520691,0.5016662", "l0.1500224,0.5022340", "l0.1491096,0.5026503", "l0.1479756,0.5033064", "l0.1470075,0.5035714", "l0.1456799,0.5036849", "l0.1413651,0.5038363", "l0.1391247,0.5038868", "l0.1366907,0.5043158", "l0.1355844,0.5045807", "l0.1305504,0.5059686", "l0.1245208,0.5084289", "l0.1239676,0.5090976", "l0.1237187,0.5100692", "l0.1244378,0.5106874", "l0.1256825,0.5112552", "l0.1266505,0.5118355", "l0.1273143,0.5125926", "l0.1276739,0.5139931", "l0.1270377,0.5150277", "l0.1262080,0.5156207", "l0.1216996,0.5180179", "l0.1175231,0.5189768", "l0.1153657,0.5192039", "l0.1134295,0.5191787", "l0.1117700,0.5190651", "l0.1100551,0.5188632", "l0.1089488,0.5186740", "l0.1062935,0.5180557", "l0.1026978,0.5173618", "l0.1006511,0.5171978", "l0.0878173,0.5166174", "l0.0863237,0.5166426", "l0.0863237,0.5166426", "l0.0873748,0.5149646", "l0.0867663,0.5136650", "l0.0835578,0.5104603", "l0.0817600,0.5080883", "l0.0827557,0.5073186", "l0.0842769,0.5067130", "l0.0853280,0.5062210", "l0.0863237,0.5055775", "l0.0873194,0.5043032", "l0.0872641,0.5034831", "l0.0874024,0.5022340", "l0.0903066,0.4985624", "l0.0913576,0.4986003", "l0.0924917,0.4991176", "l0.0935151,0.4989914", "l0.0942065,0.4984236", "l0.0961150,0.4963292", "l0.0958661,0.4952063", "l0.0941512,0.4946764", "l0.0933214,0.4953703", "l0.0897258,0.4936796", "l0.0883981,0.4924558", "l0.0897258,0.4897936", "l0.0918002,0.4890239", "l0.0959490,0.4877748", "l0.0976362,0.4848982", "l0.0958384,0.4820467", "l0.0940406,0.4782868", "l0.0938470,0.4753092", "l0.0948150,0.4737952", "c"]}, {"n": "Río Negro", "u": "AR-R", "i": ["m0.0913023,0.5466964", "l0.0911087,0.5450562", "l0.0904172,0.5432520", "l0.0898917,0.5424571", "l0.0867663,0.5395552", "l0.0835578,0.5360729", "l0.0835578,0.5352023", "l0.0846642,0.5346093", "l0.0867939,0.5329439", "l0.0859088,0.5293985", "l0.0846365,0.5280106", "l0.0843323,0.5270895", "l0.0851067,0.5251844", "l0.0859918,0.5243390", "l0.0862131,0.5236072", "l0.0872641,0.5180810", "l0.0863237,0.5166426", "l0.0863237,0.5166426", "l0.0878173,0.5166174", "l0.1006511,0.5171978", "l0.1026978,0.5173618", "l0.1062935,0.5180557", "l0.1089488,0.5186740", "l0.1100551,0.5188632", "l0.1117700,0.5190651", "l0.1134295,0.5191787", "l0.1153657,0.5192039", "l0.1175231,0.5189768", "l0.1216996,0.5180179", "l0.1262080,0.5156207", "l0.1270377,0.5150277", "l0.1276739,0.5139931", "l0.1273143,0.5125926", "l0.1266505,0.5118355", "l0.1256825,0.5112552", "l0.1244378,0.5106874", "l0.1237187,0.5100692", "l0.1239676,0.5090976", "l0.1245208,0.5084289", "l0.1305504,0.5059686", "l0.1355844,0.5045807", "l0.1366907,0.5043158", "l0.1391247,0.5038868", "l0.1413651,0.5038363", "l0.1456799,0.5036849", "l0.1470075,0.5035714", "l0.1479756,0.5033064", "l0.1491096,0.5026503", "l0.1500224,0.5022340", "l0.1520691,0.5016662", "l0.1540882,0.5013003", "l0.1556925,0.5012877", "l0.1567158,0.5015148", "l0.1579328,0.5018428", "l0.1600902,0.5019942", "l0.1693007,0.5007704", "l0.1704347,0.5005054", "l0.1753027,0.4976666", "l0.1762708,0.4968970", "l0.1799217,0.4918123", "l0.1799771,0.4896422", "l0.1793132,0.4891627", "l0.1788984,0.4885950", "l0.1789813,0.4879641", "l0.1801430,0.4862734", "l0.1811387,0.4853902", "l0.1822728,0.4847341", "l0.1837663,0.4842042", "l0.1852599,0.4838005", "l0.1916492,0.4824757", "l0.2003894,0.4808229", "l0.2021319,0.4805957", "l0.2047042,0.4804317", "l0.2060871,0.4800784", "l0.2111211,0.4781985", "l0.2120338,0.4777821", "l0.2128359,0.4773027", "l0.2137487,0.4763690", "l0.2145785,0.4755363", "l0.2156295,0.4748298", "l0.2168188,0.4742115", "l0.2182018,0.4737573", "l0.2229868,0.4723947", "l0.2251995,0.4723694", "l0.2267761,0.4722937", "l0.2309249,0.4713979", "l0.2325291,0.4708049", "l0.2353780,0.4685086", "l0.2392779,0.4657076", "l0.2403843,0.4651777", "l0.2456118,0.4633609", "l0.2464416,0.4628940", "l0.2469395,0.4623389", "l0.2477692,0.4611403", "l0.2489309,0.4603832", "l0.2524713,0.4589701", "l0.2542138,0.4587556", "l0.2555414,0.4586295", "l0.2669369,0.4559799", "l0.2670476,0.4404862", "l0.2671305,0.4158199", "l0.2671582,0.4152773", "l0.2671582,0.4152773", "l0.2695092,0.4152016", "l0.2764516,0.4154540", "l0.2840855,0.4158956", "l0.2851919,0.4160596", "l0.2880407,0.4165390", "l0.2897279,0.4169554", "l0.2910003,0.4174853", "l0.2920236,0.4181792", "l0.2933513,0.4193274", "l0.2941810,0.4204629", "l0.2940704,0.4218129", "l0.2931300,0.4229106", "l0.2923832,0.4235289", "l0.2915534,0.4238821", "l0.2902535,0.4241219", "l0.2890365,0.4243742", "l0.2863535,0.4256864", "l0.2858280,0.4266200", "l0.2861876,0.4286262", "l0.2883450,0.4298374", "l0.2905577,0.4296734", "l0.2920236,0.4298248", "l0.2932683,0.4302033", "l0.2944576,0.4307710", "l0.2952321,0.4313767", "l0.2958959,0.4321211", "l0.2963108,0.4329033", "l0.2973895,0.4336856", "l0.3000724,0.4348842", "l0.3011234,0.4352375", "l0.3024787,0.4354898", "l0.3036404,0.4355529", "l0.3118551,0.4351996", "l0.3133487,0.4349347", "l0.3152019,0.4344300", "l0.3161699,0.4340893", "l0.3171933,0.4340136", "l0.3211762,0.4343921", "l0.3223655,0.4364487", "l0.3229187,0.4377987", "l0.3259336,0.4395147", "l0.3268186,0.4398175", "l0.3313271,0.4409656", "l0.3347015,0.4415839", "l0.3387397,0.4420633", "l0.3400396,0.4422526", "l0.3465672,0.4437287", "l0.3480054,0.4442208", "l0.3494714,0.4449526", "l0.3501075,0.4454321", "l0.3506607,0.4460377", "l0.3507437,0.4472111", "l0.3517117,0.4481447", "l0.3607286,0.4493433", "l0.3658731,0.4489774", "l0.3675050,0.4486872", "l0.3702156,0.4487125", "l0.3733687,0.4488008", "l0.3766048,0.4489144", "l0.3804218,0.4491793", "l0.3876961,0.4501382", "l0.3910428,0.4509709", "l0.3962704,0.4516270", "l0.3977363,0.4512107", "l0.4005299,0.4504915", "l0.4019128,0.4504536", "l0.4052042,0.4507438", "l0.4087722,0.4513242", "l0.4102658,0.4518667", "l0.4112339,0.4521696", "l0.4173189,0.4517910", "l0.4189231,0.4515892", "l0.4206379,0.4512359", "l0.4216613,0.4511476", "l0.4280782,0.4510845", "l0.4398333,0.4514882", "l0.4526671,0.4525733", "l0.4552670,0.4526364", "l0.4571755,0.4526742", "l0.4605775,0.4531032", "l0.4623477,0.4533556", "l0.4672433,0.4541883", "l0.4695390,0.4546425", "l0.4720007,0.4552355", "l0.4807686,0.4575318", "l0.4860238,0.4598155", "l0.4947640,0.4627931", "l0.5047766,0.4660861", "l0.5065468,0.4664268", "l0.5078191,0.4665151", "l0.5106956,0.4664268", "l0.5106956,0.4664268", "l0.5107509,0.4685212", "l0.5107786,0.4771891", "l0.5107233,0.5059308", "l0.5110552,0.5075962", "l0.5120509,0.5078233", "l0.5177763,0.5082649", "l0.5202656,0.5083280", "l0.5216209,0.5084163", "l0.5241932,0.5087696", "l0.5256868,0.5091481", "l0.5300016,0.5105108", "l0.5338462,0.5122014", "l0.5348419,0.5127692", "l0.5381887,0.5149393", "l0.5394610,0.5158604", "l0.5409269,0.5170842", "l0.5415907,0.5177277", "l0.5415907,0.5177277", "l0.5301952,0.5201249", "l0.5293931,0.5204908", "l0.5283421,0.5208189", "l0.5270974,0.5209450", "l0.5230592,0.5211595", "l0.5118020,0.5211974", "l0.5081510,0.5210965", "l0.5019277,0.5211974", "l0.4961747,0.5213236", "l0.4949853,0.5213362", "l0.4913343,0.5212857", "l0.4897024,0.5211091", "l0.4880982,0.5207558", "l0.4863280,0.5202133", "l0.4846132,0.5193805", "l0.4835622,0.5188380", "l0.4821792,0.5183081", "l0.4803814,0.5179043", "l0.4768687,0.5173870", "l0.4725815,0.5169076", "l0.4650859,0.5150781", "l0.4557095,0.5132487", "l0.4545202,0.5131099", "l0.4438438,0.5112552", "l0.4425439,0.5102584", "l0.4411056,0.5082145", "l0.4397503,0.5079369", "l0.4357398,0.5075205", "l0.4344951,0.5074827", "l0.4331121,0.5075962", "l0.4307888,0.5079873", "l0.4234315,0.5116084", "l0.4216060,0.5142454", "l0.4209699,0.5160244", "l0.4215784,0.5190525", "l0.4218549,0.5197590", "l0.4233209,0.5231404", "l0.4266399,0.5296256", "l0.4276910,0.5304078", "l0.4287144,0.5308747", "l0.4297654,0.5312279", "l0.4303739,0.5319723", "l0.4301803,0.5332845", "l0.4299314,0.5338901", "l0.4292122,0.5348238", "l0.4286037,0.5357196", "l0.4285484,0.5370949", "l0.4289356,0.5380916", "l0.4293782,0.5387477", "l0.4302356,0.5396183", "l0.4295718,0.5409683", "l0.4287973,0.5418641", "l0.4263634,0.5444632", "l0.4259761,0.5454095", "l0.4261421,0.5461539", "l0.4268336,0.5470119", "l0.4268336,0.5470119", "l0.4232932,0.5466838", "l0.3848749,0.5467090", "l0.3498033,0.5466838", "l0.3147593,0.5466964", "l0.2679880,0.5466838", "l0.2379226,0.5467090", "l0.2162103,0.5467090", "l0.1844855,0.5466838", "l0.1511011,0.5467090", "l0.1494415,0.5466838", "l0.1177167,0.5466838", "l0.1093637,0.5467090", "c"]}, {"n": "Salta", "u": "AR-A", "i": ["m0.5101978,0.0963059", "l0.4838387,0.0961292", "l0.4765368,0.0950568", "l0.4719730,0.0943629", "l0.4702305,0.0940853", "l0.4585861,0.1057560", "l0.4562627,0.1093393", "l0.4556819,0.1104874", "l0.4556819,0.1104874", "l0.4552670,0.1105505", "l0.4449225,0.1106010", "l0.4432630,0.1104622", "l0.4416311,0.1102603", "l0.4396673,0.1102856", "l0.4384503,0.1104622", "l0.4371780,0.1108155", "l0.4360163,0.1113706", "l0.4346887,0.1117239", "l0.4330568,0.1119005", "l0.4318398,0.1117744", "l0.4271101,0.1111309", "l0.4163231,0.1091374", "l0.4153827,0.1076991", "l0.4143594,0.1068916", "l0.4130317,0.1067654", "l0.4119254,0.1070178", "l0.4102658,0.1075350", "l0.4089935,0.1078883", "l0.4078318,0.1079766", "l0.4022171,0.1074215", "l0.3967129,0.1067906", "l0.3957725,0.1072449", "l0.3955789,0.1080019", "l0.3956895,0.1090365", "l0.3948874,0.1119510", "l0.3938640,0.1125566", "l0.3803665,0.1116482", "l0.3774899,0.1113706", "l0.3722071,0.1107272", "l0.3722071,0.1107272", "l0.3663987,0.1107019", "l0.3650434,0.1109921", "l0.3641583,0.1115977", "l0.3630243,0.1127964", "l0.3624987,0.1135155", "l0.3617796,0.1143104", "l0.3610328,0.1146889", "l0.3600094,0.1147520", "l0.3589307,0.1144997", "l0.3580180,0.1141085", "l0.3542840,0.1123169", "l0.3533713,0.1116987", "l0.3523479,0.1106767", "l0.3510756,0.1092888", "l0.3488352,0.1073584", "l0.3468438,0.1060336", "l0.3417268,0.1030055", "l0.3410354,0.1026396", "l0.3404269,0.1022359", "l0.3399290,0.1017943", "l0.3392929,0.1008102", "l0.3389609,0.1000279", "l0.3389056,0.0993087", "l0.3390716,0.0983625", "l0.3396248,0.0978704", "l0.3426672,0.0967222", "l0.3465948,0.0966718", "l0.3508266,0.0965582", "l0.3520990,0.0963059", "l0.3541457,0.0956246", "l0.3550585,0.0951073", "l0.3563308,0.0918394", "l0.3526245,0.0870576", "l0.3511862,0.0864772", "l0.3401226,0.0865781", "l0.3238038,0.0866791", "l0.3067659,0.0867674", "l0.2893407,0.0868431", "l0.2606307,0.0843197", "l0.2560116,0.0839033", "l0.2553202,0.0838024", "l0.2553202,0.0838024", "l0.2586116,0.0835627", "l0.2618477,0.0827678", "l0.2546010,0.0770901", "l0.2521947,0.0764593", "l0.2510607,0.0750462", "l0.2512266,0.0742639", "l0.2525819,0.0729517", "l0.2542138,0.0714629", "l0.2564542,0.0698227", "l0.2601052,0.0673119", "l0.2613498,0.0669586", "l0.2636732,0.0671353", "l0.2657753,0.0658988", "l0.2669646,0.0646750", "l0.2701454,0.0640063", "l0.2847217,0.0610665", "l0.2976937,0.0584295", "l0.3129338,0.0552879", "l0.3171933,0.0481214", "l0.3171933,0.0481214", "l0.3176912,0.0484368", "l0.3188805,0.0489415", "l0.3228911,0.0502789", "l0.3248549,0.0503798", "l0.3262101,0.0507584", "l0.3296675,0.0524995", "l0.3331526,0.0544552", "l0.3367759,0.0562720", "l0.3377163,0.0564991", "l0.3440502,0.0578239", "l0.3454331,0.0580889", "l0.3478118,0.0583538", "l0.3537308,0.0587197", "l0.3549755,0.0578618", "l0.3609222,0.0491686", "l0.3613924,0.0481466", "l0.3614200,0.0470489", "l0.3613371,0.0462667", "l0.3607009,0.0450176", "l0.3595392,0.0434909", "l0.3594839,0.0427465", "l0.3596222,0.0420905", "l0.3605903,0.0402231", "l0.3612817,0.0393778", "l0.3630796,0.0390876", "l0.3669795,0.0396427", "l0.3713496,0.0403619", "l0.3744198,0.0411442", "l0.3784027,0.0423176", "l0.3801452,0.0430998", "l0.3806430,0.0436676", "l0.3805877,0.0478186", "l0.3794537,0.0483990", "l0.3787346,0.0491686", "l0.3785410,0.0513261", "l0.3798963,0.0534584", "l0.3821366,0.0546696", "l0.3831600,0.0545687", "l0.3841004,0.0542280", "l0.3856217,0.0544047", "l0.3915130,0.0564234", "l0.3922598,0.0570669", "l0.3920939,0.0578491", "l0.3919279,0.0584800", "l0.3920662,0.0590225", "l0.3925641,0.0595272", "l0.4006682,0.0648516", "l0.4033511,0.0656212", "l0.4140274,0.0670343", "l0.4157146,0.0672362", "l0.4238740,0.0673624", "l0.4264740,0.0682834", "l0.4280229,0.0687503", "l0.4328356,0.0696082", "l0.4344121,0.0696461", "l0.4352142,0.0693180", "l0.4359334,0.0685484", "l0.4364589,0.0678418", "l0.4371504,0.0670470", "l0.4379801,0.0664413", "l0.4390035,0.0660250", "l0.4433460,0.0676526", "l0.4446459,0.0682708", "l0.4461119,0.0689774", "l0.4486012,0.0700120", "l0.4490437,0.0700877", "l0.4507862,0.0687124", "l0.4518649,0.0679428", "l0.4529436,0.0673876", "l0.4538564,0.0670343", "l0.4594988,0.0653437", "l0.4623200,0.0651670", "l0.4637030,0.0651670", "l0.4649200,0.0648642", "l0.4662476,0.0642207", "l0.4669391,0.0638296", "l0.4695114,0.0621642", "l0.4710879,0.0609151", "l0.4718624,0.0599814", "l0.4721390,0.0591739", "l0.4718071,0.0575085", "l0.4716411,0.0560575", "l0.4713092,0.0513387", "l0.4713369,0.0506070", "l0.4712262,0.0476293", "l0.4709773,0.0425194", "l0.4614626,0.0424311", "l0.4599967,0.0435540", "l0.4563180,0.0445634", "l0.4540777,0.0432260", "l0.4522522,0.0424690", "l0.4463608,0.0410685", "l0.4425439,0.0414596", "l0.4417694,0.0417876", "l0.4409673,0.0421914", "l0.4394461,0.0425068", "l0.4359057,0.0418255", "l0.4356291,0.0407152", "l0.4330292,0.0381539", "l0.4320888,0.0374221", "l0.4312313,0.0371320", "l0.4298207,0.0369806", "l0.4282718,0.0366273", "l0.4277463,0.0358955", "l0.4286314,0.0343941", "l0.4291846,0.0335866", "l0.4294335,0.0326403", "l0.4295995,0.0318202", "l0.4295441,0.0311262", "l0.4288527,0.0303566", "l0.4277186,0.0298393", "l0.4264187,0.0297131", "l0.4253676,0.0296627", "l0.4232379,0.0296627", "l0.4218549,0.0296753", "l0.4205550,0.0295491", "l0.4195592,0.0292337", "l0.4181486,0.0284262", "l0.4164338,0.0259911", "l0.4155763,0.0232658", "l0.4132253,0.0192158", "l0.4129764,0.0180045", "l0.4133360,0.0174746", "l0.4139721,0.0170709", "l0.4146359,0.0165283", "l0.4180380,0.0131217", "l0.4179827,0.0120114", "l0.4181210,0.0108633", "l0.4187848,0.0095511", "l0.4204443,0.0076964", "l0.4204443,0.0076964", "l0.4305399,0.0075955", "l0.4314803,0.0080118", "l0.4442034,0.0098413", "l0.4458076,0.0096773", "l0.4503714,0.0105983", "l0.4526671,0.0117717", "l0.4529990,0.0124026", "l0.4536904,0.0154054", "l0.4569265,0.0180045", "l0.4578116,0.0196195", "l0.4572584,0.0204901", "l0.4573691,0.0211966", "l0.4591946,0.0221681", "l0.4618775,0.0234803", "l0.4624030,0.0242247", "l0.4626243,0.0253855", "l0.4626243,0.0260920", "l0.4631222,0.0267607", "l0.4642009,0.0265336", "l0.4649476,0.0258397", "l0.4658327,0.0239093", "l0.4657221,0.0232532", "l0.4660263,0.0212345", "l0.4673816,0.0193167", "l0.4678242,0.0188751", "l0.4688752,0.0179667", "l0.4700646,0.0175251", "l0.4714199,0.0169195", "l0.4737155,0.0154433", "l0.4804090,0.0076838", "l0.4830090,0.0054001", "l0.4934364,0.0054379", "l0.5004341,0.0054506", "l0.5236400,0.0053875", "l0.5393227,0.0053118", "l0.5401524,0.0057912", "l0.5405397,0.0068132", "l0.5405397,0.0076712", "l0.5405673,0.0082011", "l0.5419226,0.0091726", "l0.5473438,0.0111661", "l0.5480076,0.0112292", "l0.5493076,0.0121376", "l0.5541479,0.0144717", "l0.5605924,0.0165914", "l0.5620584,0.0168690", "l0.5631647,0.0169195", "l0.5631647,0.0169195", "l0.5631924,0.0172727", "l0.5633307,0.0252972", "l0.5633583,0.0348230", "l0.5632477,0.0526635", "l0.5632477,0.0576851", "l0.5632477,0.0576851", "l0.5634137,0.0613567", "l0.5635243,0.0645740", "l0.5479246,0.0740747", "l0.5255485,0.0872973", "l0.5241932,0.0880670", "c"]}, {"n": "Santa Cruz", "u": "AR-Z", "i": ["m0.3043042,0.7740808", "l0.3016766,0.7752794", "l0.3004320,0.7760364", "l0.2977767,0.7787364", "l0.2989937,0.7805785", "l0.2957853,0.7831272", "l0.2933789,0.7845277", "l0.2912768,0.7856632", "l0.2901428,0.7861174", "l0.2882897,0.7880983", "l0.2935725,0.7878207", "l0.2948172,0.7868871", "l0.2952874,0.7859029", "l0.2971682,0.7836823", "l0.2984129,0.7834174", "l0.2994086,0.7838211", "l0.2968640,0.7895366", "l0.2952044,0.7928802", "l0.2937385,0.7967031", "l0.2932406,0.7993779", "l0.2928257,0.8011317", "l0.2920236,0.8032009", "l0.2913875,0.8046266", "l0.2909449,0.8053963", "l0.2902811,0.8063173", "l0.2891748,0.8070491", "l0.2858833,0.8087272", "l0.2848046,0.8092192", "l0.2809877,0.8107711", "l0.2793835,0.8113894", "l0.2775580,0.8120202", "l0.2765899,0.8123230", "l0.2707539,0.8135847", "l0.2696199,0.8138118", "l0.2674624,0.8140515", "l0.2659689,0.8140894", "l0.2648902,0.8140894", "l0.2630647,0.8140011", "l0.2584180,0.8121338", "l0.2542968,0.8089543", "l0.2499820,0.8071879", "l0.2492905,0.8079197", "l0.2449757,0.8088155", "l0.2431225,0.8087398", "l0.2379226,0.8086010", "l0.2368993,0.8086136", "l0.2322802,0.8091688", "l0.2312568,0.8093328", "l0.2294313,0.8100646", "l0.2341334,0.8098248", "l0.2354333,0.8094463", "l0.2373695,0.8091057", "l0.2388631,0.8091183", "l0.2404673,0.8093580", "l0.2461927,0.8094463", "l0.2472714,0.8093328", "l0.2487097,0.8090173", "l0.2503692,0.8090173", "l0.2519734,0.8096356", "l0.2528032,0.8105945", "l0.2534670,0.8117552", "l0.2541585,0.8122978", "l0.2552095,0.8127015", "l0.2561223,0.8130170", "l0.2607137,0.8144301", "l0.2609626,0.8152249", "l0.2597732,0.8161586", "l0.2584456,0.8166507", "l0.2573669,0.8169030", "l0.2558457,0.8171932", "l0.2522223,0.8177610", "l0.2470778,0.8186063", "l0.2409928,0.8200068", "l0.2385588,0.8206124", "l0.2369822,0.8211171", "l0.2358482,0.8215965", "l0.2325291,0.8235269", "l0.2316441,0.8241199", "l0.2261952,0.8283340", "l0.2255038,0.8290154", "l0.2244251,0.8308953", "l0.2222677,0.8362954", "l0.2222953,0.8384529", "l0.2226549,0.8405095", "l0.2223783,0.8412665", "l0.2209400,0.8422380", "l0.2172061,0.8442820", "l0.2139700,0.8455815", "l0.2128636,0.8460736", "l0.2106232,0.8472975", "l0.2092403,0.8484330", "l0.2112041,0.8474615", "l0.2144125,0.8459222", "l0.2199166,0.8443451", "l0.2214102,0.8457456", "l0.2223783,0.8472218", "l0.2224060,0.8483573", "l0.2222953,0.8494424", "l0.2224889,0.8503382", "l0.2229315,0.8512466", "l0.2266654,0.8573911", "l0.2271910,0.8581481", "l0.2291547,0.8607851", "l0.2306760,0.8627155", "l0.2313675,0.8639141", "l0.2319206,0.8652137", "l0.2310632,0.8664249", "l0.2297909,0.8664123", "l0.2288505,0.8660716", "l0.2268314,0.8662356", "l0.2256421,0.8665763", "l0.2230144,0.8677875", "l0.2217975,0.8676992", "l0.2192528,0.8671945", "l0.2147168,0.8658697", "l0.2108168,0.8658193", "l0.2055063,0.8665511", "l0.1990341,0.8683048", "l0.2020489,0.8680903", "l0.2032106,0.8678759", "l0.2047319,0.8675478", "l0.2101530,0.8671314", "l0.2121998,0.8672198", "l0.2166805,0.8677749", "l0.2205805,0.8686833", "l0.2288782,0.8680525", "l0.2300675,0.8683174", "l0.2334419,0.8711310", "l0.2362908,0.8741339", "l0.2390843,0.8774396", "l0.2399971,0.8784363", "l0.2452246,0.8829911", "l0.2489309,0.8857037", "l0.2498160,0.8863220", "l0.2509500,0.8869654", "l0.2539372,0.8885426", "l0.2576158,0.8912426", "l0.2592477,0.8927062", "l0.2604924,0.8943338", "l0.2585839,0.8960119", "l0.2575329,0.8962137", "l0.2578371,0.8943843", "l0.2508394,0.8935137", "l0.2471607,0.8932109", "l0.2432055,0.8929333", "l0.2381439,0.8925548", "l0.2327781,0.8907253", "l0.2300122,0.8898169", "l0.2279378,0.8893879", "l0.2178699,0.8874827", "l0.2151593,0.8875080", "l0.2064467,0.8874954", "l0.1912066,0.8844042", "l0.1823281,0.8825621", "l0.1795622,0.8820322", "l0.1739474,0.8820322", "l0.1576839,0.8820700", "l0.1176890,0.8820700", "l0.0945661,0.8820574", "l0.0837514,0.8820069", "l0.0821472,0.8789915", "l0.0821472,0.8777676", "l0.0812898,0.8767961", "l0.0749005,0.8734652", "l0.0724666,0.8725694", "l0.0711942,0.8721404", "l0.0701709,0.8718376", "l0.0688156,0.8715474", "l0.0663263,0.8713455", "l0.0647774,0.8709544", "l0.0591902,0.8642548", "l0.0607668,0.8637122", "l0.0618455,0.8631949", "l0.0637540,0.8600659", "l0.0635604,0.8586149", "l0.0636433,0.8568612", "l0.0646114,0.8558770", "l0.0661050,0.8551831", "l0.0667688,0.8541864", "l0.0647220,0.8529625", "l0.0628965,0.8525209", "l0.0616519,0.8520793", "l0.0604349,0.8513223", "l0.0594668,0.8494676", "l0.0625370,0.8467928", "l0.0651369,0.8466540", "l0.0659667,0.8459348", "l0.0671284,0.8402950", "l0.0665475,0.8394623", "l0.0652199,0.8383520", "l0.0641135,0.8376202", "l0.0625093,0.8367370", "l0.0623157,0.8358538", "l0.0642242,0.8339108", "l0.0645561,0.8330276", "l0.0607115,0.8316397", "l0.0546542,0.8312360", "l0.0532989,0.8313369", "l0.0520819,0.8316271", "l0.0509755,0.8322579", "l0.0498692,0.8332673", "l0.0488734,0.8336080", "l0.0472416,0.8337089", "l0.0456373,0.8334187", "l0.0446416,0.8330150", "l0.0437565,0.8324724", "l0.0423459,0.8318668", "l0.0408800,0.8318668", "l0.0355418,0.8330780", "l0.0338823,0.8335449", "l0.0328865,0.8339739", "l0.0299823,0.8357907", "l0.0282675,0.8364973", "l0.0265526,0.8369389", "l0.0249761,0.8371912", "l0.0237038,0.8373300", "l0.0222931,0.8372291", "l0.0212421,0.8368379", "l0.0203294,0.8361440", "l0.0177018,0.8310593", "l0.0166784,0.8275518", "l0.0158209,0.8223662", "l0.0152678,0.8214073", "l0.0132763,0.8192119", "l0.0125295,0.8185937", "l0.0116998,0.8181142", "l0.0073020,0.8165119", "l0.0029872,0.8149852", "l0.0022957,0.8139758", "l0.0028765,0.8128277", "l0.0040382,0.8117174", "l0.0054212,0.8108468", "l0.0056148,0.8097744", "l0.0046191,0.8091435", "l0.0033744,0.8086010", "l0.0014106,0.8076169", "l0.0026553,0.8045004", "l0.0040382,0.8037434", "l0.0058084,0.8029738", "l0.0068041,0.8023177", "l0.0033467,0.7957695", "l0.0006638,0.7941545", "l0.0000000,0.7935110", "l0.0021297,0.7900918", "l0.0058914,0.7854739", "l0.0079658,0.7854109", "l0.0223485,0.7852216", "l0.0248378,0.7839347", "l0.0207719,0.7834174", "l0.0204123,0.7830767", "l0.0203017,0.7823449", "l0.0253080,0.7769827", "l0.0288483,0.7745728", "l0.0300377,0.7738789", "l0.0315866,0.7733994", "l0.0333844,0.7730462", "l0.0343801,0.7729200", "l0.0363716,0.7729578", "l0.0386396,0.7727434", "l0.0401332,0.7724784", "l0.0414332,0.7721251", "l0.0423459,0.7718349", "l0.0437565,0.7712798", "l0.0498692,0.7685419", "l0.0511691,0.7676713", "l0.0516117,0.7668890", "l0.0516117,0.7653119", "l0.0511415,0.7625740", "l0.0505330,0.7603534", "l0.0502287,0.7595712", "l0.0490117,0.7571361", "l0.0494266,0.7564169", "l0.0503117,0.7558618", "l0.0513627,0.7555211", "l0.0546818,0.7546884", "l0.0579179,0.7540954", "l0.0646391,0.7521145", "l0.0642242,0.7467270", "l0.0631455,0.7429040", "l0.0588860,0.7405194", "l0.0567286,0.7402797", "l0.0553180,0.7398381", "l0.0534648,0.7389171", "l0.0526627,0.7382484", "l0.0524691,0.7373652", "l0.0564243,0.7321922", "l0.0578073,0.7307665", "l0.0590243,0.7297823", "l0.0615966,0.7279024", "l0.0622604,0.7272589", "l0.0627583,0.7265271", "l0.0638370,0.7234738", "l0.0621498,0.7229565", "l0.0612647,0.7225528", "l0.0617349,0.7216065", "l0.0624540,0.7211144", "l0.0635604,0.7207990", "l0.0645837,0.7205971", "l0.0664369,0.7202943", "l0.0677645,0.7202817", "l0.0695347,0.7205467", "l0.0713049,0.7202943", "l0.0752048,0.7183387", "l0.0784132,0.7158026", "l0.0851344,0.7143012", "l0.0858812,0.7138344", "l0.0866556,0.7122951", "l0.0861578,0.7111848", "l0.0846365,0.7103773", "l0.0804600,0.7076647", "l0.0823132,0.7003846", "l0.0834195,0.6998421", "l0.0867663,0.6997285", "l0.0885918,0.6993753", "l0.0949810,0.6966121", "l0.0956725,0.6959813", "l0.0959767,0.6949467", "l0.0957831,0.6911616", "l0.0948150,0.6895844", "l0.0930448,0.6875909", "l0.0922427,0.6823422", "l0.0919661,0.6815348", "l0.0909428,0.6806894", "l0.0892556,0.6803109", "l0.0875407,0.6800207", "l0.0841940,0.6783174", "l0.0867386,0.6777623", "l0.0880662,0.6776992", "l0.0896428,0.6775352", "l0.0909981,0.6772576", "l0.0922704,0.6765889", "l0.0932661,0.6756552", "l0.0943172,0.6748730", "l0.0960044,0.6738257", "l0.0970554,0.6733968", "l0.0970554,0.6733968", "l0.1026978,0.6734220", "l0.1243825,0.6734220", "l0.1343674,0.6733968", "l0.1694666,0.6733968", "l0.1862003,0.6734220", "l0.1995320,0.6734220", "l0.2012192,0.6733968", "l0.2496224,0.6733968", "l0.2512819,0.6734220", "l0.2980256,0.6733968", "l0.3004873,0.6734220", "l0.3004873,0.6734220", "l0.2988001,0.6757562", "l0.2986618,0.6776866", "l0.2987724,0.6792385", "l0.2992426,0.6803740", "l0.3006256,0.6833895", "l0.3010405,0.6841213", "l0.3030319,0.6873260", "l0.3045808,0.6886508", "l0.3074020,0.6907073", "l0.3094765,0.6921331", "l0.3118551,0.6935588", "l0.3128232,0.6940382", "l0.3193231,0.6964607", "l0.3207890,0.6968140", "l0.3247719,0.6984542", "l0.3320739,0.7021889", "l0.3388503,0.7061506", "l0.3430268,0.7075763", "l0.3443268,0.7079170", "l0.3463459,0.7081315", "l0.3477288,0.7081946", "l0.3487246,0.7081819", "l0.3509649,0.7080684", "l0.3545053,0.7080432", "l0.3613094,0.7085605", "l0.3622498,0.7091282", "l0.3693858,0.7096455", "l0.3748347,0.7095698", "l0.3771580,0.7090021", "l0.3791771,0.7087497", "l0.3803941,0.7087623", "l0.3851515,0.7099105", "l0.3911258,0.7130395", "l0.3932555,0.7175943", "l0.3932555,0.7182756", "l0.3931172,0.7195625", "l0.3926747,0.7219598", "l0.3921215,0.7245210", "l0.3906279,0.7270570", "l0.3863685,0.7319272", "l0.3854834,0.7322931", "l0.3833260,0.7323436", "l0.3814175,0.7320408", "l0.3797856,0.7319903", "l0.3783750,0.7321796", "l0.3774069,0.7324698", "l0.3765772,0.7329114", "l0.3753325,0.7336179", "l0.3741708,0.7340343", "l0.3713220,0.7342235", "l0.3683901,0.7348039", "l0.3676710,0.7354852", "l0.3692475,0.7349301", "l0.3707411,0.7347661", "l0.3735070,0.7346525", "l0.3810026,0.7329240", "l0.3820260,0.7329744", "l0.3846536,0.7337693", "l0.3904620,0.7379582", "l0.3904067,0.7390685", "l0.3884705,0.7393082", "l0.3872259,0.7390559", "l0.3856770,0.7386016", "l0.3842111,0.7383998", "l0.3815005,0.7389423", "l0.3825515,0.7419325", "l0.3816664,0.7433961", "l0.3764942,0.7436611", "l0.3657625,0.7485691", "l0.3630519,0.7499191", "l0.3592903,0.7519000", "l0.3564691,0.7538430", "l0.3523202,0.7541837", "l0.3478118,0.7550038", "l0.3465672,0.7552940", "l0.3454055,0.7558239", "l0.3422247,0.7577291", "l0.3384907,0.7597604", "l0.3357802,0.7600254", "l0.3341206,0.7602272", "l0.3328760,0.7604291", "l0.3314377,0.7607193", "l0.3265974,0.7618548", "l0.3253251,0.7622334", "l0.3235272,0.7632049", "l0.3194890,0.7664727", "l0.3175252,0.7684914", "l0.3155061,0.7688952", "l0.3140955,0.7692106", "l0.3128509,0.7696017", "l0.3095041,0.7709517", "l0.3053829,0.7733868", "c"]}, {"n": "Santiago del Estero", "u": "AR-G", "i": ["m0.4214954,0.1536125", "l0.4250910,0.1533854", "l0.4263634,0.1530447", "l0.4298484,0.1502690", "l0.4283548,0.1483512", "l0.4273314,0.1473797", "l0.4266676,0.1466857", "l0.4264463,0.1458278", "l0.4268336,0.1423455", "l0.4274974,0.1417398", "l0.4330292,0.1388632", "l0.4344121,0.1386613", "l0.4356015,0.1385604", "l0.4380908,0.1363271", "l0.4392524,0.1349897", "l0.4420183,0.1308513", "l0.4443694,0.1285677", "l0.4466374,0.1251989", "l0.4485182,0.1251484", "l0.4506480,0.1220951", "l0.4542436,0.1222087", "l0.4552117,0.1220573", "l0.4552117,0.1210605", "l0.4551287,0.1203413", "l0.4546032,0.1186885", "l0.4539117,0.1167833", "l0.4537458,0.1159380", "l0.4540777,0.1153198", "l0.4549074,0.1142599", "l0.4556819,0.1131875", "l0.4559585,0.1125188", "l0.4559585,0.1119005", "l0.4556819,0.1104874", "l0.4556819,0.1104874", "l0.4562627,0.1093393", "l0.4585861,0.1057560", "l0.4702305,0.0940853", "l0.4719730,0.0943629", "l0.4765368,0.0950568", "l0.4838387,0.0961292", "l0.5101978,0.0963059", "l0.5101978,0.0963059", "l0.5253549,0.0963690", "l0.5301399,0.0963942", "l0.5428630,0.0964194", "l0.5715454,0.0964194", "l0.5839643,0.0963942", "l0.5925939,0.0963563", "l0.5945024,0.0963690", "l0.5945577,0.0968736", "l0.5947790,0.1103739", "l0.5948619,0.1254891", "l0.5948066,0.1413361", "l0.5948343,0.1546345", "l0.5947790,0.1559466", "l0.5947790,0.1559466", "l0.5930364,0.1612206", "l0.5927875,0.1620911", "l0.5900493,0.1704184", "l0.5862600,0.1818494", "l0.5835494,0.1898612", "l0.5806176,0.1982768", "l0.5758879,0.2120420", "l0.5758879,0.2120420", "l0.5723752,0.2079289", "l0.5673136,0.2018727", "l0.5485884,0.2020241", "l0.5204039,0.2021881", "l0.5176933,0.2021629", "l0.5105850,0.2019231", "l0.5096169,0.2005731", "l0.5072659,0.1994376", "l0.5049979,0.1989329", "l0.5001022,0.1984408", "l0.4983874,0.1984408", "l0.4968938,0.1986049", "l0.4955938,0.1987689", "l0.4940172,0.1988572", "l0.4926343,0.1988698", "l0.4912237,0.1988572", "l0.4892599,0.1987058", "l0.4797176,0.1964221", "l0.4778091,0.1951983", "l0.4778644,0.1943655", "l0.4664966,0.1927632", "l0.4368738,0.1962329", "l0.4358504,0.1963338", "l0.4358504,0.1963338", "l0.4355738,0.1961824", "l0.4347440,0.1956651", "l0.4302909,0.1917790", "l0.4280782,0.1893061", "l0.4276357,0.1885238", "l0.4273038,0.1875397", "l0.4264187,0.1831616", "l0.4262251,0.1798181", "l0.4254506,0.1749731", "l0.4249527,0.1739764", "l0.4237358,0.1733582", "l0.4225188,0.1730680", "l0.4209975,0.1728156", "l0.4209145,0.1721469", "l0.4209145,0.1714530", "l0.4233209,0.1701030", "l0.4250081,0.1692829", "l0.4259761,0.1684375", "l0.4263080,0.1672010", "l0.4263634,0.1665576", "l0.4263357,0.1654977", "l0.4260868,0.1634538", "l0.4259761,0.1628734", "l0.4252017,0.1609682", "l0.4233209,0.1566910", "l0.4217443,0.1538396", "c"]}, {"n": "Santa Fe", "u": "AR-S", "i": ["m0.6656966,0.2949360", "l0.6668859,0.2955542", "l0.6662774,0.2965636", "l0.6629584,0.2985066", "l0.6596393,0.3007020", "l0.6595287,0.3015473", "l0.6591138,0.3025819", "l0.6586436,0.3031749", "l0.6564862,0.3050296", "l0.6533330,0.3054838", "l0.6521714,0.3054586", "l0.6511756,0.3053072", "l0.6500416,0.3048656", "l0.6492672,0.3044745", "l0.6478842,0.3039445", "l0.6468332,0.3036670", "l0.6380653,0.3029226", "l0.6366823,0.3029856", "l0.6354653,0.3031371", "l0.6344419,0.3034020", "l0.6337228,0.3038562", "l0.6335292,0.3044492", "l0.6340271,0.3053703", "l0.6140573,0.3157793", "l0.5947513,0.3256080", "l0.5858174,0.3256585", "l0.5647690,0.3257342", "l0.5374695,0.3257594", "l0.5374695,0.3257594", "l0.5381057,0.3252421", "l0.5435268,0.3212930", "l0.5642158,0.3059507", "l0.5834941,0.2915420", "l0.5855409,0.2902172", "l0.5875323,0.2902046", "l0.5898833,0.2895359", "l0.5910727,0.2889303", "l0.5919854,0.2881732", "l0.5923173,0.2875045", "l0.5936726,0.2834797", "l0.5932301,0.2825334", "l0.5886387,0.2792151", "l0.5866749,0.2764520", "l0.5855132,0.2744585", "l0.5846558,0.2734996", "l0.5835494,0.2728183", "l0.5823048,0.2723262", "l0.5808941,0.2718973", "l0.5797325,0.2714809", "l0.5785984,0.2707996", "l0.5779346,0.2699164", "l0.5775751,0.2687682", "l0.5768283,0.2678724", "l0.5758049,0.2673299", "l0.5749475,0.2670523", "l0.5731496,0.2666864", "l0.5693603,0.2646551", "l0.5692220,0.2630275", "l0.5694433,0.2622074", "l0.5696093,0.2588134", "l0.5690008,0.2567316", "l0.5680051,0.2535899", "l0.5736475,0.2514198", "l0.5828303,0.2358251", "l0.5879195,0.2271320", "l0.5799261,0.2257189", "l0.5707710,0.2227791", "l0.5711029,0.2198646", "l0.5732326,0.2198015", "l0.5758879,0.2120420", "l0.5758879,0.2120420", "l0.5806176,0.1982768", "l0.5835494,0.1898612", "l0.5862600,0.1818494", "l0.5900493,0.1704184", "l0.5927875,0.1620911", "l0.5930364,0.1612206", "l0.5947790,0.1559466", "l0.5947790,0.1559466", "l0.6065340,0.1559845", "l0.6212210,0.1559971", "l0.6607733,0.1559971", "l0.6744645,0.1559593", "l0.6976981,0.1559593", "l0.7377206,0.1559214", "l0.7377206,0.1559214", "l0.7376930,0.1563125", "l0.7374994,0.1568172", "l0.7370568,0.1573724", "l0.7360058,0.1584574", "l0.7346781,0.1590000", "l0.7334335,0.1592271", "l0.7323824,0.1592271", "l0.7306123,0.1591135", "l0.7286485,0.1595551", "l0.7276251,0.1600724", "l0.7270719,0.1605519", "l0.7267953,0.1615486", "l0.7269060,0.1626589", "l0.7276251,0.1657753", "l0.7276251,0.1668982", "l0.7263251,0.1722479", "l0.7256890,0.1731815", "l0.7212082,0.1817863", "l0.7205720,0.1826191", "l0.7120254,0.1866691", "l0.7106425,0.1870476", "l0.7070468,0.1875776", "l0.7060511,0.1879308", "l0.7017086,0.1921323", "l0.7012384,0.1927884", "l0.7013214,0.1944791", "l0.7011001,0.1966745", "l0.7007129,0.1983273", "l0.6999938,0.1997530", "l0.6988321,0.2015446", "l0.6978917,0.2025918", "l0.6975874,0.2032227", "l0.6974768,0.2041437", "l0.6981959,0.2052540", "l0.6995789,0.2059858", "l0.7009342,0.2067807", "l0.7018193,0.2074999", "l0.7020129,0.2084840", "l0.6989151,0.2130766", "l0.6969789,0.2150827", "l0.6979470,0.2168112", "l0.6979470,0.2168112", "l0.6981683,0.2171267", "l0.7003533,0.2187290", "l0.7013491,0.2193094", "l0.7016256,0.2202305", "l0.7016810,0.2234226", "l0.7012108,0.2247852", "l0.6962045,0.2289362", "l0.6935769,0.2309550", "l0.6929131,0.2313966", "l0.6911429,0.2324564", "l0.6864685,0.2357873", "l0.6837579,0.2379700", "l0.6810750,0.2396986", "l0.6787240,0.2404682", "l0.6772857,0.2415280", "l0.6763730,0.2425626", "l0.6757645,0.2434584", "l0.6750453,0.2442659", "l0.6731922,0.2456286", "l0.6630690,0.2509782", "l0.6607180,0.2521137", "l0.6587542,0.2527824", "l0.6556564,0.2529969", "l0.6539415,0.2530474", "l0.6508990,0.2531988", "l0.6489906,0.2534638", "l0.6479119,0.2539937", "l0.6449524,0.2652481", "l0.6464460,0.2696767", "l0.6442056,0.2722127", "l0.6431545,0.2741683", "l0.6433205,0.2774109", "l0.6450907,0.2824451", "l0.6454779,0.2833157", "l0.6459757,0.2839718", "l0.6536373,0.2909490", "l0.6545777,0.2912770", "l0.6575649,0.2918196", "l0.6616307,0.2927911", "l0.6630413,0.2932074", "l0.6653370,0.2946584", "c"]}, {"n": "San Juan", "u": "AR-J", "i": ["m0.1672263,0.2693234", "l0.1637689,0.2686294", "l0.1633817,0.2681248", "l0.1636029,0.2671280", "l0.1619987,0.2633303", "l0.1641008,0.2622831", "l0.1662029,0.2621317", "l0.1678348,0.2600625", "l0.1675582,0.2593433", "l0.1652072,0.2580942", "l0.1642391,0.2578419", "l0.1607541,0.2579428", "l0.1588456,0.2577536", "l0.1579052,0.2574760", "l0.1571031,0.2569461", "l0.1564669,0.2565045", "l0.1500777,0.2493254", "l0.1504649,0.2484296", "l0.1510458,0.2468020", "l0.1514053,0.2428907", "l0.1528436,0.2391308", "l0.1533691,0.2385504", "l0.1568541,0.2368345", "l0.1579052,0.2373392", "l0.1613349,0.2367966", "l0.1646816,0.2351060", "l0.1648752,0.2342102", "l0.1630498,0.2331756", "l0.1628561,0.2325068", "l0.1630774,0.2314344", "l0.1636306,0.2296806", "l0.1659816,0.2258072", "l0.1668114,0.2247348", "l0.1688581,0.2226656", "l0.1727581,0.2194987", "l0.1768793,0.2183253", "l0.1779856,0.2184010", "l0.1795622,0.2183253", "l0.1825493,0.2177323", "l0.1845408,0.2164832", "l0.1879152,0.2129378", "l0.1880258,0.2117140", "l0.1873897,0.2110957", "l0.1863110,0.2106668", "l0.1832408,0.2079289", "l0.1835451,0.2072475", "l0.1840982,0.2057840", "l0.1842089,0.2026675", "l0.1837663,0.2005984", "l0.1836280,0.2004091", "l0.1819685,0.1999170", "l0.1813323,0.1995007", "l0.1810281,0.1988950", "l0.1812770,0.1982011", "l0.1816366,0.1974567", "l0.1814706,0.1962959", "l0.1812217,0.1957660", "l0.1793132,0.1928515", "l0.1780133,0.1915645", "l0.1777367,0.1909715", "l0.1780133,0.1893818", "l0.1814706,0.1870350", "l0.1844025,0.1854200", "l0.1875833,0.1852560", "l0.1891875,0.1847640", "l0.1898513,0.1842971", "l0.1901556,0.1836537", "l0.1900449,0.1822406", "l0.1916215,0.1788592", "l0.1933364,0.1765503", "l0.1930321,0.1756797", "l0.1925066,0.1750993", "l0.1921747,0.1745189", "l0.1922023,0.1732320", "l0.1944427,0.1711880", "l0.1960469,0.1707969", "l0.1963788,0.1699137", "l0.1967384,0.1662800", "l0.1967384,0.1662800", "l0.2074701,0.1679328", "l0.2121445,0.1682861", "l0.2217421,0.1719198", "l0.2232357,0.1737619", "l0.2240655,0.1755409", "l0.2277995,0.1774208", "l0.2338568,0.1800452", "l0.2350461,0.1844990", "l0.2343823,0.1861518", "l0.2335802,0.1866818", "l0.2320313,0.1867827", "l0.2316164,0.1887762", "l0.2300952,0.1926496", "l0.2286569,0.1952487", "l0.2284356,0.1958543", "l0.2282420,0.1967502", "l0.2283526,0.1974819", "l0.2289058,0.1981128", "l0.2306760,0.1984030", "l0.2385588,0.1983399", "l0.2405779,0.1979866", "l0.2418502,0.1977343", "l0.2436204,0.1975450", "l0.2451416,0.1975072", "l0.2561223,0.1987815", "l0.2606307,0.1995511", "l0.2639221,0.2004091", "l0.2710581,0.2029830", "l0.2755389,0.2046737", "l0.2777793,0.2056199", "l0.2782771,0.2061120", "l0.2791345,0.2070961", "l0.2835876,0.2091401", "l0.2846387,0.2095817", "l0.2862982,0.2100107", "l0.2901981,0.2114238", "l0.2971405,0.2140860", "l0.2984129,0.2146285", "l0.2996299,0.2152594", "l0.3001830,0.2157262", "l0.3013724,0.2178837", "l0.3078446,0.2210758", "l0.3108041,0.2221735", "l0.3143998,0.2243184", "l0.3168614,0.2259586", "l0.3182444,0.2262362", "l0.3196826,0.2265642", "l0.3209273,0.2272834", "l0.3256846,0.2315732", "l0.3233060,0.2353205", "l0.3267633,0.2365443", "l0.3258782,0.2393074", "l0.3254080,0.2406575", "l0.3243570,0.2438370", "l0.3275101,0.2485053", "l0.3317419,0.2504483", "l0.3371908,0.2522399", "l0.3412013,0.2553563", "l0.3421970,0.2563026", "l0.3432757,0.2576905", "l0.3432757,0.2576905", "l0.3406481,0.2579176", "l0.3326270,0.2580942", "l0.3312164,0.2580816", "l0.3207060,0.2574255", "l0.3142615,0.2569839", "l0.3121317,0.2569334", "l0.3112190,0.2571984", "l0.3103339,0.2580311", "l0.3098637,0.2624092", "l0.3100573,0.2678850", "l0.3104169,0.2698785", "l0.3108594,0.2706482", "l0.3116892,0.2717080", "l0.3116892,0.2717080", "l0.3111913,0.2713547", "l0.3103339,0.2708248", "l0.3068765,0.2690080", "l0.3058808,0.2686799", "l0.3010958,0.2679229", "l0.2994362,0.2678977", "l0.2984129,0.2680238", "l0.2960895,0.2681121", "l0.2916917,0.2677967", "l0.2887046,0.2675570", "l0.2877088,0.2673173", "l0.2828132,0.2653490", "l0.2819558,0.2642639", "l0.2812090,0.2637088", "l0.2803515,0.2633303", "l0.2795494,0.2630275", "l0.2785537,0.2628256", "l0.2766729,0.2628508", "l0.2750134,0.2631536", "l0.2738793,0.2633177", "l0.2683199,0.2638981", "l0.2620689,0.2636079", "l0.2609349,0.2634817", "l0.2587775,0.2628761", "l0.2574776,0.2628256", "l0.2562052,0.2632546", "l0.2557350,0.2639359", "l0.2555138,0.2652607", "l0.2545734,0.2658537", "l0.2529968,0.2660934", "l0.2513373,0.2660051", "l0.2429013,0.2650841", "l0.2416013,0.2648443", "l0.2391673,0.2643270", "l0.2381716,0.2640747", "l0.2368163,0.2634691", "l0.2358482,0.2632167", "l0.2329993,0.2629013", "l0.2286292,0.2631789", "l0.2267761,0.2625480", "l0.2259463,0.2620181", "l0.2252548,0.2613494", "l0.2243421,0.2607690", "l0.2233464,0.2602770", "l0.2224613,0.2599994", "l0.2203315,0.2598354", "l0.2170124,0.2609330", "l0.2097105,0.2622957", "l0.2074148,0.2623714", "l0.1995873,0.2640873", "l0.1985916,0.2644658", "l0.1980660,0.2649453", "l0.1980660,0.2655509", "l0.1982043,0.2665981", "l0.1978724,0.2672920", "l0.1961576,0.2679607", "l0.1925342,0.2680617", "l0.1905151,0.2680995", "l0.1879705,0.2682383", "l0.1852599,0.2685159", "l0.1839046,0.2687556", "l0.1828536,0.2689953", "l0.1807792,0.2692098", "l0.1782069,0.2690080", "l0.1713475,0.2689323", "c"]}, {"n": "San Luis", "u": "AR-D", "i": ["m0.3116892,0.2717080", "l0.3108594,0.2706482", "l0.3104169,0.2698785", "l0.3100573,0.2678850", "l0.3098637,0.2624092", "l0.3103339,0.2580311", "l0.3112190,0.2571984", "l0.3121317,0.2569334", "l0.3142615,0.2569839", "l0.3207060,0.2574255", "l0.3312164,0.2580816", "l0.3326270,0.2580942", "l0.3406481,0.2579176", "l0.3432757,0.2576905", "l0.3432757,0.2576905", "l0.3438566,0.2576652", "l0.3449076,0.2576778", "l0.3468161,0.2579428", "l0.3483927,0.2583087", "l0.3509649,0.2588008", "l0.3616690,0.2593054", "l0.3667859,0.2591667", "l0.3683901,0.2590657", "l0.3698837,0.2588891", "l0.3718475,0.2584727", "l0.3735070,0.2580311", "l0.3748900,0.2577914", "l0.3769921,0.2575517", "l0.3794260,0.2574381", "l0.3807260,0.2575769", "l0.3822196,0.2578923", "l0.3834643,0.2582961", "l0.3863961,0.2584601", "l0.3919003,0.2579302", "l0.3919003,0.2579302", "l0.3962427,0.2579302", "l0.3980959,0.2580816", "l0.4144423,0.2625606", "l0.4174848,0.2640999", "l0.4178997,0.2649705", "l0.4180103,0.2659420", "l0.4201677,0.2697524", "l0.4216337,0.2698785", "l0.4271378,0.2695505", "l0.4289080,0.2693360", "l0.4299867,0.2691089", "l0.4311484,0.2689575", "l0.4328079,0.2688313", "l0.4342738,0.2694495", "l0.4362929,0.2759347", "l0.4358780,0.2777389", "l0.4344398,0.2794170", "l0.4315356,0.2843250", "l0.4296548,0.2879714", "l0.4277740,0.2900406", "l0.4254506,0.2916429", "l0.4241506,0.2926901", "l0.4234315,0.2934724", "l0.4245655,0.3055469", "l0.4256166,0.3142148", "l0.4256995,0.3152746", "l0.4257272,0.3176593", "l0.4256719,0.3378339", "l0.4256166,0.3429060", "l0.4256166,0.3429060", "l0.4256719,0.3436251", "l0.4255889,0.3499084", "l0.4255612,0.3625507", "l0.4256166,0.3640143", "l0.4255612,0.3708653", "l0.3489458,0.3708022", "l0.3489458,0.3708022", "l0.3488352,0.3707392", "l0.3480054,0.3699443", "l0.3493054,0.3664746", "l0.3509649,0.3633960", "l0.3514075,0.3625002", "l0.3536202,0.3570749", "l0.3538691,0.3563305", "l0.3544776,0.3527599", "l0.3544223,0.3464009", "l0.3527628,0.3411017", "l0.3523756,0.3404078", "l0.3511586,0.3387423", "l0.3501905,0.3376068", "l0.3467331,0.3350582", "l0.3426119,0.3319165", "l0.3422247,0.3313866", "l0.3392099,0.3259739", "l0.3386014,0.3217346", "l0.3398184,0.3206117", "l0.3418375,0.3196654", "l0.3425290,0.3175836", "l0.3414503,0.3155018", "l0.3378269,0.3125872", "l0.3369418,0.3120573", "l0.3339270,0.3110984", "l0.3326824,0.3102783", "l0.3307186,0.3074142", "l0.3268740,0.3036039", "l0.3239974,0.3015221", "l0.3220890,0.2996674", "l0.3201252,0.2939014", "l0.3206783,0.2930056", "l0.3204018,0.2898892", "l0.3199039,0.2873910", "l0.3189912,0.2867223", "l0.3185209,0.2861419", "l0.3191018,0.2837825", "l0.3198209,0.2819657", "l0.3172763,0.2792530", "l0.3160870,0.2762880", "l0.3147593,0.2742188", "l0.3131551,0.2722884", "c"]}, {"n": "Tierra del Fuego", "u": "AR-V", "i": ["m0.2763410,0.9911570", "l0.2746538,0.9907280", "l0.2738240,0.9905640", "l0.2720538,0.9902990", "l0.2673795,0.9899583", "l0.2641987,0.9903747", "l0.2636455,0.9909425", "l0.2630094,0.9910686", "l0.2550159,0.9914850", "l0.2538819,0.9915102", "l0.2529138,0.9913967", "l0.2519181,0.9911822", "l0.2508671,0.9907028", "l0.2478522,0.9888228", "l0.2480458,0.9792717", "l0.2481288,0.9717898", "l0.2480735,0.9709823", "l0.2482118,0.9578732", "l0.2483224,0.9517666", "l0.2484607,0.9390612", "l0.2485160,0.9324877", "l0.2484884,0.9301283", "l0.2486543,0.9118841", "l0.2487650,0.9064461", "l0.2488203,0.9061055", "l0.2511436,0.9077962", "l0.2534947,0.9098275", "l0.2571733,0.9125654", "l0.2592201,0.9137388", "l0.2623455,0.9151771", "l0.2631476,0.9155935", "l0.2646136,0.9167417", "l0.2650285,0.9170823", "l0.2653880,0.9174356", "l0.2663008,0.9185837", "l0.2666880,0.9191894", "l0.2669093,0.9196057", "l0.2685688,0.9236684", "l0.2685965,0.9241226", "l0.2677944,0.9240848", "l0.2671305,0.9231511", "l0.2668816,0.9227347", "l0.2666050,0.9220787", "l0.2662178,0.9209684", "l0.2658859,0.9203375", "l0.2652221,0.9197950", "l0.2641157,0.9194543", "l0.2634242,0.9194291", "l0.2613775,0.9197950", "l0.2601881,0.9201609", "l0.2525819,0.9244380", "l0.2516415,0.9254474", "l0.2513926,0.9262549", "l0.2513926,0.9267848", "l0.2516138,0.9272012", "l0.2518904,0.9276175", "l0.2525819,0.9283619", "l0.2534947,0.9289928", "l0.2540202,0.9292830", "l0.2548776,0.9296741", "l0.2568691,0.9303428", "l0.2582520,0.9307718", "l0.2595796,0.9309484", "l0.2615987,0.9310872", "l0.2643093,0.9311251", "l0.2656370,0.9310746", "l0.2685135,0.9305573", "l0.2697858,0.9304816", "l0.2708368,0.9305321", "l0.2716666,0.9308223", "l0.2722751,0.9312134", "l0.2748751,0.9337116", "l0.2752346,0.9341027", "l0.2755389,0.9344938", "l0.2765623,0.9372065", "l0.2777239,0.9395785", "l0.2794665,0.9413701", "l0.2800473,0.9419000", "l0.2804622,0.9422407", "l0.2813749,0.9428715", "l0.2897003,0.9467576", "l0.2929640,0.9482086", "l0.2970023,0.9499245", "l0.2984682,0.9504544", "l0.3006256,0.9514638", "l0.3007086,0.9520441", "l0.3004596,0.9524731", "l0.3004596,0.9530030", "l0.3005703,0.9534825", "l0.3009298,0.9541133", "l0.3012341,0.9545171", "l0.3017319,0.9548325", "l0.3119658,0.9591097", "l0.3165848,0.9607499", "l0.3302760,0.9652289", "l0.3364993,0.9668692", "l0.3377993,0.9670710", "l0.3421417,0.9682949", "l0.3441608,0.9690014", "l0.3448246,0.9692412", "l0.3457374,0.9696449", "l0.3515458,0.9735688", "l0.3525415,0.9740609", "l0.3639923,0.9778460", "l0.3679752,0.9789941", "l0.3777112,0.9811517", "l0.3897429,0.9837003", "l0.3948321,0.9842554", "l0.3958555,0.9843185", "l0.3964640,0.9843059", "l0.4087722,0.9833723", "l0.4136679,0.9828297", "l0.4153274,0.9827540", "l0.4184252,0.9827540", "l0.4192550,0.9827793", "l0.4222698,0.9831325", "l0.4232102,0.9835363", "l0.4182869,0.9898700", "l0.4142487,0.9933649", "l0.4133360,0.9940210", "l0.4126445,0.9943869", "l0.4113445,0.9945005", "l0.4103488,0.9942860", "l0.4100999,0.9938318", "l0.4058957,0.9933902", "l0.4000320,0.9945510", "l0.3948321,0.9943112", "l0.3944449,0.9939327", "l0.3937811,0.9935416", "l0.3932555,0.9933776", "l0.3917343,0.9931252", "l0.3862025,0.9929486", "l0.3856770,0.9929864", "l0.3832983,0.9932388", "l0.3824962,0.9940210", "l0.3809473,0.9948538", "l0.3795920,0.9954594", "l0.3748623,0.9964687", "l0.3738942,0.9965949", "l0.3707411,0.9968094", "l0.3670072,0.9966328", "l0.3630519,0.9965697", "l0.3624434,0.9965697", "l0.3612541,0.9967211", "l0.3607839,0.9969103", "l0.3577137,0.9993202", "l0.3571052,0.9993202", "l0.3524032,0.9990426", "l0.3509649,0.9988912", "l0.3483650,0.9984496", "l0.3473416,0.9982351", "l0.3462353,0.9977809", "l0.3456821,0.9974781", "l0.3452395,0.9971248", "l0.3444927,0.9966454", "l0.3435800,0.9962416", "l0.3425843,0.9958631", "l0.3400950,0.9950935", "l0.3388226,0.9948664", "l0.3293080,0.9936299", "l0.3287824,0.9935794", "l0.3220060,0.9932135", "l0.3053553,0.9923808", "l0.2995745,0.9925827", "l0.2985512,0.9926710", "l0.2969469,0.9927593", "l0.2958129,0.9927846", "l0.2940704,0.9927593", "l0.2884556,0.9923808", "l0.2797430,0.9917374", "l0.2783048,0.9915859", "l0.2766452,0.9912579", "l0.2763410,0.9911570", "c", "m0.4460842,0.9935290", "l0.4465268,0.9920149", "l0.4448396,0.9911570", "l0.4436226,0.9910434", "l0.4424609,0.9909803", "l0.4422120,0.9905387", "l0.4429588,0.9895546", "l0.4453651,0.9883812", "l0.4466097,0.9883055", "l0.4475778,0.9885326", "l0.4488225,0.9890499", "l0.4495692,0.9892518", "l0.4501224,0.9892770", "l0.4542436,0.9886462", "l0.4611307,0.9872457", "l0.4631775,0.9864508", "l0.4716411,0.9870438", "l0.4789154,0.9866274", "l0.4840877,0.9859083", "l0.4846962,0.9858830", "l0.4889833,0.9861480", "l0.4894259,0.9864760", "l0.4866876,0.9886714", "l0.4823728,0.9897691", "l0.4812665,0.9889238", "l0.4794963,0.9884443", "l0.4780580,0.9888985", "l0.4732730,0.9900467", "l0.4671604,0.9909172", "l0.4666348,0.9903999", "l0.4667731,0.9895420", "l0.4637030,0.9888480", "l0.4625690,0.9894158", "l0.4588903,0.9908668", "l0.4573967,0.9911570", "l0.4568436,0.9912074", "l0.4557649,0.9911696", "l0.4511458,0.9919897", "l0.4480203,0.9933271", "l0.4460842,0.9935290", "c", "m0.2477969,0.9894663", "l0.2485437,0.9898953", "l0.2490416,0.9902990", "l0.2503415,0.9916869", "l0.2507011,0.9918509", "l0.2512819,0.9920149", "l0.2516968,0.9922420", "l0.2516138,0.9924818", "l0.2511436,0.9926079", "l0.2505905,0.9926584", "l0.2498437,0.9928224", "l0.2492905,0.9928981", "l0.2485714,0.9928981", "l0.2480182,0.9928603", "l0.2474373,0.9927719", "l0.2477416,0.9926332", "l0.2477969,0.9894663", "c"]}, {"n": "Tucumán", "u": "AR-T", "i": ["m0.4214954,0.1536125", "l0.4202784,0.1539027", "l0.4191167,0.1540162", "l0.4179550,0.1539027", "l0.4169870,0.1536882", "l0.4154657,0.1531709", "l0.4138615,0.1524770", "l0.4128381,0.1523129", "l0.4094637,0.1532971", "l0.4076935,0.1538774", "l0.4046787,0.1551265", "l0.4036277,0.1557952", "l0.4028532,0.1565901", "l0.4016362,0.1572336", "l0.3974874,0.1551896", "l0.3967129,0.1545840", "l0.3958831,0.1534863", "l0.3956342,0.1528681", "l0.3954683,0.1521741", "l0.3949151,0.1513540", "l0.3915960,0.1504330", "l0.3896046,0.1508998", "l0.3881386,0.1507863", "l0.3834919,0.1471778", "l0.3819154,0.1443390", "l0.3805877,0.1412856", "l0.3779878,0.1401375", "l0.3749729,0.1392038", "l0.3728432,0.1390777", "l0.3704092,0.1386361", "l0.3727326,0.1361379", "l0.3781261,0.1328070", "l0.3791218,0.1322392", "l0.3821919,0.1307883", "l0.3836855,0.1302079", "l0.3851515,0.1292616", "l0.3858706,0.1286686", "l0.3864238,0.1279494", "l0.3873642,0.1237227", "l0.3870876,0.1231171", "l0.3864791,0.1227260", "l0.3787069,0.1200259", "l0.3767431,0.1195969", "l0.3755538,0.1194455", "l0.3729815,0.1192815", "l0.3703262,0.1191553", "l0.3691092,0.1188147", "l0.3689433,0.1150043", "l0.3695518,0.1142599", "l0.3718198,0.1119258", "l0.3722071,0.1107272", "l0.3722071,0.1107272", "l0.3774899,0.1113706", "l0.3803665,0.1116482", "l0.3938640,0.1125566", "l0.3948874,0.1119510", "l0.3956895,0.1090365", "l0.3955789,0.1080019", "l0.3957725,0.1072449", "l0.3967129,0.1067906", "l0.4022171,0.1074215", "l0.4078318,0.1079766", "l0.4089935,0.1078883", "l0.4102658,0.1075350", "l0.4119254,0.1070178", "l0.4130317,0.1067654", "l0.4143594,0.1068916", "l0.4153827,0.1076991", "l0.4163231,0.1091374", "l0.4271101,0.1111309", "l0.4318398,0.1117744", "l0.4330568,0.1119005", "l0.4346887,0.1117239", "l0.4360163,0.1113706", "l0.4371780,0.1108155", "l0.4384503,0.1104622", "l0.4396673,0.1102856", "l0.4416311,0.1102603", "l0.4432630,0.1104622", "l0.4449225,0.1106010", "l0.4552670,0.1105505", "l0.4556819,0.1104874", "l0.4556819,0.1104874", "l0.4559585,0.1119005", "l0.4559585,0.1125188", "l0.4556819,0.1131875", "l0.4549074,0.1142599", "l0.4540777,0.1153198", "l0.4537458,0.1159380", "l0.4539117,0.1167833", "l0.4546032,0.1186885", "l0.4551287,0.1203413", "l0.4552117,0.1210605", "l0.4552117,0.1220573", "l0.4542436,0.1222087", "l0.4506480,0.1220951", "l0.4485182,0.1251484", "l0.4466374,0.1251989", "l0.4443694,0.1285677", "l0.4420183,0.1308513", "l0.4392524,0.1349897", "l0.4380908,0.1363271", "l0.4356015,0.1385604", "l0.4344121,0.1386613", "l0.4330292,0.1388632", "l0.4274974,0.1417398", "l0.4268336,0.1423455", "l0.4264463,0.1458278", "l0.4266676,0.1466857", "l0.4273314,0.1473797", "l0.4283548,0.1483512", "l0.4298484,0.1502690", "l0.4263634,0.1530447", "l0.4250910,0.1533854", "c"]}]} """;
}
