import 'package:flutter/material.dart';

class SMapEgyptColors {
  /// Al Iskandarīyah
  final Color? egALX;

  /// Aswān
  final Color? egASN;

  /// Asyūţ
  final Color? egAST;

  /// Al Baḩr al Aḩmar
  final Color? egBA;

  /// Al Buḩayrah
  final Color? egBH;

  /// Banī Suwayf
  final Color? egBNS;

  /// Al Qāhirah
  final Color? egC;

  /// Ad Daqahlīyah
  final Color? egDK;

  /// Dumyāţ
  final Color? egDT;

  /// Al Fayyūm
  final Color? egFYM;

  /// Al Gharbīyah
  final Color? egGH;

  /// Al Jīzah
  final Color? egGZ;

  /// Al Ismāٰīlīyah
  final Color? egIS;

  /// Janūb Sīnā'
  final Color? egJS;

  /// Al Qalyūbīyah
  final Color? egKB;

  /// Kafr ash Shaykh
  final Color? egKFS;

  /// Qinā
  final Color? egKN;

  /// Al Uqşur
  final Color? egLX;

  /// Al Minyā
  final Color? egMN;

  /// Al Minūfīyah
  final Color? egMNF;

  /// Maţrūḩ
  final Color? egMT;

  /// Būr Saٰīd
  final Color? egPTS;

  /// Sūhāj
  final Color? egSHG;

  /// Ash Sharqīyah
  final Color? egSHR;

  /// Shamāl Sīnā'
  final Color? egSIN;

  /// Disputed Territory
  final Color? egTER;

  /// Hala'Ib Triangle
  final Color? egHT;

  /// As Suways
  final Color? egSUZ;

  /// Al Wādī al Jadīd
  final Color? egWAD;
  SMapEgyptColors({
    this.egALX,
    this.egASN,
    this.egAST,
    this.egBA,
    this.egBH,
    this.egBNS,
    this.egC,
    this.egDK,
    this.egDT,
    this.egFYM,
    this.egGH,
    this.egGZ,
    this.egIS,
    this.egJS,
    this.egKB,
    this.egKFS,
    this.egKN,
    this.egLX,
    this.egMN,
    this.egMNF,
    this.egMT,
    this.egPTS,
    this.egSHG,
    this.egSHR,
    this.egSIN,
    this.egTER,
    this.egHT,
    this.egSUZ,
    this.egWAD,
  });
  Map<String, Color?> toMap() {
    return {
      "EG-ALX": egALX,
      "EG-ASN": egASN,
      "EG-AST": egAST,
      "EG-BA": egBA,
      "EG-BH": egBH,
      "EG-BNS": egBNS,
      "EG-C": egC,
      "EG-DK": egDK,
      "EG-DT": egDT,
      "EG-FYM": egFYM,
      "EG-GH": egGH,
      "EG-GZ": egGZ,
      "EG-IS": egIS,
      "EG-JS": egJS,
      "EG-KB": egKB,
      "EG-KFS": egKFS,
      "EG-KN": egKN,
      "EG-LX": egLX,
      "EG-MN": egMN,
      "EG-MNF": egMNF,
      "EG-MT": egMT,
      "EG-PTS": egPTS,
      "EG-SHG": egSHG,
      "EG-SHR": egSHR,
      "EG-SIN": egSIN,
      "EG-TER": egTER,
      "EG-HT": egHT,
      "EG-SUZ": egSUZ,
      "EG-WAD": egWAD,
    };
  }

  static SMapEgyptColors fromMap(Map<String, Color?> map) {
    return SMapEgyptColors(
      egALX: map["EG-ALX"],
      egASN: map["EG-ASN"],
      egAST: map["EG-AST"],
      egBA: map["EG-BA"],
      egBH: map["EG-BH"],
      egBNS: map["EG-BNS"],
      egC: map["EG-C"],
      egDK: map["EG-DK"],
      egDT: map["EG-DT"],
      egFYM: map["EG-FYM"],
      egGH: map["EG-GH"],
      egGZ: map["EG-GZ"],
      egIS: map["EG-IS"],
      egJS: map["EG-JS"],
      egKB: map["EG-KB"],
      egKFS: map["EG-KFS"],
      egKN: map["EG-KN"],
      egLX: map["EG-LX"],
      egMN: map["EG-MN"],
      egMNF: map["EG-MNF"],
      egMT: map["EG-MT"],
      egPTS: map["EG-PTS"],
      egSHG: map["EG-SHG"],
      egSHR: map["EG-SHR"],
      egSIN: map["EG-SIN"],
      egTER: map["EG-TER"],
      egHT: map["EG-HT"],
      egSUZ: map["EG-SUZ"],
      egWAD: map["EG-WAD"],
    );
  }
}

class SMapEgypt {
  static const String instructions =
      """{"n": "Egypt", "w": 548.58221, "h": 498.86664, "g": {"a": "24.697924,31.667680","b": "36.894654,21.724740"}, "i":[{"n": "Al Iskandarīyah", "u": "EG-ALX", "i": ["m0.4412825,0.0359451", "l0.4412825,0.0361255", "l0.4414648,0.0362458", "l0.4414283,0.0363861", "l0.4413189,0.0363861", "l0.4412460,0.0361455", "l0.4411002,0.0361455", "l0.4407174,0.0364663", "l0.4407538,0.0367669", "l0.4409908,0.0368271", "l0.4408085,0.0371678", "l0.4410090,0.0372881", "l0.4405351,0.0374084", "l0.4405533,0.0375888", "l0.4407538,0.0377291", "l0.4405898,0.0382904", "l0.4409726,0.0388717", "l0.4409543,0.0393127", "l0.4411731,0.0397337", "l0.4416470,0.0400544", "l0.4417382,0.0410166", "l0.4419569,0.0412170", "l0.4419569,0.0412170", "l0.4419205,0.0456872", "l0.4398971,0.0493154", "l0.4398971,0.0493154", "l0.4398971,0.0493154", "l0.4398971,0.0493154", "l0.4377278,0.0556097", "l0.4294155,0.0608816", "l0.4294155,0.0608816", "l0.4235823,0.0661736", "l0.4277749,0.0702428", "l0.4264989,0.0757754", "l0.4264989,0.0757754", "l0.4243661,0.0799649", "l0.4285223,0.0874619", "l0.4387669,0.1003711", "l0.4295431,0.1155255", "l0.4205928,0.1201961", "l0.4134835,0.1227418", "l0.4102206,0.1232630", "l0.4076321,0.1274325", "l0.4050254,0.1358916", "l0.4050254,0.1358916", "l0.4033665,0.0746127", "l0.4034030,0.0684387", "l0.4034030,0.0684387", "l0.4037311,0.0681982", "l0.4039134,0.0678574", "l0.4044603,0.0677171", "l0.4046608,0.0673763", "l0.4050618,0.0671959", "l0.4065201,0.0658529", "l0.4068118,0.0657727", "l0.4074863,0.0651914", "l0.4076321,0.0646902", "l0.4077415,0.0646902", "l0.4077415,0.0648105", "l0.4079420,0.0646902", "l0.4086711,0.0639085", "l0.4093821,0.0633472", "l0.4100201,0.0625053", "l0.4112414,0.0614028", "l0.4114237,0.0613827", "l0.4115330,0.0611422", "l0.4121711,0.0609016", "l0.4131554,0.0600196", "l0.4136476,0.0598192", "l0.4139210,0.0593581", "l0.4146866,0.0587969", "l0.4147778,0.0585363", "l0.4152153,0.0583960", "l0.4152700,0.0581354", "l0.4156163,0.0579349", "l0.4166553,0.0565718", "l0.4169288,0.0558502", "l0.4168923,0.0553290", "l0.4172022,0.0552087", "l0.4174756,0.0548880", "l0.4178584,0.0548680", "l0.4176579,0.0551887", "l0.4172751,0.0553090", "l0.4172934,0.0555495", "l0.4175121,0.0555495", "l0.4175850,0.0557500", "l0.4177855,0.0556297", "l0.4179678,0.0551887", "l0.4182413,0.0553090", "l0.4182048,0.0556097", "l0.4179314,0.0559504", "l0.4178402,0.0564716", "l0.4180043,0.0563914", "l0.4180954,0.0560106", "l0.4184418,0.0555495", "l0.4185694,0.0557500", "l0.4184965,0.0563714", "l0.4189522,0.0564315", "l0.4190615,0.0560507", "l0.4192256,0.0559705", "l0.4192256,0.0566921", "l0.4196996,0.0563714", "l0.4200094,0.0564315", "l0.4202464,0.0561308", "l0.4205016,0.0560707", "l0.4208844,0.0557299", "l0.4211396,0.0551486", "l0.4213037,0.0552689", "l0.4215042,0.0551486", "l0.4218870,0.0544871", "l0.4224521,0.0541463", "l0.4227620,0.0536452", "l0.4229078,0.0527432", "l0.4231083,0.0527432", "l0.4231083,0.0530037", "l0.4232359,0.0529837", "l0.4237828,0.0524224", "l0.4237646,0.0522420", "l0.4238740,0.0522220", "l0.4240016,0.0524024", "l0.4244755,0.0516206", "l0.4243661,0.0513199", "l0.4241474,0.0513801", "l0.4241656,0.0515605", "l0.4240380,0.0516206", "l0.4238010,0.0512798", "l0.4241838,0.0506183", "l0.4246396,0.0502776", "l0.4245666,0.0501573", "l0.4244937,0.0503377", "l0.4244026,0.0503177", "l0.4242385,0.0499769", "l0.4239651,0.0499769", "l0.4237464,0.0504379", "l0.4235823,0.0505181", "l0.4235641,0.0507587", "l0.4231995,0.0507386", "l0.4231083,0.0511796", "l0.4228896,0.0509792", "l0.4229990,0.0513801", "l0.4225979,0.0510794", "l0.4234547,0.0500972", "l0.4234911,0.0498566", "l0.4233818,0.0497363", "l0.4238557,0.0496161", "l0.4239469,0.0493755", "l0.4246578,0.0492352", "l0.4246578,0.0488944", "l0.4244755,0.0485937", "l0.4246760,0.0484534", "l0.4250771,0.0484735", "l0.4253140,0.0482329", "l0.4254052,0.0483732", "l0.4251500,0.0485537", "l0.4251135,0.0489345", "l0.4254234,0.0494557", "l0.4257880,0.0496962", "l0.4264624,0.0495960", "l0.4270275,0.0488142", "l0.4266447,0.0482931", "l0.4269364,0.0483131", "l0.4273739,0.0487541", "l0.4280119,0.0483732", "l0.4284676,0.0478521", "l0.4292150,0.0473509", "l0.4294884,0.0469099", "l0.4298895,0.0467095", "l0.4302358,0.0461482", "l0.4305092,0.0461482", "l0.4306004,0.0458275", "l0.4308556,0.0458876", "l0.4308191,0.0455869", "l0.4309467,0.0454065", "l0.4313842,0.0454266", "l0.4315847,0.0451259", "l0.4317488,0.0451058", "l0.4318399,0.0447851", "l0.4320769,0.0447250", "l0.4321681,0.0443842", "l0.4324415,0.0440434", "l0.4328243,0.0438430", "l0.4330977,0.0433819", "l0.4335717,0.0430612", "l0.4335899,0.0428006", "l0.4334805,0.0426202", "l0.4335899,0.0423195", "l0.4345013,0.0422594", "l0.4348477,0.0418785", "l0.4349024,0.0414776", "l0.4353763,0.0414175", "l0.4355586,0.0409765", "l0.4353216,0.0406558", "l0.4354310,0.0404753", "l0.4356680,0.0404954", "l0.4356498,0.0402348", "l0.4359597,0.0401747", "l0.4363425,0.0405154", "l0.4364154,0.0402548", "l0.4361966,0.0403150", "l0.4361602,0.0401947", "l0.4363425,0.0396936", "l0.4364701,0.0400143", "l0.4367253,0.0402148", "l0.4370898,0.0401947", "l0.4376732,0.0398539", "l0.4381107,0.0392325", "l0.4381289,0.0390321", "l0.4386757,0.0383906", "l0.4386575,0.0381300", "l0.4382565,0.0378093", "l0.4386028,0.0375688", "l0.4385481,0.0373883", "l0.4394414,0.0371278", "l0.4399335,0.0364061", "l0.4403346,0.0362257", "l0.4403710,0.0360854", "l0.4405533,0.0361455", "l0.4412825,0.0359451", "c"]}, {"n": "Aswān", "u": "EG-ASN", "i": ["m0.6812830,0.7510260", "l0.6794236,0.7581421", "l0.6794054,0.7702295", "l0.6808455,0.7739379", "l0.6814288,0.7799315", "l0.6831058,0.7822167", "l0.6852386,0.7864863", "l0.6856032,0.7901948", "l0.6862047,0.7930412", "l0.6879912,0.7965892", "l0.6909625,0.7984535", "l0.6935874,0.8017209", "l0.6939520,0.8108015", "l0.6959025,0.8116233", "l0.6956108,0.8153117", "l0.6942983,0.8167750", "l0.6932228,0.8187595", "l0.6925119,0.8231695", "l0.6926395,0.8278601", "l0.6944259,0.8346756", "l0.6972879,0.8353972", "l0.6988008,0.8392259", "l0.7002045,0.8421325", "l0.6997852,0.8448787", "l0.6983451,0.8471438", "l0.6971602,0.8515538", "l0.6952462,0.8556631", "l0.6924025,0.8589105", "l0.6903791,0.8616166", "l0.6881005,0.8657059", "l0.6857308,0.8685524", "l0.6856032,0.8709578", "l0.6873896,0.8726617", "l0.6919104,0.8776129", "l0.6974337,0.8780940", "l0.6992930,0.8800584", "l0.7053450,0.8847691", "l0.7053450,0.8847691", "l0.7094100,0.8918251", "l0.7097928,0.8984602", "l0.7097928,0.8984602", "l0.7076236,0.9025093", "l0.7026836,0.9017075", "l0.6976524,0.8958142", "l0.6950092,0.8919855", "l0.6897594,0.8928474", "l0.6897594,0.8928474", "l0.6850745,0.8912839", "l0.6817387,0.8889386", "l0.6769627,0.8852502", "l0.6712024,0.8859117", "l0.6712024,0.8859117", "l0.6657520,0.8891992", "l0.6662260,0.9002843", "l0.6640750,0.9071398", "l0.6598641,0.9123116", "l0.6548876,0.9154988", "l0.6481065,0.9204099", "l0.6423827,0.9259224", "l0.6376067,0.9274860", "l0.6376067,0.9274860", "l0.6322475,0.9292499", "l0.6259950,0.9262030", "l0.6259950,0.9262030", "l0.6217112,0.9216327", "l0.6190316,0.9178241", "l0.6151853,0.9151580", "l0.6101724,0.9164810", "l0.6080214,0.9254012", "l0.6073105,0.9301119", "l0.6051595,0.9358850", "l0.6032637,0.9398139", "l0.6007299,0.9433018", "l0.5957898,0.9456271", "l0.5879879,0.9442840", "l0.5853630,0.9505783", "l0.5817901,0.9545072", "l0.5767772,0.9573937", "l0.5619936,0.9629062", "l0.5619936,0.9629062", "l0.5598244,0.9722274", "l0.5504001,0.9722073", "l0.5502907,0.9717262", "l0.5504548,0.9703231", "l0.5515485,0.9669153", "l0.5523141,0.9651513", "l0.5547750,0.9608816", "l0.5555224,0.9599395", "l0.5567073,0.9588972", "l0.5572177,0.9579550", "l0.5581838,0.9566922", "l0.5586578,0.9555295", "l0.5586213,0.9549682", "l0.5583114,0.9544471", "l0.5573635,0.9539058", "l0.5562698,0.9518011", "l0.5555224,0.9512398", "l0.5550485,0.9514603", "l0.5534261,0.9529837", "l0.5464809,0.9576543", "l0.5438560,0.9573937", "l0.5438560,0.9573937", "l0.5389889,0.9579149", "l0.5362363,0.9534648", "l0.5376582,0.9479523", "l0.5455330,0.9434822", "l0.5510199,0.9416581", "l0.5583114,0.9418986", "l0.5637071,0.9364262", "l0.5672071,0.9320964", "l0.5687201,0.9289493", "l0.5695950,0.9257821", "l0.5691758,0.9225748", "l0.5691758,0.9138951", "l0.5687930,0.9094451", "l0.5703242,0.9057767", "l0.5730038,0.9022888", "l0.5751366,0.9012866", "l0.5801860,0.9012465", "l0.5839229,0.9017075", "l0.5868577,0.9012465", "l0.5909774,0.8997631", "l0.6067271,0.8949121", "l0.6167347,0.8916648", "l0.6185212,0.8924265", "l0.6232424,0.8929477", "l0.6279272,0.8939700", "l0.6314636,0.8964155", "l0.6341979,0.8977385", "l0.6371875,0.8958943", "l0.6402864,0.8892393", "l0.6420181,0.8852101", "l0.6442602,0.8808402", "l0.6457003,0.8760894", "l0.6479789,0.8704767", "l0.6510596,0.8650645", "l0.6534658,0.8605141", "l0.6562730,0.8540194", "l0.6593537,0.8489479", "l0.6619422,0.8442172", "l0.6624891,0.8422928", "l0.6616141,0.8383238", "l0.6578407,0.8385443", "l0.6547054,0.8393261", "l0.6498200,0.8386045", "l0.6403775,0.8361389", "l0.6378437,0.8328314", "l0.6384999,0.8262565", "l0.6416171,0.8143695", "l0.6441873,0.8103404", "l0.6470310,0.8082958", "l0.6512054,0.8055696", "l0.6551975,0.8037455", "l0.6588615,0.8026229", "l0.6627260,0.7991751", "l0.6621427,0.7966494", "l0.6594266,0.7942239", "l0.6555803,0.7901346", "l0.6552704,0.7838403", "l0.6578043,0.7810540", "l0.6601375,0.7800718", "l0.6634916,0.7782276", "l0.6703092,0.7703899", "l0.6710201,0.7574606", "l0.6710201,0.7515271", "l0.6720956,0.7431080", "l0.6721321,0.7362525", "l0.6734993,0.7292767", "l0.6747024,0.7222808", "l0.6747024,0.7165077", "l0.6757232,0.7098526", "l0.6724420,0.7028768", "l0.6714212,0.6984869", "l0.6692884,0.6913507", "l0.6691790,0.6870008", "l0.6692337,0.6817890", "l0.6685228,0.6780806", "l0.6656062,0.6740515", "l0.6607209,0.6690000", "l0.6543590,0.6657527", "l0.6543590,0.6657527", "l0.6561090,0.6587167", "l0.6559814,0.6515605", "l0.6559814,0.6515605", "l0.6594631,0.6550284", "l0.6594631,0.6550284", "l0.6638198,0.6579951", "l0.6671556,0.6615431", "l0.6750852,0.6675969", "l0.6810824,0.6786218", "l0.6819392,0.6853170", "l0.6821944,0.7045206", "l0.6856943,0.7136011", "l0.6912723,0.7238444", "l0.6916916,0.7269514", "l0.6909807,0.7349896", "l0.6851475,0.7403217", "l0.6815199,0.7462752", "l0.6812830,0.7510260", "l0.6812830,0.7510260", "c"]}, {"n": "Asyūţ", "u": "EG-AST", "i": ["m0.5677357,0.4976115", "l0.5636889,0.4975715", "l0.5621395,0.4938630", "l0.5602437,0.4918986", "l0.5586213,0.4879296", "l0.5570536,0.4856244", "l0.5538089,0.4852435", "l0.5527699,0.4874285", "l0.5506735,0.4907560", "l0.5491059,0.4920389", "l0.5459705,0.4939633", "l0.5438013,0.4959277", "l0.5426164,0.4963286", "l0.5426164,0.4963286", "l0.5385332,0.4888918", "l0.5351791,0.4802923", "l0.5318979,0.4728554", "l0.5287807,0.4672227", "l0.5238772,0.4641156", "l0.5208694,0.4633338", "l0.5169320,0.4628528", "l0.5151274,0.4617903", "l0.5112811,0.4580218", "l0.5040989,0.4503043", "l0.5015651,0.4487408", "l0.4995053,0.4454333", "l0.4985574,0.4411435", "l0.4960236,0.4374351", "l0.4942918,0.4333459", "l0.4934715,0.4282343", "l0.4915940,0.4272922", "l0.4912841,0.4234033", "l0.4898622,0.4218398", "l0.4900263,0.4173496", "l0.4919221,0.4171492", "l0.4919221,0.4171492", "l0.4974454,0.4171492", "l0.5007813,0.4181314", "l0.5052109,0.4189132", "l0.5080546,0.4161669", "l0.5131222,0.4165478", "l0.5131222,0.4165478", "l0.5119009,0.4233632", "l0.5129581,0.4328046", "l0.5140701,0.4359117", "l0.5167497,0.4394397", "l0.5184632,0.4403618", "l0.5246610,0.4427472", "l0.5271948,0.4448920", "l0.5342858,0.4479390", "l0.5363822,0.4481394", "l0.5402102,0.4502442", "l0.5426529,0.4517476", "l0.5451502,0.4606077", "l0.5503272,0.4649776", "l0.5503272,0.4649776", "l0.5549938,0.4693475", "l0.5573271,0.4711516", "l0.5573271,0.4711516", "l0.5598791,0.4773256", "l0.5640717,0.4849027", "l0.5667878,0.4926002", "c"]}, {"n": "Al Baḩr al Aḩmar", "u": "EG-BA", "i": ["m0.9106378,0.7926002", "l0.9107837,0.7939032", "l0.9109842,0.7945647", "l0.9108201,0.7949455", "l0.9104738,0.7950057", "l0.9101639,0.7948653", "l0.9101456,0.7946448", "l0.9102186,0.7945446", "l0.9103279,0.7946047", "l0.9103462,0.7944043", "l0.9107107,0.7940836", "l0.9106378,0.7929209", "l0.9105285,0.7927004", "l0.9106378,0.7926002", "c", "m0.7600496,0.5028635", "l0.7603413,0.5031441", "l0.7604142,0.5034849", "l0.7607788,0.5036252", "l0.7608517,0.5039259", "l0.7617631,0.5038457", "l0.7619272,0.5040060", "l0.7619819,0.5044270", "l0.7617267,0.5060908", "l0.7618907,0.5065719", "l0.7622006,0.5068725", "l0.7624194,0.5075340", "l0.7624194,0.5078347", "l0.7622371,0.5080953", "l0.7623282,0.5092179", "l0.7622006,0.5093582", "l0.7622918,0.5094985", "l0.7622006,0.5096589", "l0.7620366,0.5095987", "l0.7613986,0.5085764", "l0.7611616,0.5078147", "l0.7609246,0.5076142", "l0.7607970,0.5076343", "l0.7603413,0.5068725", "l0.7605054,0.5063113", "l0.7604142,0.5058101", "l0.7599767,0.5055896", "l0.7597215,0.5050284", "l0.7595028,0.5050083", "l0.7595028,0.5046475", "l0.7590835,0.5041664", "l0.7591017,0.5037254", "l0.7592658,0.5035049", "l0.7596121,0.5033646", "l0.7598856,0.5028434", "l0.7600496,0.5028434", "c", "m0.7548544,0.4536519", "l0.7551643,0.4539526", "l0.7552372,0.4537321", "l0.7556018,0.4538724", "l0.7561304,0.4545740", "l0.7563674,0.4551353", "l0.7565679,0.4552756", "l0.7566773,0.4560574", "l0.7565315,0.4564583", "l0.7565497,0.4568592", "l0.7568049,0.4572200", "l0.7569143,0.4577612", "l0.7573153,0.4579617", "l0.7574611,0.4590241", "l0.7576617,0.4591644", "l0.7577528,0.4597056", "l0.7576434,0.4599261", "l0.7571695,0.4597858", "l0.7570966,0.4599061", "l0.7566773,0.4599662", "l0.7565862,0.4597658", "l0.7561122,0.4594851", "l0.7556383,0.4582824", "l0.7548180,0.4575207", "l0.7543440,0.4574605", "l0.7544352,0.4571599", "l0.7542893,0.4570797", "l0.7542529,0.4567990", "l0.7538518,0.4564583", "l0.7536149,0.4560173", "l0.7537242,0.4556765", "l0.7543622,0.4559772", "l0.7547268,0.4557767", "l0.7547086,0.4554159", "l0.7543622,0.4544938", "l0.7544534,0.4541330", "l0.7546175,0.4540127", "l0.7547086,0.4537120", "l0.7548544,0.4536519", "c", "m0.7566955,0.4263500", "l0.7568414,0.4265505", "l0.7577528,0.4266106", "l0.7581174,0.4264903", "l0.7592840,0.4266307", "l0.7594845,0.4271117", "l0.7600314,0.4273322", "l0.7607606,0.4283145", "l0.7617449,0.4288156", "l0.7620366,0.4288357", "l0.7627657,0.4293969", "l0.7628569,0.4296976", "l0.7636954,0.4297176", "l0.7639324,0.4298379", "l0.7643881,0.4305996", "l0.7644063,0.4310006", "l0.7648620,0.4320630", "l0.7649350,0.4327445", "l0.7652813,0.4331454", "l0.7656641,0.4347090", "l0.7653907,0.4353504", "l0.7648256,0.4354907", "l0.7642423,0.4354707", "l0.7642423,0.4352502", "l0.7645157,0.4351901", "l0.7645157,0.4349896", "l0.7637501,0.4340675", "l0.7634767,0.4333459", "l0.7630209,0.4330051", "l0.7623647,0.4330652", "l0.7622918,0.4325641", "l0.7616902,0.4318425", "l0.7614168,0.4316821", "l0.7612892,0.4314015", "l0.7608699,0.4312010", "l0.7605965,0.4307801", "l0.7598491,0.4308602", "l0.7595575,0.4306598", "l0.7591200,0.4306798", "l0.7590835,0.4304794", "l0.7585366,0.4298981", "l0.7582268,0.4299181", "l0.7578257,0.4295773", "l0.7574247,0.4297978", "l0.7569690,0.4298580", "l0.7566955,0.4297377", "l0.7556565,0.4284147", "l0.7554924,0.4277131", "l0.7555107,0.4275527", "l0.7557659,0.4275527", "l0.7559664,0.4278133", "l0.7561304,0.4276931", "l0.7563127,0.4267309", "l0.7566955,0.4263500", "c", "m0.7448104,0.4241851", "l0.7450109,0.4243054", "l0.7450838,0.4245259", "l0.7448833,0.4248867", "l0.7449562,0.4255883", "l0.7446828,0.4254480", "l0.7446828,0.4252275", "l0.7444458,0.4251072", "l0.7442635,0.4246662", "l0.7444640,0.4242653", "l0.7448104,0.4241851", "c", "m0.7419302,0.4233232", "l0.7423130,0.4234835", "l0.7423495,0.4237642", "l0.7425864,0.4238243", "l0.7426776,0.4240849", "l0.7431698,0.4245660", "l0.7433703,0.4251072", "l0.7432427,0.4251673", "l0.7425318,0.4245459", "l0.7418573,0.4234835", "l0.7419302,0.4233232", "c", "m0.7432244,0.4173095", "l0.7436073,0.4177104", "l0.7436984,0.4180512", "l0.7441723,0.4183318", "l0.7440083,0.4196548", "l0.7437531,0.4200958", "l0.7440083,0.4201760", "l0.7440083,0.4204567", "l0.7441906,0.4207974", "l0.7445005,0.4208576", "l0.7455030,0.4215792", "l0.7459952,0.4216393", "l0.7461957,0.4221204", "l0.7459405,0.4228020", "l0.7451932,0.4233031", "l0.7450473,0.4236439", "l0.7444093,0.4237241", "l0.7440265,0.4239446", "l0.7440994,0.4249468", "l0.7444822,0.4255081", "l0.7443729,0.4257687", "l0.7441541,0.4255482", "l0.7436802,0.4245459", "l0.7436619,0.4250270", "l0.7430239,0.4239646", "l0.7431515,0.4234835", "l0.7440812,0.4234635", "l0.7441541,0.4230425", "l0.7439171,0.4230225", "l0.7434797,0.4226617", "l0.7430786,0.4226817", "l0.7426047,0.4225213", "l0.7426047,0.4223810", "l0.7423677,0.4222607", "l0.7422219,0.4220002", "l0.7413833,0.4218598", "l0.7411464,0.4217396", "l0.7410552,0.4215391", "l0.7415656,0.4205569", "l0.7417297,0.4199355", "l0.7420031,0.4196548", "l0.7420031,0.4192539", "l0.7425500,0.4175701", "l0.7426411,0.4174098", "l0.7432244,0.4173095", "c", "m0.7444640,0.4167282", "l0.7445734,0.4167883", "l0.7447192,0.4174899", "l0.7449744,0.4177104", "l0.7449926,0.4181314", "l0.7447010,0.4179911", "l0.7444275,0.4174498", "l0.7443182,0.4168284", "l0.7444640,0.4167282", "c", "m0.7458676,0.4134608", "l0.7461228,0.4137214", "l0.7464145,0.4144029", "l0.7471254,0.4147437", "l0.7474171,0.4160868", "l0.7473624,0.4168084", "l0.7468702,0.4175701", "l0.7467244,0.4181915", "l0.7464509,0.4181314", "l0.7456124,0.4173095", "l0.7455577,0.4170088", "l0.7452843,0.4167483", "l0.7449744,0.4155054", "l0.7447739,0.4153651", "l0.7446281,0.4149642", "l0.7446098,0.4147036", "l0.7448650,0.4146234", "l0.7447557,0.4141824", "l0.7449197,0.4138818", "l0.7453390,0.4138016", "l0.7455030,0.4135811", "l0.7458676,0.4134608", "c", "m0.7465785,0.4116567", "l0.7466697,0.4119373", "l0.7465603,0.4120576", "l0.7463233,0.4119774", "l0.7460499,0.4121779", "l0.7457036,0.4127993", "l0.7456124,0.4132403", "l0.7452296,0.4131601", "l0.7447921,0.4133004", "l0.7447010,0.4134408", "l0.7447010,0.4132804", "l0.7445369,0.4131601", "l0.7446463,0.4127993", "l0.7448104,0.4129196", "l0.7449744,0.4126189", "l0.7453208,0.4125387", "l0.7453572,0.4119173", "l0.7458859,0.4119774", "l0.7461411,0.4118371", "l0.7462869,0.4119173", "l0.7465785,0.4116567", "c", "m0.7303002,0.4029169", "l0.7303549,0.4030572", "l0.7301544,0.4031975", "l0.7300997,0.4030372", "l0.7303002,0.4029169", "c", "m0.7293341,0.4011930", "l0.7298080,0.4013934", "l0.7301179,0.4017342", "l0.7301362,0.4019347", "l0.7299721,0.4021552", "l0.7302455,0.4024158", "l0.7303549,0.4028568", "l0.7300815,0.4025962", "l0.7298992,0.4030773", "l0.7300450,0.4031374", "l0.7301362,0.4033980", "l0.7302091,0.4043602", "l0.7295346,0.4040996", "l0.7293888,0.4035383", "l0.7282768,0.4025761", "l0.7287143,0.4019948", "l0.7288237,0.4015137", "l0.7291153,0.4014536", "l0.7291883,0.4011930", "l0.7293341,0.4011930", "c", "m0.5590406,0.2719400", "l0.5671342,0.2732029", "l0.5752824,0.2767309", "l0.5870947,0.2798981", "l0.5893551,0.2798981", "l0.5893551,0.2798981", "l0.5913420,0.2841076", "l0.6007481,0.2821431", "l0.6128338,0.2819427", "l0.6274715,0.2720402", "l0.6352734,0.2696949", "l0.6424556,0.2650043", "l0.6522627,0.2646234", "l0.6522627,0.2646234", "l0.6524997,0.2646034", "l0.6526637,0.2650845", "l0.6525726,0.2654052", "l0.6529189,0.2656658", "l0.6531741,0.2661469", "l0.6531012,0.2668685", "l0.6532653,0.2672694", "l0.6532106,0.2678107", "l0.6527731,0.2689733", "l0.6528278,0.2691136", "l0.6524997,0.2693341", "l0.6522262,0.2698553", "l0.6520986,0.2697751", "l0.6510778,0.2707172", "l0.6510778,0.2709177", "l0.6512783,0.2710380", "l0.6512601,0.2712585", "l0.6511143,0.2710580", "l0.6503851,0.2711983", "l0.6497471,0.2720603", "l0.6496195,0.2724612", "l0.6496195,0.2725815", "l0.6496377,0.2727218", "l0.6502393,0.2735436", "l0.6503304,0.2746862", "l0.6498200,0.2754279", "l0.6496195,0.2763701", "l0.6494372,0.2786552", "l0.6495284,0.2793769", "l0.6504580,0.2810206", "l0.6509867,0.2815819", "l0.6517523,0.2827245", "l0.6524268,0.2833459", "l0.6529372,0.2840274", "l0.6532470,0.2851299", "l0.6536845,0.2858315", "l0.6539215,0.2871946", "l0.6542314,0.2881568", "l0.6544684,0.2882971", "l0.6543225,0.2893395", "l0.6550699,0.2902415", "l0.6552158,0.2908028", "l0.6551064,0.2910032", "l0.6560361,0.2917649", "l0.6564918,0.2925267", "l0.6567470,0.2925467", "l0.6568564,0.2927472", "l0.6573485,0.2929476", "l0.6580048,0.2935089", "l0.6586610,0.2950123", "l0.6589162,0.2961549", "l0.6595360,0.2969968", "l0.6599006,0.2971572", "l0.6599917,0.2974779", "l0.6602287,0.2975380", "l0.6605933,0.2979590", "l0.6619969,0.2980993", "l0.6629812,0.2984601", "l0.6633823,0.2987408", "l0.6642208,0.2995426", "l0.6646765,0.3006250", "l0.6648953,0.3008856", "l0.6654968,0.3024492", "l0.6656426,0.3033312", "l0.6659525,0.3041731", "l0.6661348,0.3045940", "l0.6663900,0.3046742", "l0.6667364,0.3051353", "l0.6664629,0.3061375", "l0.6664994,0.3072200", "l0.6669733,0.3082824", "l0.6673379,0.3084428", "l0.6672832,0.3089840", "l0.6678119,0.3104072", "l0.6676296,0.3105275", "l0.6676478,0.3118705", "l0.6679030,0.3121913", "l0.6679212,0.3126723", "l0.6685592,0.3130332", "l0.6685592,0.3137748", "l0.6687962,0.3139953", "l0.6688874,0.3143361", "l0.6689056,0.3149375", "l0.6693431,0.3164409", "l0.6694160,0.3177639", "l0.6697077,0.3195279", "l0.6696894,0.3202696", "l0.6693978,0.3208108", "l0.6696894,0.3213520", "l0.6697988,0.3215124", "l0.6709108,0.3219935", "l0.6711295,0.3223342", "l0.6716581,0.3223342", "l0.6724238,0.3227552", "l0.6731347,0.3226951", "l0.6733899,0.3228955", "l0.6743013,0.3230960", "l0.6746112,0.3233766", "l0.6747935,0.3233766", "l0.6748482,0.3235971", "l0.6750852,0.3237976", "l0.6750122,0.3240782", "l0.6755591,0.3243388", "l0.6757414,0.3248800", "l0.6759966,0.3251606", "l0.6759966,0.3254212", "l0.6761971,0.3255816", "l0.6763247,0.3261429", "l0.6766893,0.3266039", "l0.6772179,0.3270048", "l0.6777466,0.3269848", "l0.6778013,0.3268244", "l0.6778924,0.3268445", "l0.6778924,0.3270048", "l0.6776554,0.3272053", "l0.6775825,0.3278066", "l0.6777466,0.3281474", "l0.6780018,0.3283078", "l0.6780382,0.3286085", "l0.6783846,0.3292098", "l0.6785486,0.3292299", "l0.6786033,0.3292499", "l0.6786762,0.3293702", "l0.6789861,0.3293101", "l0.6790955,0.3295306", "l0.6798611,0.3294704", "l0.6803351,0.3296308", "l0.6804444,0.3298914", "l0.6803351,0.3300317", "l0.6803897,0.3306731", "l0.6806449,0.3310741", "l0.6824131,0.3323971", "l0.6828689,0.3340608", "l0.6837621,0.3355642", "l0.6840173,0.3364663", "l0.6840173,0.3369273", "l0.6845459,0.3381501", "l0.6847100,0.3382904", "l0.6846917,0.3386913", "l0.6850199,0.3388918", "l0.6853298,0.3393929", "l0.6853480,0.3396735", "l0.6856032,0.3396735", "l0.6856943,0.3398940", "l0.6859678,0.3398139", "l0.6861500,0.3407159", "l0.6869521,0.3419988", "l0.6874443,0.3423596", "l0.6880094,0.3423797", "l0.6886656,0.3427806", "l0.6893036,0.3429810", "l0.6895588,0.3433419", "l0.6897229,0.3437628", "l0.6896318,0.3443642", "l0.6897776,0.3458676", "l0.6897594,0.3462685", "l0.6897958,0.3473109", "l0.6903062,0.3477118", "l0.6907802,0.3483532", "l0.6908531,0.3493354", "l0.6907619,0.3497564", "l0.6913270,0.3500370", "l0.6917098,0.3505983", "l0.6921838,0.3509190", "l0.6928765,0.3510393", "l0.6928582,0.3515204", "l0.6934780,0.3520015", "l0.6935509,0.3528835", "l0.6937879,0.3533846", "l0.6938791,0.3542867", "l0.6941343,0.3544270", "l0.6945171,0.3552088", "l0.6948999,0.3554092", "l0.6954467,0.3559705", "l0.6957384,0.3571933", "l0.6963946,0.3573937", "l0.6965769,0.3576743", "l0.6971056,0.3579550", "l0.6975795,0.3584160", "l0.6983269,0.3597992", "l0.6991472,0.3604005", "l0.6998034,0.3615231", "l0.7003321,0.3620042", "l0.7005143,0.3624853", "l0.7003503,0.3629864", "l0.7006237,0.3649909", "l0.7009701,0.3649508", "l0.7014622,0.3652716", "l0.7020820,0.3652716", "l0.7023555,0.3650511", "l0.7025560,0.3650511", "l0.7029023,0.3653317", "l0.7036132,0.3654720", "l0.7037044,0.3658930", "l0.7035950,0.3663941", "l0.7045429,0.3673563", "l0.7049075,0.3680579", "l0.7051080,0.3683786", "l0.7056731,0.3690000", "l0.7058554,0.3690000", "l0.7062382,0.3693408", "l0.7063476,0.3697417", "l0.7069127,0.3698018", "l0.7069673,0.3700023", "l0.7074048,0.3701627", "l0.7080428,0.3709043", "l0.7080611,0.3711048", "l0.7078788,0.3713253", "l0.7079152,0.3727084", "l0.7085168,0.3742118", "l0.7091913,0.3741918", "l0.7093918,0.3745526", "l0.7095741,0.3744724", "l0.7098110,0.3746729", "l0.7105402,0.3746127", "l0.7107407,0.3755348", "l0.7109230,0.3755148", "l0.7111782,0.3756752", "l0.7110688,0.3759959", "l0.7115063,0.3764369", "l0.7120896,0.3764369", "l0.7138943,0.3760360", "l0.7146964,0.3762364", "l0.7148422,0.3766574", "l0.7149516,0.3769380", "l0.7153161,0.3773991", "l0.7159724,0.3773991", "l0.7162823,0.3776196", "l0.7168291,0.3786619", "l0.7169385,0.3786419", "l0.7178682,0.3795640", "l0.7186702,0.3797243", "l0.7195088,0.3802255", "l0.7197457,0.3805061", "l0.7201468,0.3806464", "l0.7208212,0.3816286", "l0.7210947,0.3824104", "l0.7213134,0.3826109", "l0.7218421,0.3837334", "l0.7228629,0.3851366", "l0.7231363,0.3852769", "l0.7234280,0.3863393", "l0.7236649,0.3864195", "l0.7240295,0.3871211", "l0.7242847,0.3873215", "l0.7243212,0.3878628", "l0.7247587,0.3887648", "l0.7248863,0.3891256", "l0.7248863,0.3894263", "l0.7250321,0.3894464", "l0.7252873,0.3898473", "l0.7254331,0.3898473", "l0.7254514,0.3895466", "l0.7255972,0.3895666", "l0.7257248,0.3897270", "l0.7256154,0.3900678", "l0.7259800,0.3900678", "l0.7261805,0.3902682", "l0.7263810,0.3908295", "l0.7263263,0.3915511", "l0.7264357,0.3924732", "l0.7266909,0.3930145", "l0.7268914,0.3931347", "l0.7273289,0.3937561", "l0.7275294,0.3944377", "l0.7284773,0.3949388", "l0.7285138,0.3952595", "l0.7284044,0.3952595", "l0.7283315,0.3954600", "l0.7284773,0.3961415", "l0.7281857,0.3961415", "l0.7280945,0.3966427", "l0.7284409,0.3975447", "l0.7281492,0.3985269", "l0.7283133,0.3987875", "l0.7283133,0.3994891", "l0.7287690,0.4001907", "l0.7287143,0.4005515", "l0.7286414,0.4006117", "l0.7283315,0.4007520", "l0.7279669,0.4004513", "l0.7276753,0.4007520", "l0.7276388,0.4009725", "l0.7274383,0.4009925", "l0.7273654,0.4001707", "l0.7272560,0.3999101", "l0.7269644,0.3996896", "l0.7270373,0.3990080", "l0.7269461,0.3987474", "l0.7266362,0.3985470", "l0.7263263,0.3981060", "l0.7259800,0.3981260", "l0.7257795,0.3986272", "l0.7249410,0.3985069", "l0.7240842,0.3976249", "l0.7239201,0.3976049", "l0.7236649,0.3971037", "l0.7228446,0.3970436", "l0.7225348,0.3965024", "l0.7213499,0.3964823", "l0.7208942,0.3960614", "l0.7203655,0.3958609", "l0.7200009,0.3962017", "l0.7198369,0.3962017", "l0.7194723,0.3974044", "l0.7192718,0.3976049", "l0.7190713,0.3983866", "l0.7190895,0.3988878", "l0.7198551,0.3997297", "l0.7206754,0.3998099", "l0.7206754,0.4000704", "l0.7209306,0.4005114", "l0.7212405,0.4006718", "l0.7213316,0.4010126", "l0.7216415,0.4014135", "l0.7217327,0.4027365", "l0.7222066,0.4030773", "l0.7224618,0.4030572", "l0.7231181,0.4047811", "l0.7239384,0.4048012", "l0.7244123,0.4045005", "l0.7245946,0.4045205", "l0.7259435,0.4034180", "l0.7262899,0.4040996", "l0.7263993,0.4040795", "l0.7264175,0.4043000", "l0.7261441,0.4047811", "l0.7261258,0.4052221", "l0.7258889,0.4054226", "l0.7258342,0.4058435", "l0.7255243,0.4064249", "l0.7255060,0.4066854", "l0.7256519,0.4069059", "l0.7251232,0.4074873", "l0.7249410,0.4082690", "l0.7246311,0.4086298", "l0.7246311,0.4091911", "l0.7247951,0.4092112", "l0.7249956,0.4095720", "l0.7252873,0.4094317", "l0.7254514,0.4094918", "l0.7254696,0.4096321", "l0.7253055,0.4097123", "l0.7253784,0.4104540", "l0.7252144,0.4107146", "l0.7255790,0.4113961", "l0.7277664,0.4116567", "l0.7278758,0.4119574", "l0.7278758,0.4129998", "l0.7281492,0.4130599", "l0.7282586,0.4134608", "l0.7285503,0.4134608", "l0.7283680,0.4140020", "l0.7291883,0.4145833", "l0.7292976,0.4145633", "l0.7293341,0.4147838", "l0.7292247,0.4155656", "l0.7290424,0.4157660", "l0.7289695,0.4156458", "l0.7286596,0.4157059", "l0.7284591,0.4149642", "l0.7280216,0.4143829", "l0.7280763,0.4138016", "l0.7271831,0.4127392", "l0.7268367,0.4125788", "l0.7264175,0.4120977", "l0.7262899,0.4120977", "l0.7261441,0.4123783", "l0.7258706,0.4124986", "l0.7259800,0.4128594", "l0.7266180,0.4137214", "l0.7266909,0.4140020", "l0.7265269,0.4140020", "l0.7260711,0.4133606", "l0.7256701,0.4132403", "l0.7255060,0.4128995", "l0.7251597,0.4128193", "l0.7251232,0.4123182", "l0.7247404,0.4119574", "l0.7247769,0.4117369", "l0.7241024,0.4114763", "l0.7225530,0.4127392", "l0.7220061,0.4135610", "l0.7216598,0.4138216", "l0.7213863,0.4143829", "l0.7213316,0.4148840", "l0.7212405,0.4149041", "l0.7211676,0.4147437", "l0.7208942,0.4148840", "l0.7209853,0.4156057", "l0.7216051,0.4156858", "l0.7218785,0.4159063", "l0.7221155,0.4159063", "l0.7222066,0.4161268", "l0.7226077,0.4160667", "l0.7228629,0.4166881", "l0.7233186,0.4168485", "l0.7234826,0.4173496", "l0.7243394,0.4181715", "l0.7252691,0.4196949", "l0.7257795,0.4212384", "l0.7262170,0.4214389", "l0.7262717,0.4232831", "l0.7265269,0.4236439", "l0.7264722,0.4246061", "l0.7260894,0.4257487", "l0.7261623,0.4268712", "l0.7263628,0.4275728", "l0.7267456,0.4277332", "l0.7275659,0.4275728", "l0.7287872,0.4280138", "l0.7289148,0.4279537", "l0.7290242,0.4281140", "l0.7289877,0.4285149", "l0.7295528,0.4291363", "l0.7299903,0.4301186", "l0.7301544,0.4302388", "l0.7310476,0.4301787", "l0.7314486,0.4305195", "l0.7314669,0.4309605", "l0.7317768,0.4312611", "l0.7319226,0.4321031", "l0.7320320,0.4322434", "l0.7320866,0.4334862", "l0.7322507,0.4336866", "l0.7322689,0.4339472", "l0.7324695,0.4340675", "l0.7327247,0.4348493", "l0.7329981,0.4351901", "l0.7332351,0.4351901", "l0.7335996,0.4355509", "l0.7340918,0.4358115", "l0.7343652,0.4361121", "l0.7346022,0.4369741", "l0.7347663,0.4370342", "l0.7347845,0.4368137", "l0.7349850,0.4367536", "l0.7350944,0.4372948", "l0.7360788,0.4382971", "l0.7361152,0.4392192", "l0.7364251,0.4396401", "l0.7365345,0.4400611", "l0.7368079,0.4400811", "l0.7367350,0.4403818", "l0.7369902,0.4411636", "l0.7368808,0.4412839", "l0.7368626,0.4418451", "l0.7366256,0.4424665", "l0.7364251,0.4424465", "l0.7363340,0.4427873", "l0.7362246,0.4428274", "l0.7363704,0.4420656", "l0.7363704,0.4419253", "l0.7362610,0.4419053", "l0.7362064,0.4422661", "l0.7358965,0.4423864", "l0.7358600,0.4428875", "l0.7360423,0.4431080", "l0.7362246,0.4431080", "l0.7365892,0.4428274", "l0.7367350,0.4446515", "l0.7371725,0.4447116", "l0.7372636,0.4449321", "l0.7375553,0.4450725", "l0.7374641,0.4459344", "l0.7373001,0.4461349", "l0.7375735,0.4468966", "l0.7383391,0.4472374", "l0.7385214,0.4474378", "l0.7390683,0.4487608", "l0.7391412,0.4488410", "l0.7394511,0.4487608", "l0.7397245,0.4489212", "l0.7397974,0.4494624", "l0.7422583,0.4500838", "l0.7423859,0.4503645", "l0.7424406,0.4509859", "l0.7427140,0.4511061", "l0.7429510,0.4509859", "l0.7436802,0.4518478", "l0.7439354,0.4518478", "l0.7440083,0.4521886", "l0.7446281,0.4524091", "l0.7447010,0.4528100", "l0.7450473,0.4530305", "l0.7453025,0.4530104", "l0.7454301,0.4531708", "l0.7462322,0.4533111", "l0.7463963,0.4535918", "l0.7466879,0.4536519", "l0.7467973,0.4540929", "l0.7476358,0.4541129", "l0.7479275,0.4539726", "l0.7481098,0.4543334", "l0.7485837,0.4542533", "l0.7488571,0.4543735", "l0.7495863,0.4555963", "l0.7499326,0.4556765", "l0.7502243,0.4559772", "l0.7501696,0.4569394", "l0.7500785,0.4571398", "l0.7495498,0.4575407", "l0.7494405,0.4579015", "l0.7496410,0.4583425", "l0.7496410,0.4590040", "l0.7501696,0.4596655", "l0.7504066,0.4603270", "l0.7501696,0.4606277", "l0.7499144,0.4605074", "l0.7499144,0.4607881", "l0.7496774,0.4607079", "l0.7494040,0.4608482", "l0.7489301,0.4613894", "l0.7490212,0.4616901", "l0.7488936,0.4618906", "l0.7486202,0.4619507", "l0.7483285,0.4623516", "l0.7485108,0.4626323", "l0.7483467,0.4628327", "l0.7484379,0.4631133", "l0.7482556,0.4636947", "l0.7484561,0.4638951", "l0.7487113,0.4640354", "l0.7487842,0.4649776", "l0.7486931,0.4658997", "l0.7486384,0.4662404", "l0.7487478,0.4681648", "l0.7485108,0.4682450", "l0.7484014,0.4684655", "l0.7484743,0.4693675", "l0.7486384,0.4693675", "l0.7488207,0.4695880", "l0.7488025,0.4701493", "l0.7488936,0.4703097", "l0.7491306,0.4704299", "l0.7494952,0.4703698", "l0.7497504,0.4704299", "l0.7497321,0.4706905", "l0.7501149,0.4707507", "l0.7502061,0.4710313", "l0.7505524,0.4712318", "l0.7506253,0.4717329", "l0.7511904,0.4720336", "l0.7512998,0.4720336", "l0.7513180,0.4718932", "l0.7517555,0.4719133", "l0.7518467,0.4721338", "l0.7520654,0.4722942", "l0.7522659,0.4724144", "l0.7525576,0.4723342", "l0.7529039,0.4724545", "l0.7538883,0.4736572", "l0.7539612,0.4740181", "l0.7542346,0.4741784", "l0.7543987,0.4748399", "l0.7546539,0.4751206", "l0.7546904,0.4754814", "l0.7545263,0.4757620", "l0.7546539,0.4760226", "l0.7539248,0.4756618", "l0.7537060,0.4756618", "l0.7531409,0.4762231", "l0.7530498,0.4765839", "l0.7530680,0.4772253", "l0.7534144,0.4778467", "l0.7540159,0.4785684", "l0.7541435,0.4789092", "l0.7546539,0.4794303", "l0.7551461,0.4796508", "l0.7551643,0.4799515", "l0.7553101,0.4800317", "l0.7551643,0.4805529", "l0.7543440,0.4808937", "l0.7542164,0.4811542", "l0.7547815,0.4816754", "l0.7553101,0.4818358", "l0.7554742,0.4817757", "l0.7556565,0.4821966", "l0.7560028,0.4823169", "l0.7564039,0.4836399", "l0.7560028,0.4838002", "l0.7560758,0.4838604", "l0.7564768,0.4839205", "l0.7574794,0.4872681", "l0.7578986,0.4873884", "l0.7586096,0.4885510", "l0.7590835,0.4888316", "l0.7596851,0.4904754", "l0.7595028,0.4907360", "l0.7598127,0.4909565", "l0.7600679,0.4914776", "l0.7603960,0.4912772", "l0.7603778,0.4909966", "l0.7605783,0.4909765", "l0.7606876,0.4906758", "l0.7611616,0.4904152", "l0.7617267,0.4902549", "l0.7622553,0.4903952", "l0.7615991,0.4921792", "l0.7616173,0.4927606", "l0.7623282,0.4943842", "l0.7628933,0.4947651", "l0.7628751,0.4954266", "l0.7627110,0.4958676", "l0.7623647,0.4961282", "l0.7622006,0.4960079", "l0.7618907,0.4961282", "l0.7615809,0.4959077", "l0.7613986,0.4959678", "l0.7610340,0.4953865", "l0.7609975,0.4950457", "l0.7605418,0.4948854", "l0.7602684,0.4943241", "l0.7597944,0.4942439", "l0.7593934,0.4946448", "l0.7587554,0.4963086", "l0.7586642,0.4969500", "l0.7581356,0.4972307", "l0.7578622,0.4977519", "l0.7578257,0.4980926", "l0.7579898,0.4988945", "l0.7580809,0.4990949", "l0.7583179,0.4991751", "l0.7584273,0.4997364", "l0.7580445,0.5008188", "l0.7574247,0.5012598", "l0.7572789,0.5015605", "l0.7575523,0.5018612", "l0.7574794,0.5026229", "l0.7578804,0.5039058", "l0.7582450,0.5041063", "l0.7584820,0.5045272", "l0.7584820,0.5046675", "l0.7582268,0.5048279", "l0.7583179,0.5053491", "l0.7589012,0.5054293", "l0.7583544,0.5060707", "l0.7581538,0.5060106", "l0.7579716,0.5062110", "l0.7580445,0.5064917", "l0.7579716,0.5067924", "l0.7577893,0.5069527", "l0.7577893,0.5072133", "l0.7580445,0.5073536", "l0.7579169,0.5076543", "l0.7577528,0.5073937", "l0.7576434,0.5074739", "l0.7577164,0.5077746", "l0.7574247,0.5083359", "l0.7575523,0.5093181", "l0.7574611,0.5102201", "l0.7575341,0.5104406", "l0.7577164,0.5105208", "l0.7576434,0.5110019", "l0.7572971,0.5116434", "l0.7572789,0.5122247", "l0.7570419,0.5125855", "l0.7573153,0.5130866", "l0.7572606,0.5136479", "l0.7575705,0.5140689", "l0.7578440,0.5142092", "l0.7579533,0.5148306", "l0.7580627,0.5150912", "l0.7581903,0.5152916", "l0.7590835,0.5155923", "l0.7594845,0.5159331", "l0.7601955,0.5160934", "l0.7600314,0.5157126", "l0.7601226,0.5156524", "l0.7603048,0.5160333", "l0.7609611,0.5166748", "l0.7609975,0.5169554", "l0.7617267,0.5170757", "l0.7622189,0.5173563", "l0.7622189,0.5177171", "l0.7622006,0.5179777", "l0.7625652,0.5182784", "l0.7625652,0.5185590", "l0.7628386,0.5187595", "l0.7635678,0.5189198", "l0.7636407,0.5192005", "l0.7638230,0.5192005", "l0.7640600,0.5195413", "l0.7642240,0.5195413", "l0.7642058,0.5209244", "l0.7648620,0.5219066", "l0.7650808,0.5224679", "l0.7652448,0.5231294", "l0.7650443,0.5234301", "l0.7654454,0.5234501", "l0.7656094,0.5236706", "l0.7654454,0.5243321", "l0.7657188,0.5248934", "l0.7655183,0.5250137", "l0.7655183,0.5251540", "l0.7658646,0.5250938", "l0.7660105,0.5253745", "l0.7660834,0.5255348", "l0.7664297,0.5260360", "l0.7668672,0.5263968", "l0.7670677,0.5274792", "l0.7675599,0.5278200", "l0.7678333,0.5281808", "l0.7680885,0.5289025", "l0.7682891,0.5288824", "l0.7683255,0.5291430", "l0.7684531,0.5292833", "l0.7683802,0.5296241", "l0.7680156,0.5297644", "l0.7680156,0.5299047", "l0.7683802,0.5299047", "l0.7685078,0.5300451", "l0.7684896,0.5308469", "l0.7690547,0.5321097", "l0.7692370,0.5328314", "l0.7692552,0.5342546", "l0.7694375,0.5347758", "l0.7695104,0.5349963", "l0.7698203,0.5354974", "l0.7699479,0.5359384", "l0.7705130,0.5364195", "l0.7708775,0.5377626", "l0.7711692,0.5380231", "l0.7710234,0.5383238", "l0.7713150,0.5389252", "l0.7714791,0.5399074", "l0.7728280,0.5408295", "l0.7728645,0.5410500", "l0.7730650,0.5411302", "l0.7730832,0.5412906", "l0.7729374,0.5413106", "l0.7730103,0.5417516", "l0.7734843,0.5421726", "l0.7734660,0.5426536", "l0.7735754,0.5429543", "l0.7745780,0.5441571", "l0.7746874,0.5447384", "l0.7751613,0.5450791", "l0.7752160,0.5456404", "l0.7756170,0.5462217", "l0.7762368,0.5464422", "l0.7767108,0.5472641", "l0.7769660,0.5474044", "l0.7772576,0.5482062", "l0.7775493,0.5484869", "l0.7776404,0.5492285", "l0.7779503,0.5499702", "l0.7776951,0.5511329", "l0.7778227,0.5524158", "l0.7783878,0.5536586", "l0.7790987,0.5543201", "l0.7792628,0.5546609", "l0.7792263,0.5548212", "l0.7793904,0.5551019", "l0.7790441,0.5554025", "l0.7789894,0.5556230", "l0.7794815,0.5559638", "l0.7794998,0.5561843", "l0.7796638,0.5562044", "l0.7798644,0.5567055", "l0.7802289,0.5595319", "l0.7816325,0.5621178", "l0.7820154,0.5624786", "l0.7822888,0.5637815", "l0.7823982,0.5639219", "l0.7823982,0.5643829", "l0.7831638,0.5649642", "l0.7834737,0.5655455", "l0.7840023,0.5658462", "l0.7842393,0.5663273", "l0.7844033,0.5675501", "l0.7847497,0.5681113", "l0.7854059,0.5687127", "l0.7857705,0.5687929", "l0.7859710,0.5690134", "l0.7859710,0.5692740", "l0.7861351,0.5694744", "l0.7859710,0.5699956", "l0.7860439,0.5704767", "l0.7858981,0.5703364", "l0.7857158,0.5703564", "l0.7856064,0.5707774", "l0.7858799,0.5711583", "l0.7863174,0.5711783", "l0.7870100,0.5717396", "l0.7873929,0.5723008", "l0.7877757,0.5737441", "l0.7880309,0.5738043", "l0.7881767,0.5740849", "l0.7883954,0.5752275", "l0.7884137,0.5760093", "l0.7891610,0.5781742", "l0.7895985,0.5794170", "l0.7903641,0.5808001", "l0.7905100,0.5817422", "l0.7907652,0.5822434", "l0.7913120,0.5830252", "l0.7927886,0.5837668", "l0.7929344,0.5840074", "l0.7933719,0.5842279", "l0.7939370,0.5858516", "l0.7934630,0.5860921", "l0.7938094,0.5862926", "l0.7939005,0.5866534", "l0.7945568,0.5863126", "l0.7948302,0.5863727", "l0.7949213,0.5865131", "l0.7948302,0.5867135", "l0.7949943,0.5868538", "l0.7949031,0.5873550", "l0.7950672,0.5875955", "l0.7950125,0.5877559", "l0.7953771,0.5877358", "l0.7959057,0.5890388", "l0.7959422,0.5894798", "l0.7963250,0.5902014", "l0.7962156,0.5910634", "l0.7963797,0.5923262", "l0.7966531,0.5925267", "l0.7967989,0.5929476", "l0.7971635,0.5933686", "l0.7971270,0.5937294", "l0.7966895,0.5935891", "l0.7964890,0.5937896", "l0.7965437,0.5940501", "l0.7968901,0.5939900", "l0.7969083,0.5938898", "l0.7970723,0.5939499", "l0.7975645,0.5956939", "l0.7977650,0.5959745", "l0.7980567,0.5959745", "l0.7982390,0.5964155", "l0.7979838,0.5967964", "l0.7984577,0.5967964", "l0.7989317,0.5971371", "l0.8000801,0.5970770", "l0.8009733,0.5977586", "l0.8014290,0.5987809", "l0.8014837,0.5992419", "l0.8019759,0.6004045", "l0.8022676,0.6008255", "l0.8022676,0.6013266", "l0.8025410,0.6017877", "l0.8023587,0.6020082", "l0.8023769,0.6022287", "l0.8027233,0.6019280", "l0.8029238,0.6019280", "l0.8037259,0.6030305", "l0.8043639,0.6031508", "l0.8045644,0.6034314", "l0.8048743,0.6035918", "l0.8054758,0.6046943", "l0.8061321,0.6053357", "l0.8064784,0.6053959", "l0.8067518,0.6056765", "l0.8068612,0.6059170", "l0.8066972,0.6060373", "l0.8066789,0.6063180", "l0.8071346,0.6067790", "l0.8070800,0.6071398", "l0.8072623,0.6078615", "l0.8068248,0.6083826", "l0.8067883,0.6086833", "l0.8071529,0.6084829", "l0.8074081,0.6085630", "l0.8079367,0.6101065", "l0.8087935,0.6103872", "l0.8088846,0.6108081", "l0.8087935,0.6116701", "l0.8089575,0.6118104", "l0.8086112,0.6123717", "l0.8085383,0.6127325", "l0.8086294,0.6129329", "l0.8089393,0.6129129", "l0.8089575,0.6135544", "l0.8093039,0.6138550", "l0.8101424,0.6141958", "l0.8102518,0.6143562", "l0.8102153,0.6145767", "l0.8100148,0.6147370", "l0.8100148,0.6150979", "l0.8100877,0.6155188", "l0.8103611,0.6160199", "l0.8104888,0.6171024", "l0.8107804,0.6174031", "l0.8106893,0.6178240", "l0.8109809,0.6183252", "l0.8111450,0.6183252", "l0.8112908,0.6185256", "l0.8116007,0.6194076", "l0.8135330,0.6210714", "l0.8138429,0.6217329", "l0.8146085,0.6227352", "l0.8146996,0.6240381", "l0.8149913,0.6247197", "l0.8149730,0.6256217", "l0.8148272,0.6259825", "l0.8150095,0.6261429", "l0.8151006,0.6268846", "l0.8149366,0.6271853", "l0.8149548,0.6272855", "l0.8151371,0.6274859", "l0.8153741,0.6283479", "l0.8158662,0.6289493", "l0.8156293,0.6294103", "l0.8158298,0.6297912", "l0.8164860,0.6299916", "l0.8168506,0.6302723", "l0.8174704,0.6313747", "l0.8178532,0.6317957", "l0.8177803,0.6324772", "l0.8180355,0.6330786", "l0.8179443,0.6340207", "l0.8183271,0.6345820", "l0.8185823,0.6352636", "l0.8188193,0.6352034", "l0.8190016,0.6353437", "l0.8191110,0.6359251", "l0.8190198,0.6362257", "l0.8190927,0.6368271", "l0.8191839,0.6369674", "l0.8193662,0.6369674", "l0.8194026,0.6371679", "l0.8193662,0.6373082", "l0.8192203,0.6373082", "l0.8192933,0.6387715", "l0.8199495,0.6404553", "l0.8201500,0.6404754", "l0.8213531,0.6421592", "l0.8220458,0.6427405", "l0.8224833,0.6434020", "l0.8232307,0.6457072", "l0.8231213,0.6457273", "l0.8231031,0.6461081", "l0.8228661,0.6465291", "l0.8232489,0.6465892", "l0.8234130,0.6473911", "l0.8236317,0.6474512", "l0.8233765,0.6486138", "l0.8237411,0.6497163", "l0.8241421,0.6504380", "l0.8244156,0.6504179", "l0.8246161,0.6505582", "l0.8260562,0.6524225", "l0.8272593,0.6545072", "l0.8273322,0.6551486", "l0.8277150,0.6555696", "l0.8276056,0.6559104", "l0.8276238,0.6565719", "l0.8281160,0.6574539", "l0.8283712,0.6584762", "l0.8286446,0.6586766", "l0.8289545,0.6592580", "l0.8289363,0.6594785", "l0.8284988,0.6599195", "l0.8288998,0.6596990", "l0.8291733,0.6596990", "l0.8294832,0.6601600", "l0.8296837,0.6608215", "l0.8302306,0.6612425", "l0.8306134,0.6618238", "l0.8308868,0.6619240", "l0.8315430,0.6626055", "l0.8315795,0.6629263", "l0.8319441,0.6633673", "l0.8323998,0.6645499", "l0.8323269,0.6648306", "l0.8324180,0.6652515", "l0.8330560,0.6661335", "l0.8332930,0.6667950", "l0.8334935,0.6669955", "l0.8339492,0.6679376", "l0.8339310,0.6687795", "l0.8345508,0.6701226", "l0.8344779,0.6709645", "l0.8346602,0.6710647", "l0.8347695,0.6714857", "l0.8353893,0.6723677", "l0.8358633,0.6725080", "l0.8359544,0.6728688", "l0.8362096,0.6731094", "l0.8361185,0.6733299", "l0.8363737,0.6737107", "l0.8363919,0.6742920", "l0.8373216,0.6760159", "l0.8374309,0.6771986", "l0.8381601,0.6778802", "l0.8383424,0.6786018", "l0.8387069,0.6791430", "l0.8397460,0.6800451", "l0.8397642,0.6808870", "l0.8399830,0.6817289", "l0.8393450,0.6827913", "l0.8390351,0.6837334", "l0.8390715,0.6841945", "l0.8393450,0.6844150", "l0.8391991,0.6845553", "l0.8391991,0.6848359", "l0.8394543,0.6847557", "l0.8395637,0.6853371", "l0.8397278,0.6853571", "l0.8398007,0.6855977", "l0.8399100,0.6856177", "l0.8400559,0.6859384", "l0.8404569,0.6862391", "l0.8410402,0.6868405", "l0.8412225,0.6872614", "l0.8414777,0.6871612", "l0.8415871,0.6873015", "l0.8417329,0.6881033", "l0.8420246,0.6887849", "l0.8423709,0.6891457", "l0.8425532,0.6896468", "l0.8432459,0.6903083", "l0.8433188,0.6910701", "l0.8431183,0.6915111", "l0.8433188,0.6923931", "l0.8432824,0.6934154", "l0.8439204,0.6939165", "l0.8437746,0.6958609", "l0.8439568,0.6972841", "l0.8443396,0.6975648", "l0.8445219,0.6981060", "l0.8448318,0.6983466", "l0.8448501,0.6985069", "l0.8455974,0.6994090", "l0.8465089,0.7000103", "l0.8467094,0.7003311", "l0.8473656,0.7008723", "l0.8478578,0.7016741", "l0.8480401,0.7024960", "l0.8483864,0.7024960", "l0.8485870,0.7026964", "l0.8494255,0.7038991", "l0.8495349,0.7042600", "l0.8496442,0.7043602", "l0.8500453,0.7043602", "l0.8503552,0.7052021", "l0.8507197,0.7056631", "l0.8507562,0.7062845", "l0.8515218,0.7083492", "l0.8514671,0.7093715", "l0.8512848,0.7099729", "l0.8510296,0.7103538", "l0.8511025,0.7105743", "l0.8508656,0.7114563", "l0.8510296,0.7115565", "l0.8510114,0.7116968", "l0.8515400,0.7127392", "l0.8522145,0.7129797", "l0.8529436,0.7129196", "l0.8531442,0.7131401", "l0.8530895,0.7134608", "l0.8526884,0.7137014", "l0.8523421,0.7149041", "l0.8523239,0.7154253", "l0.8524150,0.7160467", "l0.8529619,0.7162672", "l0.8530348,0.7165679", "l0.8539645,0.7176102", "l0.8539645,0.7178508", "l0.8533811,0.7184321", "l0.8533994,0.7186325", "l0.8538733,0.7187729", "l0.8537275,0.7184922", "l0.8538186,0.7182918", "l0.8548941,0.7183319", "l0.8552587,0.7187929", "l0.8554592,0.7202161", "l0.8560425,0.7214990", "l0.8563342,0.7216394", "l0.8566441,0.7220804", "l0.8568811,0.7220804", "l0.8571363,0.7223610", "l0.8575738,0.7225214", "l0.8578472,0.7228421", "l0.8578837,0.7234434", "l0.8574097,0.7233432", "l0.8572274,0.7236439", "l0.8566259,0.7238043", "l0.8562431,0.7241851", "l0.8564983,0.7256284", "l0.8561519,0.7262298", "l0.8558420,0.7263901", "l0.8554592,0.7268311", "l0.8553134,0.7274325", "l0.8553863,0.7278735", "l0.8557691,0.7285350", "l0.8566988,0.7291965", "l0.8569722,0.7296575", "l0.8572456,0.7297578", "l0.8575373,0.7303792", "l0.8580659,0.7309605", "l0.8581935,0.7310607", "l0.8592326,0.7311409", "l0.8600711,0.7318425", "l0.8602352,0.7321432", "l0.8602352,0.7326643", "l0.8603628,0.7329650", "l0.8605451,0.7332457", "l0.8609279,0.7333258", "l0.8610555,0.7334862", "l0.8610555,0.7337869", "l0.8611648,0.7338069", "l0.8608549,0.7343482", "l0.8607273,0.7343281", "l0.8607273,0.7344684", "l0.8612560,0.7349094", "l0.8613654,0.7354507", "l0.8617482,0.7358115", "l0.8621857,0.7367336", "l0.8623862,0.7376557", "l0.8632247,0.7389586", "l0.8643002,0.7398406", "l0.8654668,0.7401212", "l0.8655580,0.7409431", "l0.8658679,0.7414843", "l0.8666153,0.7419253", "l0.8668522,0.7422060", "l0.8677637,0.7425267", "l0.8679277,0.7428474", "l0.8684746,0.7432082", "l0.8689303,0.7431481", "l0.8692767,0.7432483", "l0.8693131,0.7430880", "l0.8691491,0.7430679", "l0.8691855,0.7428474", "l0.8702975,0.7429877", "l0.8703157,0.7438297", "l0.8702246,0.7438497", "l0.8705709,0.7443709", "l0.8707714,0.7453531", "l0.8710631,0.7454333", "l0.8711725,0.7457540", "l0.8714641,0.7458142", "l0.8721021,0.7467763", "l0.8723756,0.7469567", "l0.8724849,0.7469567", "l0.8724849,0.7467763", "l0.8727584,0.7467964", "l0.8733052,0.7471772", "l0.8735787,0.7476383", "l0.8738885,0.7476984", "l0.8740344,0.7482797", "l0.8738339,0.7483599", "l0.8743625,0.7494223", "l0.8756750,0.7510059", "l0.8759484,0.7515271", "l0.8761489,0.7516073", "l0.8771880,0.7531708", "l0.8780994,0.7548546", "l0.8782452,0.7563180", "l0.8787921,0.7565184", "l0.8788832,0.7568391", "l0.8790838,0.7570596", "l0.8789379,0.7574606", "l0.8794848,0.7579617", "l0.8794848,0.7581221", "l0.8791384,0.7583626", "l0.8789197,0.7590441", "l0.8790108,0.7593649", "l0.8793025,0.7597457", "l0.8793754,0.7601466", "l0.8795395,0.7601667", "l0.8798311,0.7607079", "l0.8802869,0.7611690", "l0.8802686,0.7613293", "l0.8807061,0.7622314", "l0.8811618,0.7625120", "l0.8813624,0.7629129", "l0.8816722,0.7629931", "l0.8818181,0.7634541", "l0.8822738,0.7638350", "l0.8823467,0.7640555", "l0.8826019,0.7640555", "l0.8828389,0.7642760", "l0.8829118,0.7645767", "l0.8834587,0.7648573", "l0.8838050,0.7650979", "l0.8838597,0.7653785", "l0.8841331,0.7654386", "l0.8845706,0.7657995", "l0.8846071,0.7659398", "l0.8844795,0.7659398", "l0.8842790,0.7662605", "l0.8845159,0.7668017", "l0.8843883,0.7670824", "l0.8845524,0.7673029", "l0.8845524,0.7675835", "l0.8850263,0.7679443", "l0.8852816,0.7678641", "l0.8857373,0.7679443", "l0.8861383,0.7676637", "l0.8861748,0.7672227", "l0.8859196,0.7669821", "l0.8857555,0.7661402", "l0.8853909,0.7659197", "l0.8849534,0.7654186", "l0.8846071,0.7651981", "l0.8843337,0.7652983", "l0.8840967,0.7649976", "l0.8854456,0.7647170", "l0.8859196,0.7654587", "l0.8861748,0.7655990", "l0.8862477,0.7659598", "l0.8865393,0.7660600", "l0.8870133,0.7666815", "l0.8872138,0.7666815", "l0.8874872,0.7670423", "l0.8887450,0.7670623", "l0.8893101,0.7676637", "l0.8896565,0.7676436", "l0.8899846,0.7678240", "l0.8902762,0.7684054", "l0.8911877,0.7688865", "l0.8919533,0.7698486", "l0.8919898,0.7702295", "l0.8923726,0.7705502", "l0.8924819,0.7712919", "l0.8929194,0.7719734", "l0.8930288,0.7727352", "l0.8932658,0.7733365", "l0.8932111,0.7742987", "l0.8933934,0.7748399", "l0.8932293,0.7754413", "l0.8933387,0.7760226", "l0.8931017,0.7763033", "l0.8931199,0.7767042", "l0.8933205,0.7768445", "l0.8942319,0.7769848", "l0.8950704,0.7776062", "l0.8953439,0.7776263", "l0.8956355,0.7780272", "l0.8959819,0.7779670", "l0.8961824,0.7782477", "l0.8967292,0.7782276", "l0.8974766,0.7778468", "l0.8987526,0.7777866", "l0.8994636,0.7782276", "l0.9001745,0.7782076", "l0.9009036,0.7784481", "l0.9019245,0.7787689", "l0.9040208,0.7799114", "l0.9053332,0.7808736", "l0.9056067,0.7812745", "l0.9058436,0.7813547", "l0.9062265,0.7818158", "l0.9067551,0.7826978", "l0.9066457,0.7829984", "l0.9070285,0.7834996", "l0.9071379,0.7839606", "l0.9071197,0.7845620", "l0.9073202,0.7850431", "l0.9074113,0.7857447", "l0.9079764,0.7863460", "l0.9081405,0.7868071", "l0.9088149,0.7871078", "l0.9090701,0.7874084", "l0.9090701,0.7881501", "l0.9088879,0.7887515", "l0.9087603,0.7887715", "l0.9084868,0.7877893", "l0.9081040,0.7872882", "l0.9077577,0.7870677", "l0.9068645,0.7851433", "l0.9063176,0.7847023", "l0.9054608,0.7844217", "l0.9049322,0.7844016", "l0.9047317,0.7846823", "l0.9042577,0.7849228", "l0.9041666,0.7851032", "l0.9037291,0.7851032", "l0.9033281,0.7850230", "l0.9028359,0.7854640", "l0.9025442,0.7859251", "l0.9015416,0.7863861", "l0.9008672,0.7872080", "l0.9005755,0.7872681", "l0.8995365,0.7870677", "l0.8992813,0.7866267", "l0.8972579,0.7857647", "l0.8967110,0.7851834", "l0.8958178,0.7854239", "l0.8940132,0.7855843", "l0.8922996,0.7850431", "l0.8919533,0.7847223", "l0.8918439,0.7843615", "l0.8914064,0.7842212", "l0.8914247,0.7838604", "l0.8910965,0.7834996", "l0.8909689,0.7831187", "l0.8906590,0.7829583", "l0.8905861,0.7827378", "l0.8902945,0.7826376", "l0.8892007,0.7828581", "l0.8879794,0.7837201", "l0.8870680,0.7841611", "l0.8869951,0.7840608", "l0.8871044,0.7839005", "l0.8876695,0.7835798", "l0.8879430,0.7832590", "l0.8884898,0.7830987", "l0.8892919,0.7826176", "l0.8898388,0.7825374", "l0.8900028,0.7823570", "l0.8898388,0.7820563", "l0.8894377,0.7817757", "l0.8890914,0.7817155", "l0.8887086,0.7813347", "l0.8879065,0.7810941", "l0.8876148,0.7811142", "l0.8866123,0.7805729", "l0.8859925,0.7804928", "l0.8852633,0.7806531", "l0.8848441,0.7810139", "l0.8849352,0.7814148", "l0.8848441,0.7815151", "l0.8850810,0.7818358", "l0.8849170,0.7820563", "l0.8849352,0.7823369", "l0.8849170,0.7825574", "l0.8848623,0.7828381", "l0.8852086,0.7829183", "l0.8852633,0.7834394", "l0.8850628,0.7834394", "l0.8846800,0.7833593", "l0.8845524,0.7839606", "l0.8846253,0.7840608", "l0.8843701,0.7841611", "l0.8844248,0.7843615", "l0.8842607,0.7847223", "l0.8840420,0.7847424", "l0.8839873,0.7850431", "l0.8838232,0.7849629", "l0.8835863,0.7855442", "l0.8833493,0.7855242", "l0.8831123,0.7848627", "l0.8828753,0.7850832", "l0.8830394,0.7853037", "l0.8828571,0.7856244", "l0.8834769,0.7860854", "l0.8834040,0.7864463", "l0.8831852,0.7865866", "l0.8834769,0.7868271", "l0.8834040,0.7871478", "l0.8836592,0.7870677", "l0.8836410,0.7872882", "l0.8834951,0.7873683", "l0.8835680,0.7876089", "l0.8835680,0.7878494", "l0.8837686,0.7882103", "l0.8835316,0.7885711", "l0.8836410,0.7893328", "l0.8834951,0.7898139", "l0.8836410,0.7902749", "l0.8834951,0.7903551", "l0.8834587,0.7910367", "l0.8837139,0.7914376", "l0.8838962,0.7920991", "l0.8840602,0.7920790", "l0.8840785,0.7909565", "l0.8838962,0.7903752", "l0.8840238,0.7902749", "l0.8841696,0.7904153", "l0.8842425,0.7908763", "l0.8842972,0.7919187", "l0.8839144,0.7930011", "l0.8838050,0.7930612", "l0.8835498,0.7928207", "l0.8835498,0.7934221", "l0.8832764,0.7935223", "l0.8832764,0.7940635", "l0.8834769,0.7946448", "l0.8834769,0.7953464", "l0.8835863,0.7957072", "l0.8834951,0.7959879", "l0.8835863,0.7962084", "l0.8833493,0.7963888", "l0.8832946,0.7966293", "l0.8831123,0.7966494", "l0.8828753,0.7973911", "l0.8827842,0.7986339", "l0.8829300,0.7990949", "l0.8831306,0.7991751", "l0.8829300,0.7997163", "l0.8833858,0.8000170", "l0.8835316,0.8003979", "l0.8835134,0.8007787", "l0.8836956,0.8010794", "l0.8843337,0.8012999", "l0.8845159,0.8010995", "l0.8843701,0.8007787", "l0.8845159,0.8007186", "l0.8848987,0.7995961", "l0.8852998,0.7993756", "l0.8858284,0.7994557", "l0.8862659,0.8008389", "l0.8860836,0.8015204", "l0.8861201,0.8023423", "l0.8857190,0.8027833", "l0.8854821,0.8028033", "l0.8854638,0.8022421", "l0.8856279,0.8016407", "l0.8854274,0.8015004", "l0.8849899,0.8015605", "l0.8848076,0.8018411", "l0.8849717,0.8020216", "l0.8840420,0.8020015", "l0.8838415,0.8022421", "l0.8838597,0.8024826", "l0.8841331,0.8029236", "l0.8845889,0.8030840", "l0.8846071,0.8033245", "l0.8852269,0.8036452", "l0.8851539,0.8042666", "l0.8854092,0.8054092", "l0.8853545,0.8057300", "l0.8856461,0.8064716", "l0.8855368,0.8067723", "l0.8857008,0.8073136", "l0.8855914,0.8080151", "l0.8856461,0.8092179", "l0.8859013,0.8090375", "l0.8861565,0.8094384", "l0.8857555,0.8109618", "l0.8857008,0.8135878", "l0.8858466,0.8144096", "l0.8852633,0.8144297", "l0.8852633,0.8142693", "l0.8849170,0.8138885", "l0.8846253,0.8126055", "l0.8842607,0.8127459", "l0.8840420,0.8131468", "l0.8842061,0.8137682", "l0.8840055,0.8141290", "l0.8841514,0.8142092", "l0.8842243,0.8144898", "l0.8842243,0.8151513", "l0.8844248,0.8153317", "l0.8845889,0.8153117", "l0.8845706,0.8146502", "l0.8844613,0.8144698", "l0.8848441,0.8146301", "l0.8849170,0.8158329", "l0.8852816,0.8172761", "l0.8851722,0.8177973", "l0.8853362,0.8179978", "l0.8853362,0.8183987", "l0.8858649,0.8187996", "l0.8858831,0.8190602", "l0.8857737,0.8192807", "l0.8855003,0.8216460", "l0.8853180,0.8220870", "l0.8853180,0.8229490", "l0.8850263,0.8235504", "l0.8850993,0.8237709", "l0.8852998,0.8234100", "l0.8853727,0.8238510", "l0.8844613,0.8256752", "l0.8844795,0.8261964", "l0.8843154,0.8262164", "l0.8843154,0.8257353", "l0.8840967,0.8260560", "l0.8841149,0.8263367", "l0.8844977,0.8263567", "l0.8843519,0.8268779", "l0.8838232,0.8271585", "l0.8836592,0.8270784", "l0.8836410,0.8272187", "l0.8839326,0.8280405", "l0.8840785,0.8279002", "l0.8839691,0.8275394", "l0.8841878,0.8276797", "l0.8843337,0.8290027", "l0.8845889,0.8298446", "l0.8846618,0.8306865", "l0.8854821,0.8312879", "l0.8853909,0.8314483", "l0.8857920,0.8317690", "l0.8857737,0.8320095", "l0.8859196,0.8322701", "l0.8860654,0.8324104", "l0.8863388,0.8323904", "l0.8866487,0.8331321", "l0.8872685,0.8339940", "l0.8877971,0.8344751", "l0.8878883,0.8350364", "l0.8884898,0.8366200", "l0.8883258,0.8371011", "l0.8886174,0.8376223", "l0.8888544,0.8377024", "l0.8887086,0.8381835", "l0.8888726,0.8385644", "l0.8889273,0.8392459", "l0.8891096,0.8393061", "l0.8889638,0.8396068", "l0.8892554,0.8402081", "l0.8893466,0.8398072", "l0.8895471,0.8401279", "l0.8896565,0.8408696", "l0.8894742,0.8438965", "l0.8896565,0.8445981", "l0.8894559,0.8447584", "l0.8893648,0.8455202", "l0.8896565,0.8468231", "l0.8897294,0.8482062", "l0.8900757,0.8483666", "l0.8901669,0.8489078", "l0.8909689,0.8508923", "l0.8906955,0.8522755", "l0.8907137,0.8527566", "l0.8909689,0.8534381", "l0.8909507,0.8553825", "l0.8914064,0.8556030", "l0.8919715,0.8562445", "l0.8924455,0.8564048", "l0.8924637,0.8569461", "l0.8927736,0.8576677", "l0.8929559,0.8585898", "l0.8942684,0.8601333", "l0.8945053,0.8611356", "l0.8948152,0.8611155", "l0.8947423,0.8614763", "l0.8951069,0.8620176", "l0.8655762,0.8926871", "l0.8655762,0.8926871", "l0.8616023,0.8968164", "l0.8423892,0.8905422", "l0.8402382,0.8899809", "l0.8189834,0.9442640", "l0.8089393,0.9463086", "l0.8070982,0.9465291", "l0.8069159,0.9466895", "l0.8044186,0.9471906", "l0.8029785,0.9473510", "l0.8023769,0.9475715", "l0.7948667,0.9490949", "l0.7930985,0.9493355", "l0.7926245,0.9495159", "l0.7754712,0.9530439", "l0.7694557,0.9726483", "l0.7694557,0.9726483", "l0.6940431,0.9724679", "l0.6940431,0.9724679", "l0.6428566,0.9726483", "l0.6072375,0.9727085", "l0.6055969,0.9726283", "l0.6004017,0.9727686", "l0.5938029,0.9724278", "l0.5890270,0.9725080", "l0.5880973,0.9724078", "l0.5597697,0.9723075", "l0.5607358,0.9676971", "l0.5619207,0.9629664", "l0.5619207,0.9629664", "l0.5767043,0.9574539", "l0.5817172,0.9545673", "l0.5852901,0.9506384", "l0.5879150,0.9443442", "l0.5956987,0.9457073", "l0.6006387,0.9433619", "l0.6031725,0.9398941", "l0.6050865,0.9359652", "l0.6072375,0.9301921", "l0.6079485,0.9254614", "l0.6100995,0.9165411", "l0.6151124,0.9152382", "l0.6189587,0.9179042", "l0.6216201,0.9217129", "l0.6259038,0.9262832", "l0.6259038,0.9262832", "l0.6321745,0.9293301", "l0.6375338,0.9275661", "l0.6375338,0.9275661", "l0.6423098,0.9259825", "l0.6480336,0.9204700", "l0.6548147,0.9155589", "l0.6597912,0.9123717", "l0.6640020,0.9072000", "l0.6661530,0.9003645", "l0.6656791,0.8892593", "l0.6711295,0.8859719", "l0.6711295,0.8859719", "l0.6768898,0.8853304", "l0.6816658,0.8889987", "l0.6850016,0.8913641", "l0.6896864,0.8929076", "l0.6896864,0.8929076", "l0.6949363,0.8920456", "l0.6975977,0.8958943", "l0.7026289,0.9017877", "l0.7075689,0.9025895", "l0.7097381,0.8985403", "l0.7097381,0.8985403", "l0.7093553,0.8919053", "l0.7052903,0.8848493", "l0.7052903,0.8848493", "l0.6992383,0.8801587", "l0.6973790,0.8781942", "l0.6973790,0.8781942", "l0.6973790,0.8781942", "l0.6973790,0.8781942", "l0.6918739,0.8776931", "l0.6873531,0.8727419", "l0.6855667,0.8710380", "l0.6856943,0.8686325", "l0.6880823,0.8658061", "l0.6903427,0.8616968", "l0.6923661,0.8590107", "l0.6952280,0.8557433", "l0.6971420,0.8516340", "l0.6983269,0.8472441", "l0.6997487,0.8449789", "l0.7001862,0.8422327", "l0.6987644,0.8393061", "l0.6972514,0.8354774", "l0.6972514,0.8354774", "l0.6972514,0.8354774", "l0.6972514,0.8354774", "l0.6943895,0.8347558", "l0.6926030,0.8279403", "l0.6924754,0.8232497", "l0.6931864,0.8188397", "l0.6942619,0.8168552", "l0.6955743,0.8153919", "l0.6955743,0.8153919", "l0.6955743,0.8153919", "l0.6955743,0.8153919", "l0.6958660,0.8117035", "l0.6958660,0.8117035", "l0.6958660,0.8117035", "l0.6958660,0.8117035", "l0.6939155,0.8108816", "l0.6935509,0.8018011", "l0.6909260,0.7985337", "l0.6879547,0.7966895", "l0.6861683,0.7931214", "l0.6855667,0.7902749", "l0.6852022,0.7865665", "l0.6830512,0.7822968", "l0.6813741,0.7800117", "l0.6807726,0.7740181", "l0.6793507,0.7703097", "l0.6793507,0.7582223", "l0.6793507,0.7582223", "l0.6793507,0.7582223", "l0.6793507,0.7582223", "l0.6812100,0.7511061", "l0.6814470,0.7463554", "l0.6850745,0.7404019", "l0.6908895,0.7350898", "l0.6916005,0.7270516", "l0.6911812,0.7239245", "l0.6856032,0.7136813", "l0.6821215,0.7046208", "l0.6818480,0.6854172", "l0.6818480,0.6854172", "l0.6820121,0.6858382", "l0.6818480,0.6854172", "l0.6818480,0.6854172", "l0.6810095,0.6787221", "l0.6749940,0.6676971", "l0.6749940,0.6676971", "l0.6749940,0.6676971", "l0.6749940,0.6676971", "l0.6670827,0.6616434", "l0.6637468,0.6580953", "l0.6593902,0.6551085", "l0.6593902,0.6551085", "l0.6546142,0.6503377", "l0.6546142,0.6503377", "l0.6517887,0.6454066", "l0.6503304,0.6403351", "l0.6503304,0.6295506", "l0.6517887,0.6258823", "l0.6549241,0.6222140", "l0.6583693,0.6159999", "l0.6688874,0.6084628", "l0.6724784,0.6021485", "l0.6756503,0.5911235", "l0.6756503,0.5911235", "l0.6759966,0.5889386", "l0.6759419,0.5816821", "l0.6759419,0.5816821", "l0.6753039,0.5748065", "l0.6753039,0.5748065", "l0.6753039,0.5748065", "l0.6753039,0.5748065", "l0.6732441,0.5698353", "l0.6721139,0.5654654", "l0.6695071,0.5608749", "l0.6633276,0.5562845", "l0.6551611,0.5543602", "l0.6440780,0.5544805", "l0.6395754,0.5561442", "l0.6342344,0.5602335", "l0.6304610,0.5633004", "l0.6278543,0.5648239", "l0.6247737,0.5650644", "l0.6247737,0.5650644", "l0.6212008,0.5633004", "l0.6215472,0.5600130", "l0.6209274,0.5597524", "l0.6171905,0.5541397", "l0.6152947,0.5489479", "l0.6119953,0.5462819", "l0.6046490,0.5438564", "l0.5996726,0.5404086", "l0.5981960,0.5387047", "l0.5960815,0.5351567", "l0.5938758,0.5279403", "l0.5930920,0.5219668", "l0.5930920,0.5219668", "l0.5930920,0.5219668", "l0.5930920,0.5219668", "l0.5901025,0.5209043", "l0.5883160,0.5183385", "l0.5874775,0.5151313", "l0.5838135,0.5099996", "l0.5732044,0.5002575", "l0.5685013,0.4983532", "l0.5685013,0.4983532", "l0.5685013,0.4983532", "l0.5685013,0.4983532", "l0.5675899,0.4976917", "l0.5675899,0.4976917", "l0.5666420,0.4926804", "l0.5639259,0.4849829", "l0.5597333,0.4774057", "l0.5571812,0.4712318", "l0.5571812,0.4712318", "l0.5548297,0.4694076", "l0.5501631,0.4650578", "l0.5501631,0.4650578", "l0.5449862,0.4606879", "l0.5449862,0.4606879", "l0.5449862,0.4606879", "l0.5449862,0.4606879", "l0.5424888,0.4518278", "l0.5400461,0.4503244", "l0.5362363,0.4482196", "l0.5341400,0.4480191", "l0.5270490,0.4449722", "l0.5245152,0.4428274", "l0.5183174,0.4404420", "l0.5166039,0.4395199", "l0.5139060,0.4360119", "l0.5127941,0.4328848", "l0.5117368,0.4234434", "l0.5129581,0.4166480", "l0.5129581,0.4166480", "l0.5136326,0.4099328", "l0.5131769,0.4004313", "l0.5111353,0.3931548", "l0.5102238,0.3813881", "l0.5041172,0.3659531", "l0.5029870,0.3538657", "l0.5027682,0.3493755", "l0.5041354,0.3437428", "l0.5063958,0.3392325", "l0.5084374,0.3355642", "l0.5105702,0.3321365", "l0.5106431,0.3271652", "l0.5106431,0.3271652", "l0.5107707,0.3185657", "l0.5131040,0.3111288", "l0.5131040,0.3111288", "l0.5139425,0.3078815", "l0.5139425,0.3078815", "l0.5139425,0.3078815", "l0.5139425,0.3078815", "l0.5071431,0.3068792", "l0.5071431,0.3068792", "l0.5121561,0.3050952", "l0.5132863,0.2977585", "l0.5187184,0.2875755", "l0.5225647,0.2858716", "l0.5250621,0.2816220", "l0.5266480,0.2782343", "l0.5293641,0.2739846", "l0.5334291,0.2683118", "l0.5347963,0.2668886", "l0.5350150,0.2603738", "l0.5381868,0.2575273", "l0.5384056,0.2512932", "l0.5386243,0.2484468", "l0.5386243,0.2484468", "l0.5435461,0.2534982", "l0.5472648,0.2577278", "l0.5529521,0.2672494", "l0.5590406,0.2719400", "l0.5590406,0.2719400", "l0.5590406,0.2719400", "c"]}, {"n": "Al Buḩayrah", "u": "EG-BH", "i": ["m0.4668393,0.0199488", "l0.4670215,0.0202896", "l0.4669486,0.0204099", "l0.4664018,0.0202695", "l0.4661648,0.0204500", "l0.4655450,0.0205301", "l0.4653992,0.0206705", "l0.4652716,0.0218130", "l0.4652898,0.0219333", "l0.4655815,0.0220536", "l0.4655997,0.0222540", "l0.4658549,0.0222540", "l0.4659643,0.0220736", "l0.4658549,0.0218732", "l0.4661466,0.0215324", "l0.4665476,0.0214723", "l0.4672950,0.0219333", "l0.4674043,0.0221338", "l0.4676960,0.0221538", "l0.4677142,0.0219534", "l0.4674773,0.0217730", "l0.4673861,0.0213921", "l0.4670945,0.0210714", "l0.4671309,0.0209511", "l0.4679512,0.0219734", "l0.4686621,0.0221739", "l0.4687351,0.0220536", "l0.4685345,0.0219333", "l0.4685163,0.0217529", "l0.4680606,0.0214923", "l0.4681335,0.0212317", "l0.4676596,0.0207907", "l0.4675866,0.0209310", "l0.4674773,0.0208509", "l0.4675319,0.0206705", "l0.4676413,0.0206705", "l0.4682246,0.0208108", "l0.4682793,0.0210513", "l0.4691908,0.0208108", "l0.4692272,0.0210112", "l0.4699928,0.0212718", "l0.4704303,0.0217329", "l0.4711777,0.0219133", "l0.4728730,0.0227552", "l0.4736204,0.0325774", "l0.4787062,0.0390321", "l0.4787062,0.0528634", "l0.4853780,0.0521618", "l0.4951668,0.0623048", "l0.4951668,0.0623048", "l0.4951486,0.0679777", "l0.4965704,0.0688797", "l0.4979923,0.0703831", "l0.4977553,0.0756551", "l0.4992865,0.0762565", "l0.4992865,0.0815284", "l0.4982293,0.0828915", "l0.4999975,0.0837935", "l0.5007084,0.0846956", "l0.5008178,0.0860587", "l0.5022396,0.0878628", "l0.5012917,0.0896668", "l0.4997605,0.0913306", "l0.4997605,0.0946381", "l0.5009454,0.0950992", "l0.5007084,0.0984067", "l0.5001251,0.1006718", "l0.5007084,0.1032376", "l0.5023125,0.1030171", "l0.5023125,0.1030171", "l0.5018386,0.1123583", "l0.5020755,0.1131601", "l0.5040260,0.1133004", "l0.5031875,0.1169487", "l0.5053385,0.1187127", "l0.5048645,0.1221805", "l0.5059218,0.1252675", "l0.5061041,0.1333459", "l0.5059583,0.1370543", "l0.5059583,0.1370543", "l0.5059583,0.1370543", "l0.5059583,0.1370543", "l0.5034245,0.1373750", "l0.5031693,0.1410233", "l0.5031693,0.1410233", "l0.4905549,0.1552154", "l0.4857061,0.1559170", "l0.4722168,0.1708910", "l0.4722168,0.1708910", "l0.4635763,0.1839806", "l0.4622274,0.1866066", "l0.4608602,0.1875086", "l0.4580347,0.1812745", "l0.4580347,0.1812745", "l0.4549723,0.1791497", "l0.4498135,0.1780472", "l0.4360326,0.1668217", "l0.4324597,0.1648974", "l0.4208480,0.1547945", "l0.4130825,0.1545138", "l0.4130825,0.1545138", "l0.4073222,0.1514268", "l0.4050071,0.1473576", "l0.4050071,0.1473576", "l0.4050071,0.1358916", "l0.4050071,0.1358916", "l0.4076139,0.1274325", "l0.4102023,0.1232630", "l0.4134653,0.1227418", "l0.4134653,0.1227418", "l0.4134653,0.1227418", "l0.4134653,0.1227418", "l0.4205745,0.1201961", "l0.4295249,0.1155255", "l0.4387487,0.1003711", "l0.4285041,0.0874619", "l0.4243479,0.0799649", "l0.4264807,0.0757754", "l0.4264807,0.0757754", "l0.4277567,0.0702428", "l0.4235641,0.0661736", "l0.4293973,0.0608816", "l0.4293973,0.0608816", "l0.4377096,0.0556097", "l0.4398788,0.0493154", "l0.4419022,0.0456872", "l0.4419387,0.0412170", "l0.4419387,0.0412170", "l0.4426861,0.0415378", "l0.4446730,0.0418785", "l0.4448371,0.0422193", "l0.4463318,0.0420990", "l0.4465688,0.0422393", "l0.4470975,0.0422995", "l0.4471886,0.0420389", "l0.4474620,0.0419788", "l0.4473162,0.0421592", "l0.4475714,0.0421592", "l0.4476990,0.0423997", "l0.4478813,0.0423997", "l0.4479907,0.0421592", "l0.4481000,0.0426002", "l0.4486287,0.0423396", "l0.4492302,0.0422794", "l0.4493214,0.0425400", "l0.4493943,0.0421391", "l0.4506703,0.0419587", "l0.4507068,0.0418184", "l0.4527119,0.0409965", "l0.4549723,0.0396535", "l0.4553551,0.0391323", "l0.4564671,0.0383104", "l0.4583629,0.0363861", "l0.4590009,0.0355642", "l0.4591102,0.0351633", "l0.4594019,0.0350430", "l0.4594748,0.0347424", "l0.4597665,0.0344818", "l0.4598394,0.0341811", "l0.4602222,0.0337401", "l0.4607508,0.0327178", "l0.4607326,0.0324772", "l0.4608784,0.0324171", "l0.4610243,0.0319560", "l0.4613159,0.0315551", "l0.4615164,0.0308335", "l0.4621362,0.0295506", "l0.4622274,0.0289693", "l0.4625737,0.0283278", "l0.4630659,0.0268044", "l0.4630659,0.0265037", "l0.4632482,0.0262230", "l0.4637768,0.0240381", "l0.4640320,0.0233766", "l0.4641961,0.0232363", "l0.4641232,0.0230559", "l0.4643055,0.0220536", "l0.4643966,0.0217329", "l0.4646518,0.0214322", "l0.4645971,0.0212919", "l0.4654356,0.0203297", "l0.4668393,0.0199488", "c"]}, {"n": "Banī Suwayf", "u": "EG-BNS", "i": ["m0.4138846,0.3031908", "l0.4172022,0.2984401", "l0.4179131,0.2921458", "l0.4189886,0.2809204", "l0.4211396,0.2709578", "l0.4212672,0.2709778", "l0.4215771,0.2688129", "l0.4215771,0.2688129", "l0.4267906,0.2696548", "l0.4371992,0.2710781", "l0.4566676,0.2750471", "l0.4605139,0.2773122", "l0.4602040,0.2806999", "l0.4620268,0.2815017", "l0.4646336,0.2813213", "l0.5056302,0.2687327", "l0.5159477,0.2509524", "l0.5222731,0.2404486", "l0.5274136,0.2363594", "l0.5274136,0.2363594", "l0.5275230,0.2370610", "l0.5275230,0.2370610", "l0.5284891,0.2354974", "l0.5326999,0.2374418", "l0.5326999,0.2374418", "l0.5368379,0.2384842", "l0.5368379,0.2384842", "l0.5385696,0.2397470", "l0.5385696,0.2430545", "l0.5388066,0.2484468", "l0.5388066,0.2484468", "l0.5385696,0.2512932", "l0.5383509,0.2575273", "l0.5351791,0.2603537", "l0.5349603,0.2668886", "l0.5335932,0.2682917", "l0.5295281,0.2739646", "l0.5268120,0.2782142", "l0.5252261,0.2816019", "l0.5227288,0.2858515", "l0.5188825,0.2875354", "l0.5134503,0.2977184", "l0.5123201,0.3050551", "l0.5073072,0.3068391", "l0.5073072,0.3068391", "l0.5020391,0.3028100", "l0.4976095,0.2999836", "l0.4367070,0.3022086", "l0.4339363,0.3021485", "l0.4184600,0.3027298", "c"]}, {"n": "Al Qāhirah", "u": "EG-C", "i": ["m0.5888082,0.1489212", "l0.5890816,0.1560573", "l0.5890816,0.1560573", "l0.5913238,0.1645967", "l0.5925087,0.1743789", "l0.5948419,0.1915979", "l0.5947690,0.2003177", "l0.5907769,0.2513734", "l0.5893551,0.2799181", "l0.5893551,0.2799181", "l0.5871129,0.2799181", "l0.5753007,0.2767509", "l0.5671342,0.2732229", "l0.5590406,0.2719601", "l0.5531344,0.2672694", "l0.5474470,0.2577278", "l0.5437284,0.2534982", "l0.5388066,0.2484468", "l0.5388066,0.2484468", "l0.5385696,0.2430545", "l0.5385696,0.2397470", "l0.5368379,0.2384842", "l0.5368379,0.2384842", "l0.5358718,0.2382436", "l0.5358718,0.2382436", "l0.5354889,0.2351967", "l0.5358171,0.2322300", "l0.5363639,0.2307266", "l0.5377493,0.2296441", "l0.5382962,0.2283011", "l0.5384056,0.2250537", "l0.5389342,0.2238310", "l0.5399003,0.2222073", "l0.5399003,0.2185590", "l0.5401191,0.2144898", "l0.5404472,0.2122046", "l0.5418508,0.2109818", "l0.5420513,0.2090775", "l0.5420513,0.2070529", "l0.5401191,0.2051486", "l0.5399003,0.2012197", "l0.5400097,0.1997163", "l0.5422336,0.1994357", "l0.5423065,0.1979122", "l0.5424888,0.1825173", "l0.5376582,0.1806932", "l0.5373483,0.1770449", "l0.5356530,0.1737575", "l0.5373118,0.1723342", "l0.5370202,0.1608081", "l0.5370202,0.1608081", "l0.5405383,0.1612090", "l0.5405383,0.1612090", "l0.5439289,0.1578213", "l0.5519496,0.1542733", "l0.5601708,0.1536719", "l0.5601708,0.1536719", "l0.5685378,0.1536719", "l0.5742799,0.1498633", "l0.5857458,0.1410433", "l0.5857458,0.1410433", "l0.5857640,0.1416246", "l0.5862744,0.1418251", "c"]}, {"n": "Ad Daqahlīyah", "u": "EG-DK", "i": ["m0.5458976,0.0153985", "l0.5463533,0.0155990", "l0.5464627,0.0157994", "l0.5470096,0.0160600", "l0.5470825,0.0162204", "l0.5486319,0.0168819", "l0.5496163,0.0177639", "l0.5516032,0.0189065", "l0.5534079,0.0202094", "l0.5554859,0.0212718", "l0.5568167,0.0221939", "l0.5572724,0.0222540", "l0.5575640,0.0225146", "l0.5578739,0.0224545", "l0.5584208,0.0228755", "l0.5593505,0.0232162", "l0.5602619,0.0237775", "l0.5610457,0.0239780", "l0.5613556,0.0238978", "l0.5616837,0.0240982", "l0.5622124,0.0239980", "l0.5624311,0.0240381", "l0.5627410,0.0242385", "l0.5631238,0.0240581", "l0.5631238,0.0240581", "l0.5631238,0.0276864", "l0.5602801,0.0293301", "l0.5574364,0.0305929", "l0.5574364,0.0337000", "l0.5618660,0.0336198", "l0.5651108,0.0331387", "l0.5652930,0.0371879", "l0.5670977,0.0375888", "l0.5692852,0.0388517", "l0.5710351,0.0406958", "l0.5704153,0.0456671", "l0.5690300,0.0534848", "l0.5765038,0.0494757", "l0.5822094,0.0459878", "l0.5822094,0.0459878", "l0.5853447,0.0452061", "l0.5887171,0.0457473", "l0.5896285,0.0452261", "l0.5900113,0.0442639", "l0.5901754,0.0430011", "l0.5909410,0.0429409", "l0.5908863,0.0434822", "l0.5903394,0.0448653", "l0.5902847,0.0458074", "l0.5953524,0.0457072", "l0.5957352,0.0448653", "l0.5963367,0.0455869", "l0.5976310,0.0464088", "l0.6001465,0.0469500", "l0.6009486,0.0483933", "l0.6012767,0.0499368", "l0.6006205,0.0522220", "l0.6016048,0.0532443", "l0.6023158,0.0548479", "l0.6032090,0.0557299", "l0.6027533,0.0563513", "l0.6024251,0.0573135", "l0.6025345,0.0587969", "l0.6032454,0.0592178", "l0.6029173,0.0593381", "l0.6029173,0.0593381", "l0.5968107,0.0619240", "l0.5892275,0.0630465", "l0.5875322,0.0634274", "l0.5809881,0.0632871", "l0.5790011,0.0669153", "l0.5787277,0.0708843", "l0.5734778,0.0768578", "l0.5732226,0.0826509", "l0.5690846,0.0830118", "l0.5687930,0.0862792", "l0.5663868,0.0877224", "l0.5660040,0.0906691", "l0.5499262,0.0911502", "l0.5475200,0.0934955", "l0.5475200,0.1065050", "l0.5490512,0.1080485", "l0.5473741,0.1127993", "l0.5436919,0.1167883", "l0.5436919,0.1167883", "l0.5415591,0.1166480", "l0.5396087,0.1130599", "l0.5379498,0.1118772", "l0.5379498,0.1118772", "l0.5379681,0.1116366", "l0.5379681,0.1116366", "l0.5402284,0.1090909", "l0.5399915,0.1021752", "l0.5387701,0.1016139", "l0.5389342,0.0995893", "l0.5371478,0.0974846", "l0.5365827,0.0907894", "l0.5370202,0.0857379", "l0.5381504,0.0803056", "l0.5387154,0.0757754", "l0.5405566,0.0734300", "l0.5419784,0.0725280", "l0.5437466,0.0677973", "l0.5397727,0.0683585", "l0.5362910,0.0686191", "l0.5358718,0.0683986", "l0.5364551,0.0653317", "l0.5376035,0.0631868", "l0.5376035,0.0631868", "l0.5374212,0.0572133", "l0.5374212,0.0572133", "l0.5404107,0.0578347", "l0.5416867,0.0567522", "l0.5412493,0.0533445", "l0.5411216,0.0320563", "l0.5402831,0.0300517", "l0.5401373,0.0242385", "l0.5381504,0.0244190", "l0.5380045,0.0202295", "l0.5398456,0.0184053", "l0.5398456,0.0184053", "l0.5420878,0.0186058", "l0.5420513,0.0131935", "l0.5430357,0.0135744", "l0.5438924,0.0142559", "l0.5450591,0.0148172", "c"]}, {"n": "Dumyāţ", "u": "EG-DT", "i": ["m0.5975398,0.0251205", "l0.5980684,0.0256417", "l0.5981414,0.0260827", "l0.5990710,0.0278668", "l0.6000554,0.0286485", "l0.6007116,0.0294904", "l0.6008757,0.0295105", "l0.6012585,0.0300116", "l0.6019876,0.0305328", "l0.6023704,0.0310540", "l0.6029173,0.0313747", "l0.6033548,0.0319560", "l0.6040110,0.0323569", "l0.6043938,0.0327979", "l0.6049589,0.0330986", "l0.6050683,0.0332991", "l0.6057610,0.0336399", "l0.6061438,0.0340408", "l0.6063808,0.0340207", "l0.6074198,0.0345219", "l0.6080031,0.0350430", "l0.6081490,0.0350230", "l0.6087141,0.0354840", "l0.6090057,0.0355442", "l0.6098078,0.0361856", "l0.6100448,0.0361856", "l0.6103182,0.0365665", "l0.6111750,0.0371278", "l0.6112661,0.0373883", "l0.6117947,0.0376489", "l0.6118677,0.0378293", "l0.6120317,0.0378293", "l0.6123963,0.0382703", "l0.6125968,0.0383906", "l0.6127791,0.0382703", "l0.6130708,0.0383505", "l0.6135994,0.0393127", "l0.6123963,0.0395332", "l0.6083677,0.0367268", "l0.6059251,0.0354039", "l0.6046126,0.0343214", "l0.6028626,0.0325173", "l0.6014408,0.0312544", "l0.5998002,0.0304125", "l0.5982143,0.0299314", "l0.5970659,0.0301720", "l0.5973393,0.0308335", "l0.5988158,0.0315551", "l0.5989799,0.0320964", "l0.5981049,0.0320362", "l0.5970659,0.0315551", "l0.5961909,0.0303524", "l0.5976674,0.0289091", "l0.5978315,0.0266440", "l0.5968471,0.0267041", "l0.5970112,0.0256818", "l0.5975398,0.0251205", "c", "m0.5899019,0.0195680", "l0.5901754,0.0210714", "l0.5898837,0.0208910", "l0.5897014,0.0204299", "l0.5896832,0.0197484", "l0.5899019,0.0195680", "c", "m0.5895556,0.0175634", "l0.5893733,0.0177639", "l0.5887718,0.0171425", "l0.5886442,0.0168418", "l0.5887900,0.0166614", "l0.5895009,0.0172627", "l0.5895556,0.0175634", "c", "m0.5918160,0.0176837", "l0.5920347,0.0185657", "l0.5924175,0.0191470", "l0.5918889,0.0200691", "l0.5912326,0.0198486", "l0.5910686,0.0190668", "l0.5905764,0.0178641", "l0.5896832,0.0170823", "l0.5895191,0.0167415", "l0.5895738,0.0164008", "l0.5899749,0.0162605", "l0.5908316,0.0179844", "l0.5912873,0.0184855", "l0.5914149,0.0183452", "l0.5909592,0.0174632", "l0.5907222,0.0161001", "l0.5908134,0.0158195", "l0.5912326,0.0160400", "l0.5913785,0.0170222", "l0.5918160,0.0176837", "c", "m0.5922535,0.0155589", "l0.5927821,0.0157593", "l0.5928732,0.0159397", "l0.5931284,0.0159598", "l0.5932743,0.0161602", "l0.5938029,0.0164609", "l0.5938758,0.0166213", "l0.5941857,0.0167415", "l0.5955346,0.0185256", "l0.5962820,0.0192472", "l0.5975034,0.0200691", "l0.5977950,0.0205702", "l0.5980684,0.0212317", "l0.5982507,0.0225146", "l0.5979408,0.0230960", "l0.5976492,0.0232162", "l0.5979408,0.0226349", "l0.5979044,0.0224545", "l0.5977221,0.0224545", "l0.5979226,0.0222741", "l0.5979955,0.0218331", "l0.5979044,0.0218331", "l0.5978132,0.0221538", "l0.5976492,0.0221338", "l0.5978132,0.0215124", "l0.5974669,0.0209511", "l0.5973211,0.0209511", "l0.5972117,0.0202896", "l0.5970294,0.0204099", "l0.5969383,0.0199488", "l0.5967924,0.0198686", "l0.5969565,0.0211315", "l0.5968471,0.0222941", "l0.5968653,0.0209511", "l0.5965555,0.0196882", "l0.5964825,0.0198085", "l0.5966831,0.0204500", "l0.5966831,0.0208509", "l0.5965190,0.0208308", "l0.5965190,0.0202495", "l0.5962273,0.0194276", "l0.5959357,0.0191069", "l0.5955711,0.0189866", "l0.5951883,0.0183452", "l0.5948966,0.0184655", "l0.5949695,0.0189666", "l0.5950607,0.0189666", "l0.5951336,0.0193475", "l0.5952794,0.0194878", "l0.5954617,0.0203898", "l0.5957169,0.0209511", "l0.5958628,0.0218331", "l0.5961727,0.0222741", "l0.5962820,0.0226750", "l0.5965190,0.0228554", "l0.5966284,0.0234768", "l0.5968653,0.0224345", "l0.5967742,0.0235169", "l0.5969747,0.0241584", "l0.5973758,0.0247998", "l0.5972846,0.0249201", "l0.5965555,0.0236171", "l0.5960997,0.0231962", "l0.5958081,0.0224144", "l0.5953524,0.0220736", "l0.5947873,0.0204099", "l0.5940581,0.0200691", "l0.5937847,0.0194276", "l0.5937300,0.0188664", "l0.5938394,0.0186058", "l0.5924904,0.0170623", "l0.5921076,0.0168618", "l0.5917248,0.0159999", "l0.5913967,0.0156390", "l0.5922535,0.0155589", "c", "m0.5878056,0.0379296", "l0.5869671,0.0389118", "l0.5872041,0.0388116", "l0.5878056,0.0379296", "l0.5880973,0.0380899", "l0.5872588,0.0392927", "l0.5868213,0.0405355", "l0.5865661,0.0406357", "l0.5857275,0.0402949", "l0.5854359,0.0409965", "l0.5856364,0.0418585", "l0.5854906,0.0424799", "l0.5852536,0.0425801", "l0.5845062,0.0418986", "l0.5845062,0.0425200", "l0.5851442,0.0433218", "l0.5859827,0.0433418", "l0.5860921,0.0436425", "l0.5858369,0.0438430", "l0.5849437,0.0439031", "l0.5848343,0.0444043", "l0.5849255,0.0448052", "l0.5854541,0.0451459", "l0.5822094,0.0459478", "l0.5822094,0.0459478", "l0.5765038,0.0494357", "l0.5690300,0.0534648", "l0.5704153,0.0456270", "l0.5710351,0.0406558", "l0.5692852,0.0388316", "l0.5670977,0.0375688", "l0.5652930,0.0371678", "l0.5651108,0.0331187", "l0.5618660,0.0335998", "l0.5574547,0.0336599", "l0.5574547,0.0305729", "l0.5602984,0.0292900", "l0.5631420,0.0276463", "l0.5631420,0.0240180", "l0.5631420,0.0240180", "l0.5640170,0.0240782", "l0.5643816,0.0239379", "l0.5646550,0.0240180", "l0.5682097,0.0231360", "l0.5687565,0.0231160", "l0.5690300,0.0229155", "l0.5691758,0.0229757", "l0.5730403,0.0217529", "l0.5738788,0.0216126", "l0.5749725,0.0211515", "l0.5757199,0.0210313", "l0.5761027,0.0207907", "l0.5767225,0.0206705", "l0.5769595,0.0204700", "l0.5780532,0.0200691", "l0.5781444,0.0199288", "l0.5783084,0.0199488", "l0.5786001,0.0189265", "l0.5784178,0.0207707", "l0.5781079,0.0219333", "l0.5783631,0.0221338", "l0.5786548,0.0219534", "l0.5796027,0.0231561", "l0.5798761,0.0232363", "l0.5798943,0.0229757", "l0.5794204,0.0225146", "l0.5796209,0.0216928", "l0.5791469,0.0215525", "l0.5790740,0.0213520", "l0.5789100,0.0212919", "l0.5787277,0.0206504", "l0.5789647,0.0201894", "l0.5793110,0.0200490", "l0.5791469,0.0193875", "l0.5792381,0.0195880", "l0.5797850,0.0195279", "l0.5810792,0.0187060", "l0.5826469,0.0179443", "l0.5838500,0.0169019", "l0.5851989,0.0160199", "l0.5858369,0.0153183", "l0.5860010,0.0153785", "l0.5860921,0.0156591", "l0.5863291,0.0157192", "l0.5873134,0.0158996", "l0.5877509,0.0157192", "l0.5882067,0.0158395", "l0.5874411,0.0161001", "l0.5865478,0.0170623", "l0.5861833,0.0185055", "l0.5866390,0.0185857", "l0.5871676,0.0181648", "l0.5871858,0.0186459", "l0.5865661,0.0198887", "l0.5871858,0.0206905", "l0.5872588,0.0213320", "l0.5880973,0.0223342", "l0.5880608,0.0244590", "l0.5884801,0.0252007", "l0.5885348,0.0258823", "l0.5882249,0.0258021", "l0.5877874,0.0246595", "l0.5862379,0.0226550", "l0.5856364,0.0227752", "l0.5855817,0.0218932", "l0.5857093,0.0215525", "l0.5855635,0.0213119", "l0.5850895,0.0216326", "l0.5844333,0.0225748", "l0.5842875,0.0242987", "l0.5843786,0.0246395", "l0.5859645,0.0235971", "l0.5861468,0.0237174", "l0.5862015,0.0239579", "l0.5860192,0.0242786", "l0.5867666,0.0243789", "l0.5870036,0.0250203", "l0.5866025,0.0258221", "l0.5870765,0.0263834", "l0.5873864,0.0272654", "l0.5878239,0.0272654", "l0.5880608,0.0271050", "l0.5890087,0.0272454", "l0.5879879,0.0282476", "l0.5872405,0.0282075", "l0.5859463,0.0277665", "l0.5855270,0.0285684", "l0.5858551,0.0294103", "l0.5856364,0.0301319", "l0.5859281,0.0301920", "l0.5863291,0.0298914", "l0.5864932,0.0302722", "l0.5861286,0.0307734", "l0.5848343,0.0309738", "l0.5844515,0.0312745", "l0.5854723,0.0318759", "l0.5861650,0.0317355", "l0.5863473,0.0325975", "l0.5873499,0.0329583", "l0.5877509,0.0332790", "l0.5883707,0.0334594", "l0.5888994,0.0330184", "l0.5892092,0.0335998", "l0.5888994,0.0339806", "l0.5878056,0.0379296", "c"]}, {"n": "Al Fayyūm", "u": "EG-FYM", "i": ["m0.4215771,0.2688129", "l0.4331342,0.2543602", "l0.4369805,0.2523556", "l0.4496495,0.2358983", "l0.4523656,0.2356177", "l0.4636674,0.2213854", "l0.4704668,0.2194009", "l0.4777036,0.2142693", "l0.4849405,0.2088570", "l0.4878935,0.2082957", "l0.4924690,0.2052689", "l0.4951121,0.2027833", "l0.4953491,0.2005983", "l0.5208694,0.2003377", "l0.5205413,0.2031441", "l0.5203590,0.2087167", "l0.5217627,0.2106411", "l0.5241871,0.2162538", "l0.5255907,0.2263366", "l0.5269761,0.2332122", "l0.5269761,0.2332122", "l0.5274136,0.2363594", "l0.5274136,0.2363594", "l0.5222731,0.2404486", "l0.5159477,0.2509524", "l0.5056302,0.2687327", "l0.4646336,0.2813213", "l0.4620268,0.2815017", "l0.4602040,0.2806999", "l0.4605139,0.2773122", "l0.4566676,0.2750471", "l0.4371992,0.2710781", "l0.4267906,0.2696548", "c"]}, {"n": "Al Gharbīyah", "u": "EG-GH", "i": ["m0.5253355,0.1060440", "l0.5244787,0.1036185", "l0.5164034,0.1037187", "l0.5157107,0.1020950", "l0.5135961,0.1019948", "l0.5134685,0.1001907", "l0.5090572,0.1001907", "l0.5087837,0.1021752", "l0.5023672,0.1030572", "l0.5023672,0.1030572", "l0.5007631,0.1032777", "l0.5001615,0.1007319", "l0.5007631,0.0984668", "l0.5009818,0.0951593", "l0.4998152,0.0946983", "l0.4998152,0.0913908", "l0.5013464,0.0897270", "l0.5022943,0.0879229", "l0.5008724,0.0861188", "l0.5007631,0.0847557", "l0.5000521,0.0838537", "l0.4982657,0.0829516", "l0.4993412,0.0815885", "l0.4993412,0.0763166", "l0.4977918,0.0757152", "l0.4980287,0.0704433", "l0.4966251,0.0689198", "l0.4952033,0.0680178", "l0.4952215,0.0623650", "l0.4952215,0.0623650", "l0.4962423,0.0634073", "l0.4997423,0.0704032", "l0.5019844,0.0704232", "l0.5019844,0.0704232", "l0.5025313,0.0725280", "l0.5110441,0.0725280", "l0.5113358,0.0705034", "l0.5117550,0.0687194", "l0.5212705,0.0688998", "l0.5212705,0.0576543", "l0.5230022,0.0577946", "l0.5324812,0.0569327", "l0.5324812,0.0569327", "l0.5352155,0.0570730", "l0.5374212,0.0570128", "l0.5376035,0.0631868", "l0.5376035,0.0631868", "l0.5364551,0.0653317", "l0.5358718,0.0683986", "l0.5362910,0.0686191", "l0.5397727,0.0683585", "l0.5437466,0.0677973", "l0.5419784,0.0725280", "l0.5405566,0.0734300", "l0.5387154,0.0757754", "l0.5381504,0.0803056", "l0.5370202,0.0857379", "l0.5365827,0.0907894", "l0.5371478,0.0974846", "l0.5389342,0.0995893", "l0.5387701,0.1016139", "l0.5399915,0.1021752", "l0.5402284,0.1090909", "l0.5379681,0.1116366", "l0.5379681,0.1116366", "l0.5310776,0.1081487", "l0.5310776,0.1081487", "l0.5254449,0.1081087", "l0.5253355,0.1060440", "l0.5253355,0.1060440", "c"]}, {"n": "Al Jīzah", "u": "EG-GZ", "i": ["m0.5370202,0.1608081", "l0.5373118,0.1723342", "l0.5356530,0.1737575", "l0.5373483,0.1770449", "l0.5376582,0.1806932", "l0.5424888,0.1825173", "l0.5423065,0.1979122", "l0.5422336,0.1994357", "l0.5400097,0.1997163", "l0.5399003,0.2012197", "l0.5401191,0.2051486", "l0.5420513,0.2070529", "l0.5420513,0.2090775", "l0.5418508,0.2109818", "l0.5404472,0.2122046", "l0.5401191,0.2144898", "l0.5399003,0.2185590", "l0.5399003,0.2222073", "l0.5389342,0.2238310", "l0.5384056,0.2250537", "l0.5382962,0.2283011", "l0.5377493,0.2296441", "l0.5363639,0.2307266", "l0.5358171,0.2322300", "l0.5354889,0.2351967", "l0.5358718,0.2382436", "l0.5358718,0.2382436", "l0.5326999,0.2374418", "l0.5326999,0.2374418", "l0.5284891,0.2354974", "l0.5275230,0.2370610", "l0.5275230,0.2370610", "l0.5269761,0.2332122", "l0.5269761,0.2332122", "l0.5255907,0.2263366", "l0.5241871,0.2162538", "l0.5217627,0.2106411", "l0.5203590,0.2087167", "l0.5205413,0.2031441", "l0.5208694,0.2003377", "l0.4953491,0.2005983", "l0.4951121,0.2027833", "l0.4924690,0.2052689", "l0.4878935,0.2082957", "l0.4849405,0.2088570", "l0.4777036,0.2142693", "l0.4704668,0.2194009", "l0.4636674,0.2213854", "l0.4523656,0.2356177", "l0.4496495,0.2358983", "l0.4369805,0.2523556", "l0.4331342,0.2543602", "l0.4215771,0.2688129", "l0.4215771,0.2688129", "l0.4212672,0.2709778", "l0.4211396,0.2709578", "l0.4189886,0.2809204", "l0.4179131,0.2921458", "l0.4172022,0.2984401", "l0.4138846,0.3031908", "l0.4138846,0.3031908", "l0.4118065,0.3118906", "l0.4089263,0.3177037", "l0.4067753,0.3244190", "l0.4038952,0.3351633", "l0.4017442,0.3463286", "l0.3974240,0.3507988", "l0.3927574,0.3548279", "l0.3841352,0.3610620", "l0.3772993,0.3677572", "l0.3726328,0.3691002", "l0.3679480,0.3731093", "l0.3611304,0.3757754", "l0.3535837,0.3820095", "l0.3478234,0.3851166", "l0.3381256,0.3873616", "l0.3352455,0.3891256", "l0.3323653,0.3913507", "l0.3309435,0.3949188", "l0.3302143,0.3993689", "l0.3291388,0.4029169", "l0.3273342,0.4073469", "l0.3248186,0.4128795", "l0.3248186,0.4128795", "l0.2213154,0.4131601", "l0.2213154,0.4131601", "l0.2200759,0.4131601", "l0.2200759,0.4131601", "l0.2177426,0.4131601", "l0.2177426,0.4131601", "l0.2549111,0.3220937", "l0.3312716,0.3019280", "l0.3901142,0.2382837", "l0.4018900,0.2216661", "l0.4139575,0.2183986", "l0.4553004,0.1883305", "l0.4608967,0.1875287", "l0.4608967,0.1875287", "l0.4622821,0.1866266", "l0.4636128,0.1840007", "l0.4722532,0.1709311", "l0.4738756,0.1710112", "l0.4722532,0.1709311", "l0.4722532,0.1709311", "l0.4857425,0.1559571", "l0.4905914,0.1552555", "l0.5032057,0.1410634", "l0.5032057,0.1410634", "l0.5058307,0.1408228", "l0.5070702,0.1396602", "l0.5108801,0.1399408", "l0.5110441,0.1463153", "l0.5136326,0.1461749", "l0.5152914,0.1479590", "l0.5154190,0.1515672", "l0.5170596,0.1533512", "l0.5200309,0.1539526", "l0.5214892,0.1521485", "l0.5231116,0.1531908", "l0.5231116,0.1531908", "l0.5244970,0.1535717", "l0.5280516,0.1522487", "l0.5280516,0.1520883", "l0.5280516,0.1520883", "l0.5310593,0.1576610", "l0.5354525,0.1606277", "l0.5354525,0.1606277", "c"]}, {"n": "Al Ismāٰīlīyah", "u": "EG-IS", "i": ["m0.6154952,0.0591777", "l0.6156046,0.0595786", "l0.6204899,0.0585964", "l0.6218024,0.0570730", "l0.6236070,0.0574538", "l0.6246278,0.0606811", "l0.6286382,0.0610219", "l0.6321745,0.0629663", "l0.6379895,0.0652916", "l0.6379895,0.0652916", "l0.6434582,0.0691804", "l0.6490727,0.0708041", "l0.6490727,0.0708041", "l0.6495101,0.0844751", "l0.6514242,0.1197150", "l0.6572756,0.1298379", "l0.6603198,0.1357914", "l0.6628901,0.1435089", "l0.6642937,0.1491016", "l0.6642937,0.1491016", "l0.6538304,0.1485603", "l0.6538304,0.1485603", "l0.6454269,0.1496027", "l0.6422733,0.1524291", "l0.6310808,0.1515672", "l0.6262684,0.1499435", "l0.5923264,0.1501640", "l0.5888447,0.1505248", "l0.5888447,0.1505248", "l0.5887900,0.1489412", "l0.5887900,0.1489412", "l0.5862744,0.1418451", "l0.5857640,0.1416447", "l0.5857275,0.1410634", "l0.5857275,0.1410634", "l0.5839047,0.1312411", "l0.5831391,0.1221004", "l0.5800766,0.1203564", "l0.5797667,0.1170489", "l0.5839047,0.1172494", "l0.5846703,0.1189933", "l0.5915608,0.1193742", "l0.5926363,0.1176302", "l0.6018236,0.1170489", "l0.6022975,0.1151646", "l0.6109380,0.1016540", "l0.6107922,0.0962217", "l0.6091333,0.0885042", "l0.6124327,0.0802655", "l0.6128520,0.0765772", "l0.6159509,0.0764770", "l0.6155863,0.0651713", "l0.6120135,0.0649909", "l0.6107922,0.0625654", "l0.6107922,0.0625654", "l0.6095708,0.0608415", "l0.6094979,0.0602602", "l0.6100265,0.0596588", "l0.6114302,0.0588570", "l0.6113755,0.0582356", "l0.6109562,0.0577345", "l0.6110109,0.0567322", "l0.6133442,0.0567122", "l0.6133260,0.0530037", "l0.6140551,0.0520015", "l0.6149301,0.0519213", "l0.6153494,0.0527031", "l0.6154040,0.0540662", "l0.6156592,0.0549281", "l0.6151488,0.0558101", "l0.6152400,0.0562110", "l0.6159691,0.0563112", "l0.6162608,0.0566921", "l0.6161150,0.0578948", "l0.6154952,0.0591777", "c", "m0.6191227,0.0457874", "l0.6198154,0.0467696", "l0.6208545,0.0461081", "l0.6207998,0.0467095", "l0.6211279,0.0472307", "l0.6217112,0.0495158", "l0.6214560,0.0502575", "l0.6208909,0.0498967", "l0.6200888,0.0497764", "l0.6191227,0.0490147", "l0.6186488,0.0488944", "l0.6183571,0.0497363", "l0.6175915,0.0502976", "l0.6169170,0.0494156", "l0.6160603,0.0495760", "l0.6151124,0.0491149", "l0.6140916,0.0496562", "l0.6128520,0.0497764", "l0.6122869,0.0493154", "l0.6120499,0.0485737", "l0.6110838,0.0475915", "l0.6112296,0.0468899", "l0.6121046,0.0470502", "l0.6121411,0.0461683", "l0.6128702,0.0458676", "l0.6163884,0.0459678", "l0.6170993,0.0465692", "l0.6178832,0.0460480", "l0.6191227,0.0457874", "c", "m0.6164795,0.0404753", "l0.6165889,0.0406558", "l0.6168623,0.0407359", "l0.6178832,0.0409163", "l0.6185394,0.0411769", "l0.6192139,0.0412371", "l0.6197060,0.0415578", "l0.6208727,0.0415778", "l0.6216018,0.0419186", "l0.6216018,0.0419186", "l0.6210185,0.0426603", "l0.6210185,0.0426603", "l0.6200524,0.0422193", "l0.6182113,0.0417783", "l0.6162061,0.0405355", "l0.6164795,0.0404753", "c"]}, {"n": "Janūb Sīnā'", "u": "EG-JS", "i": ["m0.8328920,0.2299448", "l0.8329284,0.2301653", "l0.8327826,0.2302856", "l0.8327097,0.2300050", "l0.8328920,0.2299448", "c", "m0.6689967,0.1836599", "l0.6724055,0.1838002", "l0.6728430,0.1832390", "l0.6728795,0.1834795", "l0.6849287,0.1826175", "l0.7027383,0.1831989", "l0.7179775,0.1855642", "l0.7198369,0.1861455", "l0.7276024,0.1860052", "l0.7425500,0.1898539", "l0.7457765,0.1915779", "l0.7458676,0.1917984", "l0.7603960,0.2018411", "l0.7664844,0.2062712", "l0.7730468,0.2086365", "l0.7800831,0.2104005", "l0.7910933,0.2177772", "l0.7912391,0.2177171", "l0.7928980,0.2182784", "l0.7976921,0.2200424", "l0.8024681,0.2221872", "l0.8050748,0.2219467", "l0.8056399,0.2224879", "l0.8126762,0.2236706", "l0.8190016,0.2242519", "l0.8258009,0.2257152", "l0.8326185,0.2254146", "l0.8369752,0.2265772", "l0.8369752,0.2265772", "l0.8364101,0.2272387", "l0.8360455,0.2274391", "l0.8356810,0.2272988", "l0.8351341,0.2272988", "l0.8343138,0.2278200", "l0.8336029,0.2280806", "l0.8333112,0.2288824", "l0.8327097,0.2292031", "l0.8326003,0.2299649", "l0.8323998,0.2303056", "l0.8325092,0.2310473", "l0.8322175,0.2319895", "l0.8313060,0.2332523", "l0.8308503,0.2333125", "l0.8306863,0.2336332", "l0.8302123,0.2333525", "l0.8305769,0.2338938", "l0.8306134,0.2342546", "l0.8303399,0.2344751", "l0.8298842,0.2346154", "l0.8296108,0.2348760", "l0.8296108,0.2350163", "l0.8294467,0.2350364", "l0.8294285,0.2353571", "l0.8292644,0.2353571", "l0.8291915,0.2359585", "l0.8293556,0.2365598", "l0.8291004,0.2365398", "l0.8289545,0.2363794", "l0.8285900,0.2364997", "l0.8287722,0.2375821", "l0.8286629,0.2382035", "l0.8282801,0.2386646", "l0.8281160,0.2390855", "l0.8278973,0.2391657", "l0.8273504,0.2390855", "l0.8269858,0.2392259", "l0.8267671,0.2396268", "l0.8266212,0.2399675", "l0.8266212,0.2405889", "l0.8264390,0.2408495", "l0.8264936,0.2417115", "l0.8262202,0.2423930", "l0.8259103,0.2426135", "l0.8259286,0.2426937", "l0.8262020,0.2426336", "l0.8260197,0.2427939", "l0.8256551,0.2427338", "l0.8249442,0.2429343", "l0.8245978,0.2435356", "l0.8245249,0.2438964", "l0.8241239,0.2441771", "l0.8240145,0.2450591", "l0.8232489,0.2454399", "l0.8231395,0.2456404", "l0.8231578,0.2464623", "l0.8235041,0.2472039", "l0.8234859,0.2476650", "l0.8231031,0.2485269", "l0.8232489,0.2502308", "l0.8230484,0.2507520", "l0.8225015,0.2513133", "l0.8224468,0.2515738", "l0.8226291,0.2519948", "l0.8227750,0.2532978", "l0.8229390,0.2534782", "l0.8231031,0.2541597", "l0.8230119,0.2545005", "l0.8231213,0.2550217", "l0.8229573,0.2551620", "l0.8228843,0.2557032", "l0.8229937,0.2559638", "l0.8228843,0.2561843", "l0.8227021,0.2562444", "l0.8225198,0.2572467", "l0.8222099,0.2578080", "l0.8215172,0.2583492", "l0.8212255,0.2598927", "l0.8198401,0.2601533", "l0.8194026,0.2604139", "l0.8190927,0.2608348", "l0.8189287,0.2616367", "l0.8191110,0.2619975", "l0.8191292,0.2623984", "l0.8188922,0.2628594", "l0.8189651,0.2632202", "l0.8186917,0.2637013", "l0.8186917,0.2641223", "l0.8184912,0.2643227", "l0.8186735,0.2648038", "l0.8183636,0.2650243", "l0.8180537,0.2663072", "l0.8177438,0.2666280", "l0.8181995,0.2674498", "l0.8181995,0.2676503", "l0.8180902,0.2681915", "l0.8177803,0.2685122", "l0.8177438,0.2687728", "l0.8175798,0.2689132", "l0.8175798,0.2692740", "l0.8173975,0.2694945", "l0.8174704,0.2700156", "l0.8173246,0.2701359", "l0.8173246,0.2703364", "l0.8175798,0.2708976", "l0.8176162,0.2716193", "l0.8173610,0.2721806", "l0.8168688,0.2727418", "l0.8167959,0.2731427", "l0.8168871,0.2732630", "l0.8167412,0.2732831", "l0.8168141,0.2734234", "l0.8169782,0.2733031", "l0.8171605,0.2738443", "l0.8173975,0.2739646", "l0.8174157,0.2741250", "l0.8175433,0.2741049", "l0.8175068,0.2744256", "l0.8176891,0.2745058", "l0.8177074,0.2747664", "l0.8176162,0.2753076", "l0.8184547,0.2762498", "l0.8185277,0.2770716", "l0.8186188,0.2771919", "l0.8184547,0.2775928", "l0.8186188,0.2794971", "l0.8182542,0.2799582", "l0.8171423,0.2802990", "l0.8171423,0.2806197", "l0.8167048,0.2804794", "l0.8159027,0.2807400", "l0.8155564,0.2814616", "l0.8149184,0.2818625", "l0.8149730,0.2822033", "l0.8147361,0.2828247", "l0.8148272,0.2838270", "l0.8154652,0.2846288", "l0.8154834,0.2852502", "l0.8150277,0.2857714", "l0.8151918,0.2866333", "l0.8154288,0.2871144", "l0.8153376,0.2876356", "l0.8155928,0.2884374", "l0.8154105,0.2888383", "l0.8154470,0.2894597", "l0.8151553,0.2900010", "l0.8153376,0.2903217", "l0.8152100,0.2907827", "l0.8154652,0.2914843", "l0.8154834,0.2920255", "l0.8152282,0.2925467", "l0.8141345,0.2928274", "l0.8138429,0.2933686", "l0.8133507,0.2938497", "l0.8132595,0.2942105", "l0.8132048,0.2951727", "l0.8134965,0.2958542", "l0.8132595,0.2965157", "l0.8136423,0.2969768", "l0.8134965,0.2976784", "l0.8135876,0.2980392", "l0.8134965,0.2989412", "l0.8136059,0.2990815", "l0.8134965,0.2996829", "l0.8135876,0.2999435", "l0.8134418,0.3005649", "l0.8137335,0.3013266", "l0.8137517,0.3017275", "l0.8136241,0.3021284", "l0.8134600,0.3022086", "l0.8134054,0.3026697", "l0.8131866,0.3028902", "l0.8132231,0.3036920", "l0.8131319,0.3039125", "l0.8135694,0.3047343", "l0.8137152,0.3052956", "l0.8133507,0.3057166", "l0.8128950,0.3070797", "l0.8125851,0.3074405", "l0.8125851,0.3077211", "l0.8122023,0.3083225", "l0.8120747,0.3089840", "l0.8115825,0.3095252", "l0.8114366,0.3100263", "l0.8109445,0.3104874", "l0.8107440,0.3110286", "l0.8102335,0.3114295", "l0.8104341,0.3120910", "l0.8103611,0.3125120", "l0.8101059,0.3127926", "l0.8095955,0.3130131", "l0.8094315,0.3132737", "l0.8093768,0.3137548", "l0.8098143,0.3142960", "l0.8098325,0.3146568", "l0.8096320,0.3145967", "l0.8093586,0.3151981", "l0.8093403,0.3155990", "l0.8095044,0.3161602", "l0.8090669,0.3163006", "l0.8087570,0.3167215", "l0.8085018,0.3167215", "l0.8082648,0.3168819", "l0.8081008,0.3173630", "l0.8075904,0.3174832", "l0.8071893,0.3188263", "l0.8070800,0.3189065", "l0.8069888,0.3206705", "l0.8065878,0.3212919", "l0.8062779,0.3214522", "l0.8062050,0.3217329", "l0.8059133,0.3219333", "l0.8054211,0.3228153", "l0.8048560,0.3234167", "l0.8047649,0.3240381", "l0.8046008,0.3242586", "l0.8045644,0.3256417", "l0.8043274,0.3270850", "l0.8049107,0.3280271", "l0.8050566,0.3288490", "l0.8047467,0.3290495", "l0.8047649,0.3295105", "l0.8044186,0.3308936", "l0.8039628,0.3317957", "l0.8032155,0.3315151", "l0.8037441,0.3314549", "l0.8038352,0.3313346", "l0.8037623,0.3310139", "l0.8033977,0.3311342", "l0.8031425,0.3308736", "l0.8027780,0.3308736", "l0.8020853,0.3311342", "l0.8019577,0.3318157", "l0.8015566,0.3320763", "l0.8014655,0.3325574", "l0.8012832,0.3326176", "l0.8010098,0.3331788", "l0.8009915,0.3341410", "l0.8008275,0.3346221", "l0.8003718,0.3350430", "l0.7999707,0.3351032", "l0.7997338,0.3354239", "l0.7996608,0.3362658", "l0.7998614,0.3366667", "l0.7998614,0.3370075", "l0.7993692,0.3380900", "l0.7992598,0.3390521", "l0.7989499,0.3395132", "l0.7989499,0.3404553", "l0.7991140,0.3407159", "l0.7991322,0.3410567", "l0.7990228,0.3414576", "l0.7986400,0.3419587", "l0.7984942,0.3427405", "l0.7985489,0.3431615", "l0.7981661,0.3435624", "l0.7976374,0.3438230", "l0.7974369,0.3443642", "l0.7970906,0.3445245", "l0.7969265,0.3447450", "l0.7967442,0.3457874", "l0.7961791,0.3465491", "l0.7959422,0.3471104", "l0.7961427,0.3476717", "l0.7959057,0.3479523", "l0.7958328,0.3487742", "l0.7959604,0.3489947", "l0.7956870,0.3498165", "l0.7958328,0.3501774", "l0.7958328,0.3521218", "l0.7959604,0.3524826", "l0.7959604,0.3531240", "l0.7962156,0.3534849", "l0.7964708,0.3543669", "l0.7963797,0.3549682", "l0.7960698,0.3554493", "l0.7960880,0.3562311", "l0.7963250,0.3570730", "l0.7968171,0.3579750", "l0.7966349,0.3583759", "l0.7968901,0.3585764", "l0.7969630,0.3583759", "l0.7971453,0.3583559", "l0.7975281,0.3587167", "l0.7971817,0.3588570", "l0.7970723,0.3593983", "l0.7976374,0.3596188", "l0.7979473,0.3600397", "l0.7980020,0.3595586", "l0.7987129,0.3604607", "l0.7986036,0.3607814", "l0.7989681,0.3607814", "l0.7992598,0.3619641", "l0.7992051,0.3632871", "l0.7990957,0.3636278", "l0.7991869,0.3642493", "l0.7990775,0.3645098", "l0.7986947,0.3647303", "l0.7986765,0.3650511", "l0.7984213,0.3654119", "l0.7984213,0.3658128", "l0.7985853,0.3662337", "l0.7985489,0.3667750", "l0.7987312,0.3669955", "l0.7985671,0.3676169", "l0.7986765,0.3678775", "l0.7985124,0.3681982", "l0.7982572,0.3683185", "l0.7981843,0.3688196", "l0.7982025,0.3692205", "l0.7981114,0.3694811", "l0.7980385,0.3702228", "l0.7976921,0.3705636", "l0.7976739,0.3708242", "l0.7973822,0.3711449", "l0.7974916,0.3722674", "l0.7976557,0.3724679", "l0.7976557,0.3726884", "l0.7980567,0.3729089", "l0.7984031,0.3733900", "l0.7984213,0.3739312", "l0.7982208,0.3745526", "l0.7981478,0.3757353", "l0.7985489,0.3763567", "l0.7986218,0.3767576", "l0.7977833,0.3810072", "l0.7971999,0.3812879", "l0.7970359,0.3818491", "l0.7973276,0.3822501", "l0.7971999,0.3825307", "l0.7969447,0.3825908", "l0.7969265,0.3827913", "l0.7964890,0.3833325", "l0.7961427,0.3833125", "l0.7957963,0.3835731", "l0.7950854,0.3835731", "l0.7949213,0.3838537", "l0.7949396,0.3840742", "l0.7946844,0.3842346", "l0.7945750,0.3845152", "l0.7938641,0.3845954", "l0.7938458,0.3851366", "l0.7940099,0.3858181", "l0.7937547,0.3859585", "l0.7936453,0.3862792", "l0.7933901,0.3864396", "l0.7930802,0.3865799", "l0.7926792,0.3865598", "l0.7925334,0.3867001", "l0.7923693,0.3869808", "l0.7925516,0.3874017", "l0.7925334,0.3878427", "l0.7922964,0.3882637", "l0.7918771,0.3884040", "l0.7915672,0.3881434", "l0.7913667,0.3881434", "l0.7908928,0.3884441", "l0.7908381,0.3887849", "l0.7907105,0.3889252", "l0.7903641,0.3888450", "l0.7900178,0.3885443", "l0.7895985,0.3884641", "l0.7891610,0.3886846", "l0.7891246,0.3889051", "l0.7894345,0.3892259", "l0.7890699,0.3904887", "l0.7891246,0.3909297", "l0.7893251,0.3913306", "l0.7886142,0.3917516", "l0.7885230,0.3921926", "l0.7887782,0.3925935", "l0.7888876,0.3931548", "l0.7884866,0.3936158", "l0.7882131,0.3951994", "l0.7877027,0.3949789", "l0.7875387,0.3949789", "l0.7873564,0.3952395", "l0.7871012,0.3952195", "l0.7867913,0.3947985", "l0.7865543,0.3937561", "l0.7862080,0.3936158", "l0.7859528,0.3938163", "l0.7860075,0.3940969", "l0.7862991,0.3940969", "l0.7863903,0.3942573", "l0.7860986,0.3945379", "l0.7859163,0.3950791", "l0.7856976,0.3949388", "l0.7858069,0.3943775", "l0.7856429,0.3942172", "l0.7854424,0.3944778", "l0.7846403,0.3946181", "l0.7847497,0.3951593", "l0.7849320,0.3952395", "l0.7849684,0.3961215", "l0.7845309,0.3968431", "l0.7843851,0.3974044", "l0.7838200,0.3975447", "l0.7838382,0.3977652", "l0.7840752,0.3977452", "l0.7842393,0.3979456", "l0.7842940,0.3984267", "l0.7839294,0.3988276", "l0.7837653,0.4000304", "l0.7834190,0.4009524", "l0.7831091,0.4010326", "l0.7826351,0.4010527", "l0.7819607,0.4014135", "l0.7815232,0.4005916", "l0.7813591,0.4005716", "l0.7809216,0.4010527", "l0.7806300,0.4011930", "l0.7801013,0.4009124", "l0.7797914,0.4004914", "l0.7796821,0.4005716", "l0.7797003,0.4009324", "l0.7794086,0.4010527", "l0.7791352,0.4009925", "l0.7790805,0.4015538", "l0.7792628,0.4020950", "l0.7798644,0.4027365", "l0.7799737,0.4032176", "l0.7803748,0.4035784", "l0.7805753,0.4035984", "l0.7807576,0.4033980", "l0.7818695,0.4035984", "l0.7823617,0.4032978", "l0.7832002,0.4034381", "l0.7830909,0.4037989", "l0.7828721,0.4039994", "l0.7829997,0.4044203", "l0.7828903,0.4046408", "l0.7831638,0.4051820", "l0.7832731,0.4062244", "l0.7836377,0.4069661", "l0.7835466,0.4071064", "l0.7834007,0.4073670", "l0.7830909,0.4073469", "l0.7825258,0.4064649", "l0.7824711,0.4068859", "l0.7828356,0.4071064", "l0.7829450,0.4075073", "l0.7827080,0.4077879", "l0.7824528,0.4077879", "l0.7820154,0.4074873", "l0.7821065,0.4068458", "l0.7819242,0.4065451", "l0.7819424,0.4063246", "l0.7815961,0.4062044", "l0.7809399,0.4055829", "l0.7804477,0.4049415", "l0.7800649,0.4040394", "l0.7797185,0.4037388", "l0.7796091,0.4032577", "l0.7790441,0.4027164", "l0.7788982,0.4022955", "l0.7786430,0.4020950", "l0.7782784,0.4020950", "l0.7780779,0.4017543", "l0.7759998,0.4011128", "l0.7755441,0.4013734", "l0.7754894,0.4016340", "l0.7743775,0.4009925", "l0.7739947,0.4009725", "l0.7735390,0.4005515", "l0.7729009,0.4006117", "l0.7718072,0.4003912", "l0.7706588,0.4005315", "l0.7698021,0.4012130", "l0.7695651,0.4004513", "l0.7686719,0.4001306", "l0.7684167,0.3998499", "l0.7679427,0.3998299", "l0.7666485,0.3989880", "l0.7665573,0.3987875", "l0.7660287,0.3984869", "l0.7657370,0.3976449", "l0.7654454,0.3972440", "l0.7647162,0.3967028", "l0.7643334,0.3958609", "l0.7639324,0.3956605", "l0.7638048,0.3953798", "l0.7635131,0.3953197", "l0.7630392,0.3948787", "l0.7630209,0.3945980", "l0.7624558,0.3936359", "l0.7621460,0.3934755", "l0.7618361,0.3930345", "l0.7616902,0.3925935", "l0.7615626,0.3921124", "l0.7613074,0.3912905", "l0.7595939,0.3910300", "l0.7595028,0.3906090", "l0.7593205,0.3905489", "l0.7584820,0.3904687", "l0.7584090,0.3907293", "l0.7582997,0.3907092", "l0.7582997,0.3904286", "l0.7579351,0.3897270", "l0.7568049,0.3884240", "l0.7558935,0.3871612", "l0.7558752,0.3865197", "l0.7554742,0.3860386", "l0.7548362,0.3858382", "l0.7536331,0.3864596", "l0.7528857,0.3861990", "l0.7526123,0.3863193", "l0.7525211,0.3865799", "l0.7521748,0.3864396", "l0.7519925,0.3857981", "l0.7516097,0.3853771", "l0.7512634,0.3846756", "l0.7507712,0.3840341", "l0.7495498,0.3834528", "l0.7486566,0.3827712", "l0.7483103,0.3826510", "l0.7481098,0.3823904", "l0.7477999,0.3823703", "l0.7469614,0.3808268", "l0.7467062,0.3808469", "l0.7465056,0.3806464", "l0.7463233,0.3806665", "l0.7462869,0.3800851", "l0.7452661,0.3786419", "l0.7447010,0.3785216", "l0.7444458,0.3786619", "l0.7443364,0.3783211", "l0.7432427,0.3776997", "l0.7429510,0.3776797", "l0.7427687,0.3768378", "l0.7433520,0.3758556", "l0.7430604,0.3753745", "l0.7428052,0.3746127", "l0.7426958,0.3744925", "l0.7423312,0.3745125", "l0.7419484,0.3742319", "l0.7414745,0.3743522", "l0.7414745,0.3739512", "l0.7408182,0.3736105", "l0.7406360,0.3734100", "l0.7404354,0.3731294", "l0.7397792,0.3726683", "l0.7389771,0.3728287", "l0.7386308,0.3721872", "l0.7389771,0.3716059", "l0.7389589,0.3713052", "l0.7386855,0.3709444", "l0.7386672,0.3705836", "l0.7382115,0.3702428", "l0.7378105,0.3695613", "l0.7372636,0.3689800", "l0.7370813,0.3683586", "l0.7366985,0.3679176", "l0.7364616,0.3667950", "l0.7362610,0.3665144", "l0.7356959,0.3663540", "l0.7354407,0.3661335", "l0.7352767,0.3646101", "l0.7353496,0.3636278", "l0.7351126,0.3630666", "l0.7347663,0.3628461", "l0.7339095,0.3627859", "l0.7336726,0.3632871", "l0.7336361,0.3625053", "l0.7331075,0.3624251", "l0.7327976,0.3622247", "l0.7322689,0.3618238", "l0.7318861,0.3612625", "l0.7317768,0.3605208", "l0.7318497,0.3584962", "l0.7316492,0.3574538", "l0.7316309,0.3566320", "l0.7311570,0.3560306", "l0.7310841,0.3557099", "l0.7307013,0.3553691", "l0.7305190,0.3553691", "l0.7302091,0.3555094", "l0.7304461,0.3560106", "l0.7304278,0.3561709", "l0.7302820,0.3561709", "l0.7296622,0.3554894", "l0.7294617,0.3550885", "l0.7291153,0.3547678", "l0.7291883,0.3539860", "l0.7287143,0.3537855", "l0.7286232,0.3534849", "l0.7286232,0.3523222", "l0.7277664,0.3520015", "l0.7275841,0.3511195", "l0.7270190,0.3497364", "l0.7264904,0.3494557", "l0.7255972,0.3493354", "l0.7241936,0.3478120", "l0.7232457,0.3475314", "l0.7228082,0.3472507", "l0.7223160,0.3471705", "l0.7216780,0.3468097", "l0.7211129,0.3461282", "l0.7206390,0.3453063", "l0.7200739,0.3448854", "l0.7195088,0.3446849", "l0.7193629,0.3443441", "l0.7183786,0.3440635", "l0.7181781,0.3437428", "l0.7177406,0.3434220", "l0.7173031,0.3433419", "l0.7159542,0.3425400", "l0.7159359,0.3422795", "l0.7156989,0.3421391", "l0.7155896,0.3417984", "l0.7152797,0.3415177", "l0.7150792,0.3413774", "l0.7146234,0.3409565", "l0.7146417,0.3407560", "l0.7144594,0.3403952", "l0.7138943,0.3399341", "l0.7136391,0.3400143", "l0.7133474,0.3386913", "l0.7129829,0.3386111", "l0.7129646,0.3382503", "l0.7126547,0.3381100", "l0.7116704,0.3370275", "l0.7111235,0.3361856", "l0.7109777,0.3356845", "l0.7106131,0.3351232", "l0.7106860,0.3340207", "l0.7104855,0.3334194", "l0.7103032,0.3332189", "l0.7099933,0.3332189", "l0.7097017,0.3326777", "l0.7092642,0.3322166", "l0.7079882,0.3319360", "l0.7079335,0.3317756", "l0.7074595,0.3313747", "l0.7071132,0.3313547", "l0.7070220,0.3308135", "l0.7066575,0.3304126", "l0.7063111,0.3302923", "l0.7061106,0.3299315", "l0.7058554,0.3298713", "l0.7051809,0.3292499", "l0.7045976,0.3280873", "l0.7037955,0.3276663", "l0.7034856,0.3264436", "l0.7033216,0.3262431", "l0.7032304,0.3255816", "l0.7016628,0.3244190", "l0.7015716,0.3239379", "l0.7021185,0.3239579", "l0.7022825,0.3243789", "l0.7026471,0.3243187", "l0.7027018,0.3240982", "l0.7025195,0.3238176", "l0.7027383,0.3236572", "l0.7027383,0.3233966", "l0.7026107,0.3232764", "l0.7025560,0.3222340", "l0.7021185,0.3214923", "l0.7019909,0.3208108", "l0.7015534,0.3203297", "l0.7004232,0.3204099", "l0.6998581,0.3205702", "l0.6997852,0.3210313", "l0.7001315,0.3212317", "l0.7002956,0.3217329", "l0.7004779,0.3217128", "l0.7004961,0.3219333", "l0.7003685,0.3220135", "l0.7005326,0.3222942", "l0.7003867,0.3224545", "l0.7006420,0.3225748", "l0.7007513,0.3228354", "l0.7006420,0.3230358", "l0.7003685,0.3230358", "l0.7002227,0.3228153", "l0.6999493,0.3224545", "l0.6995482,0.3210914", "l0.6990196,0.3203497", "l0.6988191,0.3198486", "l0.6989284,0.3187461", "l0.6988008,0.3183252", "l0.6988738,0.3178641", "l0.6984727,0.3169019", "l0.6985092,0.3165812", "l0.6986550,0.3163807", "l0.6987462,0.3156190", "l0.6986186,0.3151981", "l0.6976889,0.3140956", "l0.6977983,0.3138951", "l0.6974337,0.3133940", "l0.6972879,0.3127926", "l0.6970509,0.3120910", "l0.6969415,0.3115298", "l0.6967410,0.3113293", "l0.6969415,0.3104874", "l0.6971785,0.3100865", "l0.6970873,0.3098058", "l0.6974519,0.3089840", "l0.6976160,0.3084428", "l0.6975431,0.3075608", "l0.6976342,0.3066788", "l0.6982540,0.3059972", "l0.6983451,0.3055763", "l0.6985456,0.3053758", "l0.6984363,0.3048747", "l0.6987097,0.3045940", "l0.6987462,0.3039726", "l0.6992748,0.3027899", "l0.6992930,0.3023289", "l0.6996029,0.3013868", "l0.6993112,0.3008856", "l0.6984727,0.3000437", "l0.6982722,0.2990214", "l0.6981081,0.2986205", "l0.6978894,0.2984601", "l0.6977436,0.2974579", "l0.6973790,0.2973977", "l0.6967957,0.2967763", "l0.6966134,0.2966159", "l0.6962670,0.2963554", "l0.6960665,0.2960146", "l0.6959754,0.2957540", "l0.6954467,0.2958943", "l0.6954467,0.2954333", "l0.6955926,0.2954132", "l0.6956290,0.2952128", "l0.6954285,0.2946114", "l0.6951369,0.2945914", "l0.6951915,0.2941303", "l0.6948452,0.2932684", "l0.6947358,0.2927071", "l0.6947540,0.2905422", "l0.6952827,0.2894998", "l0.6952280,0.2888985", "l0.6950639,0.2886178", "l0.6947540,0.2884575", "l0.6948634,0.2879363", "l0.6952462,0.2874552", "l0.6955014,0.2867736", "l0.6957749,0.2866935", "l0.6960301,0.2857914", "l0.6959389,0.2853705", "l0.6955926,0.2849094", "l0.6954285,0.2846288", "l0.6953921,0.2843080", "l0.6951186,0.2840274", "l0.6951004,0.2837668", "l0.6948270,0.2836065", "l0.6945900,0.2836666", "l0.6943348,0.2840875", "l0.6941525,0.2841076", "l0.6945900,0.2835062", "l0.6945535,0.2833860", "l0.6943166,0.2833860", "l0.6941707,0.2833058", "l0.6945353,0.2831655", "l0.6945353,0.2818625", "l0.6947723,0.2811208", "l0.6947176,0.2806197", "l0.6948634,0.2799381", "l0.6951186,0.2795773", "l0.6953556,0.2787755", "l0.6954467,0.2776129", "l0.6947358,0.2769313", "l0.6943348,0.2770516", "l0.6937515,0.2769113", "l0.6933869,0.2763500", "l0.6933869,0.2758088", "l0.6931317,0.2753277", "l0.6922385,0.2749869", "l0.6918739,0.2745259", "l0.6915640,0.2746461", "l0.6913999,0.2743254", "l0.6910354,0.2742653", "l0.6908713,0.2735637", "l0.6905250,0.2731026", "l0.6904156,0.2730826", "l0.6902151,0.2733432", "l0.6900510,0.2730626", "l0.6892125,0.2732029", "l0.6885745,0.2729222", "l0.6884651,0.2718398", "l0.6875537,0.2715191", "l0.6871162,0.2709778", "l0.6867334,0.2708175", "l0.6866605,0.2702161", "l0.6868610,0.2697952", "l0.6868427,0.2688530", "l0.6864235,0.2685122", "l0.6862047,0.2681314", "l0.6859131,0.2682517", "l0.6859131,0.2678307", "l0.6856214,0.2673697", "l0.6852204,0.2672093", "l0.6851292,0.2667883", "l0.6849834,0.2667883", "l0.6846006,0.2662271", "l0.6836709,0.2655656", "l0.6833975,0.2652047", "l0.6831058,0.2643829", "l0.6827595,0.2639218", "l0.6824678,0.2638617", "l0.6822309,0.2640020", "l0.6818845,0.2637414", "l0.6818298,0.2632002", "l0.6813741,0.2628594", "l0.6809184,0.2620576", "l0.6808455,0.2615765", "l0.6806449,0.2615164", "l0.6802986,0.2609752", "l0.6797700,0.2606945", "l0.6785669,0.2605742", "l0.6782934,0.2601132", "l0.6782205,0.2597724", "l0.6777830,0.2593715", "l0.6777830,0.2591510", "l0.6775825,0.2586298", "l0.6768534,0.2574271", "l0.6767075,0.2568258", "l0.6754133,0.2563647", "l0.6743378,0.2566453", "l0.6738274,0.2558636", "l0.6729524,0.2549014", "l0.6725696,0.2546809", "l0.6721868,0.2546809", "l0.6717493,0.2542198", "l0.6714941,0.2541597", "l0.6714029,0.2539593", "l0.6710566,0.2537588", "l0.6708561,0.2527365", "l0.6704550,0.2523356", "l0.6704004,0.2517543", "l0.6702545,0.2515939", "l0.6707467,0.2501105", "l0.6705280,0.2498900", "l0.6705097,0.2494691", "l0.6701634,0.2492085", "l0.6701634,0.2489479", "l0.6698535,0.2486071", "l0.6699082,0.2480659", "l0.6694707,0.2474445", "l0.6687780,0.2469033", "l0.6685410,0.2470235", "l0.6679942,0.2469434", "l0.6679212,0.2463821", "l0.6674837,0.2456604", "l0.6671739,0.2456604", "l0.6666088,0.2453798", "l0.6665905,0.2444377", "l0.6664629,0.2440568", "l0.6667546,0.2434955", "l0.6667546,0.2429543", "l0.6665905,0.2422928", "l0.6661895,0.2417516", "l0.6654421,0.2411502", "l0.6654421,0.2408896", "l0.6656244,0.2407694", "l0.6655515,0.2400878", "l0.6657156,0.2393662", "l0.6658249,0.2392860", "l0.6658614,0.2386846", "l0.6662442,0.2383639", "l0.6656791,0.2364997", "l0.6651140,0.2360186", "l0.6650046,0.2357380", "l0.6642390,0.2356778", "l0.6639838,0.2354172", "l0.6637286,0.2348159", "l0.6634734,0.2345553", "l0.6632547,0.2342145", "l0.6632729,0.2337935", "l0.6627443,0.2331922", "l0.6623432,0.2329917", "l0.6618146,0.2330719", "l0.6615958,0.2327512", "l0.6601011,0.2319895", "l0.6600829,0.2318692", "l0.6602651,0.2317489", "l0.6602287,0.2312879", "l0.6600464,0.2310072", "l0.6597912,0.2308870", "l0.6596089,0.2299448", "l0.6593355,0.2298646", "l0.6592990,0.2304860", "l0.6593719,0.2306464", "l0.6592079,0.2308469", "l0.6590620,0.2307667", "l0.6588251,0.2309872", "l0.6585881,0.2303858", "l0.6588615,0.2301252", "l0.6588980,0.2295840", "l0.6590438,0.2295640", "l0.6592079,0.2292833", "l0.6590074,0.2286619", "l0.6588433,0.2286619", "l0.6586610,0.2289425", "l0.6586975,0.2292232", "l0.6589709,0.2292432", "l0.6589709,0.2293635", "l0.6580777,0.2298446", "l0.6579136,0.2300450", "l0.6579501,0.2296241", "l0.6583511,0.2292031", "l0.6587886,0.2280806", "l0.6587157,0.2272788", "l0.6584058,0.2265171", "l0.6578407,0.2257353", "l0.6576037,0.2255549", "l0.6573485,0.2255549", "l0.6578225,0.2248934", "l0.6578225,0.2244925", "l0.6576584,0.2242118", "l0.6577313,0.2232697", "l0.6575673,0.2225280", "l0.6579319,0.2219868", "l0.6580048,0.2211649", "l0.6575673,0.2208843", "l0.6576220,0.2203431", "l0.6575308,0.2201426", "l0.6572209,0.2201226", "l0.6572027,0.2193007", "l0.6569110,0.2190401", "l0.6570751,0.2181581", "l0.6569475,0.2177772", "l0.6567652,0.2176369", "l0.6567470,0.2173763", "l0.6566012,0.2172160", "l0.6562548,0.2172160", "l0.6557262,0.2169955", "l0.6543225,0.2165344", "l0.6542132,0.2163139", "l0.6542314,0.2159331", "l0.6550335,0.2150711", "l0.6552704,0.2141490", "l0.6549059,0.2128661", "l0.6547783,0.2109217", "l0.6544866,0.2106010", "l0.6543772,0.2099996", "l0.6544684,0.2097390", "l0.6546507,0.2097190", "l0.6546324,0.2094383", "l0.6548147,0.2092379", "l0.6549241,0.2087568", "l0.6548330,0.2084762", "l0.6551428,0.2077345", "l0.6549059,0.2063914", "l0.6557626,0.2047076", "l0.6555986,0.2025828", "l0.6555074,0.2023823", "l0.6553251,0.2023623", "l0.6551611,0.2017810", "l0.6549606,0.2016006", "l0.6549423,0.2012598", "l0.6542314,0.1999368", "l0.6540673,0.1999368", "l0.6536845,0.1995960", "l0.6535752,0.1995960", "l0.6536299,0.1997764", "l0.6534840,0.1998566", "l0.6531377,0.1997965", "l0.6527549,0.1983332", "l0.6524632,0.1977919", "l0.6516976,0.1969500", "l0.6516976,0.1969500", "l0.6643302,0.1865264", "l0.6690150,0.1853437", "l0.6690150,0.1853437", "l0.6690150,0.1836599", "c"]}, {"n": "Al Qalyūbīyah", "u": "EG-KB", "i": ["m0.5354525,0.1606277", "l0.5310593,0.1576610", "l0.5280516,0.1520883", "l0.5280516,0.1520883", "l0.5277417,0.1428073", "l0.5277417,0.1428073", "l0.5261376,0.1393194", "l0.5254084,0.1355509", "l0.5254084,0.1355509", "l0.5277417,0.1302188", "l0.5318796,0.1270716", "l0.5318796,0.1270716", "l0.5362728,0.1233833", "l0.5372207,0.1209177", "l0.5372207,0.1209177", "l0.5379498,0.1118772", "l0.5379498,0.1118772", "l0.5396087,0.1130599", "l0.5415591,0.1166480", "l0.5436919,0.1167883", "l0.5436919,0.1167883", "l0.5413769,0.1193942", "l0.5412310,0.1243655", "l0.5400279,0.1244457", "l0.5400279,0.1296976", "l0.5420695,0.1318224", "l0.5441112,0.1347691", "l0.5463169,0.1395599", "l0.5481762,0.1449522", "l0.5520589,0.1482797", "l0.5565250,0.1509658", "l0.5568896,0.1515070", "l0.5601708,0.1536719", "l0.5601708,0.1536719", "l0.5519496,0.1542733", "l0.5439289,0.1578213", "l0.5405383,0.1612090", "l0.5405383,0.1612090", "c"]}, {"n": "Kafr ash Shaykh", "u": "EG-KFS", "i": ["m0.5251350,0.0073803", "l0.5256454,0.0075607", "l0.5259188,0.0075006", "l0.5267027,0.0076409", "l0.5268120,0.0078013", "l0.5270490,0.0077011", "l0.5271584,0.0079616", "l0.5273042,0.0079416", "l0.5276688,0.0082623", "l0.5281427,0.0084427", "l0.5295828,0.0087234", "l0.5313510,0.0093247", "l0.5322807,0.0093448", "l0.5325359,0.0095252", "l0.5329369,0.0095853", "l0.5332833,0.0098459", "l0.5335932,0.0098459", "l0.5342676,0.0103671", "l0.5359811,0.0106878", "l0.5375670,0.0113694", "l0.5387519,0.0116099", "l0.5420878,0.0131935", "l0.5421242,0.0186258", "l0.5398456,0.0184053", "l0.5398456,0.0184053", "l0.5380045,0.0202295", "l0.5381504,0.0244190", "l0.5401373,0.0242385", "l0.5402831,0.0300517", "l0.5411216,0.0320563", "l0.5412493,0.0533445", "l0.5416867,0.0567522", "l0.5404107,0.0578347", "l0.5374212,0.0572133", "l0.5374212,0.0572133", "l0.5374212,0.0570128", "l0.5352520,0.0570730", "l0.5324812,0.0569327", "l0.5324812,0.0569327", "l0.5230022,0.0577946", "l0.5212705,0.0576543", "l0.5212705,0.0688998", "l0.5117550,0.0687194", "l0.5113358,0.0705034", "l0.5110441,0.0725280", "l0.5025313,0.0725280", "l0.5019844,0.0704232", "l0.5019844,0.0704232", "l0.4997787,0.0704032", "l0.4962788,0.0634073", "l0.4854691,0.0522220", "l0.4787974,0.0529236", "l0.4787974,0.0390922", "l0.4736933,0.0326376", "l0.4729459,0.0228153", "l0.4765370,0.0227953", "l0.4811124,0.0217128", "l0.4936356,0.0170422", "l0.4991225,0.0155188", "l0.5026589,0.0129730", "l0.5037890,0.0133739", "l0.5057395,0.0123917", "l0.5118280,0.0107279", "l0.5145440,0.0091443", "l0.5148539,0.0103471", "l0.5145440,0.0116500", "l0.5125753,0.0110486", "l0.5106066,0.0115297", "l0.5062682,0.0129730", "l0.5034792,0.0146769", "l0.5024401,0.0158395", "l0.5004896,0.0168017", "l0.4990678,0.0177639", "l0.4960236,0.0190869", "l0.4930887,0.0201493", "l0.4911200,0.0221939", "l0.4904638,0.0238777", "l0.4893883,0.0237575", "l0.4879664,0.0244791", "l0.4852504,0.0245793", "l0.4845941,0.0256618", "l0.4831723,0.0259023", "l0.4812218,0.0254212", "l0.4796906,0.0260226", "l0.4793624,0.0273456", "l0.4792348,0.0299715", "l0.4803468,0.0299715", "l0.4829535,0.0304526", "l0.4883128,0.0302923", "l0.4885133,0.0291296", "l0.4893883,0.0263834", "l0.4913388,0.0269848", "l0.4929429,0.0284280", "l0.4944741,0.0294303", "l0.4956955,0.0278267", "l0.4961329,0.0263834", "l0.4974454,0.0255415", "l0.4995053,0.0238777", "l0.5004896,0.0236372", "l0.5010000,0.0247196", "l0.5022396,0.0259023", "l0.5042995,0.0253010", "l0.5074348,0.0258021", "l0.5097499,0.0259825", "l0.5117915,0.0246194", "l0.5159294,0.0234167", "l0.5174789,0.0209511", "l0.5185726,0.0181247", "l0.5197575,0.0163206", "l0.5224918,0.0164409", "l0.5241142,0.0166814", "l0.5242418,0.0187461", "l0.5254813,0.0192873", "l0.5267209,0.0155990", "l0.5253173,0.0135744", "l0.5218356,0.0111689", "l0.5193200,0.0099862", "l0.5173513,0.0097056", "l0.5159294,0.0092646", "l0.5175883,0.0083425", "l0.5203408,0.0075607", "l0.5209970,0.0075006", "l0.5212522,0.0076810", "l0.5216168,0.0075006", "c"]}, {"n": "Qinā", "u": "EG-KN", "i": ["m0.6543590,0.6657527", "l0.6499294,0.6633272", "l0.6454269,0.6589372", "l0.6431483,0.6570129", "l0.6409244,0.6505983", "l0.6401770,0.6445847", "l0.6405051,0.6414777", "l0.6391197,0.6384307", "l0.6388463,0.6321766", "l0.6367500,0.6271853", "l0.6355833,0.6250404", "l0.6357839,0.6203498", "l0.6374609,0.6162805", "l0.6407056,0.6125922", "l0.6455180,0.6103070", "l0.6503304,0.6053558", "l0.6533564,0.6014068", "l0.6546142,0.5983599", "l0.6546142,0.5930078", "l0.6555621,0.5898206", "l0.6583876,0.5843482", "l0.6608120,0.5803992", "l0.6603563,0.5758890", "l0.6581324,0.5713387", "l0.6564553,0.5698152", "l0.6517523,0.5695546", "l0.6470493,0.5715993", "l0.6436040,0.5744056", "l0.6359661,0.5778534", "l0.6338698,0.5792566", "l0.6304246,0.5805195", "l0.6270705,0.5807801", "l0.6232971,0.5815418", "l0.6206904,0.5824238", "l0.6119041,0.5826643", "l0.6089875,0.5814015", "l0.6001283,0.5729022", "l0.6001283,0.5729022", "l0.5961544,0.5675701", "l0.5961544,0.5675701", "l0.5974122,0.5653050", "l0.5991986,0.5634007", "l0.6018054,0.5614763", "l0.6042116,0.5614763", "l0.6064172,0.5605743", "l0.6088234,0.5586699", "l0.6100812,0.5563647", "l0.6116489,0.5561041", "l0.6138546,0.5573870", "l0.6142739,0.5601934", "l0.6154405,0.5636412", "l0.6171540,0.5645433", "l0.6184665,0.5655455", "l0.6202529,0.5682316", "l0.6224586,0.5682316", "l0.6232971,0.5669487", "l0.6249742,0.5649241", "l0.6249742,0.5649241", "l0.6280548,0.5646836", "l0.6306616,0.5631601", "l0.6344349,0.5600932", "l0.6397760,0.5560039", "l0.6442785,0.5543401", "l0.6553616,0.5542199", "l0.6635281,0.5561442", "l0.6697077,0.5607346", "l0.6723144,0.5653250", "l0.6734446,0.5696949", "l0.6734446,0.5696949", "l0.6734446,0.5696949", "l0.6734446,0.5696949", "l0.6755044,0.5746662", "l0.6761424,0.5815418", "l0.6761424,0.5815418", "l0.6761971,0.5894597", "l0.6758325,0.5910032", "l0.6758325,0.5910032", "l0.6726607,0.6020282", "l0.6690697,0.6083425", "l0.6585516,0.6158796", "l0.6551064,0.6220937", "l0.6519710,0.6257620", "l0.6505127,0.6294303", "l0.6505127,0.6402148", "l0.6519710,0.6452863", "l0.6547965,0.6502175", "l0.6547965,0.6502175", "l0.6560907,0.6515004", "l0.6560907,0.6515004", "l0.6562183,0.6586566", "l0.6543590,0.6657527", "c", "m0.6470310,0.6174031", "l0.6503851,0.6180846", "l0.6530283,0.6175835", "l0.6547054,0.6148774", "l0.6558173,0.6119908", "l0.6563824,0.6087835", "l0.6514971,0.6082824", "l0.6489815,0.6148774", "l0.6470310,0.6174031", "c"]}, {"n": "Al Uqşur", "u": "EG-LX", "i": ["m0.6563824,0.6087835", "l0.6558355,0.6119908", "l0.6547054,0.6148774", "l0.6530465,0.6175835", "l0.6503851,0.6180846", "l0.6470310,0.6174031", "l0.6489997,0.6148774", "l0.6515153,0.6082624", "c"]}, {"n": "Al Minyā", "u": "EG-MN", "i": ["m0.3248186,0.4128795", "l0.3273342,0.4073469", "l0.3291388,0.4029169", "l0.3302143,0.3993689", "l0.3309435,0.3949188", "l0.3323653,0.3913507", "l0.3352455,0.3891256", "l0.3381256,0.3873616", "l0.3478234,0.3851166", "l0.3535837,0.3820095", "l0.3611304,0.3757754", "l0.3679480,0.3731093", "l0.3726328,0.3691002", "l0.3772993,0.3677572", "l0.3841352,0.3610620", "l0.3927574,0.3548279", "l0.3974240,0.3507988", "l0.4017442,0.3463286", "l0.4038952,0.3351633", "l0.4067753,0.3244190", "l0.4089263,0.3177037", "l0.4118065,0.3118906", "l0.4138846,0.3031908", "l0.4138846,0.3031908", "l0.4184600,0.3027298", "l0.4339363,0.3021485", "l0.4367070,0.3022086", "l0.4976095,0.2999836", "l0.5020391,0.3028100", "l0.5073072,0.3068391", "l0.5073072,0.3068391", "l0.5141066,0.3078414", "l0.5132680,0.3110687", "l0.5132680,0.3110687", "l0.5109165,0.3185256", "l0.5108071,0.3271251", "l0.5108071,0.3271251", "l0.5107342,0.3320964", "l0.5085832,0.3355041", "l0.5065598,0.3391724", "l0.5042995,0.3436626", "l0.5029323,0.3492954", "l0.5031693,0.3537855", "l0.5042995,0.3658729", "l0.5104061,0.3812879", "l0.5112993,0.3930545", "l0.5133409,0.4003310", "l0.5137967,0.4098526", "l0.5131222,0.4165478", "l0.5131222,0.4165478", "l0.5080546,0.4161669", "l0.5052109,0.4189132", "l0.5007813,0.4181314", "l0.4974454,0.4171492", "l0.4919221,0.4171492", "l0.4919221,0.4171492", "l0.4917580,0.4132403", "l0.3274618,0.4128795", "l0.3274618,0.4128795", "c"]}, {"n": "Al Minūfīyah", "u": "EG-MNF", "i": ["m0.5164034,0.1037187", "l0.5164034,0.1037187", "l0.5164034,0.1037187", "l0.5244787,0.1036185", "l0.5253355,0.1060440", "l0.5253355,0.1060440", "l0.5250256,0.1059237", "l0.5253355,0.1060440", "l0.5253355,0.1060440", "l0.5254449,0.1081087", "l0.5310776,0.1081487", "l0.5310776,0.1081487", "l0.5379681,0.1116366", "l0.5372207,0.1209177", "l0.5372207,0.1209177", "l0.5362728,0.1233833", "l0.5318796,0.1270716", "l0.5318796,0.1270716", "l0.5277417,0.1302188", "l0.5254084,0.1355509", "l0.5254084,0.1355509", "l0.5261376,0.1393194", "l0.5277417,0.1428073", "l0.5277417,0.1428073", "l0.5280516,0.1522487", "l0.5244970,0.1535717", "l0.5231116,0.1531908", "l0.5231116,0.1531908", "l0.5214892,0.1521485", "l0.5214892,0.1521485", "l0.5214892,0.1521485", "l0.5214892,0.1521485", "l0.5200309,0.1539526", "l0.5170596,0.1533512", "l0.5154190,0.1515672", "l0.5152914,0.1479590", "l0.5136326,0.1461749", "l0.5110441,0.1463153", "l0.5108801,0.1399408", "l0.5108801,0.1399408", "l0.5108801,0.1399408", "l0.5108801,0.1399408", "l0.5070702,0.1396602", "l0.5058307,0.1408228", "l0.5032057,0.1410634", "l0.5032057,0.1410634", "l0.5034609,0.1373950", "l0.5059765,0.1370944", "l0.5061223,0.1333859", "l0.5059400,0.1253076", "l0.5048828,0.1222206", "l0.5053567,0.1187528", "l0.5032240,0.1169888", "l0.5040625,0.1133606", "l0.5021120,0.1132002", "l0.5018750,0.1123984", "l0.5023672,0.1030572", "l0.5023672,0.1030572", "l0.5087837,0.1021752", "l0.5090572,0.1001907", "l0.5134685,0.1001907", "l0.5135961,0.1019948", "l0.5157107,0.1020950", "c"]}, {"n": "Maţrūḩ", "u": "EG-MT", "i": ["m0.0373503,0.0005448", "l0.0374961,0.0011061", "l0.0374779,0.0018077", "l0.0373685,0.0018879", "l0.0374414,0.0022086", "l0.0373138,0.0024091", "l0.0373321,0.0026496", "l0.0371316,0.0030104", "l0.0372956,0.0036318", "l0.0372045,0.0038724", "l0.0376602,0.0042733", "l0.0377513,0.0044737", "l0.0376420,0.0046141", "l0.0379336,0.0048546", "l0.0378060,0.0051553", "l0.0376966,0.0051553", "l0.0378060,0.0054760", "l0.0376602,0.0059972", "l0.0378243,0.0059371", "l0.0379519,0.0060774", "l0.0379154,0.0063380", "l0.0383529,0.0068391", "l0.0388268,0.0080418", "l0.0390091,0.0081621", "l0.0390274,0.0085029", "l0.0389180,0.0085831", "l0.0392096,0.0094049", "l0.0391550,0.0096054", "l0.0394284,0.0099461", "l0.0394648,0.0102869", "l0.0397383,0.0106678", "l0.0399935,0.0106878", "l0.0399023,0.0110286", "l0.0391550,0.0112291", "l0.0390274,0.0117302", "l0.0388451,0.0118705", "l0.0386992,0.0118906", "l0.0385716,0.0116300", "l0.0383711,0.0118104", "l0.0383711,0.0125921", "l0.0386628,0.0132737", "l0.0389362,0.0135944", "l0.0389180,0.0138550", "l0.0395924,0.0146769", "l0.0397565,0.0146769", "l0.0401211,0.0150176", "l0.0425273,0.0161001", "l0.0450064,0.0168017", "l0.0473215,0.0171425", "l0.0492537,0.0176436", "l0.0499646,0.0176436", "l0.0502563,0.0177639", "l0.0503474,0.0176837", "l0.0529177,0.0177639", "l0.0550505,0.0175835", "l0.0551598,0.0174431", "l0.0552510,0.0176837", "l0.0559255,0.0177438", "l0.0560531,0.0176636", "l0.0561442,0.0177839", "l0.0575478,0.0178641", "l0.0603004,0.0172828", "l0.0619227,0.0166413", "l0.0628524,0.0165010", "l0.0628706,0.0163206", "l0.0632170,0.0165210", "l0.0644748,0.0165010", "l0.0666622,0.0159999", "l0.0693783,0.0150577", "l0.0713106,0.0141557", "l0.0740814,0.0133138", "l0.0740996,0.0131735", "l0.0744824,0.0132336", "l0.0777089,0.0118906", "l0.0779823,0.0120108", "l0.0780005,0.0118906", "l0.0782922,0.0118705", "l0.0786568,0.0115698", "l0.0789120,0.0115698", "l0.0796229,0.0111689", "l0.0802427,0.0111088", "l0.0804250,0.0109284", "l0.0813546,0.0106678", "l0.0815916,0.0104673", "l0.0819927,0.0104673", "l0.0821020,0.0103270", "l0.0826489,0.0101867", "l0.0829223,0.0099261", "l0.0833598,0.0098660", "l0.0837973,0.0095452", "l0.0842348,0.0095452", "l0.0848728,0.0091443", "l0.0858025,0.0088837", "l0.0867321,0.0083225", "l0.0885733,0.0076810", "l0.0890290,0.0073603", "l0.0893753,0.0073803", "l0.0900862,0.0069393", "l0.0907060,0.0068591", "l0.0911800,0.0065986", "l0.0912893,0.0066587", "l0.0913987,0.0065184", "l0.0916539,0.0064983", "l0.0917086,0.0063179", "l0.0918727,0.0064582", "l0.0921461,0.0061976", "l0.0928935,0.0061976", "l0.0930758,0.0060172", "l0.0932581,0.0060774", "l0.0934768,0.0058970", "l0.0936591,0.0059170", "l0.0937685,0.0057166", "l0.0941513,0.0057767", "l0.0941877,0.0056564", "l0.0944247,0.0056364", "l0.0945888,0.0057166", "l0.0949351,0.0054760", "l0.0951174,0.0055361", "l0.0953908,0.0052956", "l0.0957919,0.0052956", "l0.0964299,0.0049548", "l0.0967762,0.0050150", "l0.0970314,0.0048746", "l0.0975965,0.0048546", "l0.0977059,0.0046742", "l0.0982710,0.0046942", "l0.0983986,0.0045740", "l0.0984897,0.0047143", "l0.0994741,0.0046541", "l0.0995835,0.0047744", "l0.0998569,0.0046942", "l0.0999663,0.0048346", "l0.1002397,0.0048145", "l0.1006772,0.0050751", "l0.1010600,0.0050551", "l0.1015157,0.0053156", "l0.1018803,0.0052355", "l0.1021173,0.0055361", "l0.1025547,0.0056564", "l0.1029376,0.0057166", "l0.1033204,0.0055963", "l0.1038125,0.0059771", "l0.1045417,0.0059972", "l0.1045781,0.0061175", "l0.1051068,0.0061175", "l0.1051797,0.0062377", "l0.1055443,0.0061776", "l0.1057266,0.0063179", "l0.1059271,0.0062979", "l0.1060365,0.0064783", "l0.1061823,0.0062778", "l0.1065286,0.0062979", "l0.1066380,0.0065384", "l0.1068203,0.0064181", "l0.1072031,0.0064783", "l0.1076953,0.0068792", "l0.1078411,0.0067589", "l0.1080052,0.0068992", "l0.1082968,0.0068191", "l0.1084062,0.0069995", "l0.1084427,0.0068191", "l0.1086432,0.0068191", "l0.1086614,0.0070596", "l0.1091171,0.0072400", "l0.1095911,0.0071398", "l0.1099374,0.0073202", "l0.1105207,0.0073202", "l0.1111041,0.0076810", "l0.1115780,0.0076008", "l0.1117238,0.0078414", "l0.1120337,0.0077812", "l0.1121249,0.0079216", "l0.1122525,0.0078614", "l0.1125988,0.0080418", "l0.1127811,0.0079216", "l0.1129452,0.0081621", "l0.1132004,0.0081020", "l0.1135103,0.0082824", "l0.1136014,0.0081421", "l0.1136926,0.0083225", "l0.1148045,0.0085229", "l0.1152420,0.0090241", "l0.1154607,0.0090040", "l0.1154790,0.0091443", "l0.1158436,0.0090040", "l0.1159529,0.0092045", "l0.1161352,0.0091243", "l0.1162446,0.0092446", "l0.1166456,0.0092646", "l0.1167914,0.0095051", "l0.1169920,0.0094851", "l0.1174659,0.0097457", "l0.1176300,0.0096455", "l0.1178305,0.0098259", "l0.1180857,0.0098259", "l0.1182133,0.0100063", "l0.1184867,0.0098860", "l0.1189424,0.0103471", "l0.1196716,0.0106678", "l0.1197992,0.0106076", "l0.1214763,0.0111689", "l0.1217497,0.0110887", "l0.1219502,0.0112892", "l0.1222419,0.0112691", "l0.1223330,0.0114696", "l0.1230622,0.0114896", "l0.1233356,0.0117502", "l0.1234997,0.0116300", "l0.1240647,0.0116500", "l0.1244658,0.0119106", "l0.1250856,0.0120910", "l0.1251585,0.0122313", "l0.1265074,0.0124919", "l0.1278928,0.0131133", "l0.1282938,0.0130331", "l0.1285126,0.0132336", "l0.1287131,0.0132136", "l0.1289683,0.0134741", "l0.1305177,0.0139151", "l0.1314292,0.0146368", "l0.1321036,0.0145566", "l0.1323042,0.0146368", "l0.1323406,0.0148372", "l0.1327599,0.0147771", "l0.1330515,0.0151580", "l0.1335437,0.0150778", "l0.1337260,0.0154586", "l0.1341635,0.0153785", "l0.1344552,0.0156190", "l0.1351296,0.0155388", "l0.1357859,0.0159197", "l0.1363327,0.0157994", "l0.1371895,0.0158595", "l0.1373900,0.0162204", "l0.1379186,0.0165210", "l0.1382650,0.0165210", "l0.1383561,0.0163807", "l0.1391035,0.0166413", "l0.1405800,0.0165210", "l0.1408717,0.0167215", "l0.1415462,0.0167015", "l0.1416738,0.0168819", "l0.1419290,0.0167616", "l0.1423300,0.0170422", "l0.1436789,0.0171024", "l0.1437701,0.0172427", "l0.1444081,0.0173028", "l0.1448820,0.0175434", "l0.1449550,0.0177238", "l0.1454836,0.0178440", "l0.1464315,0.0184655", "l0.1467414,0.0184053", "l0.1475070,0.0188463", "l0.1489653,0.0187862", "l0.1516632,0.0182850", "l0.1526475,0.0176235", "l0.1527569,0.0185256", "l0.1535043,0.0189666", "l0.1541605,0.0189866", "l0.1542516,0.0192873", "l0.1545433,0.0193675", "l0.1548167,0.0192873", "l0.1551266,0.0195279", "l0.1563297,0.0195880", "l0.1574417,0.0192873", "l0.1575328,0.0192873", "l0.1574964,0.0194677", "l0.1576969,0.0195279", "l0.1598844,0.0193475", "l0.1603765,0.0193675", "l0.1610328,0.0196080", "l0.1616890,0.0194878", "l0.1625458,0.0199889", "l0.1641864,0.0200490", "l0.1647332,0.0202896", "l0.1682149,0.0200891", "l0.1684337,0.0201693", "l0.1687253,0.0206103", "l0.1698008,0.0210714", "l0.1706029,0.0212117", "l0.1708216,0.0217128", "l0.1708034,0.0220335", "l0.1712409,0.0223342", "l0.1713867,0.0225948", "l0.1737747,0.0233165", "l0.1743398,0.0236973", "l0.1744492,0.0239980", "l0.1750689,0.0241383", "l0.1754153,0.0244390", "l0.1760898,0.0245793", "l0.1780949,0.0244590", "l0.1796444,0.0244590", "l0.1801912,0.0245793", "l0.1803371,0.0244590", "l0.1815949,0.0245392", "l0.1818683,0.0247196", "l0.1822329,0.0245392", "l0.1827615,0.0246595", "l0.1828526,0.0245192", "l0.1842016,0.0243989", "l0.1845479,0.0243388", "l0.1858239,0.0241985", "l0.1860062,0.0243388", "l0.1863161,0.0241584", "l0.1864802,0.0242987", "l0.1867536,0.0242385", "l0.1870088,0.0244791", "l0.1874645,0.0243388", "l0.1875375,0.0247397", "l0.1878838,0.0249201", "l0.1880661,0.0253210", "l0.1883213,0.0253811", "l0.1888135,0.0258422", "l0.1891051,0.0258422", "l0.1891780,0.0260426", "l0.1890869,0.0265638", "l0.1897067,0.0275661", "l0.1902900,0.0279069", "l0.1917483,0.0280271", "l0.1919488,0.0282877", "l0.1921858,0.0281073", "l0.1930243,0.0281073", "l0.1931337,0.0284481", "l0.1936076,0.0287889", "l0.1941363,0.0284080", "l0.1943915,0.0292299", "l0.1943915,0.0294103", "l0.1942639,0.0294704", "l0.1943550,0.0299916", "l0.1947561,0.0304326", "l0.1956675,0.0308736", "l0.1961961,0.0308134", "l0.1971076,0.0311943", "l0.1972716,0.0314549", "l0.1985477,0.0313146", "l0.1998419,0.0313948", "l0.2014825,0.0313547", "l0.2014825,0.0312344", "l0.2031049,0.0312945", "l0.2033418,0.0314148", "l0.2060762,0.0316554", "l0.2062402,0.0317957", "l0.2069876,0.0317957", "l0.2075527,0.0320362", "l0.2071152,0.0322968", "l0.2067142,0.0322968", "l0.2065501,0.0319961", "l0.2063678,0.0319159", "l0.2056933,0.0320563", "l0.2054381,0.0317957", "l0.2048730,0.0317957", "l0.2046725,0.0318759", "l0.2044902,0.0322166", "l0.2038705,0.0317756", "l0.2035970,0.0320964", "l0.2034147,0.0320964", "l0.2033054,0.0326576", "l0.2034147,0.0329784", "l0.2048001,0.0330585", "l0.2048730,0.0328581", "l0.2056751,0.0328781", "l0.2057663,0.0327579", "l0.2066595,0.0328380", "l0.2067324,0.0325774", "l0.2069876,0.0324371", "l0.2072428,0.0330786", "l0.2077350,0.0332590", "l0.2085006,0.0333191", "l0.2089381,0.0329383", "l0.2089381,0.0327979", "l0.2092844,0.0328781", "l0.2094667,0.0330786", "l0.2096672,0.0329583", "l0.2097401,0.0326576", "l0.2095579,0.0324171", "l0.2087011,0.0323369", "l0.2086282,0.0321966", "l0.2094303,0.0323169", "l0.2097037,0.0322367", "l0.2100683,0.0323169", "l0.2102323,0.0321966", "l0.2112167,0.0322968", "l0.2135135,0.0319159", "l0.2147166,0.0318558", "l0.2158286,0.0315952", "l0.2161020,0.0316754", "l0.2169405,0.0315952", "l0.2169405,0.0321164", "l0.2176150,0.0323569", "l0.2178702,0.0325975", "l0.2179066,0.0334995", "l0.2177244,0.0335196", "l0.2174327,0.0341009", "l0.2174509,0.0348626", "l0.2173598,0.0351032", "l0.2179066,0.0360453", "l0.2179066,0.0363660", "l0.2182165,0.0365665", "l0.2182895,0.0368271", "l0.2184535,0.0368872", "l0.2187452,0.0374084", "l0.2190186,0.0375888", "l0.2191280,0.0382904", "l0.2190551,0.0386312", "l0.2198024,0.0399742", "l0.2199665,0.0408963", "l0.2201670,0.0411569", "l0.2202035,0.0415979", "l0.2200394,0.0417983", "l0.2201670,0.0419387", "l0.2201488,0.0421993", "l0.2203858,0.0422193", "l0.2204769,0.0425200", "l0.2204405,0.0432416", "l0.2207503,0.0435423", "l0.2211149,0.0443040", "l0.2217529,0.0449254", "l0.2216800,0.0451058", "l0.2221175,0.0455468", "l0.2231019,0.0463286", "l0.2235940,0.0469500", "l0.2242503,0.0473309", "l0.2248154,0.0478521", "l0.2257086,0.0482931", "l0.2288986,0.0490147", "l0.2344766,0.0490347", "l0.2345131,0.0492352", "l0.2343855,0.0491149", "l0.2341121,0.0491350", "l0.2341485,0.0493956", "l0.2344037,0.0497363", "l0.2348594,0.0499167", "l0.2350782,0.0503177", "l0.2356615,0.0507587", "l0.2371380,0.0507587", "l0.2377031,0.0506384", "l0.2378307,0.0503778", "l0.2384505,0.0503778", "l0.2388333,0.0501974", "l0.2410572,0.0501372", "l0.2411301,0.0502575", "l0.2407838,0.0507787", "l0.2409479,0.0513600", "l0.2410572,0.0516206", "l0.2417682,0.0519614", "l0.2418046,0.0521017", "l0.2429166,0.0519814", "l0.2432629,0.0520416", "l0.2434270,0.0522420", "l0.2437916,0.0523623", "l0.2453592,0.0525627", "l0.2454686,0.0522621", "l0.2457420,0.0520616", "l0.2456691,0.0517208", "l0.2453957,0.0517810", "l0.2449947,0.0522821", "l0.2446119,0.0522621", "l0.2446119,0.0517008", "l0.2449947,0.0517609", "l0.2450311,0.0516407", "l0.2457785,0.0516407", "l0.2463983,0.0514001", "l0.2467446,0.0513400", "l0.2470363,0.0512197", "l0.2482212,0.0510794", "l0.2489321,0.0508388", "l0.2507914,0.0499969", "l0.2512654,0.0499969", "l0.2512836,0.0498767", "l0.2524138,0.0494757", "l0.2526143,0.0492753", "l0.2531065,0.0491951", "l0.2533070,0.0488944", "l0.2541091,0.0487541", "l0.2541455,0.0485737", "l0.2543460,0.0484935", "l0.2554398,0.0481928", "l0.2556403,0.0480124", "l0.2558408,0.0481527", "l0.2559866,0.0479122", "l0.2563694,0.0477919", "l0.2566611,0.0474512", "l0.2569345,0.0473710", "l0.2571350,0.0474512", "l0.2572262,0.0472507", "l0.2577548,0.0469300", "l0.2577548,0.0466293", "l0.2580283,0.0467496", "l0.2579553,0.0464088", "l0.2582105,0.0461081", "l0.2584111,0.0461282", "l0.2585204,0.0456872", "l0.2587027,0.0456671", "l0.2588850,0.0450457", "l0.2587756,0.0447450", "l0.2591402,0.0448252", "l0.2598147,0.0452261", "l0.2598511,0.0456070", "l0.2599787,0.0456671", "l0.2597782,0.0460079", "l0.2598511,0.0462685", "l0.2596871,0.0465090", "l0.2597053,0.0469701", "l0.2599058,0.0472908", "l0.2601063,0.0472106", "l0.2600152,0.0474111", "l0.2601975,0.0476717", "l0.2600334,0.0476717", "l0.2598511,0.0474712", "l0.2597782,0.0477318", "l0.2599605,0.0479122", "l0.2597600,0.0479322", "l0.2596871,0.0482730", "l0.2598694,0.0487341", "l0.2600699,0.0506183", "l0.2607079,0.0515204", "l0.2608173,0.0519012", "l0.2611089,0.0520215", "l0.2611089,0.0521418", "l0.2617834,0.0527432", "l0.2618198,0.0531240", "l0.2615829,0.0538457", "l0.2619474,0.0545072", "l0.2617469,0.0545272", "l0.2615464,0.0547677", "l0.2618381,0.0557299", "l0.2616011,0.0558101", "l0.2615646,0.0561308", "l0.2619292,0.0569126", "l0.2621297,0.0570529", "l0.2618745,0.0571732", "l0.2620933,0.0582556", "l0.2623303,0.0587568", "l0.2627131,0.0591978", "l0.2641714,0.0601199", "l0.2645542,0.0602401", "l0.2645724,0.0603805", "l0.2667599,0.0609016", "l0.2689473,0.0611021", "l0.2695124,0.0610219", "l0.2710436,0.0611622", "l0.2712441,0.0610620", "l0.2713535,0.0613226", "l0.2716452,0.0614629", "l0.2725931,0.0613827", "l0.2739785,0.0615030", "l0.2739785,0.0613827", "l0.2740878,0.0613827", "l0.2742337,0.0615832", "l0.2748717,0.0614429", "l0.2750722,0.0615631", "l0.2754550,0.0614429", "l0.2767128,0.0615030", "l0.2769862,0.0614228", "l0.2775331,0.0615431", "l0.2782075,0.0612424", "l0.2788456,0.0613226", "l0.2796476,0.0611221", "l0.2806684,0.0612023", "l0.2813794,0.0611221", "l0.2820903,0.0608616", "l0.2836397,0.0608816", "l0.2842777,0.0611221", "l0.2854991,0.0622046", "l0.2869574,0.0626055", "l0.2874313,0.0630064", "l0.2877412,0.0629262", "l0.2877777,0.0630666", "l0.2881240,0.0629262", "l0.2891084,0.0628461", "l0.2900563,0.0629062", "l0.2903479,0.0627859", "l0.2909313,0.0628461", "l0.2910042,0.0629663", "l0.2912229,0.0628461", "l0.2916969,0.0629663", "l0.2933192,0.0627859", "l0.2948869,0.0629663", "l0.2969103,0.0636679", "l0.2978400,0.0635476", "l0.2994259,0.0628461", "l0.3000639,0.0627659", "l0.3008113,0.0623650", "l0.3015586,0.0622246", "l0.3015951,0.0620442", "l0.3022149,0.0619841", "l0.3029805,0.0617235", "l0.3063711,0.0614629", "l0.3066080,0.0617836", "l0.3073190,0.0621846", "l0.3077929,0.0620041", "l0.3079023,0.0625053", "l0.3081028,0.0628060", "l0.3089231,0.0631868", "l0.3092147,0.0638283", "l0.3095064,0.0639085", "l0.3095429,0.0640488", "l0.3098892,0.0641691", "l0.3103449,0.0645499", "l0.3108189,0.0647303", "l0.3111288,0.0646101", "l0.3117121,0.0648506", "l0.3120038,0.0648306", "l0.3125324,0.0653317", "l0.3131522,0.0655722", "l0.3134621,0.0653918", "l0.3138631,0.0653918", "l0.3140272,0.0656324", "l0.3144646,0.0655722", "l0.3147745,0.0656925", "l0.3150662,0.0654520", "l0.3157771,0.0653918", "l0.3159412,0.0650911", "l0.3161964,0.0650911", "l0.3160870,0.0652716", "l0.3161052,0.0655321", "l0.3167250,0.0655321", "l0.3167615,0.0661135", "l0.3169255,0.0660934", "l0.3170167,0.0662738", "l0.3175089,0.0662939", "l0.3175818,0.0664141", "l0.3179099,0.0664342", "l0.3180375,0.0666346", "l0.3186573,0.0665745", "l0.3191859,0.0667750", "l0.3192771,0.0668952", "l0.3192041,0.0675968", "l0.3196963,0.0680378", "l0.3195687,0.0682984", "l0.3196416,0.0684989", "l0.3206624,0.0691002", "l0.3242353,0.0701827", "l0.3251650,0.0701626", "l0.3257300,0.0703430", "l0.3272066,0.0702228", "l0.3286831,0.0703430", "l0.3285920,0.0706838", "l0.3290112,0.0708642", "l0.3291388,0.0711048", "l0.3292664,0.0710246", "l0.3293394,0.0713253", "l0.3292482,0.0713253", "l0.3291571,0.0718465", "l0.3295034,0.0721872", "l0.3296128,0.0721672", "l0.3296128,0.0717262", "l0.3298133,0.0717262", "l0.3299409,0.0720670", "l0.3308341,0.0722674", "l0.3319643,0.0721872", "l0.3330580,0.0722674", "l0.3330580,0.0724077", "l0.3328575,0.0723877", "l0.3327299,0.0725881", "l0.3326570,0.0730492", "l0.3329669,0.0734501", "l0.3330580,0.0738310", "l0.3335502,0.0742319", "l0.3344981,0.0746729", "l0.3345346,0.0747931", "l0.3351179,0.0749335", "l0.3355554,0.0752542", "l0.3361387,0.0753143", "l0.3370319,0.0751940", "l0.3385084,0.0755148", "l0.3384173,0.0760961", "l0.3387636,0.0764770", "l0.3387272,0.0767375", "l0.3388366,0.0768578", "l0.3387454,0.0772587", "l0.3388912,0.0776396", "l0.3387272,0.0777799", "l0.3387272,0.0782410", "l0.3390735,0.0786419", "l0.3390735,0.0788223", "l0.3391829,0.0788223", "l0.3396569,0.0794236", "l0.3404772,0.0799448", "l0.3407870,0.0803858", "l0.3417167,0.0809270", "l0.3425188,0.0811676", "l0.3429016,0.0815084", "l0.3435396,0.0818090", "l0.3438313,0.0823102", "l0.3438313,0.0826109", "l0.3447609,0.0836933", "l0.3459276,0.0843548", "l0.3464744,0.0844350", "l0.3481150,0.0850764", "l0.3482973,0.0852168", "l0.3483885,0.0855976", "l0.3486254,0.0855776", "l0.3498468,0.0859785", "l0.3503936,0.0865197", "l0.3507947,0.0865398", "l0.3509769,0.0863594", "l0.3509769,0.0864997", "l0.3506124,0.0867603", "l0.3506306,0.0869407", "l0.3511957,0.0874017", "l0.3513598,0.0873817", "l0.3515420,0.0877826", "l0.3517243,0.0876623", "l0.3532009,0.0881634", "l0.3540212,0.0882436", "l0.3541305,0.0885844", "l0.3525629,0.0882035", "l0.3521254,0.0879429", "l0.3518519,0.0880632", "l0.3515056,0.0879229", "l0.3512686,0.0875821", "l0.3507400,0.0873817", "l0.3505030,0.0870008", "l0.3503207,0.0869808", "l0.3506124,0.0875220", "l0.3504301,0.0875220", "l0.3501931,0.0871812", "l0.3501567,0.0872614", "l0.3503207,0.0875420", "l0.3507035,0.0876824", "l0.3506853,0.0879429", "l0.3502843,0.0877625", "l0.3501749,0.0874418", "l0.3505030,0.0876222", "l0.3509405,0.0881234", "l0.3517972,0.0882637", "l0.3520707,0.0886044", "l0.3524353,0.0885243", "l0.3527269,0.0888650", "l0.3531644,0.0887448", "l0.3533649,0.0885042", "l0.3536566,0.0885644", "l0.3544404,0.0891657", "l0.3550055,0.0890855", "l0.3550237,0.0888851", "l0.3546409,0.0887247", "l0.3547321,0.0885844", "l0.3564456,0.0891056", "l0.3575758,0.0891657", "l0.3580497,0.0894063", "l0.3589794,0.0894864", "l0.3614221,0.0893060", "l0.3635001,0.0893662", "l0.3646850,0.0892259", "l0.3653230,0.0889452", "l0.3655053,0.0890254", "l0.3678021,0.0882436", "l0.3702813,0.0877024", "l0.3703906,0.0875220", "l0.3721588,0.0869808", "l0.3745103,0.0858181", "l0.3754036,0.0854774", "l0.3755312,0.0855375", "l0.3770259,0.0848760", "l0.3790311,0.0843348", "l0.3803436,0.0837935", "l0.3809269,0.0833926", "l0.3811821,0.0834528", "l0.3820935,0.0828714", "l0.3859763,0.0808669", "l0.3876898,0.0796241", "l0.3891481,0.0787822", "l0.3893121,0.0789024", "l0.3908616,0.0781207", "l0.3918824,0.0774792", "l0.3921558,0.0771585", "l0.3933772,0.0764970", "l0.3933772,0.0763767", "l0.3937235,0.0762364", "l0.3940699,0.0758555", "l0.3965490,0.0744123", "l0.3966401,0.0742319", "l0.3969500,0.0741116", "l0.3971141,0.0738710", "l0.3972599,0.0739312", "l0.3976062,0.0735904", "l0.3977338,0.0736505", "l0.3977521,0.0734100", "l0.3979890,0.0732095", "l0.3981896,0.0732296", "l0.3984448,0.0728487", "l0.3989369,0.0725280", "l0.3989916,0.0723476", "l0.3996296,0.0719667", "l0.4001218,0.0711248", "l0.4002859,0.0711248", "l0.4005593,0.0708241", "l0.4006687,0.0708843", "l0.4009239,0.0705836", "l0.4011609,0.0705635", "l0.4020905,0.0697216", "l0.4021999,0.0694811", "l0.4025098,0.0693408", "l0.4034030,0.0684788", "l0.4034030,0.0684788", "l0.4033665,0.0746528", "l0.4050618,0.1359317", "l0.4050618,0.1359317", "l0.4050618,0.1473977", "l0.4050618,0.1473977", "l0.4073951,0.1514669", "l0.4131554,0.1545539", "l0.4131554,0.1545539", "l0.4209209,0.1548346", "l0.4325326,0.1649375", "l0.4361055,0.1668618", "l0.4361055,0.1668618", "l0.4361055,0.1668618", "l0.4361055,0.1668618", "l0.4498865,0.1780873", "l0.4550452,0.1791898", "l0.4581077,0.1813146", "l0.4581077,0.1813146", "l0.4609331,0.1875688", "l0.4609331,0.1875688", "l0.4553369,0.1883706", "l0.4139939,0.2184387", "l0.4019265,0.2217061", "l0.3901507,0.2383238", "l0.3313081,0.3019681", "l0.2549476,0.3221338", "l0.2177790,0.4132002", "l0.2177790,0.4132002", "l0.0267047,0.4131802", "l0.0267047,0.4131802", "l0.0252281,0.4131802", "l0.0252281,0.4131802", "l0.0251917,0.2519948", "l0.0242985,0.2501707", "l0.0217100,0.2421725", "l0.0178819,0.2334528", "l0.0170070,0.2304259", "l0.0156580,0.2282610", "l0.0137987,0.2227886", "l0.0135799,0.2213453", "l0.0149836,0.2173563", "l0.0166424,0.2151112", "l0.0168611,0.2136479", "l0.0166971,0.2127859", "l0.0135252,0.2041263", "l0.0104446,0.1965291", "l0.0102076,0.1938229", "l0.0104993,0.1864863", "l0.0099342,0.1830986", "l0.0050306,0.1647971", "l0.0005099,0.1592847", "l0.0014395,0.1558569", "l0.0034994,0.1513066", "l0.0055593,0.1472574", "l0.0063796,0.1448720", "l0.0074915,0.1403417", "l0.0117024,0.1364329", "l0.0136529,0.1337267", "l0.0150565,0.1302789", "l0.0162778,0.1281541", "l0.0192491,0.1247464", "l0.0209991,0.1180712", "l0.0211813,0.1164876", "l0.0211084,0.1147437", "l0.0215824,0.1125387", "l0.0235146,0.1077679", "l0.0243896,0.1030171", "l0.0246448,0.1006317", "l0.0265771,0.0951994", "l0.0267594,0.0938563", "l0.0244443,0.0851165", "l0.0244808,0.0830519", "l0.0236787,0.0797644", "l0.0222386,0.0772587", "l0.0212907,0.0743321", "l0.0207621,0.0707840", "l0.0186293,0.0637681", "l0.0174262,0.0611823", "l0.0156945,0.0566721", "l0.0152570,0.0532042", "l0.0153664,0.0505181", "l0.0161137,0.0432416", "l0.0160044,0.0388517", "l0.0155304,0.0367669", "l0.0143820,0.0347424", "l0.0139081,0.0317155", "l0.0137075,0.0291697", "l0.0138898,0.0281274", "l0.0202517,0.0225547", "l0.0222751,0.0203297", "l0.0303869,0.0138550", "l0.0310978,0.0122514", "l0.0316994,0.0081421", "l0.0321551,0.0066587", "l0.0326473,0.0056564", "l0.0336499,0.0043134", "l0.0349076,0.0030906", "l0.0360378,0.0007052", "l0.0373503,0.0005448", "c"]}, {"n": "Būr Saٰīd", "u": "EG-PTS", "i": ["m0.6295678,0.0478721", "l0.6319193,0.0492352", "l0.6328672,0.0500170", "l0.6333776,0.0501974", "l0.6335599,0.0504580", "l0.6341979,0.0507186", "l0.6344714,0.0510593", "l0.6345443,0.0514602", "l0.6353464,0.0519614", "l0.6355469,0.0522821", "l0.6367317,0.0532643", "l0.6376432,0.0544671", "l0.6381901,0.0554894", "l0.6392109,0.0566921", "l0.6393749,0.0568725", "l0.6394843,0.0570730", "l0.6400129,0.0577946", "l0.6401223,0.0585764", "l0.6401223,0.0587768", "l0.6409244,0.0596789", "l0.6420910,0.0605809", "l0.6435311,0.0621244", "l0.6447342,0.0630866", "l0.6460831,0.0638684", "l0.6479242,0.0645098", "l0.6491273,0.0646902", "l0.6491273,0.0646902", "l0.6491273,0.0707840", "l0.6491273,0.0707840", "l0.6435129,0.0691604", "l0.6380442,0.0652716", "l0.6380442,0.0652716", "l0.6322292,0.0629463", "l0.6286928,0.0610019", "l0.6246825,0.0606611", "l0.6242632,0.0593581", "l0.6259585,0.0578547", "l0.6283465,0.0539058", "l0.6291486,0.0519814", "l0.6300235,0.0508388", "l0.6295678,0.0478721", "c", "m0.6295678,0.0478721", "l0.6278179,0.0475714", "l0.6276538,0.0473910", "l0.6277267,0.0470903", "l0.6278361,0.0469500", "l0.6278361,0.0466894", "l0.6281095,0.0466293", "l0.6284741,0.0467696", "l0.6288387,0.0470903", "l0.6289845,0.0470302", "l0.6291121,0.0470903", "l0.6294585,0.0473910", "l0.6296043,0.0473309", "l0.6295678,0.0478721", "c", "m0.6278179,0.0454667", "l0.6277996,0.0466894", "l0.6277085,0.0467095", "l0.6276720,0.0469500", "l0.6276173,0.0472106", "l0.6267059,0.0459277", "l0.6269976,0.0458676", "l0.6271799,0.0463687", "l0.6271981,0.0462284", "l0.6275809,0.0462284", "l0.6278908,0.0445646", "l0.6280366,0.0444844", "l0.6278179,0.0454667", "c", "m0.6265965,0.0392325", "l0.6266512,0.0393728", "l0.6254481,0.0413173", "l0.6251929,0.0415177", "l0.6251018,0.0418585", "l0.6247007,0.0422594", "l0.6245367,0.0427204", "l0.6247372,0.0430211", "l0.6252476,0.0431414", "l0.6253205,0.0434421", "l0.6255939,0.0436826", "l0.6253387,0.0442639", "l0.6256851,0.0448252", "l0.6262866,0.0451660", "l0.6266694,0.0451860", "l0.6265783,0.0457072", "l0.6267241,0.0459077", "l0.6256122,0.0474111", "l0.6250471,0.0483732", "l0.6245731,0.0497764", "l0.6244091,0.0468899", "l0.6247372,0.0461081", "l0.6242632,0.0452261", "l0.6238622,0.0437428", "l0.6232971,0.0448853", "l0.6235341,0.0456671", "l0.6228232,0.0461081", "l0.6229872,0.0471505", "l0.6224404,0.0485937", "l0.6217112,0.0475113", "l0.6213102,0.0459277", "l0.6206722,0.0446047", "l0.6211461,0.0436425", "l0.6210732,0.0426803", "l0.6210732,0.0426803", "l0.6216565,0.0419387", "l0.6216565,0.0419387", "l0.6219117,0.0419988", "l0.6221669,0.0416981", "l0.6228779,0.0420389", "l0.6243726,0.0421191", "l0.6246825,0.0419186", "l0.6249195,0.0419387", "l0.6265965,0.0392325", "c"]}, {"n": "Sūhāj", "u": "EG-SHG", "i": ["m0.5839411,0.5099194", "l0.5876233,0.5150511", "l0.5884619,0.5182383", "l0.5902301,0.5208041", "l0.5932196,0.5218665", "l0.5940217,0.5278601", "l0.5962091,0.5350765", "l0.5983236,0.5386245", "l0.5998002,0.5403284", "l0.6047766,0.5437762", "l0.6121229,0.5462017", "l0.6154223,0.5488677", "l0.6173181,0.5540595", "l0.6210367,0.5596722", "l0.6216565,0.5599328", "l0.6213102,0.5632203", "l0.6248830,0.5649843", "l0.6248830,0.5649843", "l0.6232060,0.5670089", "l0.6223674,0.5682717", "l0.6201618,0.5682717", "l0.6183936,0.5656057", "l0.6170629,0.5646034", "l0.6153676,0.5637014", "l0.6142009,0.5602535", "l0.6137817,0.5574472", "l0.6115760,0.5561643", "l0.6100083,0.5564249", "l0.6087505,0.5587100", "l0.6063443,0.5606344", "l0.6041569,0.5615164", "l0.6017507,0.5615164", "l0.5991257,0.5634408", "l0.5973575,0.5653451", "l0.5960997,0.5676102", "l0.5960997,0.5676102", "l0.5956805,0.5670690", "l0.5956805,0.5670690", "l0.5942039,0.5650845", "l0.5912509,0.5603738", "l0.5896103,0.5596121", "l0.5869853,0.5564249", "l0.5817537,0.5488878", "l0.5775246,0.5419320", "l0.5755741,0.5394464", "l0.5753189,0.5389051", "l0.5712903,0.5332122", "l0.5677357,0.5273389", "l0.5638530,0.5212251", "l0.5618660,0.5174766", "l0.5582020,0.5144096", "l0.5536266,0.5134675", "l0.5481580,0.5065318", "l0.5435643,0.4999970", "l0.5426164,0.4963286", "l0.5426164,0.4963286", "l0.5438013,0.4959277", "l0.5459705,0.4939633", "l0.5491059,0.4920389", "l0.5506735,0.4907560", "l0.5527699,0.4874285", "l0.5538089,0.4852435", "l0.5570536,0.4856244", "l0.5586213,0.4879296", "l0.5602437,0.4918986", "l0.5621395,0.4938630", "l0.5636889,0.4975715", "l0.5677357,0.4976115", "l0.5677357,0.4976115", "l0.5686471,0.4982730", "l0.5733502,0.5001774", "l0.5839411,0.5099194", "l0.5839411,0.5099194", "c"]}, {"n": "Ash Sharqīyah", "u": "EG-SHR", "i": ["m0.6009486,0.0615030", "l0.6021517,0.0616233", "l0.6034095,0.0612625", "l0.6051959,0.0620242", "l0.6053053,0.0629262", "l0.6059615,0.0634675", "l0.6065084,0.0631066", "l0.6067818,0.0623249", "l0.6063443,0.0617836", "l0.6062350,0.0608415", "l0.6066360,0.0607012", "l0.6078026,0.0609016", "l0.6082401,0.0616634", "l0.6096620,0.0627057", "l0.6108286,0.0625855", "l0.6108286,0.0625855", "l0.6120499,0.0650110", "l0.6156228,0.0651713", "l0.6159691,0.0764970", "l0.6128702,0.0765972", "l0.6124510,0.0802856", "l0.6091516,0.0885243", "l0.6108104,0.0962217", "l0.6109380,0.1016540", "l0.6022975,0.1151446", "l0.6018236,0.1170289", "l0.5926363,0.1176302", "l0.5915608,0.1193742", "l0.5846703,0.1189933", "l0.5839047,0.1172293", "l0.5797850,0.1170289", "l0.5800948,0.1203364", "l0.5831573,0.1221004", "l0.5839047,0.1312210", "l0.5857458,0.1410433", "l0.5857458,0.1410433", "l0.5742799,0.1498633", "l0.5685378,0.1536719", "l0.5601708,0.1536719", "l0.5601708,0.1536719", "l0.5568896,0.1515070", "l0.5565250,0.1509658", "l0.5520589,0.1482797", "l0.5481762,0.1449522", "l0.5463169,0.1395599", "l0.5441112,0.1347691", "l0.5420695,0.1318224", "l0.5400279,0.1296976", "l0.5400279,0.1244457", "l0.5412310,0.1243655", "l0.5413769,0.1193942", "l0.5436919,0.1167883", "l0.5436919,0.1167883", "l0.5473741,0.1127993", "l0.5490512,0.1080485", "l0.5475200,0.1065050", "l0.5475200,0.0934955", "l0.5499262,0.0911502", "l0.5660040,0.0906691", "l0.5663868,0.0877224", "l0.5687930,0.0862792", "l0.5690846,0.0830118", "l0.5732226,0.0826509", "l0.5734778,0.0768578", "l0.5787277,0.0708843", "l0.5790011,0.0669153", "l0.5809881,0.0632871", "l0.5875322,0.0634274", "l0.5892275,0.0630465", "l0.5968107,0.0619240", "l0.6029173,0.0593381", "l0.6029173,0.0593381", "l0.6025345,0.0602401", "l0.6009486,0.0610821", "c"]}, {"n": "Shamāl Sīnā'", "u": "EG-SIN", "i": ["m0.6710566,0.0589372", "l0.6714941,0.0592379", "l0.6714941,0.0595386", "l0.6716764,0.0597190", "l0.6717675,0.0601600", "l0.6716217,0.0602401", "l0.6715123,0.0606411", "l0.6711113,0.0602001", "l0.6709472,0.0602001", "l0.6709655,0.0604406", "l0.6714576,0.0609417", "l0.6714029,0.0611823", "l0.6706556,0.0601600", "l0.6707467,0.0595987", "l0.6705097,0.0591978", "l0.6710566,0.0589372", "c", "m0.7173213,0.0544871", "l0.7188890,0.0555295", "l0.7188343,0.0557099", "l0.7181598,0.0552488", "l0.7175036,0.0551687", "l0.7174307,0.0549682", "l0.7172666,0.0549081", "l0.7171573,0.0549882", "l0.7172849,0.0550484", "l0.7173031,0.0553090", "l0.7171937,0.0553090", "l0.7168291,0.0546074", "l0.7170479,0.0545272", "l0.7172302,0.0546675", "l0.7173213,0.0544871", "c", "m0.6922749,0.0464288", "l0.6925848,0.0465491", "l0.6944806,0.0464689", "l0.6953738,0.0465892", "l0.6957202,0.0467696", "l0.6972514,0.0468899", "l0.6978894,0.0471505", "l0.6981446,0.0470703", "l0.6983451,0.0472707", "l0.6989102,0.0474111", "l0.6990196,0.0471705", "l0.6996576,0.0475514", "l0.6998217,0.0474912", "l0.7017357,0.0478922", "l0.7019909,0.0478320", "l0.7023372,0.0479723", "l0.7027018,0.0477719", "l0.7027383,0.0478922", "l0.7024648,0.0484935", "l0.7022825,0.0484334", "l0.7019362,0.0487341", "l0.7015716,0.0483532", "l0.7013711,0.0484133", "l0.7013164,0.0482129", "l0.7011524,0.0483933", "l0.7008607,0.0480926", "l0.7004597,0.0482129", "l0.6991654,0.0477117", "l0.6985456,0.0477318", "l0.6983087,0.0475514", "l0.6970873,0.0472106", "l0.6967774,0.0471906", "l0.6965952,0.0473309", "l0.6962853,0.0470703", "l0.6958113,0.0469500", "l0.6947905,0.0469500", "l0.6943166,0.0468097", "l0.6934233,0.0468297", "l0.6924937,0.0470703", "l0.6918739,0.0468899", "l0.6907073,0.0468899", "l0.6905432,0.0470302", "l0.6899052,0.0469500", "l0.6889026,0.0471906", "l0.6886109,0.0471906", "l0.6886656,0.0470102", "l0.6883922,0.0471505", "l0.6883193,0.0470302", "l0.6880641,0.0470502", "l0.6881370,0.0476717", "l0.6879365,0.0476516", "l0.6878636,0.0479122", "l0.6877542,0.0477719", "l0.6874443,0.0477117", "l0.6872802,0.0479523", "l0.6881370,0.0483332", "l0.6882281,0.0487140", "l0.6886109,0.0487140", "l0.6888115,0.0484534", "l0.6887385,0.0486940", "l0.6889937,0.0486739", "l0.6889937,0.0487942", "l0.6878636,0.0489947", "l0.6866058,0.0493956", "l0.6852933,0.0493354", "l0.6816111,0.0516206", "l0.6804080,0.0527632", "l0.6801163,0.0527832", "l0.6798611,0.0530238", "l0.6791137,0.0532643", "l0.6765252,0.0544871", "l0.6765435,0.0546274", "l0.6762883,0.0548078", "l0.6762153,0.0553892", "l0.6760695,0.0555295", "l0.6756685,0.0555295", "l0.6755591,0.0558502", "l0.6752674,0.0561709", "l0.6747935,0.0561709", "l0.6746659,0.0559905", "l0.6747024,0.0556898", "l0.6751581,0.0553892", "l0.6762336,0.0542867", "l0.6790590,0.0525427", "l0.6803533,0.0519012", "l0.6804991,0.0516407", "l0.6827959,0.0502375", "l0.6868063,0.0474512", "l0.6883375,0.0468097", "l0.6894495,0.0465692", "l0.6922749,0.0464288", "c", "m0.7843304,0.0472307", "l0.7910933,0.0719066", "l0.7957599,0.0869607", "l0.8029785,0.1036185", "l0.8053482,0.1144631", "l0.8051113,0.1201359", "l0.8086659,0.1247263", "l0.8069706,0.1299782", "l0.8071711,0.1331654", "l0.8128950,0.1372748", "l0.8145720,0.1441704", "l0.8242880,0.1741784", "l0.8241239,0.1757420", "l0.8325092,0.2016006", "l0.8324545,0.2065718", "l0.8339310,0.2093782", "l0.8342956,0.2113226", "l0.8339128,0.2141290", "l0.8331472,0.2169554", "l0.8334753,0.2199622", "l0.8338581,0.2216861", "l0.8349336,0.2239312", "l0.8369934,0.2265972", "l0.8369934,0.2265972", "l0.8326368,0.2254346", "l0.8258192,0.2257353", "l0.8190198,0.2242720", "l0.8126944,0.2236906", "l0.8056581,0.2225080", "l0.8050930,0.2219667", "l0.8024863,0.2222073", "l0.7977104,0.2200624", "l0.7929162,0.2182984", "l0.7912574,0.2177371", "l0.7911115,0.2177973", "l0.7801013,0.2104206", "l0.7730650,0.2086566", "l0.7665026,0.2062912", "l0.7604142,0.2018612", "l0.7458859,0.1918184", "l0.7457947,0.1915979", "l0.7425682,0.1898740", "l0.7276206,0.1860253", "l0.7198551,0.1861656", "l0.7179958,0.1855843", "l0.7027565,0.1832189", "l0.6849469,0.1826376", "l0.6728977,0.1834995", "l0.6728612,0.1832590", "l0.6724238,0.1838203", "l0.6690150,0.1836800", "l0.6690150,0.1836800", "l0.6690150,0.1799916", "l0.6690150,0.1799916", "l0.6662077,0.1796909", "l0.6664447,0.1568792", "l0.6645489,0.1491417", "l0.6645489,0.1491417", "l0.6643302,0.1491216", "l0.6643302,0.1491216", "l0.6629265,0.1435289", "l0.6603563,0.1358114", "l0.6573121,0.1298580", "l0.6514606,0.1197350", "l0.6495466,0.0844951", "l0.6491091,0.0708241", "l0.6491091,0.0708241", "l0.6491091,0.0647303", "l0.6491091,0.0647303", "l0.6521715,0.0647504", "l0.6552158,0.0644096", "l0.6558720,0.0642893", "l0.6561637,0.0641089", "l0.6575126,0.0639285", "l0.6576037,0.0638082", "l0.6606479,0.0629864", "l0.6624161,0.0622647", "l0.6631088,0.0618237", "l0.6635099,0.0617035", "l0.6636010,0.0618237", "l0.6641479,0.0613827", "l0.6650593,0.0611823", "l0.6651322,0.0610019", "l0.6669733,0.0599194", "l0.6674473,0.0594784", "l0.6693066,0.0582757", "l0.6704368,0.0577545", "l0.6719133,0.0568324", "l0.6733899,0.0557500", "l0.6738456,0.0552889", "l0.6741373,0.0551687", "l0.6746112,0.0562712", "l0.6745201,0.0564716", "l0.6742466,0.0565317", "l0.6739550,0.0562712", "l0.6736998,0.0562712", "l0.6729888,0.0566119", "l0.6709108,0.0579750", "l0.6696165,0.0584761", "l0.6693431,0.0587367", "l0.6683952,0.0591176", "l0.6665723,0.0604807", "l0.6656609,0.0608816", "l0.6654239,0.0612023", "l0.6650593,0.0613226", "l0.6647859,0.0616233", "l0.6642390,0.0617035", "l0.6639656,0.0620442", "l0.6637286,0.0619641", "l0.6635281,0.0624051", "l0.6634187,0.0622848", "l0.6629812,0.0623449", "l0.6629083,0.0625253", "l0.6626349,0.0626656", "l0.6623797,0.0626055", "l0.6620880,0.0626857", "l0.6618146,0.0628060", "l0.6617052,0.0630064", "l0.6612313,0.0633271", "l0.6610490,0.0632470", "l0.6608120,0.0633271", "l0.6603745,0.0637281", "l0.6599188,0.0636479", "l0.6594084,0.0638283", "l0.6593355,0.0639686", "l0.6586063,0.0639686", "l0.6581688,0.0642292", "l0.6574944,0.0642292", "l0.6572209,0.0644697", "l0.6553980,0.0646702", "l0.6545595,0.0651713", "l0.6544684,0.0650511", "l0.6541220,0.0650711", "l0.6540491,0.0651914", "l0.6537575,0.0651312", "l0.6533929,0.0655121", "l0.6530283,0.0656324", "l0.6530283,0.0657526", "l0.6534658,0.0657727", "l0.6535569,0.0659130", "l0.6539580,0.0660333", "l0.6543955,0.0658328", "l0.6542314,0.0655321", "l0.6543772,0.0652114", "l0.6546324,0.0654720", "l0.6548330,0.0654921", "l0.6553980,0.0653718", "l0.6560361,0.0654520", "l0.6562183,0.0652114", "l0.6570751,0.0653517", "l0.6571662,0.0654921", "l0.6569840,0.0659932", "l0.6570751,0.0667750", "l0.6562730,0.0667950", "l0.6557262,0.0671759", "l0.6557991,0.0673162", "l0.6563642,0.0673763", "l0.6566194,0.0675166", "l0.6573485,0.0675166", "l0.6575490,0.0672160", "l0.6584787,0.0671558", "l0.6592079,0.0663941", "l0.6593172,0.0660734", "l0.6597730,0.0657326", "l0.6603016,0.0657526", "l0.6612313,0.0662738", "l0.6626713,0.0661536", "l0.6632364,0.0658930", "l0.6638927,0.0649909", "l0.6640385,0.0649709", "l0.6650411,0.0638283", "l0.6652781,0.0636278", "l0.6655880,0.0633672", "l0.6665723,0.0630666", "l0.6671009,0.0624852", "l0.6674108,0.0624251", "l0.6675202,0.0622246", "l0.6683223,0.0622046", "l0.6685228,0.0620041", "l0.6688145,0.0619841", "l0.6689785,0.0615832", "l0.6692337,0.0617836", "l0.6697988,0.0610821", "l0.6700905,0.0611021", "l0.6702728,0.0614028", "l0.6706738,0.0612825", "l0.6712024,0.0614028", "l0.6712936,0.0615431", "l0.6715670,0.0614028", "l0.6718222,0.0610620", "l0.6724784,0.0614028", "l0.6729524,0.0614228", "l0.6730071,0.0615431", "l0.6733899,0.0615231", "l0.6734263,0.0613226", "l0.6737727,0.0615030", "l0.6741555,0.0612625", "l0.6744654,0.0614429", "l0.6747206,0.0614228", "l0.6746477,0.0616834", "l0.6748664,0.0618237", "l0.6749758,0.0615832", "l0.6753404,0.0613226", "l0.6752674,0.0606210", "l0.6753404,0.0604206", "l0.6752857,0.0603003", "l0.6750852,0.0602802", "l0.6750122,0.0604606", "l0.6746112,0.0605208", "l0.6745201,0.0607613", "l0.6743560,0.0606210", "l0.6744472,0.0604206", "l0.6741555,0.0604406", "l0.6739914,0.0606210", "l0.6738091,0.0606210", "l0.6738274,0.0609417", "l0.6736998,0.0608616", "l0.6738091,0.0603003", "l0.6744654,0.0597791", "l0.6747753,0.0597791", "l0.6754680,0.0603003", "l0.6761971,0.0603003", "l0.6761242,0.0604206", "l0.6762336,0.0605408", "l0.6767987,0.0605408", "l0.6773455,0.0611021", "l0.6776919,0.0611622", "l0.6777830,0.0615030", "l0.6780565,0.0615631", "l0.6779471,0.0617436", "l0.6780747,0.0618638", "l0.6784393,0.0618839", "l0.6787309,0.0615030", "l0.6790773,0.0615231", "l0.6791866,0.0618237", "l0.6790044,0.0619440", "l0.6789861,0.0622046", "l0.6792413,0.0623249", "l0.6794054,0.0627659", "l0.6796606,0.0628461", "l0.6797153,0.0629663", "l0.6795694,0.0630465", "l0.6797335,0.0632470", "l0.6794601,0.0632470", "l0.6791866,0.0629262", "l0.6790955,0.0626256", "l0.6792049,0.0625454", "l0.6791502,0.0623449", "l0.6780565,0.0622848", "l0.6779835,0.0623650", "l0.6781658,0.0625654", "l0.6786033,0.0626857", "l0.6784575,0.0627659", "l0.6785486,0.0628861", "l0.6782387,0.0629463", "l0.6780382,0.0631467", "l0.6783481,0.0632670", "l0.6783846,0.0635877", "l0.6786945,0.0637681", "l0.6785851,0.0639486", "l0.6787127,0.0641891", "l0.6784575,0.0643695", "l0.6779289,0.0643896", "l0.6777283,0.0646301", "l0.6780929,0.0645700", "l0.6783846,0.0649709", "l0.6792231,0.0651713", "l0.6794965,0.0654319", "l0.6811554,0.0654319", "l0.6818116,0.0645098", "l0.6823038,0.0643294", "l0.6825954,0.0639486", "l0.6825954,0.0637080", "l0.6818845,0.0632069", "l0.6817022,0.0632069", "l0.6815928,0.0634474", "l0.6812283,0.0635677", "l0.6811554,0.0631868", "l0.6814106,0.0624852", "l0.6813923,0.0622246", "l0.6817934,0.0619841", "l0.6819939,0.0622447", "l0.6822855,0.0619841", "l0.6826683,0.0619039", "l0.6828506,0.0613827", "l0.6829600,0.0613226", "l0.6842178,0.0616032", "l0.6848740,0.0611622", "l0.6847464,0.0605809", "l0.6842907,0.0607814", "l0.6841449,0.0602602", "l0.6845277,0.0594183", "l0.6845641,0.0590775", "l0.6847647,0.0589572", "l0.6851657,0.0590174", "l0.6854391,0.0587768", "l0.6853844,0.0585964", "l0.6854938,0.0586165", "l0.6856032,0.0582356", "l0.6854938,0.0579149", "l0.6853115,0.0580552", "l0.6851657,0.0578547", "l0.6849652,0.0578347", "l0.6844183,0.0580953", "l0.6842543,0.0580351", "l0.6838714,0.0583358", "l0.6829782,0.0583559", "l0.6829053,0.0586966", "l0.6825225,0.0588169", "l0.6824131,0.0590174", "l0.6825225,0.0592579", "l0.6823220,0.0594985", "l0.6822491,0.0599395", "l0.6825225,0.0599595", "l0.6825954,0.0601399", "l0.6824861,0.0602802", "l0.6823038,0.0602201", "l0.6824314,0.0606010", "l0.6820850,0.0607814", "l0.6822855,0.0610420", "l0.6823767,0.0611823", "l0.6823585,0.0614429", "l0.6815017,0.0608014", "l0.6811554,0.0607212", "l0.6802075,0.0609016", "l0.6787674,0.0607212", "l0.6787674,0.0609217", "l0.6782387,0.0611021", "l0.6781476,0.0612825", "l0.6778377,0.0609618", "l0.6774549,0.0609417", "l0.6774731,0.0604406", "l0.6773638,0.0602602", "l0.6769263,0.0604005", "l0.6765799,0.0601600", "l0.6765982,0.0599595", "l0.6768716,0.0597791", "l0.6779471,0.0598994", "l0.6792596,0.0595987", "l0.6801528,0.0586766", "l0.6802257,0.0584160", "l0.6803897,0.0584160", "l0.6805720,0.0582156", "l0.6812283,0.0566520", "l0.6824314,0.0547076", "l0.6828506,0.0543869", "l0.6831058,0.0543869", "l0.6838350,0.0536853", "l0.6844001,0.0537655", "l0.6848740,0.0535851", "l0.6890120,0.0507587", "l0.6894495,0.0505782", "l0.6896318,0.0509792", "l0.6899781,0.0509190", "l0.6899234,0.0511596", "l0.6896318,0.0511395", "l0.6893765,0.0508388", "l0.6892854,0.0509591", "l0.6889755,0.0509591", "l0.6890667,0.0511596", "l0.6894312,0.0511596", "l0.6894130,0.0512397", "l0.6889755,0.0513600", "l0.6887932,0.0511596", "l0.6886292,0.0511596", "l0.6886656,0.0513400", "l0.6883922,0.0514602", "l0.6883193,0.0517208", "l0.6881734,0.0517409", "l0.6881552,0.0515605", "l0.6879912,0.0515805", "l0.6880094,0.0518411", "l0.6889937,0.0521418", "l0.6893583,0.0525227", "l0.6893948,0.0528233", "l0.6891943,0.0529035", "l0.6894495,0.0531842", "l0.6895406,0.0535450", "l0.6904338,0.0543267", "l0.6904338,0.0549281", "l0.6907437,0.0552288", "l0.6907619,0.0558101", "l0.6909625,0.0563313", "l0.6922202,0.0567723", "l0.6924025,0.0570930", "l0.6924390,0.0575340", "l0.6932411,0.0588169", "l0.6924754,0.0578347", "l0.6922020,0.0572333", "l0.6918374,0.0569727", "l0.6912723,0.0572734", "l0.6909625,0.0568725", "l0.6901057,0.0568725", "l0.6899416,0.0565718", "l0.6901057,0.0561308", "l0.6899052,0.0556898", "l0.6896135,0.0557500", "l0.6897229,0.0564115", "l0.6893583,0.0564917", "l0.6888661,0.0564115", "l0.6888844,0.0567522", "l0.6890484,0.0570529", "l0.6890484,0.0573736", "l0.6888844,0.0576342", "l0.6892854,0.0577545", "l0.6893765,0.0580151", "l0.6895588,0.0580953", "l0.6893765,0.0582156", "l0.6893219,0.0584761", "l0.6896864,0.0585363", "l0.6897958,0.0589773", "l0.6902515,0.0592178", "l0.6903974,0.0595987", "l0.6906890,0.0596187", "l0.6910718,0.0594183", "l0.6913817,0.0595386", "l0.6913817,0.0596187", "l0.6909989,0.0596388", "l0.6907255,0.0600196", "l0.6904338,0.0600196", "l0.6903062,0.0596187", "l0.6900146,0.0595386", "l0.6896682,0.0600597", "l0.6900510,0.0601399", "l0.6900692,0.0609818", "l0.6902515,0.0609217", "l0.6909442,0.0614830", "l0.6915275,0.0616032", "l0.6922567,0.0621244", "l0.6925666,0.0621244", "l0.6931864,0.0618638", "l0.6934963,0.0619841", "l0.6934780,0.0621645", "l0.6933869,0.0620442", "l0.6926942,0.0621645", "l0.6925301,0.0625654", "l0.6922202,0.0624852", "l0.6919833,0.0626857", "l0.6921838,0.0629463", "l0.6921656,0.0633873", "l0.6925666,0.0637882", "l0.6925301,0.0639285", "l0.6921838,0.0639486", "l0.6920015,0.0642492", "l0.6924572,0.0642693", "l0.6925301,0.0644697", "l0.6922749,0.0649909", "l0.6921838,0.0647905", "l0.6917281,0.0648105", "l0.6917098,0.0653918", "l0.6919104,0.0650911", "l0.6920197,0.0653317", "l0.6917463,0.0656324", "l0.6916551,0.0659331", "l0.6917463,0.0660132", "l0.6926395,0.0658328", "l0.6927124,0.0660333", "l0.6929676,0.0657927", "l0.6936056,0.0657126", "l0.6938244,0.0654720", "l0.6940978,0.0656123", "l0.6947176,0.0654319", "l0.6953191,0.0651513", "l0.6959754,0.0645098", "l0.6963582,0.0643294", "l0.6964129,0.0634274", "l0.6966681,0.0632269", "l0.6969597,0.0632269", "l0.6981811,0.0627659", "l0.6987097,0.0629663", "l0.6990560,0.0629663", "l0.6995300,0.0628861", "l0.6997852,0.0627659", "l0.7007331,0.0612023", "l0.7011888,0.0611823", "l0.7014987,0.0615631", "l0.7009154,0.0614830", "l0.7006602,0.0617235", "l0.7007331,0.0619641", "l0.7005508,0.0619841", "l0.7007878,0.0623048", "l0.7011524,0.0624451", "l0.7015169,0.0623850", "l0.7015534,0.0620442", "l0.7017175,0.0618438", "l0.7021549,0.0617035", "l0.7023737,0.0617235", "l0.7023555,0.0618438", "l0.7025195,0.0619039", "l0.7031028,0.0615832", "l0.7033398,0.0612023", "l0.7038685,0.0608616", "l0.7043606,0.0609417", "l0.7042877,0.0612424", "l0.7041237,0.0612424", "l0.7038867,0.0614830", "l0.7040507,0.0614830", "l0.7040507,0.0616032", "l0.7043606,0.0617836", "l0.7043606,0.0614028", "l0.7050169,0.0614830", "l0.7051627,0.0613627", "l0.7052721,0.0608014", "l0.7049622,0.0608816", "l0.7048346,0.0607012", "l0.7049986,0.0603203", "l0.7058918,0.0603203", "l0.7061288,0.0605208", "l0.7064023,0.0605208", "l0.7064205,0.0601399", "l0.7067851,0.0599595", "l0.7063293,0.0597591", "l0.7060924,0.0598192", "l0.7056549,0.0596789", "l0.7055637,0.0599395", "l0.7048346,0.0599996", "l0.7042148,0.0605609", "l0.7032122,0.0608215", "l0.7032122,0.0610019", "l0.7027747,0.0611823", "l0.7025924,0.0614228", "l0.7023008,0.0614830", "l0.7024101,0.0616634", "l0.7019362,0.0616834", "l0.7017539,0.0615431", "l0.7016263,0.0617836", "l0.7016263,0.0614629", "l0.7018997,0.0614830", "l0.7019544,0.0613026", "l0.7026107,0.0608616", "l0.7030664,0.0608816", "l0.7031028,0.0606811", "l0.7037408,0.0605408", "l0.7037591,0.0604005", "l0.7040325,0.0603404", "l0.7043059,0.0600798", "l0.7046523,0.0600597", "l0.7051992,0.0597591", "l0.7054361,0.0595185", "l0.7054544,0.0592579", "l0.7058372,0.0590575", "l0.7066939,0.0589372", "l0.7075507,0.0591176", "l0.7087538,0.0588169", "l0.7096834,0.0588771", "l0.7106131,0.0585563", "l0.7108501,0.0582556", "l0.7108501,0.0580151", "l0.7110141,0.0579951", "l0.7110324,0.0576944", "l0.7107954,0.0561910", "l0.7116157,0.0553491", "l0.7120896,0.0542466", "l0.7117251,0.0536051", "l0.7117433,0.0533445", "l0.7121079,0.0532242", "l0.7124907,0.0533646", "l0.7126912,0.0531842", "l0.7131834,0.0533044", "l0.7133657,0.0531240", "l0.7133657,0.0530037", "l0.7128735,0.0529436", "l0.7107043,0.0517208", "l0.7104673,0.0514001", "l0.7097017,0.0511596", "l0.7095194,0.0512197", "l0.7094100,0.0510393", "l0.7087720,0.0507987", "l0.7071314,0.0496962", "l0.7056549,0.0494557", "l0.7055637,0.0493354", "l0.7040325,0.0491550", "l0.7038685,0.0491550", "l0.7038867,0.0493956", "l0.7035403,0.0494757", "l0.7032304,0.0492953", "l0.7031211,0.0490347", "l0.7029570,0.0490347", "l0.7028841,0.0491751", "l0.7027018,0.0489947", "l0.7026107,0.0490548", "l0.7023372,0.0487140", "l0.7026836,0.0479924", "l0.7028294,0.0483131", "l0.7033763,0.0484935", "l0.7042148,0.0490548", "l0.7063111,0.0493555", "l0.7081704,0.0499568", "l0.7087902,0.0500170", "l0.7095558,0.0503978", "l0.7101027,0.0504580", "l0.7109959,0.0507787", "l0.7130193,0.0517008", "l0.7149698,0.0529035", "l0.7152432,0.0532844", "l0.7167015,0.0541263", "l0.7163370,0.0543869", "l0.7161729,0.0541864", "l0.7162458,0.0540060", "l0.7160271,0.0538256", "l0.7151339,0.0533846", "l0.7150063,0.0535049", "l0.7149516,0.0537655", "l0.7156807,0.0537053", "l0.7157536,0.0538457", "l0.7155896,0.0539659", "l0.7158995,0.0540461", "l0.7160088,0.0543468", "l0.7159359,0.0544671", "l0.7156625,0.0544671", "l0.7156443,0.0545873", "l0.7158995,0.0546675", "l0.7161911,0.0544671", "l0.7164828,0.0547076", "l0.7168656,0.0552087", "l0.7168474,0.0554493", "l0.7166104,0.0556297", "l0.7170114,0.0555495", "l0.7173213,0.0556698", "l0.7173213,0.0561308", "l0.7177588,0.0565718", "l0.7186520,0.0569126", "l0.7186702,0.0567322", "l0.7182874,0.0565317", "l0.7180505,0.0560106", "l0.7181234,0.0558903", "l0.7183786,0.0559103", "l0.7183968,0.0557901", "l0.7181963,0.0557901", "l0.7178864,0.0555495", "l0.7181416,0.0554292", "l0.7182874,0.0556097", "l0.7184880,0.0555896", "l0.7185062,0.0560306", "l0.7186338,0.0560306", "l0.7189254,0.0564917", "l0.7190166,0.0568926", "l0.7195635,0.0570128", "l0.7200921,0.0574137", "l0.7202015,0.0573536", "l0.7190713,0.0561509", "l0.7193265,0.0561308", "l0.7196364,0.0566520", "l0.7200192,0.0568525", "l0.7207119,0.0575541", "l0.7211129,0.0575741", "l0.7221337,0.0579750", "l0.7244488,0.0584361", "l0.7269461,0.0586165", "l0.7300268,0.0586165", "l0.7343652,0.0583158", "l0.7349850,0.0581354", "l0.7360970,0.0581554", "l0.7362975,0.0580151", "l0.7376647,0.0578347", "l0.7390683,0.0574538", "l0.7395240,0.0574739", "l0.7396698,0.0572935", "l0.7425864,0.0565718", "l0.7429510,0.0563313", "l0.7434979,0.0562712", "l0.7469067,0.0549882", "l0.7473077,0.0549682", "l0.7473624,0.0548479", "l0.7478181,0.0549081", "l0.7482921,0.0540662", "l0.7483832,0.0540662", "l0.7482921,0.0543869", "l0.7487478,0.0545873", "l0.7507347,0.0538857", "l0.7514456,0.0537053", "l0.7527946,0.0533044", "l0.7542711,0.0525828", "l0.7555289,0.0522019", "l0.7557659,0.0519614", "l0.7586460,0.0507386", "l0.7588465,0.0504780", "l0.7591382,0.0504580", "l0.7592840,0.0502776", "l0.7602137,0.0498366", "l0.7608882,0.0497564", "l0.7618178,0.0493154", "l0.7620913,0.0493354", "l0.7621824,0.0490347", "l0.7636225,0.0483732", "l0.7669584,0.0464489", "l0.7708775,0.0439432", "l0.7736848,0.0419387", "l0.7762368,0.0399542", "l0.7774217,0.0387514", "l0.7780415,0.0383706", "l0.7809581,0.0354239", "l0.7843304,0.0472307", "c"]}, {"n": "Disputed Territory", "u": "EG-TER", "i": ["m0.7695104,0.9725681", "l0.7628022,0.9949589", "l0.7266727,0.9994892", "l0.7262534,0.9993288", "l0.6941160,0.9723877", "l0.6941160,0.9723877", "c"]}, {"n": "Hala'Ib Triangle", "u": "EG-HT", "i": ["m0.9788865,0.9459879", "l0.9789776,0.9463688", "l0.9798162,0.9466694", "l0.9798891,0.9470703", "l0.9801260,0.9472508", "l0.9805635,0.9473309", "l0.9807640,0.9477519", "l0.9787224,0.9475314", "l0.9788865,0.9485337", "l0.9787042,0.9484735", "l0.9785401,0.9481728", "l0.9782667,0.9482731", "l0.9782667,0.9485136", "l0.9780844,0.9485938", "l0.9778839,0.9490749", "l0.9777381,0.9490949", "l0.9775011,0.9488544", "l0.9776834,0.9489145", "l0.9781209,0.9480325", "l0.9781026,0.9478120", "l0.9778839,0.9475915", "l0.9778657,0.9471305", "l0.9780480,0.9471104", "l0.9783396,0.9466494", "l0.9784308,0.9459478", "l0.9788865,0.9459478", "c", "m0.9058254,0.8842880", "l0.9060989,0.8844484", "l0.9065363,0.8849896", "l0.9067186,0.8854507", "l0.9065728,0.8856110", "l0.9065546,0.8861322", "l0.9067004,0.8862124", "l0.9066275,0.8864329", "l0.9069191,0.8869140", "l0.9069191,0.8870743", "l0.9067733,0.8870944", "l0.9067551,0.8875554", "l0.9065546,0.8875554", "l0.9064634,0.8878762", "l0.9059348,0.8882771", "l0.9060259,0.8875153", "l0.9058983,0.8869741", "l0.9060806,0.8865532", "l0.9058983,0.8857914", "l0.9057343,0.8855309", "l0.9052603,0.8854707", "l0.9051145,0.8853104", "l0.9052786,0.8843883", "l0.9055338,0.8843281", "l0.9062447,0.8848694", "l0.9058254,0.8842880", "c", "m0.9047681,0.8836265", "l0.9048775,0.8838069", "l0.9047499,0.8841878", "l0.9048775,0.8852101", "l0.9047864,0.8853504", "l0.9045129,0.8850297", "l0.9042577,0.8850097", "l0.9041119,0.8851500", "l0.9038385,0.8848894", "l0.9035468,0.8849495", "l0.9029817,0.8847290", "l0.9029635,0.8842880", "l0.9031276,0.8840475", "l0.9037838,0.8841076", "l0.9042395,0.8837268", "l0.9045494,0.8838270", "l0.9046223,0.8836466", "l0.9047681,0.8836466", "c", "m0.8952163,0.8618973", "l0.8955079,0.8621579", "l0.8956720,0.8639620", "l0.8962553,0.8644030", "l0.8964376,0.8647237", "l0.8960912,0.8653651", "l0.8962918,0.8666080", "l0.8967657,0.8670890", "l0.8966928,0.8678508", "l0.8964923,0.8678307", "l0.8964376,0.8679911", "l0.8971303,0.8685123", "l0.8973855,0.8684521", "l0.8974037,0.8680512", "l0.8974949,0.8680713", "l0.8980782,0.8694745", "l0.8979506,0.8708776", "l0.8985157,0.8736038", "l0.8983881,0.8739245", "l0.8986433,0.8743054", "l0.8983698,0.8751674", "l0.8983881,0.8760293", "l0.8994636,0.8782143", "l0.8994818,0.8784548", "l0.8996459,0.8785951", "l0.8995912,0.8788156", "l0.8997735,0.8789159", "l0.8996823,0.8791364", "l0.8998464,0.8792967", "l0.8996823,0.8798981", "l0.8994089,0.8799181", "l0.8993360,0.8796575", "l0.8996823,0.8794771", "l0.8996459,0.8790762", "l0.8995000,0.8790161", "l0.8993542,0.8792566", "l0.8990808,0.8789559", "l0.8991537,0.8784348", "l0.8985886,0.8784348", "l0.8982240,0.8790762", "l0.8984063,0.8803792", "l0.8991719,0.8809204", "l0.8994271,0.8814015", "l0.8996276,0.8813814", "l0.8996641,0.8807600", "l0.8995000,0.8803992", "l0.8997005,0.8804794", "l0.8998646,0.8802990", "l0.9001016,0.8802789", "l0.9002839,0.8803792", "l0.8997917,0.8805997", "l0.8998099,0.8809004", "l0.9000104,0.8807600", "l0.9001563,0.8808402", "l0.9001016,0.8805997", "l0.9003932,0.8806598", "l0.9006484,0.8812612", "l0.9007214,0.8820229", "l0.9008672,0.8822033", "l0.9007214,0.8823637", "l0.9012864,0.8828247", "l0.9014687,0.8832256", "l0.9016693,0.8833860", "l0.9016693,0.8835664", "l0.9021250,0.8839072", "l0.9020338,0.8842279", "l0.9024166,0.8842880", "l0.9024349,0.8845486", "l0.9022526,0.8847691", "l0.9020521,0.8847090", "l0.9020521,0.8848894", "l0.9024349,0.8851500", "l0.9026171,0.8859518", "l0.9029088,0.8861122", "l0.9027447,0.8858516", "l0.9027265,0.8852302", "l0.9024166,0.8846889", "l0.9027994,0.8846288", "l0.9030729,0.8847691", "l0.9029088,0.8848694", "l0.9028359,0.8851901", "l0.9033645,0.8858315", "l0.9033645,0.8863728", "l0.9040755,0.8869340", "l0.9040025,0.8875755", "l0.9043671,0.8877960", "l0.9044583,0.8879764", "l0.9047135,0.8880365", "l0.9048957,0.8887381", "l0.9051510,0.8888183", "l0.9053332,0.8891591", "l0.9056249,0.8893194", "l0.9058619,0.8900210", "l0.9061718,0.8903217", "l0.9063541,0.8907226", "l0.9066093,0.8908028", "l0.9067004,0.8904019", "l0.9065910,0.8904219", "l0.9064452,0.8901213", "l0.9063905,0.8894798", "l0.9060806,0.8888784", "l0.9060624,0.8882570", "l0.9062447,0.8880165", "l0.9065363,0.8880165", "l0.9068098,0.8881768", "l0.9072655,0.8880766", "l0.9075754,0.8878160", "l0.9075754,0.8876356", "l0.9078306,0.8876557", "l0.9081405,0.8881167", "l0.9081405,0.8885577", "l0.9086873,0.8905021", "l0.9083957,0.8911235", "l0.9081587,0.8909632", "l0.9080858,0.8905823", "l0.9076118,0.8905623", "l0.9073566,0.8911035", "l0.9074296,0.8915846", "l0.9073384,0.8917249", "l0.9076118,0.8918051", "l0.9077212,0.8921458", "l0.9080129,0.8922260", "l0.9082863,0.8926069", "l0.9089061,0.8927673", "l0.9094530,0.8927071", "l0.9095259,0.8925468", "l0.9093618,0.8924465", "l0.9093436,0.8921859", "l0.9089608,0.8917449", "l0.9086144,0.8918051", "l0.9086144,0.8921859", "l0.9084686,0.8920256", "l0.9086509,0.8908028", "l0.9088149,0.8906625", "l0.9089243,0.8907226", "l0.9091248,0.8914242", "l0.9094165,0.8916848", "l0.9095076,0.8920055", "l0.9100363,0.8927873", "l0.9097993,0.8930078", "l0.9097993,0.8931682", "l0.9100727,0.8934889", "l0.9102732,0.8934889", "l0.9103826,0.8936493", "l0.9100910,0.8942907", "l0.9102550,0.8942707", "l0.9103279,0.8940903", "l0.9106378,0.8950324", "l0.9113670,0.8958943", "l0.9116404,0.8966561", "l0.9121690,0.8970369", "l0.9127524,0.8978788", "l0.9131169,0.8980592", "l0.9132081,0.8984401", "l0.9133357,0.8984201", "l0.9137367,0.8991217", "l0.9145570,0.8999836", "l0.9148304,0.9000638", "l0.9153591,0.9007453", "l0.9159971,0.9007453", "l0.9171273,0.9015271", "l0.9172367,0.9019681", "l0.9167992,0.9022688", "l0.9169268,0.9024292", "l0.9171091,0.9024292", "l0.9171273,0.9026697", "l0.9178747,0.9028501", "l0.9178564,0.9024492", "l0.9177288,0.9022888", "l0.9179840,0.9022287", "l0.9184215,0.9029904", "l0.9182757,0.9030506", "l0.9180752,0.9028902", "l0.9181663,0.9032109", "l0.9185127,0.9032711", "l0.9185856,0.9031708", "l0.9191507,0.9034715", "l0.9196246,0.9034916", "l0.9201897,0.9037121", "l0.9208460,0.9034515", "l0.9210100,0.9036319", "l0.9221037,0.9040328", "l0.9221220,0.9043335", "l0.9217209,0.9042332", "l0.9215387,0.9043936", "l0.9215933,0.9040127", "l0.9214475,0.9040729", "l0.9212834,0.9039125", "l0.9209189,0.9039727", "l0.9209918,0.9041330", "l0.9212834,0.9039927", "l0.9214475,0.9042332", "l0.9212470,0.9049348", "l0.9214110,0.9058569", "l0.9211741,0.9060173", "l0.9212105,0.9063982", "l0.9225595,0.9060574", "l0.9226142,0.9059572", "l0.9223772,0.9059772", "l0.9223589,0.9058168", "l0.9229970,0.9054961", "l0.9231610,0.9049348", "l0.9230699,0.9047143", "l0.9232886,0.9045740", "l0.9232157,0.9043936", "l0.9233798,0.9043736", "l0.9237261,0.9045339", "l0.9239813,0.9053758", "l0.9241089,0.9053758", "l0.9241636,0.9052355", "l0.9245099,0.9056164", "l0.9245464,0.9059371", "l0.9249292,0.9060975", "l0.9255125,0.9059171", "l0.9262235,0.9059371", "l0.9266792,0.9061977", "l0.9274448,0.9064583", "l0.9277000,0.9067189", "l0.9278458,0.9064984", "l0.9281010,0.9064783", "l0.9290125,0.9067389", "l0.9291583,0.9072200", "l0.9293041,0.9072000", "l0.9293953,0.9068993", "l0.9295776,0.9068392", "l0.9307989,0.9067790", "l0.9311635,0.9069193", "l0.9314004,0.9072401", "l0.9316739,0.9071799", "l0.9317468,0.9073603", "l0.9326765,0.9074205", "l0.9329863,0.9075608", "l0.9330957,0.9077412", "l0.9334056,0.9077211", "l0.9336790,0.9078615", "l0.9337520,0.9081020", "l0.9340254,0.9082624", "l0.9344993,0.9083626", "l0.9366868,0.9082624", "l0.9367779,0.9084027", "l0.9374889,0.9083225", "l0.9379264,0.9080619", "l0.9378534,0.9083225", "l0.9383821,0.9084628", "l0.9385097,0.9087635", "l0.9388196,0.9089840", "l0.9393482,0.9089239", "l0.9398768,0.9090642", "l0.9400227,0.9088036", "l0.9402961,0.9089640", "l0.9407336,0.9086432", "l0.9410799,0.9087034", "l0.9411711,0.9088838", "l0.9414081,0.9088036", "l0.9415721,0.9089038", "l0.9417179,0.9091644", "l0.9416268,0.9096255", "l0.9419002,0.9102268", "l0.9421919,0.9103872", "l0.9422648,0.9107079", "l0.9424471,0.9106478", "l0.9425382,0.9107881", "l0.9425382,0.9110487", "l0.9427752,0.9109685", "l0.9430122,0.9111489", "l0.9439054,0.9111289", "l0.9441424,0.9114696", "l0.9444340,0.9116100", "l0.9446710,0.9114696", "l0.9451996,0.9115498", "l0.9455642,0.9121712", "l0.9454913,0.9125120", "l0.9460382,0.9130131", "l0.9462387,0.9133940", "l0.9464210,0.9133740", "l0.9465668,0.9135945", "l0.9470408,0.9136546", "l0.9473324,0.9134942", "l0.9473506,0.9146368", "l0.9479157,0.9157393", "l0.9489183,0.9162405", "l0.9492829,0.9167817", "l0.9496292,0.9179042", "l0.9497933,0.9180846", "l0.9499027,0.9194076", "l0.9501943,0.9198887", "l0.9501943,0.9209311", "l0.9504678,0.9218933", "l0.9505771,0.9228955", "l0.9509782,0.9238978", "l0.9511787,0.9239580", "l0.9513428,0.9243990", "l0.9515433,0.9244992", "l0.9514339,0.9247999", "l0.9517438,0.9251406", "l0.9518714,0.9255215", "l0.9527646,0.9262431", "l0.9531292,0.9268044", "l0.9533662,0.9268645", "l0.9538401,0.9272655", "l0.9537672,0.9273657", "l0.9539130,0.9276263", "l0.9541135,0.9276463", "l0.9544781,0.9281475", "l0.9551161,0.9283880", "l0.9552984,0.9286887", "l0.9555901,0.9287488", "l0.9557724,0.9290094", "l0.9568843,0.9296509", "l0.9570848,0.9299716", "l0.9575223,0.9302723", "l0.9581968,0.9304326", "l0.9591265,0.9310540", "l0.9593087,0.9310540", "l0.9595822,0.9306732", "l0.9599650,0.9306531", "l0.9609858,0.9316754", "l0.9608946,0.9325174", "l0.9606759,0.9328982", "l0.9606941,0.9341009", "l0.9612228,0.9356845", "l0.9612228,0.9361857", "l0.9622436,0.9382103", "l0.9626082,0.9383706", "l0.9633191,0.9390722", "l0.9637566,0.9390923", "l0.9650690,0.9400143", "l0.9655977,0.9400945", "l0.9657617,0.9404153", "l0.9659987,0.9404754", "l0.9671289,0.9413373", "l0.9674023,0.9414777", "l0.9682955,0.9414576", "l0.9688060,0.9419187", "l0.9698997,0.9423396", "l0.9707564,0.9429811", "l0.9715585,0.9432016", "l0.9716679,0.9435223", "l0.9719231,0.9435423", "l0.9723059,0.9439633", "l0.9728345,0.9440435", "l0.9728892,0.9442038", "l0.9733632,0.9444644", "l0.9737095,0.9452462", "l0.9741652,0.9452663", "l0.9742381,0.9454266", "l0.9745116,0.9454467", "l0.9749491,0.9459478", "l0.9750767,0.9459478", "l0.9749491,0.9463487", "l0.9761704,0.9471505", "l0.9761522,0.9473109", "l0.9768631,0.9479323", "l0.9768813,0.9483933", "l0.9773370,0.9485537", "l0.9772641,0.9487943", "l0.9775376,0.9490949", "l0.9777745,0.9492353", "l0.9779750,0.9490949", "l0.9785219,0.9494157", "l0.9787953,0.9493355", "l0.9788318,0.9495560", "l0.9790323,0.9495760", "l0.9791235,0.9497965", "l0.9789776,0.9499368", "l0.9789594,0.9506384", "l0.9793422,0.9514002", "l0.9809099,0.9522822", "l0.9812562,0.9529236", "l0.9812015,0.9530639", "l0.9815479,0.9534648", "l0.9817484,0.9534648", "l0.9819489,0.9539660", "l0.9821859,0.9539860", "l0.9826598,0.9537655", "l0.9832067,0.9539259", "l0.9835895,0.9545072", "l0.9834801,0.9547678", "l0.9835531,0.9550083", "l0.9840817,0.9552689", "l0.9843187,0.9559304", "l0.9847562,0.9560307", "l0.9847744,0.9562512", "l0.9850660,0.9564717", "l0.9852301,0.9566120", "l0.9853213,0.9568726", "l0.9857223,0.9568726", "l0.9871077,0.9575140", "l0.9873629,0.9574940", "l0.9874540,0.9572735", "l0.9881103,0.9574338", "l0.9886571,0.9571732", "l0.9890399,0.9572735", "l0.9891493,0.9574338", "l0.9894045,0.9571933", "l0.9893316,0.9569527", "l0.9894227,0.9566120", "l0.9891128,0.9565318", "l0.9891128,0.9562912", "l0.9891311,0.9561910", "l0.9893863,0.9561910", "l0.9897326,0.9568325", "l0.9902613,0.9574138", "l0.9913003,0.9581755", "l0.9911545,0.9596789", "l0.9912456,0.9597591", "l0.9914279,0.9595386", "l0.9916831,0.9607413", "l0.9923029,0.9612224", "l0.9933055,0.9617236", "l0.9938523,0.9623049", "l0.9940529,0.9623650", "l0.9943263,0.9630866", "l0.9950190,0.9639286", "l0.9952560,0.9644698", "l0.9958940,0.9646301", "l0.9964226,0.9650110", "l0.9971517,0.9650711", "l0.9973705,0.9651714", "l0.9973705,0.9652716", "l0.9977351,0.9652916", "l0.9977898,0.9654520", "l0.9987194,0.9661736", "l0.9988653,0.9664142", "l0.9993939,0.9663340", "l0.9994850,0.9671358", "l0.7695833,0.9723276", "l0.7695833,0.9723276", "l0.7755988,0.9527232", "l0.7927521,0.9491952", "l0.7932261,0.9490148", "l0.7949943,0.9487742", "l0.8025045,0.9472508", "l0.8031061,0.9470303", "l0.8045462,0.9468699", "l0.8070435,0.9463688", "l0.8072258,0.9462084", "l0.8090669,0.9459879", "l0.8191110,0.9439433", "l0.8403658,0.8896602", "l0.8425168,0.8902215", "l0.8617299,0.8964957", "l0.8657038,0.8923663", "l0.8657038,0.8923663", "l0.8952163,0.8618973", "c"]}, {"n": "As Suways", "u": "EG-SUZ", "i": ["m0.5893551,0.2799181", "l0.5907769,0.2513734", "l0.5947690,0.2003177", "l0.5948419,0.1915979", "l0.5925087,0.1743789", "l0.5913238,0.1645967", "l0.5890816,0.1560573", "l0.5890816,0.1560573", "l0.5888629,0.1505048", "l0.5888629,0.1505048", "l0.5923446,0.1501439", "l0.6262866,0.1499234", "l0.6310990,0.1515471", "l0.6422915,0.1524091", "l0.6454451,0.1495827", "l0.6538486,0.1485403", "l0.6538486,0.1485403", "l0.6645125,0.1491016", "l0.6645125,0.1491016", "l0.6664265,0.1568391", "l0.6661895,0.1796709", "l0.6689967,0.1799515", "l0.6689967,0.1799515", "l0.6689967,0.1852836", "l0.6689967,0.1852836", "l0.6643119,0.1864663", "l0.6516794,0.1968899", "l0.6516794,0.1968899", "l0.6512419,0.1962083", "l0.6509684,0.1960079", "l0.6507497,0.1950858", "l0.6505127,0.1946448", "l0.6502393,0.1946248", "l0.6501482,0.1942439", "l0.6494190,0.1935022", "l0.6486352,0.1934220", "l0.6483982,0.1931815", "l0.6485805,0.1928808", "l0.6498200,0.1916380", "l0.6498018,0.1914776", "l0.6502940,0.1906758", "l0.6500752,0.1899542", "l0.6504034,0.1893929", "l0.6505127,0.1887715", "l0.6505127,0.1883906", "l0.6503487,0.1880499", "l0.6499476,0.1876890", "l0.6497107,0.1877692", "l0.6491638,0.1868271", "l0.6482159,0.1857045", "l0.6472862,0.1851032", "l0.6470493,0.1852635", "l0.6468123,0.1841210", "l0.6463383,0.1834595", "l0.6456639,0.1831788", "l0.6455727,0.1832790", "l0.6456639,0.1838002", "l0.6452081,0.1839205", "l0.6452993,0.1840809", "l0.6452081,0.1842412", "l0.6447889,0.1833191", "l0.6445337,0.1833392", "l0.6443514,0.1831989", "l0.6444790,0.1828781", "l0.6449347,0.1825775", "l0.6443696,0.1823169", "l0.6447524,0.1817957", "l0.6446977,0.1814148", "l0.6443696,0.1815351", "l0.6442602,0.1813346", "l0.6442420,0.1816754", "l0.6440780,0.1816754", "l0.6440780,0.1813948", "l0.6442056,0.1812144", "l0.6442967,0.1811342", "l0.6442967,0.1809337", "l0.6441144,0.1810540", "l0.6440050,0.1807934", "l0.6446977,0.1802923", "l0.6449894,0.1798914", "l0.6447889,0.1793702", "l0.6442602,0.1787488", "l0.6440780,0.1786285", "l0.6440780,0.1790094", "l0.6435129,0.1790895", "l0.6430936,0.1793501", "l0.6423098,0.1794103", "l0.6423098,0.1797310", "l0.6421822,0.1798112", "l0.6427837,0.1808135", "l0.6424921,0.1806932", "l0.6421275,0.1798914", "l0.6417811,0.1794905", "l0.6415988,0.1793702", "l0.6410702,0.1794303", "l0.6414166,0.1951059", "l0.6391926,0.1978922", "l0.6356927,0.2006985", "l0.6331407,0.2055896", "l0.6325027,0.2118839", "l0.6312266,0.2192406", "l0.6314272,0.2252742", "l0.6325574,0.2258556", "l0.6328855,0.2262164", "l0.6334141,0.2265371", "l0.6336511,0.2268779", "l0.6338151,0.2268979", "l0.6339610,0.2271585", "l0.6349818,0.2275394", "l0.6353099,0.2281006", "l0.6355286,0.2289626", "l0.6362031,0.2293435", "l0.6366406,0.2299649", "l0.6371875,0.2302856", "l0.6373880,0.2304860", "l0.6374791,0.2307867", "l0.6376979,0.2309070", "l0.6376067,0.2312478", "l0.6377708,0.2313881", "l0.6379166,0.2318491", "l0.6380989,0.2319895", "l0.6384088,0.2319093", "l0.6385729,0.2321699", "l0.6390286,0.2321899", "l0.6395937,0.2325908", "l0.6396119,0.2332724", "l0.6395025,0.2335330", "l0.6400129,0.2342746", "l0.6401952,0.2342546", "l0.6407603,0.2345152", "l0.6408697,0.2349161", "l0.6418723,0.2353170", "l0.6421822,0.2358181", "l0.6429842,0.2363594", "l0.6431301,0.2367402", "l0.6435311,0.2368605", "l0.6437681,0.2370810", "l0.6438774,0.2374017", "l0.6444243,0.2378628", "l0.6444608,0.2380231", "l0.6449165,0.2381434", "l0.6451535,0.2388049", "l0.6456274,0.2392459", "l0.6454269,0.2396268", "l0.6455180,0.2400277", "l0.6458462,0.2402281", "l0.6461014,0.2403083", "l0.6462472,0.2411703", "l0.6465024,0.2417115", "l0.6471222,0.2421926", "l0.6472862,0.2425734", "l0.6471951,0.2430746", "l0.6474685,0.2435958", "l0.6479060,0.2454399", "l0.6478149,0.2458409", "l0.6479425,0.2462217", "l0.6478513,0.2464222", "l0.6479242,0.2467830", "l0.6483070,0.2475447", "l0.6484711,0.2475447", "l0.6485987,0.2477652", "l0.6485440,0.2479857", "l0.6482888,0.2480859", "l0.6481977,0.2482463", "l0.6482706,0.2491283", "l0.6491273,0.2498098", "l0.6491091,0.2500704", "l0.6492914,0.2502508", "l0.6493096,0.2505916", "l0.6491091,0.2506518", "l0.6490727,0.2512130", "l0.6492003,0.2514937", "l0.6495831,0.2517543", "l0.6497471,0.2520148", "l0.6498929,0.2520750", "l0.6499476,0.2526964", "l0.6502940,0.2532176", "l0.6501482,0.2536385", "l0.6498747,0.2536987", "l0.6500570,0.2539793", "l0.6499841,0.2544003", "l0.6497471,0.2548613", "l0.6500570,0.2552422", "l0.6499294,0.2555028", "l0.6501117,0.2555829", "l0.6501117,0.2559237", "l0.6504034,0.2566453", "l0.6502393,0.2567255", "l0.6499841,0.2563447", "l0.6499659,0.2566854", "l0.6500206,0.2568258", "l0.6503122,0.2568859", "l0.6507862,0.2574071", "l0.6508955,0.2580084", "l0.6511325,0.2584695", "l0.6509867,0.2591510", "l0.6511690,0.2591510", "l0.6512419,0.2594517", "l0.6516065,0.2595118", "l0.6516065,0.2597123", "l0.6515882,0.2598927", "l0.6516247,0.2601733", "l0.6514242,0.2603337", "l0.6514789,0.2607346", "l0.6517523,0.2611155", "l0.6515882,0.2613360", "l0.6516611,0.2617168", "l0.6515335,0.2619173", "l0.6517523,0.2622180", "l0.6517158,0.2626790", "l0.6519346,0.2628795", "l0.6517887,0.2631401", "l0.6517887,0.2633606", "l0.6519528,0.2635610", "l0.6519346,0.2643829", "l0.6521715,0.2644430", "l0.6522445,0.2646435", "l0.6522445,0.2646435", "l0.6424556,0.2650243", "l0.6352734,0.2697150", "l0.6274715,0.2720603", "l0.6128338,0.2819627", "l0.6007481,0.2821632", "l0.5913420,0.2841276", "l0.5913420,0.2841276", "l0.5913420,0.2841276", "l0.5913420,0.2841276", "c"]}, {"n": "Al Wādī al Jadīd", "u": "EG-WAD", "i": ["m0.3274618,0.4128795", "l0.4917580,0.4132403", "l0.4919221,0.4171492", "l0.4919221,0.4171492", "l0.4900263,0.4173496", "l0.4898622,0.4218398", "l0.4912841,0.4234033", "l0.4915940,0.4272922", "l0.4934715,0.4282343", "l0.4942918,0.4333459", "l0.4960236,0.4374351", "l0.4985574,0.4411435", "l0.4995053,0.4454333", "l0.5015651,0.4487408", "l0.5040989,0.4503043", "l0.5112811,0.4580218", "l0.5151274,0.4617903", "l0.5169320,0.4628528", "l0.5208694,0.4633338", "l0.5238772,0.4641156", "l0.5287807,0.4672227", "l0.5318979,0.4728554", "l0.5351791,0.4802923", "l0.5385332,0.4888918", "l0.5426164,0.4963286", "l0.5426164,0.4963286", "l0.5435643,0.4999970", "l0.5481580,0.5065318", "l0.5536266,0.5134675", "l0.5582020,0.5144096", "l0.5618660,0.5174766", "l0.5638530,0.5212251", "l0.5677357,0.5273389", "l0.5712903,0.5332122", "l0.5753189,0.5389051", "l0.5755741,0.5394464", "l0.5775246,0.5419320", "l0.5817537,0.5488878", "l0.5869853,0.5564249", "l0.5896103,0.5596121", "l0.5912509,0.5603738", "l0.5942039,0.5650845", "l0.5956805,0.5670690", "l0.5956805,0.5670690", "l0.6000736,0.5729423", "l0.6000736,0.5729423", "l0.6089328,0.5814416", "l0.6118494,0.5827044", "l0.6206357,0.5824438", "l0.6232424,0.5815618", "l0.6270158,0.5808001", "l0.6303699,0.5805395", "l0.6338151,0.5792566", "l0.6359115,0.5778534", "l0.6435493,0.5744257", "l0.6470128,0.5716193", "l0.6517158,0.5695747", "l0.6564189,0.5698353", "l0.6580959,0.5713587", "l0.6603198,0.5759090", "l0.6607755,0.5804393", "l0.6583511,0.5843882", "l0.6555257,0.5898606", "l0.6545960,0.5930278", "l0.6545960,0.5983800", "l0.6533382,0.6014269", "l0.6502940,0.6053758", "l0.6454816,0.6103270", "l0.6406692,0.6126122", "l0.6374244,0.6162805", "l0.6357474,0.6203498", "l0.6355469,0.6250404", "l0.6367135,0.6272053", "l0.6388098,0.6321966", "l0.6390833,0.6384508", "l0.6404869,0.6414977", "l0.6401405,0.6446047", "l0.6409061,0.6505983", "l0.6431301,0.6570129", "l0.6454269,0.6589573", "l0.6499112,0.6633472", "l0.6543590,0.6657527", "l0.6543590,0.6657527", "l0.6607209,0.6690000", "l0.6656062,0.6740515", "l0.6685228,0.6780806", "l0.6692337,0.6817890", "l0.6691790,0.6870008", "l0.6692884,0.6913507", "l0.6714212,0.6984869", "l0.6724420,0.7028768", "l0.6757232,0.7098526", "l0.6747024,0.7165077", "l0.6747024,0.7222808", "l0.6734993,0.7292767", "l0.6721321,0.7362525", "l0.6720956,0.7431080", "l0.6710201,0.7515271", "l0.6710201,0.7574606", "l0.6703092,0.7703899", "l0.6634916,0.7782276", "l0.6601375,0.7800718", "l0.6578043,0.7810540", "l0.6552704,0.7838403", "l0.6555803,0.7901346", "l0.6594266,0.7942239", "l0.6621427,0.7966494", "l0.6627260,0.7991751", "l0.6588615,0.8026229", "l0.6551975,0.8037455", "l0.6512054,0.8055696", "l0.6470310,0.8082958", "l0.6441873,0.8103404", "l0.6416171,0.8143695", "l0.6384999,0.8262565", "l0.6378437,0.8328314", "l0.6403775,0.8361389", "l0.6498200,0.8386045", "l0.6547054,0.8393261", "l0.6578407,0.8385443", "l0.6616141,0.8383238", "l0.6624891,0.8422928", "l0.6619422,0.8442172", "l0.6593537,0.8489479", "l0.6562730,0.8540194", "l0.6534658,0.8605141", "l0.6510596,0.8650645", "l0.6479789,0.8704767", "l0.6457003,0.8760894", "l0.6442602,0.8808402", "l0.6420181,0.8852101", "l0.6402864,0.8892393", "l0.6371875,0.8958943", "l0.6341979,0.8977385", "l0.6314636,0.8964155", "l0.6279272,0.8939700", "l0.6232424,0.8929477", "l0.6185212,0.8924265", "l0.6167347,0.8916648", "l0.6067271,0.8949121", "l0.5909774,0.8997631", "l0.5868577,0.9012465", "l0.5839229,0.9017075", "l0.5801860,0.9012465", "l0.5751366,0.9012866", "l0.5730038,0.9022888", "l0.5703242,0.9057767", "l0.5687930,0.9094451", "l0.5691758,0.9138951", "l0.5691758,0.9225748", "l0.5695950,0.9257821", "l0.5687201,0.9289493", "l0.5672071,0.9320964", "l0.5637071,0.9364262", "l0.5583114,0.9418986", "l0.5510199,0.9416581", "l0.5455330,0.9434822", "l0.5376582,0.9479523", "l0.5362363,0.9534648", "l0.5389889,0.9579149", "l0.5438560,0.9573937", "l0.5438560,0.9573937", "l0.5455512,0.9575541", "l0.5458794,0.9618839", "l0.5451320,0.9636880", "l0.5450044,0.9654119", "l0.5427440,0.9723677", "l0.5379498,0.9722474", "l0.5196299,0.9723276", "l0.5148175,0.9721672", "l0.5031875,0.9723476", "l0.5023125,0.9722073", "l0.4347383,0.9724880", "l0.4347383,0.9730693", "l0.4246942,0.9725481", "l0.4074133,0.9724479", "l0.3788123,0.9725681", "l0.3783748,0.9724078", "l0.3731067,0.9724679", "l0.3337690,0.9722474", "l0.3262587,0.9723476", "l0.2811971,0.9722675", "l0.2796841,0.9724078", "l0.2759654,0.9724479", "l0.2725202,0.9722675", "l0.2544007,0.9723075", "l0.2515935,0.9722073", "l0.2442837,0.9723677", "l0.2409479,0.9722474", "l0.1847120,0.9724880", "l0.1508246,0.9723075", "l0.1476893,0.9724078", "l0.1461034,0.9722875", "l0.1378640,0.9724278", "l0.0366029,0.9725681", "l0.0251917,0.9730693", "l0.0251917,0.4131401", "l0.0251917,0.4131401", "l0.0266682,0.4131200", "l0.0266682,0.4131200", "l0.2200759,0.4131601", "l0.2200759,0.4131601", "l0.2213154,0.4131601", "l0.2213154,0.4131601", "c"]}]} """;
}
