import 'package:flutter/material.dart';

class SMapGuatemalaColors {
  /// Quiché
  final Color? gtQC;

  /// Zacapa
  final Color? gtZA;

  /// Jutiapa
  final Color? gtJU;

  /// Jalapa
  final Color? gtJA;

  /// Chiquimula
  final Color? gtCQ;

  /// Izabal
  final Color? gtIZ;

  /// Santa Rosa
  final Color? gtSR;

  /// El Progreso
  final Color? gtPR;

  /// Totonicapán
  final Color? gtTO;

  /// Sololá
  final Color? gtSO;

  /// Sacatepéquez
  final Color? gtSA;

  /// Suchitepéquez
  final Color? gtSU;

  /// Guatemala
  final Color? gtGU;

  /// Escuintla
  final Color? gtES;

  /// Chimaltenango
  final Color? gtCM;

  /// Alta Verapaz
  final Color? gtAV;

  /// San Marcos
  final Color? gtSM;

  /// Retalhuleu
  final Color? gtRE;

  /// Quezaltenango
  final Color? gtQZ;

  /// Petén
  final Color? gtPE;

  /// Huehuetenango
  final Color? gtHU;

  /// Baja Verapaz
  final Color? gtBV;
  SMapGuatemalaColors({
    this.gtQC,
    this.gtZA,
    this.gtJU,
    this.gtJA,
    this.gtCQ,
    this.gtIZ,
    this.gtSR,
    this.gtPR,
    this.gtTO,
    this.gtSO,
    this.gtSA,
    this.gtSU,
    this.gtGU,
    this.gtES,
    this.gtCM,
    this.gtAV,
    this.gtSM,
    this.gtRE,
    this.gtQZ,
    this.gtPE,
    this.gtHU,
    this.gtBV,
  });
  Map<String, Color?> toMap() {
    return {
      "GT-QC": gtQC,
      "GT-ZA": gtZA,
      "GT-JU": gtJU,
      "GT-JA": gtJA,
      "GT-CQ": gtCQ,
      "GT-IZ": gtIZ,
      "GT-SR": gtSR,
      "GT-PR": gtPR,
      "GT-TO": gtTO,
      "GT-SO": gtSO,
      "GT-SA": gtSA,
      "GT-SU": gtSU,
      "GT-GU": gtGU,
      "GT-ES": gtES,
      "GT-CM": gtCM,
      "GT-AV": gtAV,
      "GT-SM": gtSM,
      "GT-RE": gtRE,
      "GT-QZ": gtQZ,
      "GT-PE": gtPE,
      "GT-HU": gtHU,
      "GT-BV": gtBV,
    };
  }

  static SMapGuatemalaColors fromMap(Map<String, Color?> map) {
    return SMapGuatemalaColors(
      gtQC: map["GT-QC"],
      gtZA: map["GT-ZA"],
      gtJU: map["GT-JU"],
      gtJA: map["GT-JA"],
      gtCQ: map["GT-CQ"],
      gtIZ: map["GT-IZ"],
      gtSR: map["GT-SR"],
      gtPR: map["GT-PR"],
      gtTO: map["GT-TO"],
      gtSO: map["GT-SO"],
      gtSA: map["GT-SA"],
      gtSU: map["GT-SU"],
      gtGU: map["GT-GU"],
      gtES: map["GT-ES"],
      gtCM: map["GT-CM"],
      gtAV: map["GT-AV"],
      gtSM: map["GT-SM"],
      gtRE: map["GT-RE"],
      gtQZ: map["GT-QZ"],
      gtPE: map["GT-PE"],
      gtHU: map["GT-HU"],
      gtBV: map["GT-BV"],
    );
  }
}

class SMapGuatemala {
  static const String instructions =
      """{"n": "Guatemala", "w": 563.42047, "h": 594.59253, "g": {"a": "-92.234204,17.815697","b": "-88.230725,13.740021"}, "i":[{"n": "Quiché", "u": "GT-QC", "i": ["m0.4466955,0.4416470", "l0.4466955,0.4416470", "l0.4437315,0.4406043", "l0.4432523,0.4418152", "l0.4424003,0.4428747", "l0.4420276,0.4440856", "l0.4404835,0.4440856", "l0.4375549,0.4423197", "l0.4327450,0.4451956", "l0.4301715,0.4440856", "l0.4284676,0.4440856", "l0.4275269,0.4455993", "l0.4267105,0.4457338", "l0.4249356,0.4440856", "l0.4244031,0.4449265", "l0.4240837,0.4456665", "l0.4238174,0.4455993", "l0.4233915,0.4440856", "l0.4223620,0.4451620", "l0.4207469,0.4464906", "l0.4200014,0.4472811", "l0.4167179,0.4456497", "l0.4145171,0.4436147", "l0.4120145,0.4422188", "l0.4078436,0.4424206", "l0.4078436,0.4406043", "l0.4090505,0.4402343", "l0.4102751,0.4395447", "l0.4113756,0.4390738", "l0.4113756,0.4372574", "l0.4096717,0.4362652", "l0.4082340,0.4361979", "l0.4070981,0.4371229", "l0.4062994,0.4390738", "l0.4046133,0.4390738", "l0.4010990,0.4356429", "l0.3946740,0.4369715", "l0.3841313,0.4424206", "l0.3859771,0.4457506", "l0.3837585,0.4471466", "l0.3837940,0.4482061", "l0.3842555,0.4494843", "l0.3833503,0.4515193", "l0.3816287,0.4525116", "l0.3804573,0.4514857", "l0.3796586,0.4498711", "l0.3790374,0.4490975", "l0.3762508,0.4502747", "l0.3723461,0.4533525", "l0.3690271,0.4541093", "l0.3690271,0.4559257", "l0.3700565,0.4567666", "l0.3722573,0.4591211", "l0.3739612,0.4574393", "l0.3744049,0.4582130", "l0.3743339,0.4586502", "l0.3745292,0.4589025", "l0.3758071,0.4591211", "l0.3758071,0.4607861", "l0.3733578,0.4624680", "l0.3714409,0.4660166", "l0.3690271,0.4741398", "l0.3752036,0.4747621", "l0.3767123,0.4789498", "l0.3741387,0.4837262", "l0.3681041,0.4859799", "l0.3670925,0.4874262", "l0.3637912,0.4959867", "l0.3570467,0.5041268", "l0.3554848,0.5076586", "l0.3587328,0.5073054", "l0.3616259,0.5076249", "l0.3639864,0.5088022", "l0.3656371,0.5110054", "l0.3644302,0.5115268", "l0.3633297,0.5124181", "l0.3621051,0.5128218", "l0.3621051,0.5143354", "l0.3657791,0.5170095", "l0.3671812,0.5178168", "l0.3638267,0.5200873", "l0.3629038,0.5228455", "l0.3647851,0.5251832", "l0.3740322,0.5266800", "l0.3845395,0.5296064", "l0.3875213,0.5311537", "l0.3895624,0.5299932", "l0.3918342,0.5296064", "l0.3941060,0.5299932", "l0.3961294,0.5311537", "l0.3952597,0.5313555", "l0.3945498,0.5313555", "l0.3941770,0.5316750", "l0.3942835,0.5328187", "l0.3990047,0.5356946", "l0.4014895,0.5388564", "l0.4016847,0.5423378", "l0.3995194,0.5463069", "l0.4032644,0.5488128", "l0.4057670,0.5538919", "l0.4074531,0.5589038", "l0.4087665,0.5611574", "l0.4103639,0.5625197", "l0.4086778,0.5654124", "l0.4059977,0.5680697", "l0.4046133,0.5687256", "l0.3976735,0.5746288", "l0.3976735,0.5762938", "l0.3996614,0.5788838", "l0.3966441,0.5804143", "l0.3867403,0.5812888", "l0.3834036,0.5829202", "l0.3823741,0.5867548", "l0.3828711,0.5911780", "l0.3841313,0.5946257", "l0.3892429,0.5993516", "l0.3969991,0.6022444", "l0.4360285,0.6079289", "l0.4399688,0.6100648", "l0.4397558,0.6150262", "l0.4374307,0.6206267", "l0.4351056,0.6247304", "l0.4334727,0.6268326", "l0.4241724,0.6389418", "l0.4159725,0.6395640", "l0.3868823,0.6383531", "l0.3457407,0.6291535", "l0.3436819,0.6281445", "l0.3421377,0.6545491", "l0.3606674,0.6773210", "l0.3829953,0.6906410", "l0.3828711,0.6917847", "l0.3817707,0.6970824", "l0.3862079,0.7014888", "l0.3879117,0.7028847", "l0.3895446,0.7039106", "l0.3913727,0.7055252", "l0.3924909,0.7078293", "l0.3953130,0.7140688", "l0.3918874,0.7128579", "l0.3829953,0.7110920", "l0.3756829,0.7087206", "l0.3714942,0.7081656", "l0.3587151,0.7081656", "l0.3468589,0.7048356", "l0.3430074,0.7049197", "l0.3395819,0.7054747", "l0.3366711,0.7060802", "l0.3205375,0.7064502", "l0.3160294,0.7056261", "l0.3118762,0.7080647", "l0.3076342,0.7091411", "l0.3052204,0.7102679", "l0.3047589,0.7105875", "l0.3042619,0.7110079", "l0.3026823,0.7134297", "l0.2970915,0.7284316", "l0.2952811,0.7298780", "l0.2886608,0.7329725", "l0.2845786,0.7315766", "l0.2834249,0.7322494", "l0.2824488,0.7355457", "l0.2821825,0.7361007", "l0.2818275,0.7365885", "l0.2814548,0.7370426", "l0.2809401,0.7373789", "l0.2803012,0.7375976", "l0.2795557,0.7376312", "l0.2788280,0.7375471", "l0.2781536,0.7368744", "l0.2776388,0.7357476", "l0.2772839,0.7331239", "l0.2772839,0.7318289", "l0.2774969,0.7308703", "l0.2778163,0.7303321", "l0.2798752,0.7281793", "l0.2806029,0.7271703", "l0.2812596,0.7260098", "l0.2814016,0.7254043", "l0.2809401,0.7246307", "l0.2798219,0.7238234", "l0.2769289,0.7227807", "l0.2755800,0.7224443", "l0.2745151,0.7222593", "l0.2738229,0.7222425", "l0.2731129,0.7221248", "l0.2715865,0.7210316", "l0.2692437,0.7170289", "l0.2679835,0.7137829", "l0.2649485,0.7124375", "l0.2570858,0.7065511", "l0.2576360,0.7050206", "l0.2590204,0.7009843", "l0.2589317,0.6994538", "l0.2582040,0.6981083", "l0.2541395,0.6953838", "l0.2524001,0.6927601", "l0.2512465,0.6884210", "l0.2505543,0.6871765", "l0.2500573,0.6864533", "l0.2456556,0.6832915", "l0.2429933,0.6816769", "l0.2425673,0.6812228", "l0.2422656,0.6806342", "l0.2421591,0.6799110", "l0.2421236,0.6791542", "l0.2423189,0.6772705", "l0.2429046,0.6756728", "l0.2437210,0.6745292", "l0.2457266,0.6730323", "l0.2469868,0.6725110", "l0.2480340,0.6722587", "l0.2506430,0.6722082", "l0.2513707,0.6717037", "l0.2519387,0.6707451", "l0.2521694,0.6682896", "l0.2521517,0.6670282", "l0.2506075,0.6642869", "l0.2488859,0.6637487", "l0.2485487,0.6603682", "l0.2461171,0.6570886", "l0.2448924,0.6523291", "l0.2431886,0.6516227", "l0.2362843,0.6448618", "l0.2355034,0.6431800", "l0.2321488,0.6415990", "l0.2309242,0.6378318", "l0.2309597,0.6334086", "l0.2321133,0.6265972", "l0.2332315,0.6245285", "l0.2352016,0.6232503", "l0.2459751,0.6213667", "l0.2516015,0.6195840", "l0.2538378,0.6195335", "l0.2599079,0.6205762", "l0.2620910,0.6203576", "l0.2659247,0.6195167", "l0.2647000,0.6146394", "l0.2632624,0.6109898", "l0.2630139,0.6095939", "l0.2651615,0.6008653", "l0.2646113,0.5964589", "l0.2577425,0.5934148", "l0.2546010,0.5928093", "l0.2473418,0.5936502", "l0.2459396,0.5936166", "l0.2449634,0.5934148", "l0.2402955,0.5892607", "l0.2387514,0.5876125", "l0.2373137,0.5855102", "l0.2362665,0.5831557", "l0.2359826,0.5817934", "l0.2359648,0.5786988", "l0.2357873,0.5779420", "l0.2353791,0.5771852", "l0.2304095,0.5714838", "l0.2296640,0.5703906", "l0.2293978,0.5698356", "l0.2290606,0.5693479", "l0.2285104,0.5682379", "l0.2282796,0.5675988", "l0.2281021,0.5669429", "l0.2279246,0.5654292", "l0.2279246,0.5646724", "l0.2280489,0.5638988", "l0.2281909,0.5632429", "l0.2286878,0.5620656", "l0.2300722,0.5598624", "l0.2304095,0.5541947", "l0.2306757,0.5533369", "l0.2312437,0.5519242", "l0.2320601,0.5507469", "l0.2334977,0.5480055", "l0.2341544,0.5457014", "l0.2345094,0.5427582", "l0.2350774,0.5417660", "l0.2357696,0.5412951", "l0.2365505,0.5413623", "l0.2374912,0.5412278", "l0.2385206,0.5409082", "l0.2415734,0.5384023", "l0.2421591,0.5381164", "l0.2428158,0.5379482", "l0.2435790,0.5378473", "l0.2451764,0.5378473", "l0.2459929,0.5376960", "l0.2526841,0.5331887", "l0.2536781,0.5318432", "l0.2546897,0.5316246", "l0.2568373,0.5314228", "l0.2577425,0.5311032", "l0.2582395,0.5306828", "l0.2580442,0.5300941", "l0.2577425,0.5296737", "l0.2574408,0.5280591", "l0.2620732,0.5238041", "l0.2626589,0.5230136", "l0.2788103,0.4916981", "l0.2812241,0.4872244", "l0.3116454,0.4296219", "l0.3130831,0.4296051", "l0.3473026,0.4295547", "l0.3814867,0.4295042", "l0.4156885,0.4294369", "l0.4379632,0.4294033", "l0.4428086,0.4288651", "l0.4472635,0.4273178", "l0.4501920,0.4287810", "l0.4514167,0.4306815", "l0.4509020,0.4330024", "l0.4488076,0.4357438", "l0.4502985,0.4383842", "l0.4492336,0.4406379", "l0.4466955,0.4416470", "c"]}, {"n": "Zacapa", "u": "GT-ZA", "i": ["m0.7701307,0.6733351", "l0.7701307,0.6733351", "l0.7667052,0.6760260", "l0.7637234,0.6804155", "l0.7598010,0.6916501", "l0.7646464,0.6959556", "l0.7646286,0.7023633", "l0.7615581,0.7092756", "l0.7596412,0.7118488", "l0.7595702,0.7116638", "l0.7587893,0.7099988", "l0.7584343,0.7094438", "l0.7581858,0.7088888", "l0.7578663,0.7083338", "l0.7571386,0.7066352", "l0.7561802,0.7049534", "l0.7558075,0.7044320", "l0.7553993,0.7039947", "l0.7549555,0.7036079", "l0.7544941,0.7032884", "l0.7538551,0.7030361", "l0.7525417,0.7032211", "l0.7506604,0.7037424", "l0.7451760,0.7063997", "l0.7435076,0.7074929", "l0.7424959,0.7084179", "l0.7412180,0.7102679", "l0.7400644,0.7115125", "l0.7385380,0.7126897", "l0.7355917,0.7136148", "l0.7337281,0.7136988", "l0.7321307,0.7126561", "l0.7311367,0.7114116", "l0.7272498,0.7102511", "l0.7150209,0.7141866", "l0.7109742,0.7141866", "l0.7075487,0.7119666", "l0.7021176,0.7104025", "l0.7000765,0.7103520", "l0.6952666,0.7116638", "l0.6802866,0.7231171", "l0.6765061,0.7239916", "l0.6632123,0.7237561", "l0.6595561,0.7229489", "l0.6516047,0.7192489", "l0.6431740,0.7151284", "l0.6402632,0.7147752", "l0.6360035,0.7178866", "l0.6303417,0.7229993", "l0.6300045,0.7242102", "l0.6307677,0.7301639", "l0.6297737,0.7341666", "l0.6238989,0.7442576", "l0.6210768,0.7435008", "l0.6171189,0.7429289", "l0.6104809,0.7429289", "l0.6096822,0.7428280", "l0.6082445,0.7412639", "l0.6061857,0.7384889", "l0.6022454,0.7312739", "l0.5999381,0.7281793", "l0.5984650,0.7256902", "l0.5977550,0.7247989", "l0.5996719,0.7207457", "l0.6052272,0.7147752", "l0.6083510,0.7134634", "l0.6136756,0.7133120", "l0.6148825,0.7131102", "l0.6158765,0.7127066", "l0.6163734,0.7115629", "l0.6168881,0.7067529", "l0.6162847,0.7059793", "l0.6150245,0.7052393", "l0.6118475,0.7048188", "l0.6088125,0.7032884", "l0.6068424,0.7006143", "l0.5959269,0.6863187", "l0.5952524,0.6851583", "l0.5950217,0.6841996", "l0.5960156,0.6838296", "l0.5972048,0.6836783", "l0.6092029,0.6834428", "l0.6089545,0.6801633", "l0.5979148,0.6642869", "l0.5887564,0.6517741", "l0.5955719,0.6488813", "l0.5981455,0.6485282", "l0.6038783,0.6487300", "l0.6125575,0.6518918", "l0.6154860,0.6524804", "l0.6312646,0.6501932", "l0.6391983,0.6506977", "l0.6563613,0.6468968", "l0.6664959,0.6457532", "l0.6701876,0.6449795", "l0.6995795,0.6355613", "l0.7286164,0.6244108", "l0.7350947,0.6198026", "l0.7386800,0.6181040", "l0.7444483,0.6169267", "l0.7520448,0.6176331", "l0.7545296,0.6182049", "l0.7602979,0.6211985", "l0.7610079,0.6216526", "l0.7618066,0.6223085", "l0.7630312,0.6235699", "l0.7636169,0.6244108", "l0.7640252,0.6251676", "l0.7642026,0.6258404", "l0.7643269,0.6274045", "l0.7637767,0.6335095", "l0.7634927,0.6350904", "l0.7632620,0.6356454", "l0.7626585,0.6367218", "l0.7622325,0.6372263", "l0.7617888,0.6375963", "l0.7607771,0.6382859", "l0.7576711,0.6394631", "l0.7574049,0.6404554", "l0.7574226,0.6420700", "l0.7593572,0.6498063", "l0.7594460,0.6513200", "l0.7592862,0.6536577", "l0.7596590,0.6574923", "l0.7611321,0.6643541", "l0.7616291,0.6657164", "l0.7664567,0.6712496", "l0.7675394,0.6719896", "l0.7693320,0.6727464", "l0.7700065,0.6732510", "l0.7701307,0.6733351", "c"]}, {"n": "Jutiapa", "u": "GT-JU", "i": ["m0.6590769,0.8066701", "l0.6590769,0.8066701", "l0.6777308,0.8059637", "l0.6792749,0.8065019", "l0.6827537,0.8101346", "l0.6834459,0.8118165", "l0.6833927,0.8129096", "l0.6831442,0.8141710", "l0.6819728,0.8175178", "l0.6812273,0.8190819", "l0.6804109,0.8214029", "l0.6797719,0.8241947", "l0.6796477,0.8255065", "l0.6796832,0.8263811", "l0.6798784,0.8267511", "l0.6801624,0.8272388", "l0.6833927,0.8308715", "l0.6834991,0.8309724", "l0.6817775,0.8316788", "l0.6756542,0.8387088", "l0.6722819,0.8410297", "l0.6715542,0.8365225", "l0.6688387,0.8339156", "l0.6652002,0.8336297", "l0.6616860,0.8361020", "l0.6600708,0.8399366", "l0.6611357,0.8426779", "l0.6629461,0.8450829", "l0.6636561,0.8479084", "l0.6620942,0.8502798", "l0.6596094,0.8519784", "l0.6581362,0.8540134", "l0.6596626,0.8574443", "l0.6648452,0.8581003", "l0.6665669,0.8588234", "l0.6680045,0.8601184", "l0.6687145,0.8610434", "l0.6701698,0.8636503", "l0.6704893,0.8647939", "l0.6709330,0.8684939", "l0.6713945,0.8700748", "l0.6724772,0.8710839", "l0.6756187,0.8725808", "l0.6764174,0.8735730", "l0.6764529,0.8773571", "l0.6748555,0.8788708", "l0.6482147,0.8849253", "l0.6416831,0.8877676", "l0.6354356,0.8923422", "l0.6304659,0.8975054", "l0.6198522,0.9153159", "l0.6191600,0.9173005", "l0.6193907,0.9191505", "l0.6210059,0.9226655", "l0.6211833,0.9230859", "l0.6210946,0.9244314", "l0.6174561,0.9262814", "l0.6138176,0.9248687", "l0.6073571,0.9201091", "l0.6028666,0.9189823", "l0.5992104,0.9192346", "l0.5882239,0.9232037", "l0.5855794,0.9248518", "l0.5802903,0.9298637", "l0.5564537,0.9457401", "l0.5527797,0.9488178", "l0.5506676,0.9522151", "l0.5490170,0.9557470", "l0.5467274,0.9591611", "l0.5436746,0.9614820", "l0.5368769,0.9649297", "l0.5338951,0.9678225", "l0.5319427,0.9713206", "l0.5306116,0.9751552", "l0.5299903,0.9790907", "l0.5301146,0.9828916", "l0.5354037,0.9992053", "l0.5340726,0.9985998", "l0.4987881,0.9847248", "l0.4996755,0.9814284", "l0.5012906,0.9754075", "l0.5013794,0.9710516", "l0.5012019,0.9698911", "l0.5007759,0.9686634", "l0.4975812,0.9631638", "l0.4951673,0.9547042", "l0.4943331,0.9527533", "l0.4936054,0.9516097", "l0.4923453,0.9510378", "l0.4918483,0.9507015", "l0.4914223,0.9502642", "l0.4911384,0.9496756", "l0.4893457,0.9396855", "l0.4889375,0.9386933", "l0.4876951,0.9374487", "l0.4868787,0.9364733", "l0.4860267,0.9347242", "l0.4858670,0.9338496", "l0.4858137,0.9325714", "l0.4860977,0.9311923", "l0.4864527,0.9303346", "l0.4879791,0.9292414", "l0.4924873,0.9280473", "l0.4994625,0.9318819", "l0.5042547,0.9357164", "l0.5055326,0.9362042", "l0.5152766,0.9384410", "l0.5177615,0.9393828", "l0.5187909,0.9393155", "l0.5196073,0.9391810", "l0.5234766,0.9366246", "l0.5273458,0.9297123", "l0.5289077,0.9270046", "l0.5297774,0.9263991", "l0.5311795,0.9256087", "l0.5340371,0.9248182", "l0.5373738,0.9242296", "l0.5379418,0.9240109", "l0.5393617,0.9225309", "l0.5436746,0.9166782", "l0.5449880,0.9139873", "l0.5456980,0.9119186", "l0.5459465,0.9104891", "l0.5459820,0.9097659", "l0.5448460,0.9001290", "l0.5452188,0.8948313", "l0.5440118,0.8924095", "l0.5379595,0.8867754", "l0.5302566,0.8807376", "l0.5285350,0.8790726", "l0.5275765,0.8783494", "l0.5261566,0.8777944", "l0.5146554,0.8746999", "l0.5110702,0.8722276", "l0.5199091,0.8513561", "l0.5232103,0.8486484", "l0.5237428,0.8482448", "l0.5323864,0.8466302", "l0.5351197,0.8467648", "l0.5363266,0.8473198", "l0.5375691,0.8477402", "l0.5381193,0.8475048", "l0.5384032,0.8467479", "l0.5376401,0.8421397", "l0.5411188,0.8417697", "l0.5456092,0.8284161", "l0.5613169,0.8282142", "l0.5672272,0.8207806", "l0.5682389,0.8197210", "l0.5689488,0.8193510", "l0.5698895,0.8190315", "l0.5716111,0.8186951", "l0.5727293,0.8186278", "l0.5737232,0.8186951", "l0.5744509,0.8188465", "l0.5751254,0.8190819", "l0.5758886,0.8194015", "l0.5869460,0.8276761", "l0.5882417,0.8193342", "l0.5903183,0.8164078", "l0.5953767,0.8131283", "l0.6001333,0.8101346", "l0.6041978,0.8075278", "l0.6090255,0.8062664", "l0.6108003,0.8065692", "l0.6117588,0.8073260", "l0.6125575,0.8082678", "l0.6142081,0.8098655", "l0.6169414,0.8119174", "l0.6174384,0.8121528", "l0.6329153,0.8050051", "l0.6382754,0.8020114", "l0.6384529,0.8012210", "l0.6383996,0.7988496", "l0.6365182,0.7934005", "l0.6465108,0.7944768", "l0.6496346,0.7954859", "l0.6501493,0.7959232", "l0.6518887,0.7977228", "l0.6532908,0.7996737", "l0.6544800,0.8018769", "l0.6573020,0.8058628", "l0.6581717,0.8064178", "l0.6590769,0.8066701", "c"]}, {"n": "Jalapa", "u": "GT-JA", "i": ["m0.5996719,0.7207457", "l0.5996719,0.7207457", "l0.5977550,0.7247989", "l0.5984650,0.7256902", "l0.5999381,0.7281793", "l0.6022454,0.7312739", "l0.6061857,0.7384889", "l0.6082445,0.7412639", "l0.6096822,0.7428280", "l0.6104809,0.7429289", "l0.6171189,0.7429289", "l0.6210768,0.7435008", "l0.6238989,0.7442576", "l0.6356486,0.7436689", "l0.6388611,0.7445435", "l0.6401567,0.7465112", "l0.6410974,0.7491181", "l0.6415944,0.7519099", "l0.6415766,0.7527003", "l0.6410619,0.7556267", "l0.6408489,0.7563163", "l0.6406892,0.7570394", "l0.6406182,0.7584858", "l0.6409022,0.7598481", "l0.6418074,0.7618663", "l0.6427836,0.7647086", "l0.6338914,0.7882205", "l0.6330040,0.7934005", "l0.6338559,0.7935182", "l0.6365182,0.7934005", "l0.6383996,0.7988496", "l0.6384529,0.8012210", "l0.6382754,0.8020114", "l0.6329153,0.8050051", "l0.6174384,0.8121528", "l0.6169414,0.8119174", "l0.6142081,0.8098655", "l0.6125575,0.8082678", "l0.6117588,0.8073260", "l0.6108003,0.8065692", "l0.6090255,0.8062664", "l0.6041978,0.8075278", "l0.6001333,0.8101346", "l0.5953767,0.8131283", "l0.5903183,0.8164078", "l0.5882417,0.8193342", "l0.5869460,0.8276761", "l0.5758886,0.8194015", "l0.5751254,0.8190819", "l0.5744509,0.8188465", "l0.5737232,0.8186951", "l0.5727293,0.8186278", "l0.5716111,0.8186951", "l0.5698895,0.8190315", "l0.5689488,0.8193510", "l0.5682389,0.8197210", "l0.5672272,0.8207806", "l0.5613169,0.8282142", "l0.5456092,0.8284161", "l0.5390422,0.8236397", "l0.5302033,0.8166937", "l0.5279847,0.8133469", "l0.5267246,0.8076287", "l0.4994448,0.8125228", "l0.4962500,0.8130946", "l0.4928067,0.8135319", "l0.4922743,0.8132460", "l0.4913159,0.8125733", "l0.4908189,0.8119174", "l0.4877129,0.8087892", "l0.4881211,0.8012714", "l0.4883341,0.8000773", "l0.4887423,0.7985805", "l0.4897185,0.7978405", "l0.4903219,0.7967305", "l0.4909609,0.7947459", "l0.4910851,0.7909282", "l0.4925228,0.7851764", "l0.5005984,0.7787350", "l0.5027105,0.7774568", "l0.5031898,0.7770700", "l0.5043434,0.7753377", "l0.5065975,0.7699222", "l0.5070412,0.7697540", "l0.5087984,0.7690309", "l0.5127741,0.7668613", "l0.5137325,0.7642545", "l0.5139987,0.7626736", "l0.5144247,0.7619840", "l0.5154186,0.7613786", "l0.5219502,0.7589904", "l0.5303098,0.7563163", "l0.5340726,0.7567535", "l0.5371076,0.7581663", "l0.5390954,0.7587885", "l0.5402491,0.7582335", "l0.5411720,0.7572749", "l0.5489105,0.7435849", "l0.5546433,0.7419535", "l0.5630030,0.7410117", "l0.5704930,0.7383880", "l0.5777344,0.7346544", "l0.5863958,0.7243112", "l0.5897503,0.7214184", "l0.5911525,0.7208802", "l0.5925901,0.7205943", "l0.5957849,0.7204766", "l0.5996719,0.7207457", "c"]}, {"n": "Chiquimula", "u": "GT-CQ", "i": ["m0.7596412,0.7118488", "l0.7596412,0.7118488", "l0.7572629,0.7150779", "l0.7511218,0.7201402", "l0.7491695,0.7229825", "l0.7489210,0.7275571", "l0.7501101,0.7309544", "l0.7522755,0.7340825", "l0.7572629,0.7398176", "l0.7596057,0.7434839", "l0.7642736,0.7542308", "l0.7669892,0.7575608", "l0.7692433,0.7594613", "l0.7703260,0.7610254", "l0.7707519,0.7616476", "l0.7711956,0.7657849", "l0.7705567,0.7676854", "l0.7679299,0.7704099", "l0.7670424,0.7719404", "l0.7680896,0.7841841", "l0.7679476,0.7884896", "l0.7667940,0.7925091", "l0.7638832,0.7951664", "l0.7610256,0.7953682", "l0.7547781,0.7933332", "l0.7517430,0.7928118", "l0.7475188,0.7933332", "l0.7456375,0.7945273", "l0.7444305,0.7964278", "l0.7421765,0.7990850", "l0.7344203,0.8054592", "l0.7309593,0.8090246", "l0.7284922,0.8132460", "l0.7264511,0.8152978", "l0.7209312,0.8166433", "l0.7183932,0.8182242", "l0.7167780,0.8213860", "l0.7163343,0.8252374", "l0.7168668,0.8327888", "l0.7096785,0.8277938", "l0.7094123,0.8283488", "l0.7081344,0.8302156", "l0.7077972,0.8255233", "l0.7052768,0.8264651", "l0.6996327,0.8319983", "l0.6957280,0.8327720", "l0.6929237,0.8317797", "l0.6901194,0.8303838", "l0.6861970,0.8298961", "l0.6834991,0.8309724", "l0.6833927,0.8308715", "l0.6801624,0.8272388", "l0.6798784,0.8267511", "l0.6796832,0.8263811", "l0.6796477,0.8255065", "l0.6797719,0.8241947", "l0.6804109,0.8214029", "l0.6812273,0.8190819", "l0.6819728,0.8175178", "l0.6831442,0.8141710", "l0.6833927,0.8129096", "l0.6834459,0.8118165", "l0.6827537,0.8101346", "l0.6792749,0.8065019", "l0.6777308,0.8059637", "l0.6590769,0.8066701", "l0.6581717,0.8064178", "l0.6573020,0.8058628", "l0.6544800,0.8018769", "l0.6532908,0.7996737", "l0.6518887,0.7977228", "l0.6501493,0.7959232", "l0.6496346,0.7954859", "l0.6465108,0.7944768", "l0.6365182,0.7934005", "l0.6338559,0.7935182", "l0.6330040,0.7934005", "l0.6338914,0.7882205", "l0.6427836,0.7647086", "l0.6418074,0.7618663", "l0.6409022,0.7598481", "l0.6406182,0.7584858", "l0.6406892,0.7570394", "l0.6408489,0.7563163", "l0.6410619,0.7556267", "l0.6415766,0.7527003", "l0.6415944,0.7519099", "l0.6410974,0.7491181", "l0.6401567,0.7465112", "l0.6388611,0.7445435", "l0.6356486,0.7436689", "l0.6238989,0.7442576", "l0.6297737,0.7341666", "l0.6307677,0.7301639", "l0.6300045,0.7242102", "l0.6303417,0.7229993", "l0.6360035,0.7178866", "l0.6402632,0.7147752", "l0.6431740,0.7151284", "l0.6516047,0.7192489", "l0.6595561,0.7229489", "l0.6632123,0.7237561", "l0.6765061,0.7239916", "l0.6802866,0.7231171", "l0.6952666,0.7116638", "l0.7000765,0.7103520", "l0.7021176,0.7104025", "l0.7075487,0.7119666", "l0.7109742,0.7141866", "l0.7150209,0.7141866", "l0.7272498,0.7102511", "l0.7311367,0.7114116", "l0.7321307,0.7126561", "l0.7337281,0.7136988", "l0.7355917,0.7136148", "l0.7385380,0.7126897", "l0.7400644,0.7115125", "l0.7412180,0.7102679", "l0.7424959,0.7084179", "l0.7435076,0.7074929", "l0.7451760,0.7063997", "l0.7506604,0.7037424", "l0.7525417,0.7032211", "l0.7538551,0.7030361", "l0.7544941,0.7032884", "l0.7549555,0.7036079", "l0.7553993,0.7039947", "l0.7558075,0.7044320", "l0.7561802,0.7049534", "l0.7571386,0.7066352", "l0.7578663,0.7083338", "l0.7581858,0.7088888", "l0.7584343,0.7094438", "l0.7587893,0.7099988", "l0.7595702,0.7116638", "l0.7596412,0.7118488", "c"]}, {"n": "Izabal", "u": "GT-IZ", "i": ["m0.9999058,0.5137636", "l0.9999058,0.5137636", "l0.9969950,0.5147895", "l0.9962318,0.5169927", "l0.9964271,0.5196500", "l0.9947764,0.5228959", "l0.9932501,0.5210795", "l0.9889726,0.5228118", "l0.9853164,0.5247291", "l0.9813761,0.5261250", "l0.9761403,0.5262259", "l0.9747559,0.5280255", "l0.9672482,0.5403196", "l0.9557115,0.5510833", "l0.9387437,0.5637810", "l0.9306503,0.5698356", "l0.9306503,0.5698524", "l0.9089791,0.5858466", "l0.8874321,0.6017566", "l0.8659206,0.6176331", "l0.8445512,0.6333917", "l0.8131891,0.6565168", "l0.8045455,0.6604018", "l0.7793423,0.6684241", "l0.7717281,0.6720905", "l0.7701307,0.6733351", "l0.7700065,0.6732510", "l0.7693320,0.6727464", "l0.7675394,0.6719896", "l0.7664567,0.6712496", "l0.7616291,0.6657164", "l0.7611321,0.6643541", "l0.7596590,0.6574923", "l0.7592862,0.6536577", "l0.7594460,0.6513200", "l0.7593572,0.6498063", "l0.7574226,0.6420700", "l0.7574049,0.6404554", "l0.7576711,0.6394631", "l0.7607771,0.6382859", "l0.7617888,0.6375963", "l0.7622325,0.6372263", "l0.7626585,0.6367218", "l0.7632620,0.6356454", "l0.7634927,0.6350904", "l0.7637767,0.6335095", "l0.7643269,0.6274045", "l0.7642026,0.6258404", "l0.7640252,0.6251676", "l0.7636169,0.6244108", "l0.7630312,0.6235699", "l0.7618066,0.6223085", "l0.7610079,0.6216526", "l0.7602979,0.6211985", "l0.7545296,0.6182049", "l0.7520448,0.6176331", "l0.7444483,0.6169267", "l0.7386800,0.6181040", "l0.7350947,0.6198026", "l0.7286164,0.6244108", "l0.6995795,0.6355613", "l0.6701876,0.6449795", "l0.6664959,0.6457532", "l0.6563613,0.6468968", "l0.6519064,0.6408590", "l0.6508060,0.6385718", "l0.6503268,0.6372936", "l0.6502735,0.6362508", "l0.6503268,0.6349054", "l0.6511255,0.6308858", "l0.6511432,0.6296413", "l0.6509302,0.6286322", "l0.6495281,0.6262944", "l0.6478774,0.6241417", "l0.6472740,0.6230822", "l0.6462623,0.6207276", "l0.6460493,0.6198867", "l0.6459961,0.6162371", "l0.6482147,0.5876629", "l0.6486229,0.5872089", "l0.6501315,0.5861157", "l0.6548349,0.5839629", "l0.6553497,0.5836098", "l0.6557934,0.5831893", "l0.6562371,0.5826848", "l0.6565743,0.5821970", "l0.6571600,0.5810534", "l0.6578700,0.5783456", "l0.6583314,0.5771179", "l0.6586332,0.5765293", "l0.6606743,0.5734347", "l0.6603193,0.5724761", "l0.6594319,0.5711474", "l0.6561838,0.5683220", "l0.6540185,0.5660515", "l0.6520484,0.5632429", "l0.6465640,0.5576424", "l0.6456233,0.5561624", "l0.6452684,0.5557251", "l0.6447714,0.5552037", "l0.6442744,0.5548169", "l0.6431740,0.5541778", "l0.6424996,0.5539928", "l0.6443277,0.5498892", "l0.6582427,0.5311032", "l0.6738793,0.5101477", "l0.6744295,0.5089199", "l0.6749443,0.5083145", "l0.6756720,0.5078099", "l0.6782455,0.5070531", "l0.6795412,0.5064477", "l0.6836766,0.5036558", "l0.6862679,0.5025458", "l0.6871554,0.5018899", "l0.6881138,0.5006790", "l0.6911311,0.4954485", "l0.6913796,0.4948094", "l0.6926397,0.4925894", "l0.6932432,0.4921185", "l0.6941129,0.4916813", "l0.6989228,0.4912103", "l0.7014609,0.4892931", "l0.7082586,0.4806317", "l0.7111694,0.4790003", "l0.7121456,0.4780921", "l0.7125716,0.4772680", "l0.7128733,0.4764607", "l0.7133170,0.4747621", "l0.7149144,0.4707594", "l0.7177720,0.4680012", "l0.7405968,0.4675639", "l0.7464184,0.4683375", "l0.7476963,0.4692625", "l0.7478738,0.4694307", "l0.7480335,0.4695653", "l0.7479093,0.4726430", "l0.7499682,0.4758385", "l0.7505184,0.4750648", "l0.7528612,0.4739380", "l0.7557720,0.4730130", "l0.7580261,0.4728953", "l0.7625698,0.4710957", "l0.7815609,0.4719366", "l0.7886426,0.4707930", "l0.7965941,0.4707425", "l0.8185315,0.4761412", "l0.8279383,0.4726430", "l0.8313993,0.4741230", "l0.8397945,0.4808503", "l0.8483849,0.4788321", "l0.8593536,0.4811699", "l0.8678197,0.4858790", "l0.8687604,0.4910085", "l0.8743868,0.4918999", "l0.8993947,0.5068681", "l0.8963420,0.5178841", "l0.8968567,0.5195154", "l0.9035479,0.5195154", "l0.9062458,0.5185400", "l0.9070444,0.5164377", "l0.9067605,0.5146213", "l0.9061748,0.5143522", "l0.9061038,0.5133431", "l0.9052518,0.5124854", "l0.9044531,0.5113418", "l0.9044886,0.5095086", "l0.9057310,0.5091386", "l0.9080384,0.5093909", "l0.9102747,0.5090377", "l0.9112509,0.5068681", "l0.9122093,0.5029327", "l0.9144102,0.5002586", "l0.9167530,0.4981731", "l0.9181907,0.4960204", "l0.9184924,0.4922531", "l0.9165933,0.4864676", "l0.9163448,0.4826667", "l0.9181907,0.4826667", "l0.9180842,0.4852230", "l0.9181907,0.4860135", "l0.9197348,0.4860135", "l0.9226811,0.4841635", "l0.9299048,0.4854921", "l0.9334191,0.4841803", "l0.9276862,0.4790844", "l0.9245092,0.4767803", "l0.9199123,0.4747789", "l0.9179954,0.4723403", "l0.9163448,0.4695484", "l0.9146409,0.4674966", "l0.9039739,0.4617616", "l0.9009211,0.4581289", "l0.9044886,0.4541261", "l0.9082691,0.4562452", "l0.9153154,0.4591716", "l0.9181907,0.4608030", "l0.9253966,0.4680348", "l0.9305970,0.4708939", "l0.9435891,0.4812539", "l0.9691650,0.4926735", "l0.9775424,0.4998886", "l0.9801870,0.5010154", "l0.9911202,0.5101645", "l0.9997461,0.5136963", "l0.9999058,0.5137636", "l0.9999058,0.5137636", "c"]}, {"n": "Santa Rosa", "u": "GT-SR", "i": ["m0.5456092,0.8284161", "l0.5456092,0.8284161", "l0.5411188,0.8417697", "l0.5376401,0.8421397", "l0.5384032,0.8467479", "l0.5381193,0.8475048", "l0.5375691,0.8477402", "l0.5363266,0.8473198", "l0.5351197,0.8467648", "l0.5323864,0.8466302", "l0.5237428,0.8482448", "l0.5232103,0.8486484", "l0.5199091,0.8513561", "l0.5110702,0.8722276", "l0.5146554,0.8746999", "l0.5261566,0.8777944", "l0.5275765,0.8783494", "l0.5285350,0.8790726", "l0.5302566,0.8807376", "l0.5379595,0.8867754", "l0.5440118,0.8924095", "l0.5452188,0.8948313", "l0.5448460,0.9001290", "l0.5459820,0.9097659", "l0.5459465,0.9104891", "l0.5456980,0.9119186", "l0.5449880,0.9139873", "l0.5436746,0.9166782", "l0.5393617,0.9225309", "l0.5379418,0.9240109", "l0.5373738,0.9242296", "l0.5340371,0.9248182", "l0.5311795,0.9256087", "l0.5297774,0.9263991", "l0.5289077,0.9270046", "l0.5273458,0.9297123", "l0.5234766,0.9366246", "l0.5196073,0.9391810", "l0.5187909,0.9393155", "l0.5177615,0.9393828", "l0.5152766,0.9384410", "l0.5055326,0.9362042", "l0.5042547,0.9357164", "l0.4994625,0.9318819", "l0.4924873,0.9280473", "l0.4879791,0.9292414", "l0.4864527,0.9303346", "l0.4860977,0.9311923", "l0.4858137,0.9325714", "l0.4858670,0.9338496", "l0.4860267,0.9347242", "l0.4868787,0.9364733", "l0.4876951,0.9374487", "l0.4889375,0.9386933", "l0.4893457,0.9396855", "l0.4911384,0.9496756", "l0.4914223,0.9502642", "l0.4918483,0.9507015", "l0.4923453,0.9510378", "l0.4936054,0.9516097", "l0.4943331,0.9527533", "l0.4951673,0.9547042", "l0.4975812,0.9631638", "l0.5007759,0.9686634", "l0.5012019,0.9698911", "l0.5013794,0.9710516", "l0.5012906,0.9754075", "l0.4996755,0.9814284", "l0.4987881,0.9847248", "l0.4975457,0.9842371", "l0.4589422,0.9678056", "l0.4343602,0.9590601", "l0.4144638,0.9545529", "l0.4028207,0.9527701", "l0.4028029,0.9500960", "l0.4028739,0.9200082", "l0.4033886,0.9187973", "l0.4044358,0.9177546", "l0.4072224,0.9170650", "l0.4099912,0.9166614", "l0.4107544,0.9163082", "l0.4113401,0.9159550", "l0.4120855,0.9135836", "l0.4139669,0.9101695", "l0.4152093,0.9089922", "l0.4184928,0.9071591", "l0.4194157,0.9063854", "l0.4201612,0.9054268", "l0.4204807,0.9049054", "l0.4203742,0.9041150", "l0.4198949,0.9031059", "l0.4163097,0.8999272", "l0.4158482,0.8994227", "l0.4149608,0.8978249", "l0.4149253,0.8944613", "l0.4165937,0.8937213", "l0.4211729,0.8930486", "l0.4218118,0.8927795", "l0.4234092,0.8918040", "l0.4274559,0.8881881", "l0.4305264,0.8844544", "l0.4303667,0.8837481", "l0.4297632,0.8829240", "l0.4275979,0.8819317", "l0.4264797,0.8817299", "l0.4255035,0.8817972", "l0.4216698,0.8831594", "l0.4209421,0.8832772", "l0.4193447,0.8833276", "l0.4177474,0.8832267", "l0.4143751,0.8826212", "l0.4133457,0.8823017", "l0.4127777,0.8820494", "l0.4124227,0.8813094", "l0.4123695,0.8801321", "l0.4131504,0.8775085", "l0.4146591,0.8747839", "l0.4182976,0.8714203", "l0.4253971,0.8689985", "l0.4273139,0.8677707", "l0.4320173,0.8636166", "l0.4368095,0.8614471", "l0.4387796,0.8607407", "l0.4402350,0.8604380", "l0.4408740,0.8602194", "l0.4413177,0.8599166", "l0.4433765,0.8575284", "l0.4441397,0.8569062", "l0.4449207,0.8564521", "l0.4455951,0.8562334", "l0.4461631,0.8559475", "l0.4466778,0.8555943", "l0.4471215,0.8552075", "l0.4483462,0.8538789", "l0.4487011,0.8508516", "l0.4473877,0.8394656", "l0.4519314,0.8284161", "l0.4621369,0.8130946", "l0.4663434,0.8112615", "l0.4673551,0.8111774", "l0.4692364,0.8116651", "l0.4698931,0.8123042", "l0.4703723,0.8130442", "l0.4707628,0.8159706", "l0.4709758,0.8165928", "l0.4712598,0.8171142", "l0.4716858,0.8175683", "l0.4728039,0.8172992", "l0.4744191,0.8163406", "l0.4791580,0.8122369", "l0.4805246,0.8108242", "l0.4825657,0.8101178", "l0.4847488,0.8101178", "l0.4877129,0.8087892", "l0.4908189,0.8119174", "l0.4913159,0.8125733", "l0.4922743,0.8132460", "l0.4928067,0.8135319", "l0.4962500,0.8130946", "l0.4994448,0.8125228", "l0.5267246,0.8076287", "l0.5279847,0.8133469", "l0.5302033,0.8166937", "l0.5390422,0.8236397", "l0.5456092,0.8284161", "c"]}, {"n": "El Progreso", "u": "GT-PR", "i": ["m0.5996719,0.7207457", "l0.5996719,0.7207457", "l0.5957849,0.7204766", "l0.5925901,0.7205943", "l0.5911525,0.7208802", "l0.5897503,0.7214184", "l0.5863958,0.7243112", "l0.5777344,0.7346544", "l0.5704930,0.7383880", "l0.5630030,0.7410117", "l0.5546433,0.7419535", "l0.5489105,0.7435849", "l0.5411720,0.7572749", "l0.5402491,0.7582335", "l0.5390954,0.7587885", "l0.5371076,0.7581663", "l0.5340726,0.7567535", "l0.5303098,0.7563163", "l0.5219502,0.7589904", "l0.5154186,0.7613786", "l0.5144247,0.7619840", "l0.5139987,0.7626736", "l0.5137325,0.7642545", "l0.5127741,0.7668613", "l0.5087984,0.7690309", "l0.5070412,0.7697540", "l0.5065975,0.7699222", "l0.5039530,0.7690813", "l0.5012374,0.7660708", "l0.4997465,0.7648599", "l0.4963920,0.7632622", "l0.4819268,0.7582504", "l0.4796017,0.7565517", "l0.4744013,0.7512708", "l0.4733009,0.7492694", "l0.4730524,0.7487144", "l0.4729637,0.7476717", "l0.4732654,0.7465449", "l0.4742771,0.7448462", "l0.4752887,0.7435344", "l0.4756437,0.7431980", "l0.4759455,0.7427776", "l0.4763182,0.7407930", "l0.4753775,0.7348562", "l0.4731234,0.7287512", "l0.4719875,0.7265480", "l0.4715970,0.7260098", "l0.4698044,0.7254043", "l0.4641248,0.7258080", "l0.4606460,0.7267498", "l0.4590842,0.7269012", "l0.4575578,0.7266825", "l0.4569188,0.7264471", "l0.4563863,0.7261275", "l0.4559249,0.7257575", "l0.4554812,0.7252025", "l0.4551084,0.7244121", "l0.4548600,0.7230666", "l0.4548600,0.7221248", "l0.4555699,0.7210989", "l0.4561911,0.7204766", "l0.4592439,0.7152629", "l0.4623677,0.7181389", "l0.4705676,0.7195348", "l0.4832047,0.7175670", "l0.4844293,0.7136484", "l0.4883696,0.7017747", "l0.5277363,0.6757905", "l0.5489282,0.6622687", "l0.5584948,0.6560964", "l0.5651683,0.6525814", "l0.5773795,0.6539100", "l0.5814972,0.6535905", "l0.5887564,0.6517741", "l0.5979148,0.6642869", "l0.6089545,0.6801633", "l0.6092029,0.6834428", "l0.5972048,0.6836783", "l0.5960156,0.6838296", "l0.5950217,0.6841996", "l0.5952524,0.6851583", "l0.5959269,0.6863187", "l0.6068424,0.7006143", "l0.6088125,0.7032884", "l0.6118475,0.7048188", "l0.6150245,0.7052393", "l0.6162847,0.7059793", "l0.6168881,0.7067529", "l0.6163734,0.7115629", "l0.6158765,0.7127066", "l0.6148825,0.7131102", "l0.6136756,0.7133120", "l0.6083510,0.7134634", "l0.6052272,0.7147752", "l0.5996719,0.7207457", "c"]}, {"n": "Totonicapán", "u": "GT-TO", "i": ["m0.2321133,0.6265972", "l0.2321133,0.6265972", "l0.2309597,0.6334086", "l0.2309242,0.6378318", "l0.2321488,0.6415990", "l0.2355034,0.6431800", "l0.2362843,0.6448618", "l0.2431886,0.6516227", "l0.2448924,0.6523291", "l0.2461171,0.6570886", "l0.2485487,0.6603682", "l0.2488859,0.6637487", "l0.2506075,0.6642869", "l0.2521517,0.6670282", "l0.2521694,0.6682896", "l0.2519387,0.6707451", "l0.2513707,0.6717037", "l0.2506430,0.6722082", "l0.2480340,0.6722587", "l0.2469868,0.6725110", "l0.2457266,0.6730323", "l0.2437210,0.6745292", "l0.2429046,0.6756728", "l0.2423189,0.6772705", "l0.2421236,0.6791542", "l0.2421591,0.6799110", "l0.2422656,0.6806342", "l0.2425673,0.6812228", "l0.2429933,0.6816769", "l0.2456556,0.6832915", "l0.2500573,0.6864533", "l0.2505543,0.6871765", "l0.2512465,0.6884210", "l0.2524001,0.6927601", "l0.2541395,0.6953838", "l0.2582040,0.6981083", "l0.2589317,0.6994538", "l0.2590204,0.7009843", "l0.2576360,0.7050206", "l0.2570858,0.7065511", "l0.2649485,0.7124375", "l0.2601031,0.7170457", "l0.2568018,0.7215361", "l0.2533763,0.7247484", "l0.2506430,0.7255557", "l0.2492941,0.7258080", "l0.2476790,0.7257743", "l0.2468980,0.7256734", "l0.2429578,0.7244289", "l0.2412007,0.7241262", "l0.2377929,0.7241262", "l0.2326813,0.7262116", "l0.2309064,0.7260098", "l0.2294865,0.7254043", "l0.2272147,0.7247989", "l0.2214996,0.7239580", "l0.2185533,0.7243616", "l0.2163880,0.7250512", "l0.2050465,0.7342339", "l0.2040881,0.7350580", "l0.1992072,0.7269516", "l0.1965094,0.7245971", "l0.1957462,0.7172979", "l0.1936163,0.7125552", "l0.1883627,0.7127570", "l0.1835528,0.7132952", "l0.1818667,0.7127570", "l0.1814940,0.7122525", "l0.1811745,0.7117479", "l0.1772343,0.7073247", "l0.1767728,0.7056934", "l0.1767905,0.7041797", "l0.1772875,0.7028847", "l0.1773585,0.7000424", "l0.1732053,0.6964770", "l0.1713594,0.6941224", "l0.1703832,0.6905738", "l0.1642777,0.6684410", "l0.1629998,0.6614109", "l0.1634967,0.6594096", "l0.1640470,0.6590732", "l0.1645972,0.6588041", "l0.1772875,0.6540614", "l0.1816182,0.6527159", "l0.1899779,0.6522954", "l0.1909008,0.6518918", "l0.1919835,0.6513032", "l0.1921432,0.6505463", "l0.1926934,0.6444245", "l0.1928709,0.6437854", "l0.1943440,0.6410440", "l0.1976098,0.6364695", "l0.1984972,0.6355613", "l0.1997397,0.6349727", "l0.2022245,0.6343167", "l0.2129802,0.6319454", "l0.2168317,0.6292376", "l0.2228130,0.6266813", "l0.2257238,0.6261767", "l0.2321133,0.6265972", "c"]}, {"n": "Sololá", "u": "GT-SO", "i": ["m0.2795557,0.7376312", "l0.2795557,0.7376312", "l0.2803012,0.7375976", "l0.2809401,0.7373789", "l0.2814548,0.7370426", "l0.2818275,0.7365885", "l0.2821825,0.7361007", "l0.2824488,0.7355457", "l0.2834249,0.7322494", "l0.2845786,0.7315766", "l0.2886608,0.7329725", "l0.2892820,0.7345366", "l0.2932755,0.7527676", "l0.2916426,0.7574935", "l0.2914651,0.7583513", "l0.2919621,0.7635649", "l0.2868682,0.7751695", "l0.2848626,0.7778436", "l0.2841171,0.7800804", "l0.2840994,0.7855127", "l0.2820405,0.8048705", "l0.2723675,0.7978069", "l0.2690662,0.7958391", "l0.2666701,0.7949982", "l0.2652147,0.7947459", "l0.2626589,0.7946787", "l0.2604758,0.7949478", "l0.2535893,0.7983955", "l0.2479807,0.7991523", "l0.2472885,0.7987991", "l0.2465431,0.7983114", "l0.2464188,0.7976219", "l0.2464366,0.7968819", "l0.2470223,0.7941405", "l0.2471110,0.7934005", "l0.2470400,0.7911468", "l0.2466496,0.7891623", "l0.2461881,0.7881532", "l0.2450699,0.7868750", "l0.2378639,0.7807868", "l0.2352726,0.7781295", "l0.2345449,0.7779277", "l0.2336220,0.7777763", "l0.2308177,0.7783650", "l0.2252623,0.7788359", "l0.2250493,0.7787013", "l0.2222273,0.7755227", "l0.2185178,0.7738577", "l0.2166010,0.7736895", "l0.2150923,0.7741604", "l0.2142226,0.7746145", "l0.2130157,0.7754218", "l0.2123413,0.7760609", "l0.2119508,0.7767336", "l0.2117200,0.7774232", "l0.2116491,0.7781295", "l0.2118265,0.7811904", "l0.2116136,0.7830573", "l0.2103711,0.7863873", "l0.2070521,0.7855127", "l0.1957462,0.7840327", "l0.1921077,0.7807195", "l0.1979825,0.7699895", "l0.1991717,0.7665754", "l0.1991007,0.7657513", "l0.1988167,0.7644058", "l0.1957284,0.7565854", "l0.1950185,0.7554585", "l0.1938116,0.7540458", "l0.2010708,0.7445939", "l0.2040881,0.7350580", "l0.2050465,0.7342339", "l0.2163880,0.7250512", "l0.2185533,0.7243616", "l0.2214996,0.7239580", "l0.2272147,0.7247989", "l0.2294865,0.7254043", "l0.2309064,0.7260098", "l0.2326813,0.7262116", "l0.2377929,0.7241262", "l0.2412007,0.7241262", "l0.2429578,0.7244289", "l0.2468980,0.7256734", "l0.2476790,0.7257743", "l0.2492941,0.7258080", "l0.2506430,0.7255557", "l0.2533763,0.7247484", "l0.2568018,0.7215361", "l0.2601031,0.7170457", "l0.2649485,0.7124375", "l0.2679835,0.7137829", "l0.2692437,0.7170289", "l0.2715865,0.7210316", "l0.2731129,0.7221248", "l0.2738229,0.7222425", "l0.2745151,0.7222593", "l0.2755800,0.7224443", "l0.2769289,0.7227807", "l0.2798219,0.7238234", "l0.2809401,0.7246307", "l0.2814016,0.7254043", "l0.2812596,0.7260098", "l0.2806029,0.7271703", "l0.2798752,0.7281793", "l0.2778163,0.7303321", "l0.2774969,0.7308703", "l0.2772839,0.7318289", "l0.2772839,0.7331239", "l0.2776388,0.7357476", "l0.2781536,0.7368744", "l0.2788280,0.7375471", "l0.2795557,0.7376312", "c"]}, {"n": "Sacatepéquez", "u": "GT-SA", "i": ["m0.3823741,0.7521285", "l0.3823741,0.7521285", "l0.3853914,0.7516408", "l0.3861546,0.7516576", "l0.3868823,0.7518090", "l0.3893849,0.7540626", "l0.3968748,0.7631781", "l0.3990579,0.7701240", "l0.4023769,0.7737568", "l0.4047730,0.7764141", "l0.4050925,0.7769522", "l0.4052345,0.7787854", "l0.4038856,0.7832086", "l0.4043826,0.7860509", "l0.4023060,0.7882709", "l0.4010103,0.7912309", "l0.3992177,0.8107401", "l0.3970701,0.8198556", "l0.3811495,0.8258429", "l0.3783984,0.8202088", "l0.3780257,0.8196706", "l0.3770850,0.8190315", "l0.3754166,0.8195024", "l0.3741920,0.8213019", "l0.3727543,0.8221429", "l0.3691513,0.8221429", "l0.3670037,0.8232865", "l0.3665423,0.8236060", "l0.3659743,0.8241106", "l0.3648029,0.8255570", "l0.3635782,0.8276929", "l0.3631877,0.8281806", "l0.3615194,0.8299970", "l0.3549701,0.8353452", "l0.3537809,0.8345884", "l0.3522190,0.8328729", "l0.3491307,0.8279956", "l0.3472316,0.8241779", "l0.3470719,0.8235051", "l0.3468234,0.8229165", "l0.3448178,0.8208815", "l0.3375231,0.8148606", "l0.3374343,0.8145746", "l0.3372923,0.8131787", "l0.3386235,0.8065019", "l0.3440014,0.7966632", "l0.3551831,0.7848400", "l0.3614484,0.7805177", "l0.3647496,0.7737063", "l0.3662405,0.7719236", "l0.3669682,0.7707295", "l0.3670392,0.7696363", "l0.3669682,0.7681563", "l0.3662050,0.7638340", "l0.3653886,0.7615299", "l0.3640042,0.7544999", "l0.3647319,0.7514558", "l0.3686011,0.7447285", "l0.3743872,0.7497235", "l0.3776530,0.7515567", "l0.3800135,0.7520444", "l0.3823741,0.7521285", "c"]}, {"n": "Suchitepéquez", "u": "GT-SU", "i": ["m0.2103711,0.7863873", "l0.2103711,0.7863873", "l0.2116136,0.7830573", "l0.2118265,0.7811904", "l0.2116491,0.7781295", "l0.2117200,0.7774232", "l0.2119508,0.7767336", "l0.2123413,0.7760609", "l0.2130157,0.7754218", "l0.2142226,0.7746145", "l0.2150923,0.7741604", "l0.2166010,0.7736895", "l0.2185178,0.7738577", "l0.2222273,0.7755227", "l0.2250493,0.7787013", "l0.2252623,0.7788359", "l0.2308177,0.7783650", "l0.2336220,0.7777763", "l0.2345449,0.7779277", "l0.2352726,0.7781295", "l0.2378639,0.7807868", "l0.2450699,0.7868750", "l0.2461881,0.7881532", "l0.2466496,0.7891623", "l0.2470400,0.7911468", "l0.2471110,0.7934005", "l0.2470223,0.7941405", "l0.2464366,0.7968819", "l0.2464188,0.7976219", "l0.2465431,0.7983114", "l0.2472885,0.7987991", "l0.2479807,0.7991523", "l0.2535893,0.7983955", "l0.2604758,0.7949478", "l0.2626589,0.7946787", "l0.2652147,0.7947459", "l0.2666701,0.7949982", "l0.2690662,0.7958391", "l0.2723675,0.7978069", "l0.2820405,0.8048705", "l0.2837622,0.8063673", "l0.2853418,0.8079987", "l0.2862292,0.8091087", "l0.2866907,0.8114801", "l0.2862470,0.8169460", "l0.2862470,0.8201247", "l0.2827327,0.8291561", "l0.2757220,0.8428629", "l0.2740891,0.8470002", "l0.2733792,0.8586216", "l0.2731129,0.8599839", "l0.2727757,0.8609425", "l0.2716398,0.8625234", "l0.2694389,0.8666439", "l0.2679125,0.8675857", "l0.2389644,0.8655507", "l0.2373847,0.8651807", "l0.2386271,0.8593616", "l0.2359293,0.8568389", "l0.2314034,0.8616153", "l0.2293978,0.8627757", "l0.2269307,0.8628430", "l0.2253156,0.8625907", "l0.2243571,0.8622039", "l0.2231147,0.8614807", "l0.2220498,0.8605221", "l0.2215351,0.8597484", "l0.2212866,0.8590421", "l0.2212156,0.8583357", "l0.2212866,0.8576125", "l0.2218013,0.8555943", "l0.2217658,0.8548207", "l0.2215174,0.8540471", "l0.2203104,0.8524661", "l0.2199555,0.8518607", "l0.2197247,0.8512889", "l0.2197247,0.8506161", "l0.2199022,0.8499770", "l0.2201507,0.8494052", "l0.2219611,0.8468657", "l0.2219256,0.8459407", "l0.2214641,0.8447466", "l0.2198667,0.8423752", "l0.2187840,0.8415847", "l0.2178256,0.8412147", "l0.2158023,0.8418370", "l0.2146486,0.8424257", "l0.2075846,0.8473702", "l0.2066972,0.8482279", "l0.2063599,0.8487325", "l0.2058452,0.8498761", "l0.2053128,0.8519111", "l0.2052418,0.8534248", "l0.2053838,0.8549552", "l0.2058097,0.8570743", "l0.2062889,0.8582853", "l0.2074781,0.8604380", "l0.2077088,0.8610266", "l0.2077798,0.8616489", "l0.2072829,0.8623553", "l0.2064487,0.8630448", "l0.2047093,0.8640371", "l0.2036799,0.8642725", "l0.2030054,0.8640707", "l0.2026682,0.8635494", "l0.2020292,0.8616825", "l0.2011596,0.8605557", "l0.1992072,0.8592271", "l0.1966336,0.8607407", "l0.1962609,0.8615480", "l0.1958172,0.8632130", "l0.1956752,0.8661562", "l0.1957994,0.8681071", "l0.1967401,0.8738421", "l0.1973081,0.8836135", "l0.1969886,0.8875154", "l0.1954622,0.8894495", "l0.1941666,0.8906940", "l0.1929774,0.8925272", "l0.1909540,0.8967318", "l0.1789026,0.9136341", "l0.1783702,0.9149795", "l0.1781394,0.9161064", "l0.1789736,0.9198568", "l0.1792221,0.9218414", "l0.1792576,0.9221273", "l0.1734183,0.9196718", "l0.1522795,0.9082354", "l0.1469727,0.9051072", "l0.1467774,0.9031395", "l0.1453043,0.8934522", "l0.1523860,0.8834622", "l0.1526523,0.8829240", "l0.1529362,0.8813935", "l0.1534510,0.8734217", "l0.1546046,0.8661898", "l0.1576929,0.8572425", "l0.1605150,0.8532566", "l0.1607102,0.8521466", "l0.1608344,0.8505657", "l0.1606747,0.8473366", "l0.1618106,0.8315443", "l0.1616686,0.8297447", "l0.1585271,0.8244133", "l0.1580301,0.8232024", "l0.1576574,0.8219410", "l0.1574622,0.8204778", "l0.1594323,0.8062496", "l0.1593258,0.8055433", "l0.1593080,0.8047528", "l0.1594145,0.8032392", "l0.1692118,0.7841841", "l0.1690698,0.7817959", "l0.1688746,0.7787013", "l0.1690166,0.7759600", "l0.1691763,0.7752704", "l0.1699395,0.7737904", "l0.1705962,0.7728318", "l0.1762226,0.7667940", "l0.1836948,0.7605208", "l0.1938116,0.7540458", "l0.1950185,0.7554585", "l0.1957284,0.7565854", "l0.1988167,0.7644058", "l0.1991007,0.7657513", "l0.1991717,0.7665754", "l0.1979825,0.7699895", "l0.1921077,0.7807195", "l0.1957462,0.7840327", "l0.2070521,0.7855127", "l0.2103711,0.7863873", "c"]}, {"n": "Guatemala", "u": "GT-GU", "i": ["m0.4592439,0.7152629", "l0.4592439,0.7152629", "l0.4561911,0.7204766", "l0.4555699,0.7210989", "l0.4548600,0.7221248", "l0.4548600,0.7230666", "l0.4551084,0.7244121", "l0.4554812,0.7252025", "l0.4559249,0.7257575", "l0.4563863,0.7261275", "l0.4569188,0.7264471", "l0.4575578,0.7266825", "l0.4590842,0.7269012", "l0.4606460,0.7267498", "l0.4641248,0.7258080", "l0.4698044,0.7254043", "l0.4715970,0.7260098", "l0.4719875,0.7265480", "l0.4731234,0.7287512", "l0.4753775,0.7348562", "l0.4763182,0.7407930", "l0.4759455,0.7427776", "l0.4756437,0.7431980", "l0.4752887,0.7435344", "l0.4742771,0.7448462", "l0.4732654,0.7465449", "l0.4729637,0.7476717", "l0.4730524,0.7487144", "l0.4733009,0.7492694", "l0.4744013,0.7512708", "l0.4796017,0.7565517", "l0.4819268,0.7582504", "l0.4963920,0.7632622", "l0.4997465,0.7648599", "l0.5012374,0.7660708", "l0.5039530,0.7690813", "l0.5065975,0.7699222", "l0.5043434,0.7753377", "l0.5031898,0.7770700", "l0.5027105,0.7774568", "l0.5005984,0.7787350", "l0.4925228,0.7851764", "l0.4910851,0.7909282", "l0.4909609,0.7947459", "l0.4903219,0.7967305", "l0.4897185,0.7978405", "l0.4887423,0.7985805", "l0.4883341,0.8000773", "l0.4881211,0.8012714", "l0.4877129,0.8087892", "l0.4847488,0.8101178", "l0.4825657,0.8101178", "l0.4805246,0.8108242", "l0.4791580,0.8122369", "l0.4744191,0.8163406", "l0.4728039,0.8172992", "l0.4716858,0.8175683", "l0.4712598,0.8171142", "l0.4709758,0.8165928", "l0.4707628,0.8159706", "l0.4703723,0.8130442", "l0.4698931,0.8123042", "l0.4692364,0.8116651", "l0.4673551,0.8111774", "l0.4663434,0.8112615", "l0.4621369,0.8130946", "l0.4519314,0.8284161", "l0.4473877,0.8394656", "l0.4487011,0.8508516", "l0.4483462,0.8538789", "l0.4471215,0.8552075", "l0.4466778,0.8555943", "l0.4461631,0.8559475", "l0.4455951,0.8562334", "l0.4449207,0.8564521", "l0.4441397,0.8569062", "l0.4433765,0.8575284", "l0.4413177,0.8599166", "l0.4408740,0.8602194", "l0.4402350,0.8604380", "l0.4387796,0.8607407", "l0.4368095,0.8614471", "l0.4320173,0.8636166", "l0.4273139,0.8677707", "l0.4253971,0.8689985", "l0.4182976,0.8714203", "l0.4167889,0.8661730", "l0.4137716,0.8595130", "l0.4129907,0.8566202", "l0.4131859,0.8485811", "l0.4115530,0.8361020", "l0.4105059,0.8328729", "l0.4099024,0.8326206", "l0.4091570,0.8325197", "l0.4059267,0.8326038", "l0.4038856,0.8319479", "l0.4002471,0.8288870", "l0.3970701,0.8198556", "l0.3992177,0.8107401", "l0.4010103,0.7912309", "l0.4023060,0.7882709", "l0.4043826,0.7860509", "l0.4038856,0.7832086", "l0.4052345,0.7787854", "l0.4050925,0.7769522", "l0.4047730,0.7764141", "l0.4023769,0.7737568", "l0.3990579,0.7701240", "l0.3968748,0.7631781", "l0.3893849,0.7540626", "l0.3868823,0.7518090", "l0.3861546,0.7516576", "l0.3853914,0.7516408", "l0.3823741,0.7521285", "l0.3800135,0.7520444", "l0.3776530,0.7515567", "l0.3743872,0.7497235", "l0.3686011,0.7447285", "l0.3731448,0.7381021", "l0.3754521,0.7308198", "l0.3768898,0.7284316", "l0.3779369,0.7275739", "l0.3789841,0.7268843", "l0.3795698,0.7266153", "l0.3802265,0.7265143", "l0.3809542,0.7265648", "l0.3815754,0.7268171", "l0.3825516,0.7267162", "l0.3837763,0.7262452", "l0.3875568,0.7234198", "l0.3887459,0.7227471", "l0.3914970,0.7218725", "l0.3926151,0.7211157", "l0.3934848,0.7203757", "l0.3939463,0.7197198", "l0.3942658,0.7191480", "l0.3945143,0.7184416", "l0.3946563,0.7178361", "l0.3953130,0.7140688", "l0.4041518,0.7171466", "l0.4078436,0.7164739", "l0.4097427,0.7184920", "l0.4110561,0.7190302", "l0.4121033,0.7187275", "l0.4132214,0.7181389", "l0.4147656,0.7181389", "l0.4185460,0.7186939", "l0.4247759,0.7174661", "l0.4310944,0.7153302", "l0.4351056,0.7131438", "l0.4369515,0.7131438", "l0.4381406,0.7153807", "l0.4400043,0.7164402", "l0.4424003,0.7166925", "l0.4452579,0.7164739", "l0.4485414,0.7156498", "l0.4495531,0.7144388", "l0.4501388,0.7130429", "l0.4521976,0.7116302", "l0.4562266,0.7108902", "l0.4581612,0.7124038", "l0.4592439,0.7152629", "c"]}, {"n": "Escuintla", "u": "GT-ES", "i": ["m0.3549701,0.8353452", "l0.3549701,0.8353452", "l0.3615194,0.8299970", "l0.3631877,0.8281806", "l0.3635782,0.8276929", "l0.3648029,0.8255570", "l0.3659743,0.8241106", "l0.3665423,0.8236060", "l0.3670037,0.8232865", "l0.3691513,0.8221429", "l0.3727543,0.8221429", "l0.3741920,0.8213019", "l0.3754166,0.8195024", "l0.3770850,0.8190315", "l0.3780257,0.8196706", "l0.3783984,0.8202088", "l0.3811495,0.8258429", "l0.3970701,0.8198556", "l0.4002471,0.8288870", "l0.4038856,0.8319479", "l0.4059267,0.8326038", "l0.4091570,0.8325197", "l0.4099024,0.8326206", "l0.4105059,0.8328729", "l0.4115530,0.8361020", "l0.4131859,0.8485811", "l0.4129907,0.8566202", "l0.4137716,0.8595130", "l0.4167889,0.8661730", "l0.4182976,0.8714203", "l0.4146591,0.8747839", "l0.4131504,0.8775085", "l0.4123695,0.8801321", "l0.4124227,0.8813094", "l0.4127777,0.8820494", "l0.4133457,0.8823017", "l0.4143751,0.8826212", "l0.4177474,0.8832267", "l0.4193447,0.8833276", "l0.4209421,0.8832772", "l0.4216698,0.8831594", "l0.4255035,0.8817972", "l0.4264797,0.8817299", "l0.4275979,0.8819317", "l0.4297632,0.8829240", "l0.4303667,0.8837481", "l0.4305264,0.8844544", "l0.4274559,0.8881881", "l0.4234092,0.8918040", "l0.4218118,0.8927795", "l0.4211729,0.8930486", "l0.4165937,0.8937213", "l0.4149253,0.8944613", "l0.4149608,0.8978249", "l0.4158482,0.8994227", "l0.4163097,0.8999272", "l0.4198949,0.9031059", "l0.4203742,0.9041150", "l0.4204807,0.9049054", "l0.4201612,0.9054268", "l0.4194157,0.9063854", "l0.4184928,0.9071591", "l0.4152093,0.9089922", "l0.4139669,0.9101695", "l0.4120855,0.9135836", "l0.4113401,0.9159550", "l0.4107544,0.9163082", "l0.4099912,0.9166614", "l0.4072224,0.9170650", "l0.4044358,0.9177546", "l0.4033886,0.9187973", "l0.4028739,0.9200082", "l0.4028029,0.9500960", "l0.4028207,0.9527701", "l0.4001761,0.9523665", "l0.3829953,0.9507688", "l0.3637912,0.9525515", "l0.3609159,0.9533756", "l0.3326067,0.9550742", "l0.2995053,0.9544856", "l0.2692259,0.9513069", "l0.2318294,0.9442937", "l0.1792576,0.9221273", "l0.1792221,0.9218414", "l0.1789736,0.9198568", "l0.1781394,0.9161064", "l0.1783702,0.9149795", "l0.1789026,0.9136341", "l0.1909540,0.8967318", "l0.1929774,0.8925272", "l0.1941666,0.8906940", "l0.1954622,0.8894495", "l0.1969886,0.8875154", "l0.1973081,0.8836135", "l0.1967401,0.8738421", "l0.1957994,0.8681071", "l0.1956752,0.8661562", "l0.1958172,0.8632130", "l0.1962609,0.8615480", "l0.1966336,0.8607407", "l0.1992072,0.8592271", "l0.2011596,0.8605557", "l0.2020292,0.8616825", "l0.2026682,0.8635494", "l0.2030054,0.8640707", "l0.2036799,0.8642725", "l0.2047093,0.8640371", "l0.2064487,0.8630448", "l0.2072829,0.8623553", "l0.2077798,0.8616489", "l0.2077088,0.8610266", "l0.2074781,0.8604380", "l0.2062889,0.8582853", "l0.2058097,0.8570743", "l0.2053838,0.8549552", "l0.2052418,0.8534248", "l0.2053128,0.8519111", "l0.2058452,0.8498761", "l0.2063599,0.8487325", "l0.2066972,0.8482279", "l0.2075846,0.8473702", "l0.2146486,0.8424257", "l0.2158023,0.8418370", "l0.2178256,0.8412147", "l0.2187840,0.8415847", "l0.2198667,0.8423752", "l0.2214641,0.8447466", "l0.2219256,0.8459407", "l0.2219611,0.8468657", "l0.2201507,0.8494052", "l0.2199022,0.8499770", "l0.2197247,0.8506161", "l0.2197247,0.8512889", "l0.2199555,0.8518607", "l0.2203104,0.8524661", "l0.2215174,0.8540471", "l0.2217658,0.8548207", "l0.2218013,0.8555943", "l0.2212866,0.8576125", "l0.2212156,0.8583357", "l0.2212866,0.8590421", "l0.2215351,0.8597484", "l0.2220498,0.8605221", "l0.2231147,0.8614807", "l0.2243571,0.8622039", "l0.2253156,0.8625907", "l0.2269307,0.8628430", "l0.2293978,0.8627757", "l0.2314034,0.8616153", "l0.2359293,0.8568389", "l0.2386271,0.8593616", "l0.2373847,0.8651807", "l0.2389644,0.8655507", "l0.2679125,0.8675857", "l0.2694389,0.8666439", "l0.2716398,0.8625234", "l0.2727757,0.8609425", "l0.2731129,0.8599839", "l0.2733792,0.8586216", "l0.2740891,0.8470002", "l0.2757220,0.8428629", "l0.2827327,0.8291561", "l0.2861937,0.8315779", "l0.2868149,0.8321329", "l0.2879686,0.8326711", "l0.2890868,0.8328224", "l0.2913409,0.8326038", "l0.2924768,0.8323011", "l0.2933642,0.8319647", "l0.2966477,0.8301652", "l0.2972689,0.8299297", "l0.2979789,0.8297447", "l0.2987243,0.8296438", "l0.2998248,0.8300474", "l0.3011382,0.8308211", "l0.3035875,0.8329065", "l0.3050429,0.8338483", "l0.3063918,0.8344202", "l0.3082022,0.8342688", "l0.3091251,0.8339661", "l0.3098173,0.8335456", "l0.3110952,0.8322002", "l0.3120359,0.8314770", "l0.3126571,0.8312920", "l0.3133138,0.8317293", "l0.3139350,0.8326711", "l0.3144497,0.8366065", "l0.3144675,0.8385743", "l0.3146272,0.8393816", "l0.3150177,0.8400206", "l0.3156921,0.8407102", "l0.3174670,0.8398693", "l0.3222059,0.8307538", "l0.3236613,0.8272388", "l0.3239985,0.8265997", "l0.3257202,0.8245479", "l0.3309028,0.8198556", "l0.3375231,0.8148606", "l0.3448178,0.8208815", "l0.3468234,0.8229165", "l0.3470719,0.8235051", "l0.3472316,0.8241779", "l0.3491307,0.8279956", "l0.3522190,0.8328729", "l0.3537809,0.8345884", "l0.3549701,0.8353452", "c"]}, {"n": "Chimaltenango", "u": "GT-CM", "i": ["m0.3587151,0.7081656", "l0.3587151,0.7081656", "l0.3714942,0.7081656", "l0.3756829,0.7087206", "l0.3829953,0.7110920", "l0.3918874,0.7128579", "l0.3953130,0.7140688", "l0.3946563,0.7178361", "l0.3945143,0.7184416", "l0.3942658,0.7191480", "l0.3939463,0.7197198", "l0.3934848,0.7203757", "l0.3926151,0.7211157", "l0.3914970,0.7218725", "l0.3887459,0.7227471", "l0.3875568,0.7234198", "l0.3837763,0.7262452", "l0.3825516,0.7267162", "l0.3815754,0.7268171", "l0.3809542,0.7265648", "l0.3802265,0.7265143", "l0.3795698,0.7266153", "l0.3789841,0.7268843", "l0.3779369,0.7275739", "l0.3768898,0.7284316", "l0.3754521,0.7308198", "l0.3731448,0.7381021", "l0.3686011,0.7447285", "l0.3647319,0.7514558", "l0.3640042,0.7544999", "l0.3653886,0.7615299", "l0.3662050,0.7638340", "l0.3669682,0.7681563", "l0.3670392,0.7696363", "l0.3669682,0.7707295", "l0.3662405,0.7719236", "l0.3647496,0.7737063", "l0.3614484,0.7805177", "l0.3551831,0.7848400", "l0.3440014,0.7966632", "l0.3386235,0.8065019", "l0.3372923,0.8131787", "l0.3374343,0.8145746", "l0.3375231,0.8148606", "l0.3309028,0.8198556", "l0.3257202,0.8245479", "l0.3239985,0.8265997", "l0.3236613,0.8272388", "l0.3222059,0.8307538", "l0.3174670,0.8398693", "l0.3156921,0.8407102", "l0.3150177,0.8400206", "l0.3146272,0.8393816", "l0.3144675,0.8385743", "l0.3144497,0.8366065", "l0.3139350,0.8326711", "l0.3133138,0.8317293", "l0.3126571,0.8312920", "l0.3120359,0.8314770", "l0.3110952,0.8322002", "l0.3098173,0.8335456", "l0.3091251,0.8339661", "l0.3082022,0.8342688", "l0.3063918,0.8344202", "l0.3050429,0.8338483", "l0.3035875,0.8329065", "l0.3011382,0.8308211", "l0.2998248,0.8300474", "l0.2987243,0.8296438", "l0.2979789,0.8297447", "l0.2972689,0.8299297", "l0.2966477,0.8301652", "l0.2933642,0.8319647", "l0.2924768,0.8323011", "l0.2913409,0.8326038", "l0.2890868,0.8328224", "l0.2879686,0.8326711", "l0.2868149,0.8321329", "l0.2861937,0.8315779", "l0.2827327,0.8291561", "l0.2862470,0.8201247", "l0.2862470,0.8169460", "l0.2866907,0.8114801", "l0.2862292,0.8091087", "l0.2853418,0.8079987", "l0.2837622,0.8063673", "l0.2820405,0.8048705", "l0.2840994,0.7855127", "l0.2841171,0.7800804", "l0.2848626,0.7778436", "l0.2868682,0.7751695", "l0.2919621,0.7635649", "l0.2914651,0.7583513", "l0.2916426,0.7574935", "l0.2932755,0.7527676", "l0.2892820,0.7345366", "l0.2886608,0.7329725", "l0.2952811,0.7298780", "l0.2970915,0.7284316", "l0.3026823,0.7134297", "l0.3042619,0.7110079", "l0.3047589,0.7105875", "l0.3052204,0.7102679", "l0.3076342,0.7091411", "l0.3118762,0.7080647", "l0.3160294,0.7056261", "l0.3205375,0.7064502", "l0.3366711,0.7060802", "l0.3395819,0.7054747", "l0.3430074,0.7049197", "l0.3468589,0.7048356", "l0.3587151,0.7081656", "c"]}, {"n": "Alta Verapaz", "u": "GT-AV", "i": ["m0.5485200,0.4469952", "l0.5485200,0.4469952", "l0.5489282,0.4467093", "l0.5489637,0.4466420", "l0.5491057,0.4463393", "l0.5492655,0.4458515", "l0.5499222,0.4452125", "l0.5510048,0.4446238", "l0.5537204,0.4442370", "l0.5548208,0.4445229", "l0.5554775,0.4451956", "l0.5556728,0.4460029", "l0.5563650,0.4468270", "l0.5573056,0.4470120", "l0.5586546,0.4467093", "l0.5593468,0.4466925", "l0.5597372,0.4468102", "l0.5606957,0.4478697", "l0.5612991,0.4479875", "l0.5620091,0.4478529", "l0.5627013,0.4475502", "l0.5646891,0.4471802", "l0.5651506,0.4469111", "l0.5652926,0.4467597", "l0.5653103,0.4466756", "l0.5653103,0.4464234", "l0.5652393,0.4459356", "l0.5647246,0.4440184", "l0.5647956,0.4432952", "l0.5652216,0.4431943", "l0.5657185,0.4433288", "l0.5675999,0.4440688", "l0.5681324,0.4443884", "l0.5684696,0.4448425", "l0.5684874,0.4454647", "l0.5683631,0.4460029", "l0.5681856,0.4464570", "l0.5680969,0.4466084", "l0.5680614,0.4467261", "l0.5683986,0.4473316", "l0.5691263,0.4477520", "l0.5695878,0.4481388", "l0.5696588,0.4486602", "l0.5690376,0.4503420", "l0.5732440,0.4534198", "l0.5760661,0.4539748", "l0.5766873,0.4537225", "l0.5777877,0.4526461", "l0.5821184,0.4554548", "l0.5844612,0.4557239", "l0.5858456,0.4555220", "l0.5864491,0.4558416", "l0.5871945,0.4568339", "l0.5880465,0.4582970", "l0.5912767,0.4624848", "l0.5919334,0.4639312", "l0.5923239,0.4651421", "l0.5934776,0.4673116", "l0.5943650,0.4680684", "l0.5952169,0.4683544", "l0.5958914,0.4681694", "l0.5967966,0.4680853", "l0.5978438,0.4681525", "l0.6016775,0.4687075", "l0.6100371,0.4682703", "l0.6113683,0.4679171", "l0.6118298,0.4676648", "l0.6121137,0.4674294", "l0.6124155,0.4670762", "l0.6134449,0.4656634", "l0.6138709,0.4652430", "l0.6143501,0.4648898", "l0.6150068,0.4646712", "l0.6157522,0.4646543", "l0.6179176,0.4648393", "l0.6186098,0.4647384", "l0.6199587,0.4639984", "l0.6208816,0.4633593", "l0.6216271,0.4634266", "l0.6223548,0.4636116", "l0.6281941,0.4661848", "l0.6288863,0.4665716", "l0.6328265,0.4697334", "l0.6379914,0.4731139", "l0.6393935,0.4737698", "l0.6405472,0.4741566", "l0.6438662,0.4743416", "l0.6452151,0.4740389", "l0.6458363,0.4737866", "l0.6464043,0.4734671", "l0.6492973,0.4712303", "l0.6510367,0.4711462", "l0.6664071,0.4730635", "l0.6673478,0.4730803", "l0.6680755,0.4729289", "l0.6687322,0.4726935", "l0.6693002,0.4723907", "l0.6697971,0.4720207", "l0.6708975,0.4716675", "l0.6724062,0.4713480", "l0.6758494,0.4711966", "l0.6774291,0.4713312", "l0.6784940,0.4717180", "l0.6786892,0.4723403", "l0.6793104,0.4850717", "l0.6794524,0.4853071", "l0.6797719,0.4852735", "l0.6863389,0.4823639", "l0.6916281,0.4813549", "l0.6958345,0.4835412", "l0.6978046,0.4837262", "l0.7008042,0.4824144", "l0.7082586,0.4806317", "l0.7014609,0.4892931", "l0.6989228,0.4912103", "l0.6941129,0.4916813", "l0.6932432,0.4921185", "l0.6926397,0.4925894", "l0.6913796,0.4948094", "l0.6911311,0.4954485", "l0.6881138,0.5006790", "l0.6871554,0.5018899", "l0.6862679,0.5025458", "l0.6836766,0.5036558", "l0.6795412,0.5064477", "l0.6782455,0.5070531", "l0.6756720,0.5078099", "l0.6749443,0.5083145", "l0.6744295,0.5089199", "l0.6738793,0.5101477", "l0.6582427,0.5311032", "l0.6443277,0.5498892", "l0.6424996,0.5539928", "l0.6431740,0.5541778", "l0.6442744,0.5548169", "l0.6447714,0.5552037", "l0.6452684,0.5557251", "l0.6456233,0.5561624", "l0.6465640,0.5576424", "l0.6520484,0.5632429", "l0.6540185,0.5660515", "l0.6561838,0.5683220", "l0.6594319,0.5711474", "l0.6603193,0.5724761", "l0.6606743,0.5734347", "l0.6586332,0.5765293", "l0.6583314,0.5771179", "l0.6578700,0.5783456", "l0.6571600,0.5810534", "l0.6565743,0.5821970", "l0.6562371,0.5826848", "l0.6557934,0.5831893", "l0.6553497,0.5836098", "l0.6548349,0.5839629", "l0.6501315,0.5861157", "l0.6486229,0.5872089", "l0.6482147,0.5876629", "l0.6459961,0.6162371", "l0.6460493,0.6198867", "l0.6462623,0.6207276", "l0.6472740,0.6230822", "l0.6478774,0.6241417", "l0.6495281,0.6262944", "l0.6509302,0.6286322", "l0.6511432,0.6296413", "l0.6511255,0.6308858", "l0.6503268,0.6349054", "l0.6502735,0.6362508", "l0.6503268,0.6372936", "l0.6508060,0.6385718", "l0.6519064,0.6408590", "l0.6563613,0.6468968", "l0.6391983,0.6506977", "l0.6312646,0.6501932", "l0.6154860,0.6524804", "l0.6125575,0.6518918", "l0.6038783,0.6487300", "l0.5981455,0.6485282", "l0.5955719,0.6488813", "l0.5887564,0.6517741", "l0.5814972,0.6535905", "l0.5773795,0.6539100", "l0.5651683,0.6525814", "l0.5761371,0.6376299", "l0.5787816,0.6305326", "l0.5789769,0.6280604", "l0.5784976,0.6268494", "l0.5778942,0.6257731", "l0.5767405,0.6243940", "l0.5739540,0.6218881", "l0.5721081,0.6208622", "l0.5712029,0.6205931", "l0.5703687,0.6204249", "l0.5592225,0.6213162", "l0.5569684,0.6218208", "l0.5488395,0.6248985", "l0.5391132,0.6252181", "l0.5120286,0.6215853", "l0.5001015,0.6188608", "l0.4967470,0.6186758", "l0.4956820,0.6193822", "l0.4952561,0.6198026", "l0.4948656,0.6202735", "l0.4942444,0.6214340", "l0.4940314,0.6219722", "l0.4938362,0.6234858", "l0.4918483,0.6310036", "l0.4901622,0.6333077", "l0.4889730,0.6342831", "l0.4859557,0.6378822", "l0.4849796,0.6388577", "l0.4824770,0.6401527", "l0.4815008,0.6402704", "l0.4807731,0.6400854", "l0.4781285,0.6375795", "l0.4644620,0.6287499", "l0.4590842,0.6271354", "l0.4532448,0.6273372", "l0.4449029,0.6271354", "l0.4392411,0.6271017", "l0.4334727,0.6268326", "l0.4351056,0.6247304", "l0.4374307,0.6206267", "l0.4397558,0.6150262", "l0.4399688,0.6100648", "l0.4360285,0.6079289", "l0.3969991,0.6022444", "l0.3892429,0.5993516", "l0.3841313,0.5946257", "l0.3828711,0.5911780", "l0.3823741,0.5867548", "l0.3834036,0.5829202", "l0.3867403,0.5812888", "l0.3966441,0.5804143", "l0.3996614,0.5788838", "l0.3976735,0.5762938", "l0.3976735,0.5746288", "l0.4046133,0.5687256", "l0.4059977,0.5680697", "l0.4086778,0.5654124", "l0.4103639,0.5625197", "l0.4087665,0.5611574", "l0.4074531,0.5589038", "l0.4057670,0.5538919", "l0.4032644,0.5488128", "l0.3995194,0.5463069", "l0.4016847,0.5423378", "l0.4014895,0.5388564", "l0.3990047,0.5356946", "l0.3942835,0.5328187", "l0.3941770,0.5316750", "l0.3945498,0.5313555", "l0.3952597,0.5313555", "l0.3961294,0.5311537", "l0.3941060,0.5299932", "l0.3918342,0.5296064", "l0.3895624,0.5299932", "l0.3875213,0.5311537", "l0.3845395,0.5296064", "l0.3740322,0.5266800", "l0.3647851,0.5251832", "l0.3629038,0.5228455", "l0.3638267,0.5200873", "l0.3671812,0.5178168", "l0.3657791,0.5170095", "l0.3621051,0.5143354", "l0.3621051,0.5128218", "l0.3633297,0.5124181", "l0.3644302,0.5115268", "l0.3656371,0.5110054", "l0.3639864,0.5088022", "l0.3616259,0.5076249", "l0.3587328,0.5073054", "l0.3554848,0.5076586", "l0.3570467,0.5041268", "l0.3637912,0.4959867", "l0.3670925,0.4874262", "l0.3681041,0.4859799", "l0.3741387,0.4837262", "l0.3767123,0.4789498", "l0.3752036,0.4747621", "l0.3690271,0.4741398", "l0.3714409,0.4660166", "l0.3733578,0.4624680", "l0.3758071,0.4607861", "l0.3758071,0.4591211", "l0.3745292,0.4589025", "l0.3743339,0.4586502", "l0.3744049,0.4582130", "l0.3739612,0.4574393", "l0.3722573,0.4591211", "l0.3700565,0.4567666", "l0.3690271,0.4559257", "l0.3690271,0.4541093", "l0.3723461,0.4533525", "l0.3762508,0.4502747", "l0.3790374,0.4490975", "l0.3796586,0.4498711", "l0.3804573,0.4514857", "l0.3816287,0.4525116", "l0.3833503,0.4515193", "l0.3842555,0.4494843", "l0.3837940,0.4482061", "l0.3837585,0.4471466", "l0.3859771,0.4457506", "l0.3841313,0.4424206", "l0.3946740,0.4369715", "l0.4010990,0.4356429", "l0.4046133,0.4390738", "l0.4062994,0.4390738", "l0.4070981,0.4371229", "l0.4082340,0.4361979", "l0.4096717,0.4362652", "l0.4113756,0.4372574", "l0.4113756,0.4390738", "l0.4102751,0.4395447", "l0.4090505,0.4402343", "l0.4078436,0.4406043", "l0.4078436,0.4424206", "l0.4120145,0.4422188", "l0.4145171,0.4436147", "l0.4167179,0.4456497", "l0.4200014,0.4472811", "l0.4207469,0.4464906", "l0.4223620,0.4451620", "l0.4233915,0.4440856", "l0.4238174,0.4455993", "l0.4240837,0.4456665", "l0.4244031,0.4449265", "l0.4249356,0.4440856", "l0.4267105,0.4457338", "l0.4275269,0.4455993", "l0.4284676,0.4440856", "l0.4301715,0.4440856", "l0.4327450,0.4451956", "l0.4375549,0.4423197", "l0.4404835,0.4440856", "l0.4420276,0.4440856", "l0.4424003,0.4428747", "l0.4432523,0.4418152", "l0.4437315,0.4406043", "l0.4466955,0.4416470", "l0.4492336,0.4406379", "l0.4502985,0.4383842", "l0.4488076,0.4357438", "l0.4509020,0.4330024", "l0.4514167,0.4306815", "l0.4501920,0.4287810", "l0.4472635,0.4273178", "l0.4472812,0.4273178", "l0.4473522,0.4272169", "l0.4540790,0.4265610", "l0.5046807,0.4339442", "l0.5469049,0.4468438", "l0.5485200,0.4469952", "c"]}, {"n": "San Marcos", "u": "GT-SM", "i": ["m0.0639796,0.6230149", "l0.0639796,0.6230149", "l0.0646540,0.6222076", "l0.0730137,0.6130080", "l0.0764037,0.6109394", "l0.0844971,0.6103508", "l0.0920226,0.6058771", "l0.0962468,0.6034216", "l0.0979152,0.6028330", "l0.0995481,0.6026985", "l0.1017311,0.6036571", "l0.1101618,0.6087194", "l0.1154332,0.6091062", "l0.1289577,0.6054398", "l0.1327737,0.6054062", "l0.1329512,0.6063312", "l0.1341758,0.6095939", "l0.1376723,0.6156485", "l0.1417900,0.6210640", "l0.1463692,0.6257899", "l0.1512679,0.6297254", "l0.1537172,0.6313567", "l0.1562020,0.6336440", "l0.1574799,0.6369068", "l0.1563440,0.6415150", "l0.1547821,0.6430622", "l0.1461917,0.6496886", "l0.1416658,0.6543136", "l0.1368914,0.6609064", "l0.1346018,0.6681887", "l0.1375658,0.6749328", "l0.1422870,0.6787001", "l0.1432987,0.6826187", "l0.1417190,0.6930292", "l0.1407961,0.6955183", "l0.1387550,0.6981252", "l0.1315135,0.7048693", "l0.1295967,0.7056765", "l0.1276265,0.7068202", "l0.1273071,0.7074761", "l0.1269876,0.7084684", "l0.1271651,0.7101670", "l0.1267569,0.7125047", "l0.1244850,0.7154816", "l0.1228344,0.7245971", "l0.1209708,0.7277757", "l0.1205448,0.7283812", "l0.1138713,0.7418526", "l0.1136050,0.7425926", "l0.1130193,0.7435008", "l0.1120964,0.7443921", "l0.1088129,0.7466962", "l0.1076947,0.7479071", "l0.1070913,0.7487144", "l0.1038787,0.7543149", "l0.1014472,0.7557949", "l0.0992818,0.7566190", "l0.0967792,0.7568544", "l0.0898217,0.7564676", "l0.0742739,0.7548867", "l0.0524784,0.7608740", "l0.0471538,0.7618326", "l0.0442607,0.7632286", "l0.0374985,0.7684254", "l0.0289613,0.7777595", "l0.0280029,0.7792395", "l0.0283046,0.7799459", "l0.0290678,0.7806691", "l0.0311977,0.7814427", "l0.0325111,0.7817623", "l0.0471715,0.7832086", "l0.0493014,0.7836964", "l0.0499403,0.7839823", "l0.0521944,0.7881532", "l0.0581048,0.8047360", "l0.0507035,0.8065019", "l0.0485382,0.8074605", "l0.0457694,0.8103701", "l0.0447932,0.8110260", "l0.0438880,0.8113960", "l0.0431781,0.8114801", "l0.0424149,0.8114465", "l0.0417049,0.8113455", "l0.0404093,0.8108915", "l0.0380487,0.8104205", "l0.0355639,0.8102692", "l0.0343570,0.8105046", "l0.0335228,0.8108242", "l0.0313042,0.8127583", "l0.0291033,0.8142383", "l0.0278609,0.8147765", "l0.0266185,0.8148606", "l0.0240272,0.8142551", "l0.0230333,0.8144401", "l0.0223588,0.8146587", "l0.0219506,0.8153146", "l0.0219506,0.8153315", "l0.0011313,0.8010191", "l0.0061365,0.8002791", "l0.0106091,0.7951328", "l0.0160580,0.7807868", "l0.0213649,0.7714022", "l0.0223411,0.7676854", "l0.0221103,0.7630940", "l0.0177264,0.7511362", "l0.0175489,0.7493703", "l0.0178684,0.7458217", "l0.0177264,0.7439212", "l0.0154191,0.7379171", "l0.0148866,0.7358989", "l0.0146736,0.7307694", "l0.0158805,0.7278598", "l0.0210454,0.7221248", "l0.0238497,0.7148425", "l0.0231398,0.6996892", "l0.0239739,0.6916838", "l0.0269202,0.6888751", "l0.0300085,0.6880342", "l0.0332033,0.6876810", "l0.0364691,0.6863524", "l0.0390071,0.6835269", "l0.0439235,0.6727464", "l0.0117806,0.6329377", "l0.0098992,0.6289854", "l0.0098105,0.6244276", "l0.0114611,0.6201726", "l0.0160403,0.6126549", "l0.0281271,0.5927925", "l0.0359543,0.5799602", "l0.0374807,0.5850393", "l0.0417759,0.5901689", "l0.0454677,0.5914975", "l0.0461066,0.5951302", "l0.0485382,0.6204249", "l0.0513070,0.6224599", "l0.0639796,0.6230149", "c"]}, {"n": "Retalhuleu", "u": "GT-RE", "i": ["m0.1451091,0.7728990", "l0.1451091,0.7728990", "l0.1474341,0.7707968", "l0.1481618,0.7691654", "l0.1486765,0.7688122", "l0.1495107,0.7684590", "l0.1509484,0.7688627", "l0.1524748,0.7696868", "l0.1531670,0.7696868", "l0.1540367,0.7693840", "l0.1559003,0.7674331", "l0.1571427,0.7657681", "l0.1573912,0.7652467", "l0.1588111,0.7631613", "l0.1596630,0.7623036", "l0.1603375,0.7620345", "l0.1612604,0.7619672", "l0.1638517,0.7626063", "l0.1653426,0.7631276", "l0.1666915,0.7634304", "l0.1675080,0.7634640", "l0.1687149,0.7630940", "l0.1701880,0.7624045", "l0.1752464,0.7591417", "l0.1767728,0.7587045", "l0.1797723,0.7589399", "l0.1836948,0.7605208", "l0.1762226,0.7667940", "l0.1705962,0.7728318", "l0.1699395,0.7737904", "l0.1691763,0.7752704", "l0.1690166,0.7759600", "l0.1688746,0.7787013", "l0.1690698,0.7817959", "l0.1692118,0.7841841", "l0.1594145,0.8032392", "l0.1593080,0.8047528", "l0.1593258,0.8055433", "l0.1594323,0.8062496", "l0.1574622,0.8204778", "l0.1576574,0.8219410", "l0.1580301,0.8232024", "l0.1585271,0.8244133", "l0.1616686,0.8297447", "l0.1618106,0.8315443", "l0.1606747,0.8473366", "l0.1608344,0.8505657", "l0.1607102,0.8521466", "l0.1605150,0.8532566", "l0.1576929,0.8572425", "l0.1546046,0.8661898", "l0.1534510,0.8734217", "l0.1529362,0.8813935", "l0.1526523,0.8829240", "l0.1523860,0.8834622", "l0.1453043,0.8934522", "l0.1467774,0.9031395", "l0.1469727,0.9051072", "l0.1211483,0.8898699", "l0.0850118,0.8647266", "l0.0499226,0.8345884", "l0.0219506,0.8153315", "l0.0219506,0.8153146", "l0.0223588,0.8146587", "l0.0230333,0.8144401", "l0.0240272,0.8142551", "l0.0266185,0.8148606", "l0.0278609,0.8147765", "l0.0291033,0.8142383", "l0.0313042,0.8127583", "l0.0335228,0.8108242", "l0.0343570,0.8105046", "l0.0355639,0.8102692", "l0.0380487,0.8104205", "l0.0404093,0.8108915", "l0.0417049,0.8113455", "l0.0424149,0.8114465", "l0.0431781,0.8114801", "l0.0438880,0.8113960", "l0.0447932,0.8110260", "l0.0457694,0.8103701", "l0.0485382,0.8074605", "l0.0507035,0.8065019", "l0.0581048,0.8047360", "l0.0601104,0.8034073", "l0.0614060,0.8028692", "l0.0620095,0.8027682", "l0.0630389,0.8030373", "l0.0776284,0.8089910", "l0.0804327,0.8094114", "l0.0876741,0.8087892", "l0.0980217,0.8065692", "l0.1057601,0.7955364", "l0.1081917,0.7928455", "l0.1087419,0.7918364", "l0.1093276,0.7902555", "l0.1101973,0.7867741", "l0.1110492,0.7845541", "l0.1121497,0.7823509", "l0.1166046,0.7760104", "l0.1177050,0.7736895", "l0.1198704,0.7670127", "l0.1215210,0.7645067", "l0.1304131,0.7603863", "l0.1337676,0.7568713", "l0.1356135,0.7553744", "l0.1366607,0.7547017", "l0.1373351,0.7543485", "l0.1380806,0.7540626", "l0.1391455,0.7539113", "l0.1399974,0.7539617", "l0.1406541,0.7541803", "l0.1410801,0.7547858", "l0.1413641,0.7553072", "l0.1409913,0.7582840", "l0.1374416,0.7663063", "l0.1367316,0.7705613", "l0.1373884,0.7712509", "l0.1386308,0.7718563", "l0.1417190,0.7723945", "l0.1431567,0.7727981", "l0.1451091,0.7728990", "c"]}, {"n": "Quezaltenango", "u": "GT-QZ", "i": ["m0.1816182,0.6527159", "l0.1816182,0.6527159", "l0.1772875,0.6540614", "l0.1645972,0.6588041", "l0.1640470,0.6590732", "l0.1634967,0.6594096", "l0.1629998,0.6614109", "l0.1642777,0.6684410", "l0.1703832,0.6905738", "l0.1713594,0.6941224", "l0.1732053,0.6964770", "l0.1773585,0.7000424", "l0.1772875,0.7028847", "l0.1767905,0.7041797", "l0.1767728,0.7056934", "l0.1772343,0.7073247", "l0.1811745,0.7117479", "l0.1814940,0.7122525", "l0.1818667,0.7127570", "l0.1835528,0.7132952", "l0.1883627,0.7127570", "l0.1936163,0.7125552", "l0.1957462,0.7172979", "l0.1965094,0.7245971", "l0.1992072,0.7269516", "l0.2040881,0.7350580", "l0.2010708,0.7445939", "l0.1938116,0.7540458", "l0.1836948,0.7605208", "l0.1797723,0.7589399", "l0.1767728,0.7587045", "l0.1752464,0.7591417", "l0.1701880,0.7624045", "l0.1687149,0.7630940", "l0.1675080,0.7634640", "l0.1666915,0.7634304", "l0.1653426,0.7631276", "l0.1638517,0.7626063", "l0.1612604,0.7619672", "l0.1603375,0.7620345", "l0.1596630,0.7623036", "l0.1588111,0.7631613", "l0.1573912,0.7652467", "l0.1571427,0.7657681", "l0.1559003,0.7674331", "l0.1540367,0.7693840", "l0.1531670,0.7696868", "l0.1524748,0.7696868", "l0.1509484,0.7688627", "l0.1495107,0.7684590", "l0.1486765,0.7688122", "l0.1481618,0.7691654", "l0.1474341,0.7707968", "l0.1451091,0.7728990", "l0.1431567,0.7727981", "l0.1417190,0.7723945", "l0.1386308,0.7718563", "l0.1373884,0.7712509", "l0.1367316,0.7705613", "l0.1374416,0.7663063", "l0.1409913,0.7582840", "l0.1413641,0.7553072", "l0.1410801,0.7547858", "l0.1406541,0.7541803", "l0.1399974,0.7539617", "l0.1391455,0.7539113", "l0.1380806,0.7540626", "l0.1373351,0.7543485", "l0.1366607,0.7547017", "l0.1356135,0.7553744", "l0.1337676,0.7568713", "l0.1304131,0.7603863", "l0.1215210,0.7645067", "l0.1198704,0.7670127", "l0.1177050,0.7736895", "l0.1166046,0.7760104", "l0.1121497,0.7823509", "l0.1110492,0.7845541", "l0.1101973,0.7867741", "l0.1093276,0.7902555", "l0.1087419,0.7918364", "l0.1081917,0.7928455", "l0.1057601,0.7955364", "l0.0980217,0.8065692", "l0.0876741,0.8087892", "l0.0804327,0.8094114", "l0.0776284,0.8089910", "l0.0630389,0.8030373", "l0.0620095,0.8027682", "l0.0614060,0.8028692", "l0.0601104,0.8034073", "l0.0581048,0.8047360", "l0.0521944,0.7881532", "l0.0499403,0.7839823", "l0.0493014,0.7836964", "l0.0471715,0.7832086", "l0.0325111,0.7817623", "l0.0311977,0.7814427", "l0.0290678,0.7806691", "l0.0283046,0.7799459", "l0.0280029,0.7792395", "l0.0289613,0.7777595", "l0.0374985,0.7684254", "l0.0442607,0.7632286", "l0.0471538,0.7618326", "l0.0524784,0.7608740", "l0.0742739,0.7548867", "l0.0898217,0.7564676", "l0.0967792,0.7568544", "l0.0992818,0.7566190", "l0.1014472,0.7557949", "l0.1038787,0.7543149", "l0.1070913,0.7487144", "l0.1076947,0.7479071", "l0.1088129,0.7466962", "l0.1120964,0.7443921", "l0.1130193,0.7435008", "l0.1136050,0.7425926", "l0.1138713,0.7418526", "l0.1205448,0.7283812", "l0.1209708,0.7277757", "l0.1228344,0.7245971", "l0.1244850,0.7154816", "l0.1267569,0.7125047", "l0.1271651,0.7101670", "l0.1269876,0.7084684", "l0.1273071,0.7074761", "l0.1276265,0.7068202", "l0.1295967,0.7056765", "l0.1315135,0.7048693", "l0.1387550,0.6981252", "l0.1407961,0.6955183", "l0.1417190,0.6930292", "l0.1432987,0.6826187", "l0.1422870,0.6787001", "l0.1375658,0.6749328", "l0.1346018,0.6681887", "l0.1368914,0.6609064", "l0.1416658,0.6543136", "l0.1461917,0.6496886", "l0.1547821,0.6430622", "l0.1563440,0.6415150", "l0.1574799,0.6369068", "l0.1741637,0.6410104", "l0.1760273,0.6424568", "l0.1759386,0.6448450", "l0.1767728,0.6471154", "l0.1816182,0.6527159", "c"]}, {"n": "Petén", "u": "GT-PE", "i": ["m0.7667762,0.0008409", "l0.7667762,0.0008409", "l0.7678411,0.0541716", "l0.7692078,0.1225041", "l0.7695805,0.1925689", "l0.7653918,0.2562763", "l0.7608481,0.3252648", "l0.7586828,0.3505762", "l0.7548668,0.4011655", "l0.7485128,0.4577252", "l0.7480335,0.4695653", "l0.7478738,0.4694307", "l0.7476963,0.4692625", "l0.7464184,0.4683375", "l0.7405968,0.4675639", "l0.7177720,0.4680012", "l0.7149144,0.4707594", "l0.7133170,0.4747621", "l0.7128733,0.4764607", "l0.7125716,0.4772680", "l0.7121456,0.4780921", "l0.7111694,0.4790003", "l0.7082586,0.4806317", "l0.7008042,0.4824144", "l0.6978046,0.4837262", "l0.6958345,0.4835412", "l0.6916281,0.4813549", "l0.6863389,0.4823639", "l0.6797719,0.4852735", "l0.6794524,0.4853071", "l0.6793104,0.4850717", "l0.6786892,0.4723403", "l0.6784940,0.4717180", "l0.6774291,0.4713312", "l0.6758494,0.4711966", "l0.6724062,0.4713480", "l0.6708975,0.4716675", "l0.6697971,0.4720207", "l0.6693002,0.4723907", "l0.6687322,0.4726935", "l0.6680755,0.4729289", "l0.6673478,0.4730803", "l0.6664071,0.4730635", "l0.6510367,0.4711462", "l0.6492973,0.4712303", "l0.6464043,0.4734671", "l0.6458363,0.4737866", "l0.6452151,0.4740389", "l0.6438662,0.4743416", "l0.6405472,0.4741566", "l0.6393935,0.4737698", "l0.6379914,0.4731139", "l0.6328265,0.4697334", "l0.6288863,0.4665716", "l0.6281941,0.4661848", "l0.6223548,0.4636116", "l0.6216271,0.4634266", "l0.6208816,0.4633593", "l0.6199587,0.4639984", "l0.6186098,0.4647384", "l0.6179176,0.4648393", "l0.6157522,0.4646543", "l0.6150068,0.4646712", "l0.6143501,0.4648898", "l0.6138709,0.4652430", "l0.6134449,0.4656634", "l0.6124155,0.4670762", "l0.6121137,0.4674294", "l0.6118298,0.4676648", "l0.6113683,0.4679171", "l0.6100371,0.4682703", "l0.6016775,0.4687075", "l0.5978438,0.4681525", "l0.5967966,0.4680853", "l0.5958914,0.4681694", "l0.5952169,0.4683544", "l0.5943650,0.4680684", "l0.5934776,0.4673116", "l0.5923239,0.4651421", "l0.5919334,0.4639312", "l0.5912767,0.4624848", "l0.5880465,0.4582970", "l0.5871945,0.4568339", "l0.5864491,0.4558416", "l0.5858456,0.4555220", "l0.5844612,0.4557239", "l0.5821184,0.4554548", "l0.5777877,0.4526461", "l0.5766873,0.4537225", "l0.5760661,0.4539748", "l0.5732440,0.4534198", "l0.5690376,0.4503420", "l0.5696588,0.4486602", "l0.5695878,0.4481388", "l0.5691263,0.4477520", "l0.5683986,0.4473316", "l0.5680614,0.4467261", "l0.5680969,0.4466084", "l0.5681856,0.4464570", "l0.5683631,0.4460029", "l0.5684874,0.4454647", "l0.5684696,0.4448425", "l0.5681324,0.4443884", "l0.5675999,0.4440688", "l0.5657185,0.4433288", "l0.5652216,0.4431943", "l0.5647956,0.4432952", "l0.5647246,0.4440184", "l0.5652393,0.4459356", "l0.5653103,0.4464234", "l0.5653103,0.4466756", "l0.5652926,0.4467597", "l0.5651506,0.4469111", "l0.5646891,0.4471802", "l0.5627013,0.4475502", "l0.5620091,0.4478529", "l0.5612991,0.4479875", "l0.5606957,0.4478697", "l0.5597372,0.4468102", "l0.5593468,0.4466925", "l0.5586546,0.4467093", "l0.5573056,0.4470120", "l0.5563650,0.4468270", "l0.5556728,0.4460029", "l0.5554775,0.4451956", "l0.5548208,0.4445229", "l0.5537204,0.4442370", "l0.5510048,0.4446238", "l0.5499222,0.4452125", "l0.5492655,0.4458515", "l0.5491057,0.4463393", "l0.5489637,0.4466420", "l0.5489282,0.4467093", "l0.5485200,0.4469952", "l0.5469049,0.4468438", "l0.5046807,0.4339442", "l0.4540790,0.4265610", "l0.4473522,0.4272169", "l0.4482752,0.4259892", "l0.4499436,0.4225246", "l0.4506713,0.4204896", "l0.4492514,0.4210446", "l0.4486302,0.4212128", "l0.4481864,0.4214483", "l0.4472812,0.4223060", "l0.4454354,0.4223060", "l0.4444769,0.4181351", "l0.4504760,0.4133587", "l0.4472812,0.4104492", "l0.4472812,0.4089187", "l0.4527479,0.4067828", "l0.4511150,0.4043273", "l0.4438912,0.4004255", "l0.4429506,0.3957836", "l0.4447077,0.3924368", "l0.4477605,0.3902168", "l0.4506713,0.3888714", "l0.4473167,0.3876100", "l0.4448852,0.3857263", "l0.4444769,0.3833045", "l0.4472812,0.3803613", "l0.4483817,0.3813872", "l0.4491449,0.3817741", "l0.4523574,0.3821945", "l0.4514345,0.3808827", "l0.4499258,0.3781581", "l0.4489851,0.3768631", "l0.4501033,0.3769809", "l0.4504228,0.3766445", "l0.4504228,0.3760222", "l0.4506713,0.3753327", "l0.4521444,0.3763081", "l0.4542033,0.3768631", "l0.4557474,0.3762577", "l0.4557474,0.3736677", "l0.4542210,0.3742563", "l0.4506180,0.3729781", "l0.4480977,0.3712290", "l0.4498371,0.3703208", "l0.4543985,0.3689081", "l0.4580725,0.3655613", "l0.4595279,0.3616258", "l0.4574513,0.3584640", "l0.4557474,0.3584640", "l0.4557474,0.3602803", "l0.4540613,0.3602803", "l0.4547002,0.3568158", "l0.4570608,0.3555544", "l0.4604331,0.3557731", "l0.4642313,0.3567990", "l0.4613737,0.3522076", "l0.4610365,0.3508117", "l0.4609833,0.3475826", "l0.4604863,0.3440676", "l0.4590842,0.3437312", "l0.4568833,0.3446898", "l0.4540613,0.3450598", "l0.4526059,0.3444376", "l0.4507600,0.3432771", "l0.4482219,0.3422007", "l0.4404125,0.3412421", "l0.4397735,0.3398462", "l0.4401108,0.3377439", "l0.4388151,0.3350362", "l0.4373420,0.3336739", "l0.4349814,0.3320930", "l0.4322126,0.3313530", "l0.4262490,0.3340775", "l0.4247226,0.3318912", "l0.4235689,0.3266607", "l0.4211729,0.3266439", "l0.4147301,0.3284770", "l0.4133989,0.3290993", "l0.4119258,0.3283257", "l0.4084470,0.3276530", "l0.4044536,0.3275016", "l0.4014008,0.3283425", "l0.4026964,0.3260048", "l0.4048973,0.3242389", "l0.4066189,0.3223888", "l0.4064769,0.3198157", "l0.4036194,0.3181507", "l0.3998034,0.3179152", "l0.3976558,0.3170070", "l0.3996969,0.3132565", "l0.3988095,0.3093043", "l0.4004246,0.3051502", "l0.4012233,0.3016520", "l0.3978510,0.2997179", "l0.3971411,0.3013492", "l0.3963069,0.3021565", "l0.3950112,0.3025601", "l0.3929346,0.3029133", "l0.3929346,0.3013997", "l0.3962004,0.2956478", "l0.3928104,0.2868351", "l0.3760378,0.2637605", "l0.3724348,0.2610359", "l0.3635605,0.2567809", "l0.3598865,0.2538713", "l0.3607384,0.2509618", "l0.3607384,0.2492968", "l0.3573484,0.2474636", "l0.3550233,0.2493304", "l0.3521125,0.2492968", "l0.3350205,0.2442513", "l0.3304413,0.2417117", "l0.3232176,0.2347490", "l0.3180705,0.2323608", "l0.3220817,0.2283076", "l0.3214782,0.2263735", "l0.3180882,0.2258185", "l0.3137753,0.2258017", "l0.3133493,0.2268276", "l0.3142545,0.2290812", "l0.3145030,0.2313349", "l0.3120714,0.2323608", "l0.3107757,0.2316881", "l0.3076520,0.2284590", "l0.3062143,0.2273322", "l0.2967187,0.2241031", "l0.2937724,0.2215971", "l0.2926543,0.2165012", "l0.2912699,0.2139112", "l0.2825020,0.2038371", "l0.2815436,0.2016675", "l0.2802834,0.1969752", "l0.2789523,0.1954448", "l0.2763254,0.1949739", "l0.2703441,0.1955961", "l0.2678770,0.1946039", "l0.2590559,0.1854211", "l0.2567663,0.1820070", "l0.2557014,0.1795347", "l0.2544413,0.1751788", "l0.2533941,0.1734633", "l0.2511045,0.1721683", "l0.2460461,0.1709070", "l0.2450699,0.1693429", "l0.2445730,0.1655251", "l0.2431531,0.1610851", "l0.2410055,0.1572001", "l0.2382899,0.1549801", "l0.2315099,0.1546437", "l0.2248719,0.1556528", "l0.2198135,0.1548119", "l0.2178256,0.1489592", "l0.2139919,0.1469746", "l0.2063244,0.1454610", "l0.2005561,0.1429550", "l0.2016210,0.1390868", "l0.2028457,0.1388682", "l0.2034669,0.1387673", "l0.3123376,0.1395073", "l0.3124796,0.0717634", "l0.3126216,0.0039018", "l0.3146095,0.0017827", "l0.3197388,0.0004205", "l0.3304236,0.0004205", "l0.3849832,0.0004709", "l0.4395073,0.0005214", "l0.4940492,0.0005886", "l0.5486088,0.0006391", "l0.6031329,0.0006727", "l0.6576925,0.0007400", "l0.7122343,0.0007905", "l0.7667762,0.0008409", "c"]}, {"n": "Huehuetenango", "u": "GT-HU", "i": ["m0.2451764,0.5378473", "l0.2451764,0.5378473", "l0.2435790,0.5378473", "l0.2428158,0.5379482", "l0.2421591,0.5381164", "l0.2415734,0.5384023", "l0.2385206,0.5409082", "l0.2374912,0.5412278", "l0.2365505,0.5413623", "l0.2357696,0.5412951", "l0.2350774,0.5417660", "l0.2345094,0.5427582", "l0.2341544,0.5457014", "l0.2334977,0.5480055", "l0.2320601,0.5507469", "l0.2312437,0.5519242", "l0.2306757,0.5533369", "l0.2304095,0.5541947", "l0.2300722,0.5598624", "l0.2286878,0.5620656", "l0.2281909,0.5632429", "l0.2280489,0.5638988", "l0.2279246,0.5646724", "l0.2279246,0.5654292", "l0.2281021,0.5669429", "l0.2282796,0.5675988", "l0.2285104,0.5682379", "l0.2290606,0.5693479", "l0.2293978,0.5698356", "l0.2296640,0.5703906", "l0.2304095,0.5714838", "l0.2353791,0.5771852", "l0.2357873,0.5779420", "l0.2359648,0.5786988", "l0.2359826,0.5817934", "l0.2362665,0.5831557", "l0.2373137,0.5855102", "l0.2387514,0.5876125", "l0.2402955,0.5892607", "l0.2449634,0.5934148", "l0.2459396,0.5936166", "l0.2473418,0.5936502", "l0.2546010,0.5928093", "l0.2577425,0.5934148", "l0.2646113,0.5964589", "l0.2651615,0.6008653", "l0.2630139,0.6095939", "l0.2632624,0.6109898", "l0.2647000,0.6146394", "l0.2659247,0.6195167", "l0.2620910,0.6203576", "l0.2599079,0.6205762", "l0.2538378,0.6195335", "l0.2516015,0.6195840", "l0.2459751,0.6213667", "l0.2352016,0.6232503", "l0.2332315,0.6245285", "l0.2321133,0.6265972", "l0.2257238,0.6261767", "l0.2228130,0.6266813", "l0.2168317,0.6292376", "l0.2129802,0.6319454", "l0.2022245,0.6343167", "l0.1997397,0.6349727", "l0.1984972,0.6355613", "l0.1976098,0.6364695", "l0.1943440,0.6410440", "l0.1928709,0.6437854", "l0.1926934,0.6444245", "l0.1921432,0.6505463", "l0.1919835,0.6513032", "l0.1909008,0.6518918", "l0.1899779,0.6522954", "l0.1816182,0.6527159", "l0.1767728,0.6471154", "l0.1759386,0.6448450", "l0.1760273,0.6424568", "l0.1741637,0.6410104", "l0.1574799,0.6369068", "l0.1562020,0.6336440", "l0.1537172,0.6313567", "l0.1512679,0.6297254", "l0.1463692,0.6257899", "l0.1417900,0.6210640", "l0.1376723,0.6156485", "l0.1341758,0.6095939", "l0.1329512,0.6063312", "l0.1327737,0.6054062", "l0.1289577,0.6054398", "l0.1154332,0.6091062", "l0.1101618,0.6087194", "l0.1017311,0.6036571", "l0.0995481,0.6026985", "l0.0979152,0.6028330", "l0.0962468,0.6034216", "l0.0920226,0.6058771", "l0.0844971,0.6103508", "l0.0764037,0.6109394", "l0.0730137,0.6130080", "l0.0646540,0.6222076", "l0.0639796,0.6230149", "l0.0513070,0.6224599", "l0.0485382,0.6204249", "l0.0461066,0.5951302", "l0.0454677,0.5914975", "l0.0417759,0.5901689", "l0.0374807,0.5850393", "l0.0359543,0.5799602", "l0.0452369,0.5647229", "l0.0648138,0.5324823", "l0.0844261,0.5002586", "l0.1015182,0.4721216", "l0.1136050,0.4521920", "l0.1182020,0.4446406", "l0.1237928,0.4353738", "l0.1267924,0.4317915", "l0.1307681,0.4298742", "l0.1420385,0.4298574", "l0.1762581,0.4297901", "l0.2104599,0.4297565", "l0.2446617,0.4297060", "l0.2788635,0.4296388", "l0.3116454,0.4296219", "l0.2812241,0.4872244", "l0.2788103,0.4916981", "l0.2626589,0.5230136", "l0.2620732,0.5238041", "l0.2574408,0.5280591", "l0.2577425,0.5296737", "l0.2580442,0.5300941", "l0.2582395,0.5306828", "l0.2577425,0.5311032", "l0.2568373,0.5314228", "l0.2546897,0.5316246", "l0.2536781,0.5318432", "l0.2526841,0.5331887", "l0.2459929,0.5376960", "l0.2451764,0.5378473", "c"]}, {"n": "Baja Verapaz", "u": "GT-BV", "i": ["m0.5391132,0.6252181", "l0.5391132,0.6252181", "l0.5488395,0.6248985", "l0.5569684,0.6218208", "l0.5592225,0.6213162", "l0.5703687,0.6204249", "l0.5712029,0.6205931", "l0.5721081,0.6208622", "l0.5739540,0.6218881", "l0.5767405,0.6243940", "l0.5778942,0.6257731", "l0.5784976,0.6268494", "l0.5789769,0.6280604", "l0.5787816,0.6305326", "l0.5761371,0.6376299", "l0.5651683,0.6525814", "l0.5584948,0.6560964", "l0.5489282,0.6622687", "l0.5277363,0.6757905", "l0.4883696,0.7017747", "l0.4844293,0.7136484", "l0.4832047,0.7175670", "l0.4705676,0.7195348", "l0.4623677,0.7181389", "l0.4592439,0.7152629", "l0.4581612,0.7124038", "l0.4562266,0.7108902", "l0.4521976,0.7116302", "l0.4501388,0.7130429", "l0.4495531,0.7144388", "l0.4485414,0.7156498", "l0.4452579,0.7164739", "l0.4424003,0.7166925", "l0.4400043,0.7164402", "l0.4381406,0.7153807", "l0.4369515,0.7131438", "l0.4351056,0.7131438", "l0.4310944,0.7153302", "l0.4247759,0.7174661", "l0.4185460,0.7186939", "l0.4147656,0.7181389", "l0.4132214,0.7181389", "l0.4121033,0.7187275", "l0.4110561,0.7190302", "l0.4097427,0.7184920", "l0.4078436,0.7164739", "l0.4041518,0.7171466", "l0.3953130,0.7140688", "l0.3924909,0.7078293", "l0.3913727,0.7055252", "l0.3895446,0.7039106", "l0.3879117,0.7028847", "l0.3862079,0.7014888", "l0.3817707,0.6970824", "l0.3828711,0.6917847", "l0.3829953,0.6906410", "l0.3606674,0.6773210", "l0.3421377,0.6545491", "l0.3436819,0.6281445", "l0.3457407,0.6291535", "l0.3868823,0.6383531", "l0.4159725,0.6395640", "l0.4241724,0.6389418", "l0.4334727,0.6268326", "l0.4392411,0.6271017", "l0.4449029,0.6271354", "l0.4532448,0.6273372", "l0.4590842,0.6271354", "l0.4644620,0.6287499", "l0.4781285,0.6375795", "l0.4807731,0.6400854", "l0.4815008,0.6402704", "l0.4824770,0.6401527", "l0.4849796,0.6388577", "l0.4859557,0.6378822", "l0.4889730,0.6342831", "l0.4901622,0.6333077", "l0.4918483,0.6310036", "l0.4938362,0.6234858", "l0.4940314,0.6219722", "l0.4942444,0.6214340", "l0.4948656,0.6202735", "l0.4952561,0.6198026", "l0.4956820,0.6193822", "l0.4967470,0.6186758", "l0.5001015,0.6188608", "l0.5120286,0.6215853", "l0.5391132,0.6252181", "c"]}]} """;
}
