import 'package:flutter/material.dart';

class SMapItalyColors {
  /// Vatican City
  final Color? vaVA;

  /// San Marino
  final Color? smSM;

  /// Corsica, France
  final Color? frH;

  /// Malta
  final Color? mtMT;

  /// Abruzzo
  final Color? it65;

  /// Basilicata
  final Color? it77;

  /// Calabria
  final Color? it78;

  /// Campania
  final Color? it72;

  /// Emilia-Romagna
  final Color? it45;

  /// Friuli-Venezia Giulia
  final Color? it36;

  /// Lazio
  final Color? it62;

  /// Liguria
  final Color? it42;

  /// Lombardia
  final Color? it25;

  /// Marche
  final Color? it57;

  /// Molise
  final Color? it67;

  /// Piemonte
  final Color? it21;

  /// Puglia
  final Color? it75;

  /// Sardegna
  final Color? it88;

  /// Sicilia
  final Color? it82;

  /// Toscana
  final Color? it52;

  /// Trentino-Alto Adige
  final Color? it32;

  /// Umbria
  final Color? it55;

  /// Valle d'Aosta
  final Color? it23;

  /// Veneto
  final Color? it34;
  SMapItalyColors({
    this.vaVA,
    this.smSM,
    this.frH,
    this.mtMT,
    this.it65,
    this.it77,
    this.it78,
    this.it72,
    this.it45,
    this.it36,
    this.it62,
    this.it42,
    this.it25,
    this.it57,
    this.it67,
    this.it21,
    this.it75,
    this.it88,
    this.it82,
    this.it52,
    this.it32,
    this.it55,
    this.it23,
    this.it34,
  });
  Map<String, Color?> toMap() {
    return {
      "VA-VA": vaVA,
      "SM-SM": smSM,
      "FR-H": frH,
      "MT-MT": mtMT,
      "IT-65": it65,
      "IT-77": it77,
      "IT-78": it78,
      "IT-72": it72,
      "IT-45": it45,
      "IT-36": it36,
      "IT-62": it62,
      "IT-42": it42,
      "IT-25": it25,
      "IT-57": it57,
      "IT-67": it67,
      "IT-21": it21,
      "IT-75": it75,
      "IT-88": it88,
      "IT-82": it82,
      "IT-52": it52,
      "IT-32": it32,
      "IT-55": it55,
      "IT-23": it23,
      "IT-34": it34,
    };
  }

  static SMapItalyColors fromMap(Map<String, Color?> map) {
    return SMapItalyColors(
      vaVA: map["VA-VA"],
      smSM: map["SM-SM"],
      frH: map["FR-H"],
      mtMT: map["MT-MT"],
      it65: map["IT-65"],
      it77: map["IT-77"],
      it78: map["IT-78"],
      it72: map["IT-72"],
      it45: map["IT-45"],
      it36: map["IT-36"],
      it62: map["IT-62"],
      it42: map["IT-42"],
      it25: map["IT-25"],
      it57: map["IT-57"],
      it67: map["IT-67"],
      it21: map["IT-21"],
      it75: map["IT-75"],
      it88: map["IT-88"],
      it82: map["IT-82"],
      it52: map["IT-52"],
      it32: map["IT-32"],
      it55: map["IT-55"],
      it23: map["IT-23"],
      it34: map["IT-34"],
    );
  }
}

class SMapItaly {
  static const String instructions =
      """{"n": "Italy", "w": 610.30981, "h": 792.58575, "g": {"a": "6.624486,47.092916","b": "18.521301,35.490303"}, "i":[{"n": "Vatican City", "u": "VA-VA", "i": ["m0.4904070,0.4695271", "l0.4902268,0.4693883", "l0.4900629,0.4694262", "l0.4897844,0.4694767", "l0.4895222,0.4698047", "l0.4894731,0.4698804", "l0.4895714,0.4699813", "l0.4896697,0.4699561", "l0.4900957,0.4700318", "l0.4904234,0.4699309", "l0.4904562,0.4698552", "l0.4903906,0.4697542", "c"]}, {"n": "San Marino", "u": "SM-SM", "i": ["m0.4864090,0.2937607", "l0.4864090,0.2937607", "l0.4926845,0.2943032", "l0.4933236,0.2926125", "l0.4933236,0.2926125", "l0.4951915,0.2906443", "l0.4946671,0.2859129", "l0.4886046,0.2890419", "l0.4858847,0.2890798", "l0.4863435,0.2936345", "c"]}, {"n": "Corsica, France", "u": "FR-H", "i": ["m0.2355037,0.3730202", "l0.2389118,0.3752282", "l0.2378959,0.3773226", "l0.2394033,0.3796315", "l0.2414023,0.3911507", "l0.2391084,0.3953774", "l0.2375027,0.4029223", "l0.2436962,0.4111486", "l0.2449087,0.4146309", "l0.2456625,0.4243080", "l0.2446957,0.4292160", "l0.2470224,0.4368997", "l0.2465800,0.4507153", "l0.2461376,0.4524564", "l0.2346025,0.4654645", "l0.2347500,0.4687575", "l0.2333572,0.4720000", "l0.2341273,0.4769711", "l0.2331115,0.4788006", "l0.2342912,0.4815889", "l0.2341437,0.4861689", "l0.2336849,0.4878721", "l0.2313091,0.4891465", "l0.2326854,0.4910390", "l0.2311452,0.4927801", "l0.2298344,0.4945087", "l0.2259184,0.4934993", "l0.2259184,0.4945213", "l0.2236572,0.4954802", "l0.2242143,0.4981297", "l0.2267868,0.4955306", "l0.2309650,0.4966914", "l0.2289169,0.4994797", "l0.2230674,0.5019400", "l0.2239849,0.5030755", "l0.2226578,0.5046022", "l0.2242799,0.5050564", "l0.2239849,0.5064569", "l0.2224611,0.5071003", "l0.2234606,0.5076303", "l0.2188072,0.5094976", "l0.2191513,0.5116677", "l0.2182502,0.5123616", "l0.2187581,0.5128158", "l0.2223792,0.5107340", "l0.2218877,0.5119831", "l0.2186434,0.5160458", "l0.2151861,0.5162476", "l0.2132691,0.5138378", "l0.2079275,0.5136864", "l0.2100576,0.5095228", "l0.2059449,0.5093840", "l0.2033888,0.5083242", "l0.2021764,0.5079331", "l0.1986699,0.5068480", "l0.1967693,0.5052457", "l0.1933612,0.5055358", "l0.1908870,0.5032017", "l0.1896581,0.5025078", "l0.1868563,0.5030629", "l0.1877738,0.5005522", "l0.1850867,0.5008045", "l0.1821865,0.4997825", "l0.1817769,0.4988741", "l0.1811051,0.4966661", "l0.1824159,0.4962624", "l0.1824814,0.4934993", "l0.1836775,0.4923890", "l0.1849064,0.4934362", "l0.1876100,0.4918212", "l0.1893632,0.4919474", "l0.1901497,0.4898656", "l0.1929515,0.4890077", "l0.1927713,0.4881245", "l0.1868071,0.4876198", "l0.1842674,0.4861436", "l0.1817113,0.4873927", "l0.1811379,0.4838221", "l0.1754358,0.4855128", "l0.1752392,0.4839987", "l0.1713887,0.4838978", "l0.1715362,0.4830651", "l0.1735515,0.4833553", "l0.1774184,0.4807940", "l0.1778608,0.4790277", "l0.1789750,0.4777407", "l0.1808757,0.4777534", "l0.1818752,0.4759491", "l0.1822684,0.4743973", "l0.1814328,0.4715963", "l0.1834973,0.4705112", "l0.1817605,0.4681393", "l0.1802203,0.4683538", "l0.1785162,0.4685304", "l0.1764353,0.4694136", "l0.1699468,0.4692243", "l0.1670794,0.4706500", "l0.1683738,0.4670794", "l0.1658178,0.4644677", "l0.1705039,0.4641649", "l0.1722407,0.4629285", "l0.1710282,0.4615028", "l0.1715034,0.4603672", "l0.1788276,0.4571373", "l0.1780247,0.4557621", "l0.1764681,0.4559387", "l0.1748624,0.4516868", "l0.1714379,0.4527088", "l0.1703564,0.4508919", "l0.1674727,0.4497312", "l0.1648347,0.4503115", "l0.1659161,0.4489741", "l0.1651951,0.4482676", "l0.1628848,0.4487849", "l0.1631470,0.4465391", "l0.1651624,0.4458830", "l0.1648347,0.4435615", "l0.1635894,0.4436246", "l0.1623605,0.4417068", "l0.1614102,0.4407984", "l0.1744200,0.4382498", "l0.1715198,0.4351460", "l0.1698157,0.4354236", "l0.1686032,0.4342754", "l0.1668173,0.4348684", "l0.1662602,0.4336950", "l0.1687999,0.4325595", "l0.1678168,0.4310833", "l0.1657522,0.4307427", "l0.1629668,0.4325721", "l0.1629012,0.4301245", "l0.1616723,0.4294431", "l0.1620328,0.4284464", "l0.1638679,0.4293422", "l0.1644906,0.4281184", "l0.1672269,0.4278282", "l0.1669483,0.4252165", "l0.1711265,0.4253048", "l0.1722243,0.4227309", "l0.1732075,0.4206239", "l0.1705858,0.4197786", "l0.1720933,0.4165360", "l0.1757799,0.4147696", "l0.1768122,0.4129528", "l0.1764353,0.4117668", "l0.1754358,0.4118299", "l0.1770743,0.4105051", "l0.1772218,0.4125491", "l0.1795485,0.4116659", "l0.1799090,0.4127509", "l0.1823831,0.4132304", "l0.1842183,0.4100888", "l0.1834973,0.4089659", "l0.1889536,0.4084486", "l0.1899531,0.4066317", "l0.1926730,0.4066570", "l0.1936397,0.4057107", "l0.2014062,0.4055845", "l0.2052076,0.4038308", "l0.2060432,0.4011434", "l0.2073540,0.3991373", "l0.2106147,0.3976611", "l0.2141866,0.3972195", "l0.2167755,0.3982667", "l0.2187745,0.3973330", "l0.2196429,0.3986452", "l0.2217893,0.3988723", "l0.2227397,0.4003106", "l0.2240505,0.4025817", "l0.2252138,0.4024681", "l0.2290807,0.3972700", "l0.2288841,0.3920970", "l0.2260986,0.3887409", "l0.2286875,0.3858643", "l0.2271473,0.3828614", "l0.2304571,0.3807544", "l0.2294248,0.3802750", "l0.2302604,0.3789123", "l0.2287039,0.3745973", "l0.2301458,0.3734366", "l0.2355037,0.3730202", "c"]}, {"n": "Malta", "u": "MT-MT", "i": ["m0.6510467,0.9595561", "l0.6515383,0.9602374", "l0.6493591,0.9615496", "l0.6532587,0.9618272", "l0.6522429,0.9636062", "l0.6560114,0.9623949", "l0.6556673,0.9633791", "l0.6567160,0.9628239", "l0.6616315,0.9649940", "l0.6611564,0.9655996", "l0.6632373,0.9665585", "l0.6619101,0.9665333", "l0.6617626,0.9676814", "l0.6637124,0.9668992", "l0.6620412,0.9687791", "l0.6642859,0.9673408", "l0.6678906,0.9692838", "l0.6671861,0.9734978", "l0.6660064,0.9719333", "l0.6643515,0.9730941", "l0.6661702,0.9736114", "l0.6645481,0.9745450", "l0.6554216,0.9730310", "l0.6481793,0.9688170", "l0.6474912,0.9668109", "l0.6485562,0.9667225", "l0.6479008,0.9655492", "l0.6488839,0.9645777", "l0.6475239,0.9638585", "l0.6486217,0.9628996", "l0.6481957,0.9616884", "l0.6467211,0.9615244", "l0.6476222,0.9603131", "l0.6510467,0.9595561", "c", "m0.6484087,0.9575500", "l0.6494901,0.9584458", "l0.6472618,0.9588496", "l0.6471307,0.9577141", "l0.6484087,0.9575500", "c", "m0.6396591,0.9526799", "l0.6460493,0.9544589", "l0.6482285,0.9565911", "l0.6419530,0.9582440", "l0.6358413,0.9564397", "l0.6355464,0.9532350", "l0.6396591,0.9526799", "c"]}, {"n": "Abruzzo", "u": "IT-65", "i": ["m0.6132463,0.3835932", "l0.6154746,0.3915923", "l0.6191449,0.3985443", "l0.6294184,0.4126500", "l0.6409043,0.4223777", "l0.6544057,0.4301371", "l0.6558312,0.4330768", "l0.6618445,0.4375306", "l0.6623852,0.4392339", "l0.6714954,0.4439021", "l0.6799501,0.4462110", "l0.6802942,0.4523302", "l0.6859143,0.4553962", "l0.6859143,0.4553962", "l0.6839972,0.4577303", "l0.6854883,0.4587901", "l0.6808349,0.4612630", "l0.6770663,0.4648462", "l0.6757227,0.4687575", "l0.6718558,0.4708519", "l0.6690376,0.4755580", "l0.6612383,0.4820305", "l0.6578957,0.4815637", "l0.6591901,0.4807562", "l0.6574369,0.4753435", "l0.6556346,0.4739935", "l0.6516366,0.4719496", "l0.6499162,0.4736150", "l0.6489822,0.4733374", "l0.6473765,0.4705743", "l0.6453447,0.4707384", "l0.6438045,0.4691486", "l0.6390364,0.4721514", "l0.6366934,0.4749524", "l0.6330559,0.4751417", "l0.6323677,0.4762772", "l0.6344158,0.4807562", "l0.6369064,0.4818791", "l0.6362182,0.4831786", "l0.6348255,0.4830146", "l0.6344158,0.4817403", "l0.6333180,0.4833048", "l0.6300574,0.4833679", "l0.6290251,0.4866988", "l0.6277307,0.4840871", "l0.6258300,0.4842006", "l0.6244045,0.4872287", "l0.6222253,0.4872918", "l0.6217665,0.4891338", "l0.6187025,0.4878974", "l0.6152616,0.4885535", "l0.6152616,0.4885535", "l0.6111817,0.4844277", "l0.6079703,0.4846674", "l0.6040378,0.4828885", "l0.6023502,0.4837086", "l0.6001709,0.4832039", "l0.5973035,0.4790277", "l0.5951407,0.4799487", "l0.5933875,0.4784599", "l0.5904709,0.4778417", "l0.5887341,0.4804786", "l0.5820981,0.4821819", "l0.5796731,0.4810085", "l0.5784770,0.4787249", "l0.5754622,0.4781823", "l0.5730372,0.4763781", "l0.5702026,0.4754949", "l0.5679086,0.4772108", "l0.5662701,0.4726309", "l0.5683674,0.4697416", "l0.5667289,0.4679626", "l0.5650740,0.4681897", "l0.5618298,0.4653131", "l0.5603551,0.4657799", "l0.5478205,0.4601149", "l0.5444943,0.4592065", "l0.5444615,0.4607710", "l0.5405619,0.4599635", "l0.5382516,0.4571247", "l0.5384973,0.4509172", "l0.5397754,0.4513714", "l0.5431835,0.4491255", "l0.5432654,0.4461101", "l0.5461000,0.4459461", "l0.5568487,0.4503999", "l0.5588804,0.4494284", "l0.5616495,0.4502106", "l0.5634027,0.4473970", "l0.5658605,0.4470311", "l0.5649921,0.4461353", "l0.5679906,0.4457190", "l0.5648282,0.4441797", "l0.5643367,0.4421232", "l0.5603551,0.4410633", "l0.5561277,0.4378586", "l0.5550627,0.4337203", "l0.5489347,0.4305913", "l0.5523428,0.4276515", "l0.5458051,0.4229328", "l0.5510156,0.4198795", "l0.5508517,0.4168767", "l0.5492132,0.4145299", "l0.5509009,0.4137981", "l0.5521461,0.4103159", "l0.5566521,0.4116280", "l0.5576515,0.4107070", "l0.5598635,0.4107070", "l0.5608139,0.4119435", "l0.5632716,0.4109719", "l0.5669747,0.4113631", "l0.5691867,0.4098869", "l0.5704319,0.4055593", "l0.5671713,0.4047644", "l0.5652870,0.4030359", "l0.5661718,0.4009163", "l0.5661718,0.4009163", "l0.5661718,0.4009163", "l0.5661718,0.4009163", "l0.5661718,0.4009163", "l0.5661718,0.4009163", "l0.5688917,0.4015219", "l0.5719721,0.3998438", "l0.5729061,0.4004242", "l0.5738892,0.3974340", "l0.5777725,0.3969419", "l0.5782640,0.3938003", "l0.5804596,0.3919204", "l0.5808529,0.3901035", "l0.5842610,0.3915293", "l0.5881443,0.3901288", "l0.5892421,0.3913148", "l0.5914541,0.3911003", "l0.5947475,0.3899143", "l0.5955012,0.3871259", "l0.5966154,0.3866465", "l0.6011704,0.3864194", "l0.6046277,0.3846404", "l0.6128039,0.3832904", "l0.6128039,0.3832904", "c"]}, {"n": "Basilicata", "u": "IT-77", "i": ["m0.7495049,0.5427053", "l0.7489642,0.5411534", "l0.7511598,0.5396016", "l0.7543549,0.5391221", "l0.7619740,0.5401062", "l0.7660867,0.5389707", "l0.7684625,0.5402955", "l0.7712316,0.5391474", "l0.7709694,0.5379487", "l0.7737058,0.5374062", "l0.7734108,0.5364473", "l0.7747544,0.5368132", "l0.7770811,0.5357408", "l0.7808497,0.5378226", "l0.7837007,0.5382011", "l0.7840939,0.5395006", "l0.7861584,0.5398791", "l0.7871579,0.5428441", "l0.7881738,0.5423142", "l0.7911887,0.5442067", "l0.7901400,0.5455189", "l0.7906316,0.5474745", "l0.7876986,0.5500610", "l0.7852245,0.5497203", "l0.7862240,0.5511461", "l0.7953833,0.5541489", "l0.7979885,0.5560540", "l0.8014949,0.5535811", "l0.8047719,0.5544012", "l0.8095892,0.5625518", "l0.8203378,0.5701850", "l0.8216158,0.5723804", "l0.8241228,0.5729103", "l0.8298248,0.5678130", "l0.8331674,0.5709294", "l0.8330690,0.5685448", "l0.8346584,0.5682168", "l0.8360511,0.5698948", "l0.8362314,0.5676995", "l0.8390005,0.5686205", "l0.8406554,0.5678130", "l0.8409339,0.5690621", "l0.8428510,0.5699453", "l0.8437358,0.5690116", "l0.8485202,0.5718126", "l0.8468325,0.5724561", "l0.8488315,0.5742350", "l0.8473569,0.5788024", "l0.8488643,0.5813888", "l0.8478320,0.5819692", "l0.8471275,0.5856155", "l0.8487004,0.5868898", "l0.8479795,0.5879118", "l0.8498802,0.5890221", "l0.8483072,0.5916464", "l0.8497163,0.5928324", "l0.8525018,0.5922899", "l0.8554020,0.5936399", "l0.8560082,0.5956838", "l0.8588592,0.5975385", "l0.8601373,0.5998853", "l0.8601373,0.5998853", "l0.8536815,0.6070012", "l0.8458003,0.6200724", "l0.8420481,0.6221794", "l0.8420481,0.6221794", "l0.8375913,0.6209808", "l0.8324792,0.6222046", "l0.8274326,0.6209177", "l0.8243030,0.6213845", "l0.8232216,0.6199840", "l0.8221893,0.6218387", "l0.8225498,0.6254219", "l0.8208621,0.6282229", "l0.8212881,0.6307463", "l0.8162907,0.6376099", "l0.8181094,0.6390482", "l0.8173885,0.6407137", "l0.8138821,0.6376982", "l0.8106050,0.6374711", "l0.8058042,0.6383038", "l0.8057714,0.6405118", "l0.8012164,0.6389094", "l0.7995123,0.6402721", "l0.7916475,0.6406001", "l0.7891078,0.6384048", "l0.7897140,0.6376225", "l0.7883213,0.6356038", "l0.7903530,0.6327902", "l0.7884524,0.6323865", "l0.7860110,0.6334589", "l0.7848804,0.6322477", "l0.7818492,0.6318692", "l0.7795061,0.6334211", "l0.7784902,0.6323234", "l0.7769664,0.6329416", "l0.7754917,0.6317556", "l0.7727390,0.6319827", "l0.7688885,0.6351748", "l0.7673319,0.6384552", "l0.7673319,0.6384552", "l0.7643990,0.6339762", "l0.7609581,0.6315538", "l0.7607287,0.6296865", "l0.7579760,0.6284500", "l0.7579760,0.6284500", "l0.7607451,0.6271757", "l0.7586642,0.6254345", "l0.7606468,0.6250056", "l0.7632029,0.6223308", "l0.7626786,0.6186593", "l0.7653330,0.6165775", "l0.7651036,0.6153158", "l0.7707892,0.6134485", "l0.7699372,0.6118966", "l0.7714610,0.6108494", "l0.7713954,0.6090578", "l0.7703960,0.6076068", "l0.7655951,0.6065344", "l0.7653657,0.6048689", "l0.7626786,0.6029638", "l0.7625966,0.5997339", "l0.7591558,0.5987750", "l0.7565341,0.5960749", "l0.7531588,0.5947754", "l0.7523723,0.5925927", "l0.7488168,0.5904352", "l0.7499965,0.5890726", "l0.7477845,0.5850225", "l0.7489314,0.5839879", "l0.7418039,0.5806697", "l0.7430000,0.5781211", "l0.7457036,0.5768467", "l0.7458019,0.5758248", "l0.7360855,0.5709673", "l0.7363641,0.5648480", "l0.7350205,0.5647597", "l0.7353810,0.5632709", "l0.7320056,0.5616686", "l0.7354465,0.5614793", "l0.7356431,0.5587793", "l0.7339718,0.5581232", "l0.7346764,0.5572905", "l0.7425249,0.5586531", "l0.7435735,0.5582115", "l0.7431967,0.5567480", "l0.7480467,0.5551204", "l0.7517497,0.5477143", "c"]}, {"n": "Calabria", "u": "IT-78", "i": ["m0.7673319,0.6384552", "l0.7688885,0.6351748", "l0.7727390,0.6319954", "l0.7754917,0.6317682", "l0.7769664,0.6329416", "l0.7784902,0.6323234", "l0.7795061,0.6334211", "l0.7818492,0.6318692", "l0.7848968,0.6322477", "l0.7860274,0.6334589", "l0.7884687,0.6323865", "l0.7903694,0.6327776", "l0.7883377,0.6355912", "l0.7897304,0.6376099", "l0.7891241,0.6383921", "l0.7916638,0.6405875", "l0.7995287,0.6402594", "l0.8012328,0.6388968", "l0.8057878,0.6404865", "l0.8058206,0.6382786", "l0.8106214,0.6374585", "l0.8138985,0.6376856", "l0.8174049,0.6406884", "l0.8181258,0.6390230", "l0.8163235,0.6375847", "l0.8213209,0.6307210", "l0.8208785,0.6281850", "l0.8225662,0.6253967", "l0.8222221,0.6218135", "l0.8232544,0.6199714", "l0.8243358,0.6213593", "l0.8274653,0.6208925", "l0.8325283,0.6221794", "l0.8376405,0.6209555", "l0.8420972,0.6221541", "l0.8420972,0.6221541", "l0.8389677,0.6252327", "l0.8384106,0.6285509", "l0.8406390,0.6358561", "l0.8331018,0.6432118", "l0.8290055,0.6490534", "l0.8290711,0.6527376", "l0.8323645,0.6556647", "l0.8314633,0.6600302", "l0.8397869,0.6638279", "l0.8529606,0.6639793", "l0.8606944,0.6707041", "l0.8683790,0.6743252", "l0.8740646,0.6754481", "l0.8753427,0.6780472", "l0.8788491,0.6806462", "l0.8852720,0.6823495", "l0.8814052,0.6897683", "l0.8809955,0.6944239", "l0.8845511,0.6984361", "l0.8813396,0.7067002", "l0.8836991,0.7090722", "l0.8831911,0.7102708", "l0.8843709,0.7117091", "l0.8893847,0.7135386", "l0.8858455,0.7160115", "l0.8862551,0.7195442", "l0.8799960,0.7245910", "l0.8795536,0.7232031", "l0.8772433,0.7225597", "l0.8737861,0.7235186", "l0.8702797,0.7207807", "l0.8625950,0.7217144", "l0.8532227,0.7244018", "l0.8388858,0.7312401", "l0.8329052,0.7395042", "l0.8347895,0.7420781", "l0.8369359,0.7593128", "l0.8361822,0.7628708", "l0.8269246,0.7702895", "l0.8150618,0.7741503", "l0.8019537,0.7869187", "l0.8002988,0.7954729", "l0.7961370,0.8015669", "l0.7933679,0.8042165", "l0.7878953,0.8048978", "l0.7812921,0.8037118", "l0.7678726,0.8046833", "l0.7609254,0.8016426", "l0.7573698,0.7965075", "l0.7591230,0.7945897", "l0.7570421,0.7903126", "l0.7591066,0.7866537", "l0.7572715,0.7824144", "l0.7573534,0.7789826", "l0.7640713,0.7768630", "l0.7671681,0.7767873", "l0.7713954,0.7749452", "l0.7734436,0.7722073", "l0.7741973,0.7681951", "l0.7760816,0.7668830", "l0.7773924,0.7634259", "l0.7798010,0.7617353", "l0.7809971,0.7592876", "l0.7822260,0.7531431", "l0.7735091,0.7471375", "l0.7742956,0.7448412", "l0.7772613,0.7426711", "l0.7841758,0.7409047", "l0.7870269,0.7385958", "l0.7910576,0.7382173", "l0.7966613,0.7395042", "l0.7994959,0.7388734", "l0.8034611,0.7364762", "l0.8067054,0.7283004", "l0.8062302,0.7218405", "l0.8011672,0.7199480", "l0.7962189,0.7129077", "l0.7935645,0.7037352", "l0.7922865,0.6905379", "l0.7877806,0.6790944", "l0.7818000,0.6719027", "l0.7774743,0.6695181", "l0.7740007,0.6602447", "l0.7725096,0.6592984", "l0.7702157,0.6482081", "l0.7686427,0.6460758", "l0.7705270,0.6436282", "l0.7673319,0.6384552", "c"]}, {"n": "Campania", "u": "IT-72", "i": ["m0.6389217,0.5848837", "l0.6422152,0.5851865", "l0.6410846,0.5863473", "l0.6362837,0.5868646", "l0.6364967,0.5848080", "l0.6389217,0.5848837", "c", "m0.6089206,0.5678887", "l0.6161464,0.5694028", "l0.6170148,0.5703743", "l0.6158843,0.5729860", "l0.6112637,0.5730238", "l0.6107557,0.5737808", "l0.6075115,0.5724687", "l0.6074459,0.5701093", "l0.6089206,0.5678887", "c", "m0.6180963,0.5077438", "l0.6205868,0.5087153", "l0.6201280,0.5106331", "l0.6235033,0.5137242", "l0.6270261,0.5131186", "l0.6291562,0.5142037", "l0.6287138,0.5111504", "l0.6264691,0.5090434", "l0.6300738,0.5039587", "l0.6338260,0.5063686", "l0.6344650,0.5046274", "l0.6401179,0.5047031", "l0.6404619,0.5057756", "l0.6433621,0.5057882", "l0.6438045,0.5070751", "l0.6471307,0.5084504", "l0.6602552,0.5114027", "l0.6608778,0.5134088", "l0.6628276,0.5145570", "l0.6683003,0.5139009", "l0.6702993,0.5161215", "l0.6738876,0.5136612", "l0.6756080,0.5135855", "l0.6755425,0.5123995", "l0.6787704,0.5120967", "l0.6803106,0.5130303", "l0.6833910,0.5122985", "l0.6862092,0.5086522", "l0.6927796,0.5107971", "l0.6953521,0.5087910", "l0.6996942,0.5085134", "l0.7045769,0.5058639", "l0.7045769,0.5058639", "l0.7075426,0.5094471", "l0.7122288,0.5104565", "l0.7125401,0.5114658", "l0.7111965,0.5124499", "l0.7120813,0.5139640", "l0.7103445,0.5141911", "l0.7089681,0.5156672", "l0.7099840,0.5189729", "l0.7148504,0.5203103", "l0.7151945,0.5230481", "l0.7207982,0.5228715", "l0.7225022,0.5247388", "l0.7251566,0.5243351", "l0.7272212,0.5261393", "l0.7245832,0.5274262", "l0.7259759,0.5304291", "l0.7226661,0.5319431", "l0.7213389,0.5344539", "l0.7239114,0.5354254", "l0.7251075,0.5378100", "l0.7284009,0.5396268", "l0.7302033,0.5384913", "l0.7348402,0.5399927", "l0.7376257,0.5383651", "l0.7410666,0.5406362", "l0.7436391,0.5404595", "l0.7495377,0.5427306", "l0.7495377,0.5427306", "l0.7517825,0.5477395", "l0.7480794,0.5551456", "l0.7432294,0.5567732", "l0.7436063,0.5582368", "l0.7425576,0.5586784", "l0.7347092,0.5573031", "l0.7339882,0.5581485", "l0.7356595,0.5587919", "l0.7354629,0.5615046", "l0.7320220,0.5616938", "l0.7353973,0.5632962", "l0.7350369,0.5647723", "l0.7363968,0.5648607", "l0.7361183,0.5709799", "l0.7458347,0.5758374", "l0.7457363,0.5768594", "l0.7430164,0.5781211", "l0.7418203,0.5806697", "l0.7489478,0.5839879", "l0.7478173,0.5850225", "l0.7500293,0.5890726", "l0.7488495,0.5904352", "l0.7523887,0.5925927", "l0.7531916,0.5947754", "l0.7565669,0.5960749", "l0.7591885,0.5987750", "l0.7626294,0.5997339", "l0.7627113,0.6029638", "l0.7654149,0.6048689", "l0.7656443,0.6065344", "l0.7704451,0.6076068", "l0.7714446,0.6090578", "l0.7715101,0.6108620", "l0.7699863,0.6119092", "l0.7708384,0.6134611", "l0.7651527,0.6153158", "l0.7653821,0.6165775", "l0.7627441,0.6186593", "l0.7632684,0.6223308", "l0.7607124,0.6250056", "l0.7587461,0.6254345", "l0.7608270,0.6271631", "l0.7580416,0.6284374", "l0.7580416,0.6284374", "l0.7566325,0.6259645", "l0.7520774,0.6254850", "l0.7462115,0.6266710", "l0.7392642,0.6328155", "l0.7337097,0.6320963", "l0.7303835,0.6295981", "l0.7267624,0.6302921", "l0.7264511,0.6294972", "l0.7278602,0.6286771", "l0.7267296,0.6258635", "l0.7213061,0.6218513", "l0.7188811,0.6215738", "l0.7147685,0.6177508", "l0.7071002,0.6178265", "l0.7027582,0.6136630", "l0.6967285,0.6122246", "l0.6957126,0.6108872", "l0.6989568,0.6089947", "l0.6991207,0.6039353", "l0.7033972,0.6020428", "l0.7034136,0.5983334", "l0.6935006,0.5824865", "l0.6847673,0.5754210", "l0.6802942,0.5759509", "l0.6780658,0.5786383", "l0.6725932,0.5774145", "l0.6681528,0.5804426", "l0.6643023,0.5809599", "l0.6603207,0.5792818", "l0.6471143,0.5841646", "l0.6483923,0.5789916", "l0.6535700,0.5781968", "l0.6542746,0.5763421", "l0.6601405,0.5732383", "l0.6583709,0.5692387", "l0.6532915,0.5680023", "l0.6474912,0.5630943", "l0.6429689,0.5607728", "l0.6386268,0.5621733", "l0.6356120,0.5651761", "l0.6332033,0.5648985", "l0.6344814,0.5644191", "l0.6333180,0.5631321", "l0.6278290,0.5619209", "l0.6260267,0.5629050", "l0.6274194,0.5662990", "l0.6237327,0.5653401", "l0.6237164,0.5596373", "l0.6218812,0.5546788", "l0.6175392,0.5493418", "l0.6174409,0.5491526", "l0.6134920,0.5458722", "l0.6111981,0.5397782", "l0.6053650,0.5324351", "l0.6001382,0.5283851", "l0.6001382,0.5283851", "l0.6010393,0.5267197", "l0.6059549,0.5259879", "l0.6067741,0.5250164", "l0.6057091,0.5247136", "l0.6058730,0.5234140", "l0.6109687,0.5220136", "l0.6092811,0.5163738", "l0.6106246,0.5144813", "l0.6084618,0.5116803", "l0.6119846,0.5112135", "l0.6169821,0.5077186", "l0.6180963,0.5077438", "c"]}, {"n": "Emilia-Romagna", "u": "IT-45", "i": ["m0.5150011,0.2878938", "l0.5130840,0.2917924", "l0.5134609,0.2970032", "l0.5093318,0.2982523", "l0.5084470,0.3009018", "l0.5036626,0.3004476", "l0.5039739,0.2991355", "l0.5026631,0.2987443", "l0.5015325,0.2955775", "l0.4970758,0.2970032", "l0.4970758,0.2943032", "l0.4933563,0.2926377", "l0.4933563,0.2926377", "l0.4952079,0.2906695", "l0.4946835,0.2859382", "l0.4886210,0.2890672", "l0.4859011,0.2891176", "l0.4863599,0.2936597", "l0.4863599,0.2936597", "l0.4863599,0.2936597", "l0.4863599,0.2936597", "l0.4883425,0.2964607", "l0.4856881,0.2964481", "l0.4851310,0.2954135", "l0.4818704,0.2964102", "l0.4802155,0.3007883", "l0.4759553,0.3034252", "l0.4756276,0.3061631", "l0.4756276,0.3061631", "l0.4755621,0.3061252", "l0.4755621,0.3061252", "l0.4728749,0.3072482", "l0.4695488,0.3067813", "l0.4681888,0.3092669", "l0.4656491,0.3063524", "l0.4632896,0.3073617", "l0.4609793,0.3071598", "l0.4609793,0.3071598", "l0.4581611,0.3082954", "l0.4563423,0.3066930", "l0.4563423,0.3066930", "l0.4548349,0.3070084", "l0.4524427,0.3058729", "l0.4507059,0.3064028", "l0.4507059,0.3064028", "l0.4480351,0.3050780", "l0.4476910,0.3038542", "l0.4476910,0.3038542", "l0.4454790,0.3036271", "l0.4446270,0.3019995", "l0.4369915,0.3017346", "l0.4337145,0.2986939", "l0.4278486,0.2961705", "l0.4282910,0.2923097", "l0.4253089,0.2907704", "l0.4258496,0.2887139", "l0.4222941,0.2860896", "l0.4227037,0.2846386", "l0.4238015,0.2847522", "l0.4234738,0.2833769", "l0.4262265,0.2825694", "l0.4269311,0.2800587", "l0.4302572,0.2772956", "l0.4308143,0.2739016", "l0.4218517,0.2752895", "l0.4175096,0.2748353", "l0.4198855,0.2721857", "l0.4195741,0.2708735", "l0.4153140,0.2702048", "l0.4136263,0.2714665", "l0.4116601,0.2711385", "l0.4088255,0.2686530", "l0.4065480,0.2681735", "l0.4059909,0.2654735", "l0.4038116,0.2639595", "l0.3997809,0.2669749", "l0.3957010,0.2673030", "l0.3953733,0.2686530", "l0.3916375,0.2712647", "l0.3850998,0.2714413", "l0.3849196,0.2726273", "l0.3897204,0.2747722", "l0.3901301,0.2761348", "l0.3859683,0.2763367", "l0.3809052,0.2752138", "l0.3754326,0.2770432", "l0.3709103,0.2766395", "l0.3683706,0.2751885", "l0.3693865,0.2738764", "l0.3687311,0.2727282", "l0.3607679,0.2796171", "l0.3596865,0.2792386", "l0.3602108,0.2780400", "l0.3590967,0.2768918", "l0.3553608,0.2762610", "l0.3472174,0.2711763", "l0.3380909,0.2710123", "l0.3364524,0.2725642", "l0.3365671,0.2742675", "l0.3338308,0.2747974", "l0.3282271,0.2709492", "l0.3278338,0.2689936", "l0.3249828,0.2669749", "l0.3250648,0.2652338", "l0.3230658,0.2643884", "l0.3203295,0.2647543", "l0.3154958,0.2609188", "l0.3128742,0.2608809", "l0.3092859,0.2593291", "l0.3053862,0.2608305", "l0.2961614,0.2533234", "l0.2921634,0.2539669", "l0.2851506,0.2502575", "l0.2832991,0.2486677", "l0.2841839,0.2453621", "l0.2824634,0.2450972", "l0.2816442,0.2435327", "l0.2776626,0.2424350", "l0.2688966,0.2431794", "l0.2633092,0.2499547", "l0.2574106,0.2525916", "l0.2574106,0.2525916", "l0.2550839,0.2484028", "l0.2506599,0.2458920", "l0.2489395,0.2467121", "l0.2466292,0.2456144", "l0.2460557,0.2468257", "l0.2415006,0.2471663", "l0.2399604,0.2485920", "l0.2395344,0.2471159", "l0.2368309,0.2476079", "l0.2393542,0.2419177", "l0.2415170,0.2416527", "l0.2423035,0.2373377", "l0.2408944,0.2347008", "l0.2356020,0.2333003", "l0.2343076,0.2311176", "l0.2303096,0.2333760", "l0.2251483,0.2301587", "l0.2244273,0.2314835", "l0.2209865,0.2310419", "l0.2215436,0.2299821", "l0.2205768,0.2291872", "l0.2168738,0.2297423", "l0.2168738,0.2297423", "l0.2168246,0.2233329", "l0.2176275,0.2235727", "l0.2176275,0.2235727", "l0.2204949,0.2234339", "l0.2199706,0.2208853", "l0.2221170,0.2240521", "l0.2274094,0.2229797", "l0.2262461,0.2212259", "l0.2277044,0.2199138", "l0.2274586,0.2183745", "l0.2246076,0.2172011", "l0.2241160,0.2158133", "l0.2304243,0.2109179", "l0.2286711,0.2068174", "l0.2270817,0.2057828", "l0.2258856,0.2062875", "l0.2230182,0.2042561", "l0.2250664,0.2021870", "l0.2240833,0.2009000", "l0.2268032,0.2003701", "l0.2290479,0.1952603", "l0.2317351,0.1930523", "l0.2315385,0.1903018", "l0.2348974,0.1879803", "l0.2347172,0.1871350", "l0.2367326,0.1873621", "l0.2372569,0.1863401", "l0.2419103,0.1854317", "l0.2444827,0.1877784", "l0.2463343,0.1864789", "l0.2453020,0.1830345", "l0.2464981,0.1828831", "l0.2491197,0.1855831", "l0.2512170,0.1849018", "l0.2522820,0.1824919", "l0.2537895,0.1840691", "l0.2535437,0.1872233", "l0.2603927,0.1894817", "l0.2630471,0.1876901", "l0.2638663,0.1864158", "l0.2626374,0.1850406", "l0.2640630,0.1846999", "l0.2654229,0.1866429", "l0.2684542,0.1878415", "l0.2690604,0.1901883", "l0.2705842,0.1861382", "l0.2722227,0.1861761", "l0.2738776,0.1880434", "l0.2753195,0.1875513", "l0.2756472,0.1860878", "l0.2737957,0.1840817", "l0.2767450,0.1822396", "l0.2779411,0.1830092", "l0.2773185,0.1857723", "l0.2820374,0.1829840", "l0.2834957,0.1830976", "l0.2865761,0.1861887", "l0.2858552,0.1880686", "l0.2883457,0.1896205", "l0.2884604,0.1911598", "l0.2909018,0.1907182", "l0.2922126,0.1929135", "l0.2976688,0.1909453", "l0.2985372,0.1921187", "l0.3021747,0.1920430", "l0.3070903,0.1950332", "l0.3097119,0.1950836", "l0.3143489,0.1979477", "l0.3183632,0.1962570", "l0.3207719,0.1999412", "l0.3282599,0.2027547", "l0.3347156,0.2025402", "l0.3370914,0.2014804", "l0.3417776,0.1962822", "l0.3425149,0.1983262", "l0.3454642,0.1957145", "l0.3470536,0.1996510", "l0.3542794,0.2005594", "l0.3555083,0.2015561", "l0.3569502,0.2013543", "l0.3570813,0.2023005", "l0.3592769,0.2020860", "l0.3589492,0.2028178", "l0.3613414,0.2016823", "l0.3635534,0.2019599", "l0.3639303,0.2005089", "l0.3677316,0.1990075", "l0.3728438,0.1993355", "l0.3743676,0.1983388", "l0.3787096,0.1991463", "l0.3807086,0.2011019", "l0.3816098,0.2002818", "l0.3879836,0.1998907", "l0.3885735,0.1990580", "l0.3909985,0.2003827", "l0.3937348,0.1983767", "l0.4039427,0.1995374", "l0.4039427,0.1995374", "l0.4042049,0.2014173", "l0.4135444,0.2009505", "l0.4169853,0.2027295", "l0.4176898,0.2047734", "l0.4188532,0.2050889", "l0.4208849,0.2049375", "l0.4241947,0.2025402", "l0.4294216,0.2014173", "l0.4306341,0.1986164", "l0.4354185,0.1969005", "l0.4456920,0.1970014", "l0.4493131,0.1960173", "l0.4602912,0.1973673", "l0.4640434,0.2012533", "l0.4664683,0.2000295", "l0.4677955,0.2013543", "l0.4713183,0.2015687", "l0.4737106,0.1999412", "l0.4754802,0.1999285", "l0.4768401,0.2012912", "l0.4758079,0.2028557", "l0.4763486,0.2065020", "l0.4773972,0.2077006", "l0.4806579,0.2083440", "l0.4816410,0.2110945", "l0.4816410,0.2110945", "l0.4805759,0.2113090", "l0.4786261,0.2089875", "l0.4766763,0.2085333", "l0.4738417,0.2114099", "l0.4759062,0.2107791", "l0.4731862,0.2162927", "l0.4722195,0.2225759", "l0.4730060,0.2267521", "l0.4762175,0.2315844", "l0.4760373,0.2427378", "l0.4789374,0.2487434", "l0.4792815,0.2530206", "l0.4826405,0.2620417", "l0.4855242,0.2664955", "l0.4965187,0.2763619", "l0.5006477,0.2784942", "l0.5104296,0.2866069", "l0.5150011,0.2878938", "c", "m0.4667961,0.3021635", "l0.4663537,0.3035892", "l0.4685984,0.3055953", "l0.4721704,0.3041822", "l0.4716788,0.3027944", "l0.4716788,0.3027944", "l0.4713347,0.3022014", "l0.4667961,0.3021635", "c"]}, {"n": "Friuli-Venezia Giulia", "u": "IT-36", "i": ["m0.5188188,0.0432515", "l0.5219811,0.0440590", "l0.5219811,0.0458632", "l0.5231281,0.0463300", "l0.5298624,0.0459515", "l0.5399392,0.0474529", "l0.5431179,0.0467716", "l0.5499505,0.0480585", "l0.5559475,0.0515408", "l0.5587330,0.0506450", "l0.5629112,0.0515408", "l0.5648446,0.0499258", "l0.5670238,0.0501151", "l0.5672041,0.0489669", "l0.5702189,0.0496230", "l0.5700551,0.0506324", "l0.5716281,0.0510235", "l0.5780183,0.0501403", "l0.5792799,0.0519572", "l0.5829010,0.0515408", "l0.5838841,0.0528277", "l0.5878166,0.0524618", "l0.5959763,0.0544427", "l0.5935186,0.0621390", "l0.5904054,0.0613189", "l0.5856209,0.0622526", "l0.5833762,0.0658484", "l0.5753802,0.0693307", "l0.5728078,0.0694190", "l0.5728406,0.0727877", "l0.5673352,0.0754120", "l0.5713823,0.0811780", "l0.5704319,0.0833355", "l0.5734304,0.0831084", "l0.5733157,0.0819476", "l0.5762814,0.0820233", "l0.5779036,0.0829191", "l0.5802466,0.0826163", "l0.5828519,0.0839411", "l0.5839005,0.0858084", "l0.5891437,0.0851775", "l0.5914704,0.0861995", "l0.5897828,0.0902622", "l0.5839333,0.0946150", "l0.5777561,0.0976305", "l0.5782476,0.1004945", "l0.5756752,0.1025258", "l0.5806726,0.1061216", "l0.5833598,0.1058315", "l0.5855390,0.1039515", "l0.5897664,0.1043805", "l0.5893076,0.1087712", "l0.5841627,0.1164171", "l0.5858667,0.1205302", "l0.5880459,0.1216531", "l0.5919456,0.1211736", "l0.5984669,0.1254256", "l0.6025959,0.1262709", "l0.6084946,0.1342069", "l0.6130660,0.1367682", "l0.6063154,0.1414112", "l0.6027762,0.1415878", "l0.5987290,0.1399476", "l0.5962713,0.1404145", "l0.5961238,0.1392411", "l0.5974019,0.1387112", "l0.6018422,0.1397836", "l0.6038248,0.1385724", "l0.6014817,0.1386355", "l0.6007280,0.1366672", "l0.5990731,0.1369448", "l0.5981064,0.1361121", "l0.6001218,0.1349261", "l0.5989421,0.1323270", "l0.5888652,0.1240125", "l0.5847689,0.1230914", "l0.5829174,0.1235582", "l0.5819998,0.1225489", "l0.5797551,0.1244162", "l0.5794438,0.1265106", "l0.5823275,0.1283022", "l0.5768221,0.1303462", "l0.5755113,0.1300055", "l0.5720377,0.1326046", "l0.5680725,0.1328948", "l0.5596669,0.1294125", "l0.5566521,0.1290340", "l0.5561441,0.1290340", "l0.5559967,0.1289457", "l0.5490657,0.1303588", "l0.5443468,0.1359355", "l0.5443468,0.1359355", "l0.5425936,0.1351784", "l0.5427902,0.1344088", "l0.5411845,0.1345602", "l0.5414630,0.1328948", "l0.5398082,0.1318854", "l0.5404144,0.1308761", "l0.5391200,0.1306237", "l0.5381860,0.1272550", "l0.5365967,0.1281508", "l0.5371701,0.1266746", "l0.5361051,0.1250344", "l0.5369080,0.1247064", "l0.5335818,0.1222713", "l0.5353678,0.1214638", "l0.5340242,0.1210349", "l0.5343191,0.1200003", "l0.5336801,0.1195334", "l0.5337457,0.1191423", "l0.5327953,0.1171488", "l0.5318286,0.1174517", "l0.5325659,0.1192433", "l0.5300262,0.1198741", "l0.5292234,0.1184989", "l0.5267328,0.1196848", "l0.5246847,0.1182465", "l0.5253401,0.1168587", "l0.5242914,0.1167703", "l0.5207359,0.1181456", "l0.5198347,0.1194577", "l0.5188024,0.1185367", "l0.5195070,0.1172750", "l0.5176555,0.1162152", "l0.5144112,0.1188647", "l0.5133134,0.1180194", "l0.5069560,0.1225489", "l0.5068741,0.1205049", "l0.5050389,0.1198489", "l0.5048423,0.1187260", "l0.5028105,0.1178932", "l0.5016964,0.1199246", "l0.4984193,0.1185998", "l0.4987798,0.1170858", "l0.4965023,0.1154960", "l0.4944378,0.1097806", "l0.4920128,0.1097679", "l0.4903087,0.1078628", "l0.4879656,0.1078123", "l0.4879329,0.1034342", "l0.4867695,0.1001538", "l0.4852621,0.0991445", "l0.4881622,0.0955991", "l0.4929139,0.0931262", "l0.4936513,0.0886093", "l0.4896861,0.0861490", "l0.4891945,0.0834616", "l0.4861960,0.0835878", "l0.4857700,0.0815943", "l0.4823619,0.0816196", "l0.4788883,0.0780237", "l0.4818376,0.0756518", "l0.4817721,0.0731410", "l0.4834761,0.0720812", "l0.4866057,0.0724218", "l0.4871464,0.0698732", "l0.4901448,0.0686998", "l0.4898499,0.0679428", "l0.4908330,0.0682835", "l0.4903087,0.0665423", "l0.4935857,0.0643218", "l0.4940445,0.0621138", "l0.4964695,0.0595399", "l0.4971413,0.0600825", "l0.4997138,0.0585053", "l0.5027450,0.0595021", "l0.5044491,0.0585053", "l0.5074312,0.0594895", "l0.5067921,0.0572941", "l0.5047768,0.0562848", "l0.5049734,0.0550988", "l0.5106426,0.0523483", "l0.5148208,0.0522726", "l0.5133790,0.0508090", "l0.5145259,0.0479450", "l0.5129366,0.0458506", "l0.5132479,0.0435795", "l0.5132479,0.0435795", "l0.5159514,0.0424314", "l0.5188188,0.0432515", "c"]}, {"n": "Lazio", "u": "IT-62", "i": ["m0.5331230,0.5546788", "l0.5327134,0.5563442", "l0.5336473,0.5565840", "l0.5320088,0.5580349", "l0.5317139,0.5544769", "l0.5353842,0.5532026", "l0.5331230,0.5546788", "c", "m0.6176866,0.5050438", "l0.6193415,0.5061162", "l0.6180963,0.5077564", "l0.6168674,0.5077186", "l0.6118863,0.5112135", "l0.6083635,0.5116803", "l0.6105263,0.5144813", "l0.6091991,0.5163738", "l0.6108868,0.5220136", "l0.6057910,0.5234267", "l0.6056272,0.5247262", "l0.6066922,0.5250290", "l0.6058730,0.5260005", "l0.6009574,0.5267323", "l0.6000562,0.5283977", "l0.5954520,0.5258491", "l0.5934530,0.5266061", "l0.5888488,0.5251552", "l0.5840152,0.5272496", "l0.5841954,0.5290917", "l0.5856701,0.5298487", "l0.5823275,0.5299370", "l0.5676792,0.5233636", "l0.5605681,0.5220514", "l0.5578809,0.5233131", "l0.5540796,0.5231617", "l0.5492951,0.5243351", "l0.5438717,0.5283094", "l0.5399228,0.5280697", "l0.5351220,0.5195785", "l0.5291251,0.5146705", "l0.5232264,0.5121597", "l0.5177046,0.5117308", "l0.5163774,0.5125256", "l0.5084798,0.5084504", "l0.5056943,0.5088036", "l0.5054649,0.5096994", "l0.5040394,0.5092326", "l0.4985996,0.5018391", "l0.4869989,0.4911778", "l0.4809692,0.4872413", "l0.4707940,0.4836707", "l0.4692702,0.4762267", "l0.4641417,0.4689720", "l0.4562276,0.4654014", "l0.4540976,0.4629537", "l0.4499030,0.4617172", "l0.4489690,0.4601906", "l0.4451349,0.4583233", "l0.4381385,0.4591182", "l0.4354022,0.4542102", "l0.4304211,0.4491508", "l0.4301262,0.4467788", "l0.4266525,0.4413914", "l0.4229659,0.4374044", "l0.4140523,0.4318151", "l0.4056468,0.4287240", "l0.4086944,0.4234879", "l0.4198363,0.4233870", "l0.4196888,0.4190594", "l0.4151174,0.4166496", "l0.4173621,0.4142019", "l0.4166248,0.4119813", "l0.4176407,0.4115649", "l0.4195086,0.4128897", "l0.4206064,0.4117668", "l0.4219336,0.4120570", "l0.4247846,0.4109467", "l0.4251287,0.4095841", "l0.4275865,0.4081836", "l0.4297001,0.4084990", "l0.4311912,0.4057990", "l0.4334359,0.4060387", "l0.4357299,0.4048780", "l0.4355988,0.4035153", "l0.4338783,0.4029097", "l0.4332066,0.3996041", "l0.4352219,0.3996167", "l0.4369260,0.3966391", "l0.4307324,0.3929045", "l0.4326331,0.3898260", "l0.4346157,0.3904190", "l0.4357626,0.3920844", "l0.4365983,0.3895484", "l0.4392690,0.3881984", "l0.4433326,0.3883750", "l0.4459869,0.3932830", "l0.4505420,0.3955541", "l0.4488871,0.3980522", "l0.4458559,0.3993644", "l0.4479695,0.4020265", "l0.4547530,0.4052565", "l0.4607827,0.4036037", "l0.4624376,0.4049537", "l0.4626342,0.4040074", "l0.4637320,0.4042850", "l0.4659932,0.4027836", "l0.4686640,0.4036415", "l0.4714003,0.4062406", "l0.4723015,0.4118804", "l0.4750378,0.4128645", "l0.4746937,0.4153374", "l0.4763977,0.4164098", "l0.4751688,0.4172552", "l0.4776594,0.4182645", "l0.4765288,0.4188449", "l0.4795928,0.4185800", "l0.4816082,0.4201697", "l0.4848852,0.4181257", "l0.4872938,0.4183276", "l0.4868842,0.4206744", "l0.4880967,0.4215323", "l0.4869825,0.4218225", "l0.4869661,0.4244216", "l0.4907183,0.4254310", "l0.4891290,0.4272226", "l0.4950932,0.4265665", "l0.4950112,0.4286861", "l0.4964367,0.4299478", "l0.5035315,0.4257085", "l0.5038920,0.4208132", "l0.5058418,0.4207122", "l0.5073001,0.4230590", "l0.5092827,0.4229959", "l0.5141818,0.4205103", "l0.5119371,0.4179365", "l0.5169509,0.4168262", "l0.5172295,0.4151482", "l0.5205884,0.4152743", "l0.5236197,0.4132178", "l0.5270441,0.4123724", "l0.5260283,0.4091551", "l0.5269786,0.4076789", "l0.5302884,0.4089280", "l0.5315992,0.4077042", "l0.5369244,0.4077546", "l0.5380877,0.4058242", "l0.5414630,0.4071869", "l0.5460509,0.4050168", "l0.5461328,0.4040326", "l0.5487872,0.4048401", "l0.5509664,0.4032252", "l0.5521953,0.3976106", "l0.5575696,0.3986074", "l0.5584544,0.3971312", "l0.5602404,0.3970050", "l0.5662701,0.4009920", "l0.5653853,0.4031242", "l0.5672696,0.4048401", "l0.5705303,0.4056350", "l0.5692850,0.4099752", "l0.5670730,0.4114514", "l0.5633700,0.4110477", "l0.5609122,0.4120192", "l0.5599618,0.4107953", "l0.5577499,0.4107827", "l0.5567504,0.4117037", "l0.5522445,0.4104042", "l0.5509992,0.4138865", "l0.5493115,0.4146056", "l0.5509500,0.4169524", "l0.5511139,0.4199552", "l0.5459034,0.4230085", "l0.5524411,0.4277272", "l0.5490166,0.4306796", "l0.5551446,0.4337960", "l0.5562097,0.4379469", "l0.5604370,0.4411516", "l0.5644022,0.4421989", "l0.5648938,0.4442554", "l0.5680725,0.4457947", "l0.5650740,0.4462110", "l0.5659260,0.4470942", "l0.5634847,0.4474601", "l0.5617314,0.4502737", "l0.5589624,0.4494914", "l0.5569306,0.4504629", "l0.5461820,0.4460092", "l0.5433473,0.4461732", "l0.5432654,0.4492013", "l0.5398573,0.4514471", "l0.5385957,0.4509929", "l0.5383499,0.4572004", "l0.5406438,0.4600392", "l0.5445598,0.4608467", "l0.5445926,0.4592822", "l0.5479188,0.4601906", "l0.5604534,0.4658556", "l0.5619117,0.4653888", "l0.5651559,0.4682654", "l0.5668272,0.4680257", "l0.5684657,0.4698047", "l0.5663684,0.4726940", "l0.5680069,0.4772739", "l0.5703009,0.4755580", "l0.5731355,0.4764412", "l0.5755605,0.4782454", "l0.5785753,0.4787880", "l0.5797878,0.4810716", "l0.5822128,0.4822450", "l0.5888488,0.4805291", "l0.5906020,0.4778922", "l0.5935022,0.4785104", "l0.5952554,0.4799992", "l0.5974346,0.4790781", "l0.6003020,0.4832543", "l0.6024812,0.4837590", "l0.6041525,0.4829263", "l0.6080849,0.4847179", "l0.6112964,0.4844782", "l0.6153927,0.4886039", "l0.6186534,0.4907740", "l0.6209473,0.4953035", "l0.6211111,0.4970320", "l0.6199969,0.4978395", "l0.6222417,0.4997447", "l0.6218812,0.5009433", "l0.6204885,0.5011704", "l0.6224875,0.5025078", "l0.6176866,0.5050438", "c", "m0.4904562,0.4698552", "l0.4903906,0.4697542", "l0.4904070,0.4695271", "l0.4902268,0.4693883", "l0.4900793,0.4694262", "l0.4898008,0.4694767", "l0.4895386,0.4698047", "l0.4894894,0.4698804", "l0.4896041,0.4699813", "l0.4897025,0.4699561", "l0.4901285,0.4700318", "l0.4904562,0.4699309", "l0.4904562,0.4698552", "c"]}, {"n": "Liguria", "u": "IT-42", "i": ["m0.2716820,0.2808535", "l0.2710266,0.2821026", "l0.2700108,0.2808535", "l0.2716820,0.2808535", "c", "m0.0917243,0.2793774", "l0.0930187,0.2797180", "l0.0955584,0.2776110", "l0.0934119,0.2776362", "l0.0919209,0.2758194", "l0.0926910,0.2738764", "l0.0958697,0.2725264", "l0.1106163,0.2761600", "l0.1133035,0.2750624", "l0.1165149,0.2759329", "l0.1172359,0.2750119", "l0.1163183,0.2739142", "l0.1141719,0.2731446", "l0.1171867,0.2712268", "l0.1196937,0.2725137", "l0.1220203,0.2718955", "l0.1239538,0.2699525", "l0.1238719,0.2675048", "l0.1214796,0.2658899", "l0.1226757,0.2637450", "l0.1212666,0.2623571", "l0.1233148,0.2608052", "l0.1212339,0.2591524", "l0.1212339,0.2578907", "l0.1219384,0.2572094", "l0.1243306,0.2580295", "l0.1248222,0.2552916", "l0.1269359,0.2554935", "l0.1285416,0.2534622", "l0.1281484,0.2509514", "l0.1333752,0.2487308", "l0.1346041,0.2462958", "l0.1323594,0.2421574", "l0.1346205,0.2415896", "l0.1345550,0.2391924", "l0.1370947,0.2376279", "l0.1387004,0.2395583", "l0.1417316,0.2397980", "l0.1467783,0.2430911", "l0.1489247,0.2421953", "l0.1498423,0.2394195", "l0.1511695,0.2389401", "l0.1535781,0.2402649", "l0.1554460,0.2381074", "l0.1560195,0.2391924", "l0.1612627,0.2390410", "l0.1629012,0.2399873", "l0.1673907,0.2361644", "l0.1660963,0.2350162", "l0.1681117,0.2325812", "l0.1739448,0.2328335", "l0.1765992,0.2331363", "l0.1795321,0.2368457", "l0.1790406,0.2379812", "l0.1804497,0.2379307", "l0.1810723,0.2407065", "l0.1831532,0.2401261", "l0.1825634,0.2382588", "l0.1854144,0.2364167", "l0.1853816,0.2345620", "l0.1891174,0.2341961", "l0.1905593,0.2356849", "l0.1929188,0.2347134", "l0.1924272,0.2300199", "l0.1900677,0.2280517", "l0.1926238,0.2264619", "l0.1936725,0.2243675", "l0.1963105,0.2240647", "l0.1974902,0.2253517", "l0.2012260,0.2250362", "l0.2038476,0.2293638", "l0.2062071,0.2289979", "l0.2085993,0.2300704", "l0.2085174,0.2319377", "l0.2111882,0.2334643", "l0.2169557,0.2316223", "l0.2168574,0.2297802", "l0.2168574,0.2297802", "l0.2205605,0.2292251", "l0.2215436,0.2300199", "l0.2209865,0.2310797", "l0.2244273,0.2315213", "l0.2251483,0.2301966", "l0.2303096,0.2334139", "l0.2343076,0.2311554", "l0.2356020,0.2333382", "l0.2408944,0.2347387", "l0.2423035,0.2373756", "l0.2415170,0.2416906", "l0.2393542,0.2419555", "l0.2368309,0.2476458", "l0.2395344,0.2471537", "l0.2399604,0.2486299", "l0.2415006,0.2472042", "l0.2460557,0.2468635", "l0.2466292,0.2456523", "l0.2489559,0.2467500", "l0.2506763,0.2459299", "l0.2551003,0.2484406", "l0.2574270,0.2526295", "l0.2574270,0.2526295", "l0.2595898,0.2523897", "l0.2612447,0.2556449", "l0.2678479,0.2595940", "l0.2720917,0.2609314", "l0.2722391,0.2641740", "l0.2735663,0.2650571", "l0.2728618,0.2685016", "l0.2762699,0.2662936", "l0.2786785,0.2675805", "l0.2774496,0.2676562", "l0.2754178,0.2701544", "l0.2818572,0.2699904", "l0.2821849,0.2729680", "l0.2837251,0.2747217", "l0.2829222,0.2762736", "l0.2858388,0.2743810", "l0.2897221,0.2762357", "l0.2892797,0.2779769", "l0.2856422,0.2811942", "l0.2856422,0.2811942", "l0.2830533,0.2808535", "l0.2811035,0.2819512", "l0.2762699,0.2791755", "l0.2763518,0.2780147", "l0.2741398,0.2780021", "l0.2708792,0.2754787", "l0.2687655,0.2764755", "l0.2708955,0.2785194", "l0.2705023,0.2792638", "l0.2717312,0.2790998", "l0.2700108,0.2808662", "l0.2622114,0.2769423", "l0.2590983,0.2738385", "l0.2551003,0.2722236", "l0.2532652,0.2732581", "l0.2510532,0.2700282", "l0.2477106,0.2688927", "l0.2462196,0.2667604", "l0.2427459,0.2657511", "l0.2412221,0.2639595", "l0.2373552,0.2638585", "l0.2350613,0.2620291", "l0.2339799,0.2626221", "l0.2313255,0.2591019", "l0.2198067,0.2541056", "l0.2180208,0.2554178", "l0.2182174,0.2584585", "l0.2122532,0.2563262", "l0.2131052,0.2540804", "l0.2119747,0.2528692", "l0.1944917,0.2494626", "l0.1934267,0.2481252", "l0.1924600,0.2486804", "l0.1931318,0.2495257", "l0.1856929,0.2479738", "l0.1876100,0.2477089", "l0.1861025,0.2472420", "l0.1822029,0.2471032", "l0.1826453,0.2477593", "l0.1792700,0.2471537", "l0.1758782,0.2481631", "l0.1733713,0.2500178", "l0.1703728,0.2504593", "l0.1679642,0.2524024", "l0.1582315,0.2562127", "l0.1569698,0.2574870", "l0.1581168,0.2573103", "l0.1532012,0.2607800", "l0.1544465,0.2620543", "l0.1513006,0.2652716", "l0.1519232,0.2678455", "l0.1388151,0.2728923", "l0.1355544,0.2772577", "l0.1351121,0.2814718", "l0.1299671,0.2859255", "l0.1296067,0.2877045", "l0.1308191,0.2894204", "l0.1237899,0.2930667", "l0.1222989,0.2951738", "l0.1185139,0.2958046", "l0.1116322,0.2992743", "l0.1043572,0.3004098", "l0.1019977,0.3019364", "l0.0994744,0.3013560", "l0.0940182,0.3038290", "l0.0910525,0.3034505", "l0.0885455,0.3054566", "l0.0808609,0.3041065", "l0.0788292,0.3053808", "l0.0771579,0.3051033", "l0.0736351,0.2985803", "l0.0737825,0.2966373", "l0.0750114,0.2954513", "l0.0790258,0.2945051", "l0.0796484,0.2905055", "l0.0868087,0.2876162", "l0.0881031,0.2854082", "l0.0876935,0.2827335", "l0.0912491,0.2815601", "l0.0917243,0.2793774", "c"]}, {"n": "Lombardia", "u": "IT-25", "i": ["m0.3049274,0.0449800", "l0.3057795,0.0457118", "l0.3042884,0.0475286", "l0.3047144,0.0489417", "l0.3081062,0.0494212", "l0.3088926,0.0513768", "l0.3125629,0.0521212", "l0.3136443,0.0508469", "l0.3172982,0.0519572", "l0.3191006,0.0513515", "l0.3222301,0.0532189", "l0.3222301,0.0532189", "l0.3241144,0.0566254", "l0.3302916,0.0570039", "l0.3346173,0.0592371", "l0.3363049,0.0609530", "l0.3359281,0.0637161", "l0.3373044,0.0654699", "l0.3348631,0.0674381", "l0.3316352,0.0675769", "l0.3274078,0.0707942", "l0.3317335,0.0723966", "l0.3327166,0.0749452", "l0.3312583,0.0765476", "l0.3325855,0.0771406", "l0.3334376,0.0798406", "l0.3297017,0.0850892", "l0.3314550,0.0870953", "l0.3299148,0.0926846", "l0.3244585,0.0978197", "l0.3250484,0.1002169", "l0.3230985,0.1014029", "l0.3221646,0.1037118", "l0.3222465,0.1049735", "l0.3250975,0.1053772", "l0.3248354,0.1079385", "l0.3269654,0.1104493", "l0.3254744,0.1130988", "l0.3263264,0.1185367", "l0.3300131,0.1197353", "l0.3288497,0.1214638", "l0.3295379,0.1225615", "l0.3317007,0.1227255", "l0.3352071,0.1210475", "l0.3384514,0.1209592", "l0.3392215,0.1182465", "l0.3457919,0.1172245", "l0.3478728,0.1184610", "l0.3485119,0.1173759", "l0.3550168,0.1183475", "l0.3550168,0.1183475", "l0.3368457,0.1391654", "l0.3386972,0.1539903", "l0.3380418,0.1564884", "l0.3394181,0.1567155", "l0.3405651,0.1556936", "l0.3445958,0.1571193", "l0.3430228,0.1603618", "l0.3445958,0.1613081", "l0.3424658,0.1625446", "l0.3441043,0.1644245", "l0.3429901,0.1668343", "l0.3454315,0.1673264", "l0.3462671,0.1685755", "l0.3502159,0.1660521", "l0.3534274,0.1684871", "l0.3552625,0.1714521", "l0.3595882,0.1721965", "l0.3597684,0.1730545", "l0.3627669,0.1736601", "l0.3626031,0.1753003", "l0.3673056,0.1769405", "l0.3686164,0.1784798", "l0.3679938,0.1806372", "l0.3706318,0.1802335", "l0.3720573,0.1809274", "l0.3704843,0.1832994", "l0.3742857,0.1857597", "l0.3762519,0.1860373", "l0.3766451,0.1844349", "l0.3788735,0.1853560", "l0.3803973,0.1832363", "l0.3853128,0.1846494", "l0.3832319,0.1859364", "l0.3839037,0.1872107", "l0.3829370,0.1892546", "l0.3880655,0.1907182", "l0.3904086,0.1896457", "l0.3904250,0.1927495", "l0.4035003,0.1981496", "l0.4038772,0.1994491", "l0.4038772,0.1994491", "l0.3936693,0.1982883", "l0.3909329,0.2002944", "l0.3885079,0.1989697", "l0.3879181,0.1998024", "l0.3815443,0.2001935", "l0.3806431,0.2010136", "l0.3786441,0.1990706", "l0.3743020,0.1982631", "l0.3727782,0.1992598", "l0.3676661,0.1989318", "l0.3638647,0.2004332", "l0.3634879,0.2018968", "l0.3612759,0.2016192", "l0.3588836,0.2027547", "l0.3592113,0.2020229", "l0.3570157,0.2022374", "l0.3568847,0.2012912", "l0.3554428,0.2014930", "l0.3542139,0.2004963", "l0.3469880,0.1996005", "l0.3453987,0.1956640", "l0.3424494,0.1982757", "l0.3417120,0.1962318", "l0.3370423,0.2014300", "l0.3346664,0.2024898", "l0.3282107,0.2027043", "l0.3207227,0.1998907", "l0.3183141,0.1962065", "l0.3142997,0.1978972", "l0.3096627,0.1950332", "l0.3070411,0.1949827", "l0.3021256,0.1919925", "l0.2984881,0.1920808", "l0.2976197,0.1909200", "l0.2921634,0.1928883", "l0.2908690,0.1907056", "l0.2884276,0.1911472", "l0.2883129,0.1896079", "l0.2858224,0.1880560", "l0.2865433,0.1861761", "l0.2834629,0.1830849", "l0.2820047,0.1829714", "l0.2772857,0.1857723", "l0.2779084,0.1830092", "l0.2767123,0.1822396", "l0.2737629,0.1840817", "l0.2756145,0.1860878", "l0.2753031,0.1875513", "l0.2738613,0.1880434", "l0.2722064,0.1861761", "l0.2705678,0.1861382", "l0.2690440,0.1901883", "l0.2684378,0.1878415", "l0.2654065,0.1866429", "l0.2640630,0.1846999", "l0.2626374,0.1850406", "l0.2638663,0.1864158", "l0.2630471,0.1876901", "l0.2603927,0.1894817", "l0.2535437,0.1872233", "l0.2537895,0.1840691", "l0.2522820,0.1824919", "l0.2512170,0.1849018", "l0.2491197,0.1855831", "l0.2464981,0.1828831", "l0.2453020,0.1830345", "l0.2463343,0.1864789", "l0.2444827,0.1877784", "l0.2419103,0.1854317", "l0.2372733,0.1863401", "l0.2367490,0.1873621", "l0.2347336,0.1871350", "l0.2349138,0.1879803", "l0.2315713,0.1903018", "l0.2317679,0.1930523", "l0.2290971,0.1952603", "l0.2268523,0.2003701", "l0.2241324,0.2009000", "l0.2251155,0.2021870", "l0.2230674,0.2042561", "l0.2259348,0.2062875", "l0.2271309,0.2057828", "l0.2287202,0.2068174", "l0.2304735,0.2109179", "l0.2241652,0.2158133", "l0.2246567,0.2172011", "l0.2275077,0.2183745", "l0.2277535,0.2199138", "l0.2262952,0.2212259", "l0.2274586,0.2229923", "l0.2221662,0.2240773", "l0.2200197,0.2209105", "l0.2205441,0.2234591", "l0.2176767,0.2235979", "l0.2176767,0.2235979", "l0.2170704,0.2200021", "l0.2181027,0.2174787", "l0.2143833,0.2153590", "l0.2136132,0.2116623", "l0.2091564,0.2126086", "l0.2084191,0.2116244", "l0.2060269,0.2114730", "l0.2062235,0.2102870", "l0.2043228,0.2088109", "l0.2058630,0.2075365", "l0.2046669,0.2050384", "l0.2029956,0.2051898", "l0.2002429,0.2033099", "l0.1977032,0.2000926", "l0.1980965,0.1979098", "l0.1969003,0.1962822", "l0.1961302,0.1957271", "l0.1939674,0.1965093", "l0.1918537,0.1943014", "l0.1913786,0.1902640", "l0.1866105,0.1905542", "l0.1839561,0.1925855", "l0.1812689,0.1928126", "l0.1808593,0.1941121", "l0.1787620,0.1938976", "l0.1784835,0.1926360", "l0.1766483,0.1928378", "l0.1760093,0.1913743", "l0.1752556,0.1935948", "l0.1698157,0.1911724", "l0.1693406,0.1867312", "l0.1670139,0.1850910", "l0.1675874,0.1834508", "l0.1657522,0.1830597", "l0.1647855,0.1811798", "l0.1624424,0.1806372", "l0.1615413,0.1794008", "l0.1644742,0.1761582", "l0.1609186,0.1773695", "l0.1600994,0.1768774", "l0.1620492,0.1763349", "l0.1600010,0.1748587", "l0.1615413,0.1737863", "l0.1606073,0.1732690", "l0.1626718,0.1730671", "l0.1600338,0.1723984", "l0.1600010,0.1717802", "l0.1615904,0.1719442", "l0.1610825,0.1697110", "l0.1577891,0.1683988", "l0.1589852,0.1665189", "l0.1611972,0.1659385", "l0.1602141,0.1636801", "l0.1626718,0.1619390", "l0.1646053,0.1632007", "l0.1691603,0.1630619", "l0.1691603,0.1642100", "l0.1710119,0.1651437", "l0.1718147,0.1683610", "l0.1742233,0.1682222", "l0.1760257,0.1674778", "l0.1769433,0.1648282", "l0.1800237,0.1633142", "l0.1764681,0.1603871", "l0.1789422,0.1607403", "l0.1808593,0.1597310", "l0.1834318,0.1602861", "l0.1869218,0.1589235", "l0.1853980,0.1554034", "l0.1839397,0.1554791", "l0.1820554,0.1505585", "l0.1763042,0.1482748", "l0.1741906,0.1420673", "l0.1749115,0.1399098", "l0.1717492,0.1378406", "l0.1712249,0.1362509", "l0.1737154,0.1366420", "l0.1723882,0.1343205", "l0.1729945,0.1330588", "l0.1696683,0.1325541", "l0.1705695,0.1291980", "l0.1655720,0.1280499", "l0.1622622,0.1232302", "l0.1623605,0.1213503", "l0.1657686,0.1183853", "l0.1636713,0.1121399", "l0.1768613,0.1010875", "l0.1752064,0.0953468", "l0.1762387,0.0933155", "l0.1762387,0.0933155", "l0.1782213,0.0916374", "l0.1796140,0.0934038", "l0.1816786,0.0942239", "l0.1836775,0.0935678", "l0.1875444,0.0960029", "l0.1875936,0.0974033", "l0.1858732,0.0981982", "l0.1818096,0.1038001", "l0.1856601,0.1038380", "l0.1888389,0.1064118", "l0.1911655,0.1068282", "l0.1912311,0.1089478", "l0.1952782,0.1151049", "l0.1924108,0.1184232", "l0.1962122,0.1173255", "l0.1996530,0.1183096", "l0.1990959,0.1195713", "l0.2029137,0.1196722", "l0.2041262,0.1150544", "l0.2074687,0.1123166", "l0.2062562,0.1121904", "l0.2049127,0.1101717", "l0.2015373,0.1094904", "l0.2011113,0.1066389", "l0.1991123,0.1057558", "l0.2022091,0.1035730", "l0.2003576,0.0994473", "l0.2012424,0.0981351", "l0.2062071,0.0967599", "l0.2071902,0.0947033", "l0.2058958,0.0916500", "l0.2098610,0.0901486", "l0.2133674,0.0870701", "l0.2151042,0.0869818", "l0.2184304,0.0810644", "l0.2208226,0.0808752", "l0.2211012,0.0778597", "l0.2249353,0.0723461", "l0.2247550,0.0697597", "l0.2229855,0.0682330", "l0.2234279,0.0641577", "l0.2207079,0.0615334", "l0.2229035,0.0600951", "l0.2231985,0.0564488", "l0.2304079,0.0551997", "l0.2314238,0.0574581", "l0.2345042,0.0591110", "l0.2365687,0.0560829", "l0.2389446,0.0551871", "l0.2385513,0.0570292", "l0.2374207,0.0573572", "l0.2390265,0.0581016", "l0.2388299,0.0677536", "l0.2419267,0.0685484", "l0.2435652,0.0723461", "l0.2460557,0.0746424", "l0.2468094,0.0741630", "l0.2531505,0.0761312", "l0.2566569,0.0746046", "l0.2596062,0.0755634", "l0.2619165,0.0701634", "l0.2653738,0.0715513", "l0.2762207,0.0672867", "l0.2777937,0.0686746", "l0.2800712,0.0674129", "l0.2837743,0.0699994", "l0.2825126,0.0727120", "l0.2842167,0.0735573", "l0.2840200,0.0763205", "l0.2888045,0.0782004", "l0.2879361,0.0814303", "l0.2899351,0.0825028", "l0.2917374,0.0815312", "l0.2944082,0.0818971", "l0.2989305,0.0789195", "l0.2971445,0.0756139", "l0.2929499,0.0718414", "l0.2931629,0.0699489", "l0.2949325,0.0690783", "l0.2957845,0.0668451", "l0.2977344,0.0665423", "l0.2980785,0.0646246", "l0.2966038,0.0643722", "l0.2960139,0.0628077", "l0.2909018,0.0635017", "l0.2874609,0.0613189", "l0.2886079,0.0594138", "l0.2876739,0.0580890", "l0.2886734,0.0542913", "l0.2878378,0.0524114", "l0.2925567,0.0484875", "l0.2927205,0.0457496", "l0.2950308,0.0462291", "l0.2999955,0.0442734", "l0.3021420,0.0450809", "l0.3041573,0.0435164", "l0.3049274,0.0449800", "c"]}, {"n": "Marche", "u": "IT-57", "i": ["m0.5885867,0.3253913", "l0.5840480,0.3233600", "l0.5821145,0.3204328", "l0.5787064,0.3182501", "l0.5773301,0.3201679", "l0.5739547,0.3198525", "l0.5615676,0.3145407", "l0.5279945,0.2918681", "l0.5189990,0.2882092", "l0.5150175,0.2879064", "l0.5150175,0.2879064", "l0.5131004,0.2918050", "l0.5134773,0.2970158", "l0.5093482,0.2982649", "l0.5084634,0.3009145", "l0.5036790,0.3004602", "l0.5039903,0.2991481", "l0.5026795,0.2987570", "l0.5015489,0.2955901", "l0.4970921,0.2970158", "l0.4970921,0.2943158", "l0.4933727,0.2926504", "l0.4933727,0.2926504", "l0.4927173,0.2943537", "l0.4864582,0.2938111", "l0.4864582,0.2938111", "l0.4863927,0.2936850", "l0.4863927,0.2936850", "l0.4883753,0.2964859", "l0.4857209,0.2964733", "l0.4851638,0.2954387", "l0.4819031,0.2964354", "l0.4802482,0.3008135", "l0.4759881,0.3034505", "l0.4756604,0.3061883", "l0.4756604,0.3061883", "l0.4758734,0.3063145", "l0.4758734,0.3063145", "l0.4793962,0.3073996", "l0.4831484,0.3112856", "l0.4797075,0.3113108", "l0.4801991,0.3140613", "l0.4786917,0.3139856", "l0.4776922,0.3092921", "l0.4769712,0.3132286", "l0.4749558,0.3140613", "l0.4725636,0.3137080", "l0.4728913,0.3147300", "l0.4713511,0.3160548", "l0.4675662,0.3171020", "l0.4699420,0.3199156", "l0.4699420,0.3199156", "l0.4711053,0.3213917", "l0.4761683,0.3213413", "l0.4767418,0.3220478", "l0.4801499,0.3199282", "l0.4832303,0.3197768", "l0.4823947,0.3207609", "l0.4831812,0.3225777", "l0.4783967,0.3259843", "l0.4806251,0.3277759", "l0.4829682,0.3268549", "l0.4850491,0.3290376", "l0.4873758,0.3264007", "l0.4889979,0.3265647", "l0.4903579,0.3283563", "l0.4918653,0.3284194", "l0.4923405,0.3273343", "l0.4938315,0.3278642", "l0.5042524,0.3370620", "l0.5077425,0.3354344", "l0.5113964,0.3364690", "l0.5135592,0.3330750", "l0.5169673,0.3337816", "l0.5163610,0.3363176", "l0.5178357,0.3373774", "l0.5148864,0.3395096", "l0.5149683,0.3405695", "l0.5186877,0.3443041", "l0.5193104,0.3479756", "l0.5182945,0.3488588", "l0.5213749,0.3505495", "l0.5224727,0.3548645", "l0.5247502,0.3557350", "l0.5245208,0.3593939", "l0.5218664,0.3613496", "l0.5229642,0.3632926", "l0.5263560,0.3638225", "l0.5272899,0.3659800", "l0.5268967,0.3694749", "l0.5281256,0.3721370", "l0.5267001,0.3729698", "l0.5282403,0.3754301", "l0.5273227,0.3773100", "l0.5317303,0.3793413", "l0.5320580,0.3804390", "l0.5338767,0.3806030", "l0.5340734,0.3857002", "l0.5360560,0.3839843", "l0.5360887,0.3818268", "l0.5382188,0.3827983", "l0.5405127,0.3810446", "l0.5454446,0.3839465", "l0.5495409,0.3889176", "l0.5539157,0.3881479", "l0.5559639,0.3858516", "l0.5582742,0.3904190", "l0.5578646,0.3927152", "l0.5563571,0.3951125", "l0.5557345,0.3941410", "l0.5525885,0.3951251", "l0.5521789,0.3976485", "l0.5521789,0.3976485", "l0.5575532,0.3986452", "l0.5584380,0.3971690", "l0.5602240,0.3970429", "l0.5662537,0.4010298", "l0.5662537,0.4010298", "l0.5689901,0.4016480", "l0.5720705,0.3999700", "l0.5729880,0.4005504", "l0.5739711,0.3975475", "l0.5778544,0.3970555", "l0.5783460,0.3939139", "l0.5805252,0.3920466", "l0.5809348,0.3902171", "l0.5843429,0.3916554", "l0.5882098,0.3902549", "l0.5893076,0.3914536", "l0.5915196,0.3912391", "l0.5948130,0.3900531", "l0.5955667,0.3872647", "l0.5966809,0.3867853", "l0.6012360,0.3865456", "l0.6047096,0.3847666", "l0.6128858,0.3834166", "l0.6128858,0.3834166", "l0.6092811,0.3749632", "l0.6067578,0.3647057", "l0.5883081,0.3294918", "l0.5885867,0.3253913", "c", "m0.4883425,0.3213034", "l0.4871300,0.3209754", "l0.4871300,0.3209754", "l0.4868187,0.3208997", "l0.4868187,0.3208997", "l0.4873430,0.3200165", "l0.4882769,0.3204328", "l0.4882769,0.3204328", "l0.4884408,0.3211015", "l0.4884408,0.3211015", "l0.4883425,0.3213034", "c"]}, {"n": "Molise", "u": "IT-67", "i": ["m0.6866516,0.4558882", "l0.6955651,0.4595345", "l0.7037413,0.4607079", "l0.7102462,0.4661836", "l0.7154239,0.4677355", "l0.7154239,0.4677355", "l0.7157680,0.4718613", "l0.7122779,0.4757347", "l0.7136215,0.4794314", "l0.7120485,0.4814375", "l0.7136871,0.4829768", "l0.7124582,0.4836329", "l0.7140967,0.4855128", "l0.7171443,0.4865852", "l0.7137854,0.4878721", "l0.7126712,0.4897647", "l0.7114095,0.4887932", "l0.7113604,0.4898278", "l0.7079359,0.4909759", "l0.7057730,0.4940292", "l0.7004643,0.4921367", "l0.6984161,0.4940544", "l0.6999072,0.4950638", "l0.6987438,0.5021040", "l0.7012999,0.5029494", "l0.7045605,0.5058513", "l0.7045605,0.5058513", "l0.6996778,0.5085008", "l0.6953357,0.5087658", "l0.6927469,0.5107845", "l0.6861764,0.5086270", "l0.6833582,0.5122859", "l0.6802778,0.5130177", "l0.6787376,0.5120840", "l0.6755097,0.5123742", "l0.6755753,0.5135602", "l0.6738548,0.5136485", "l0.6702665,0.5161088", "l0.6682675,0.5138883", "l0.6627949,0.5145443", "l0.6608450,0.5133962", "l0.6602224,0.5113901", "l0.6470979,0.5084377", "l0.6437717,0.5070625", "l0.6433457,0.5057882", "l0.6404292,0.5057756", "l0.6401015,0.5047157", "l0.6344486,0.5046274", "l0.6338096,0.5063686", "l0.6300574,0.5039587", "l0.6264527,0.5090434", "l0.6287138,0.5111504", "l0.6291562,0.5142037", "l0.6270261,0.5131186", "l0.6235033,0.5137242", "l0.6201280,0.5106331", "l0.6205868,0.5087153", "l0.6180963,0.5077438", "l0.6180963,0.5077438", "l0.6193415,0.5061162", "l0.6176866,0.5050438", "l0.6223728,0.5024447", "l0.6203738,0.5011073", "l0.6217665,0.5008802", "l0.6221106,0.4996816", "l0.6198659,0.4977764", "l0.6209800,0.4969816", "l0.6208162,0.4952530", "l0.6185223,0.4907236", "l0.6152616,0.4885535", "l0.6152616,0.4885535", "l0.6187025,0.4878974", "l0.6217665,0.4891338", "l0.6222253,0.4872918", "l0.6244045,0.4872287", "l0.6258300,0.4842006", "l0.6277307,0.4840871", "l0.6290251,0.4866988", "l0.6300574,0.4833679", "l0.6333180,0.4833048", "l0.6344158,0.4817403", "l0.6348255,0.4830146", "l0.6362182,0.4831786", "l0.6369064,0.4818791", "l0.6344158,0.4807562", "l0.6323677,0.4762772", "l0.6330559,0.4751417", "l0.6366934,0.4749524", "l0.6390364,0.4721514", "l0.6438045,0.4691486", "l0.6453447,0.4707384", "l0.6473765,0.4705743", "l0.6489822,0.4733374", "l0.6499162,0.4736150", "l0.6516366,0.4719496", "l0.6556346,0.4739935", "l0.6574369,0.4753435", "l0.6591901,0.4807562", "l0.6578957,0.4815637", "l0.6612383,0.4820305", "l0.6690376,0.4755580", "l0.6718558,0.4708519", "l0.6757227,0.4687575", "l0.6770663,0.4648462", "l0.6808349,0.4612630", "l0.6854883,0.4587901", "l0.6839972,0.4577303", "l0.6859143,0.4553962", "l0.6859143,0.4553962", "c"]}, {"n": "Piemonte", "u": "IT-21", "i": ["m0.1527916,0.0594769", "l0.1553313,0.0614577", "l0.1543154,0.0633755", "l0.1555279,0.0658610", "l0.1549380,0.0718414", "l0.1517429,0.0750588", "l0.1542007,0.0782004", "l0.1531193,0.0796892", "l0.1554460,0.0812915", "l0.1604434,0.0825532", "l0.1640482,0.0875874", "l0.1664732,0.0883822", "l0.1659652,0.0897196", "l0.1672105,0.0914608", "l0.1701762,0.0913851", "l0.1734860,0.0933407", "l0.1761732,0.0931767", "l0.1761732,0.0931767", "l0.1751409,0.0952080", "l0.1767958,0.1009487", "l0.1636058,0.1120011", "l0.1657031,0.1182591", "l0.1622950,0.1212241", "l0.1621967,0.1231167", "l0.1655064,0.1279363", "l0.1705039,0.1290845", "l0.1696027,0.1324280", "l0.1729289,0.1329326", "l0.1723227,0.1341943", "l0.1736499,0.1365285", "l0.1711429,0.1361247", "l0.1716673,0.1377271", "l0.1748296,0.1397836", "l0.1741086,0.1419411", "l0.1762223,0.1481487", "l0.1819735,0.1504323", "l0.1838578,0.1553529", "l0.1853161,0.1552772", "l0.1868399,0.1587973", "l0.1833498,0.1601600", "l0.1807610,0.1596174", "l0.1788439,0.1606268", "l0.1763698,0.1602609", "l0.1799254,0.1631880", "l0.1768450,0.1647021", "l0.1759274,0.1673516", "l0.1741250,0.1680960", "l0.1717164,0.1682348", "l0.1709135,0.1650175", "l0.1690620,0.1640838", "l0.1690784,0.1629357", "l0.1645233,0.1630745", "l0.1625735,0.1618128", "l0.1601321,0.1635539", "l0.1611152,0.1658124", "l0.1588869,0.1663927", "l0.1577071,0.1682727", "l0.1610005,0.1695848", "l0.1615085,0.1718180", "l0.1599027,0.1716540", "l0.1599355,0.1722596", "l0.1625899,0.1729283", "l0.1605254,0.1731302", "l0.1614593,0.1736601", "l0.1599027,0.1747325", "l0.1619509,0.1762087", "l0.1600010,0.1767512", "l0.1608203,0.1772433", "l0.1643759,0.1760321", "l0.1614429,0.1792746", "l0.1623441,0.1805111", "l0.1646872,0.1810662", "l0.1656539,0.1829461", "l0.1674890,0.1833373", "l0.1668992,0.1849775", "l0.1692423,0.1866051", "l0.1697174,0.1910588", "l0.1751409,0.1934687", "l0.1758946,0.1912607", "l0.1765500,0.1927117", "l0.1783852,0.1925098", "l0.1786801,0.1937841", "l0.1807774,0.1939860", "l0.1811870,0.1926990", "l0.1838742,0.1924719", "l0.1865286,0.1904406", "l0.1912966,0.1901378", "l0.1917718,0.1941878", "l0.1938855,0.1963958", "l0.1960483,0.1956135", "l0.1968020,0.1961687", "l0.1979981,0.1977963", "l0.1976049,0.1999790", "l0.2001446,0.2031963", "l0.2028973,0.2050762", "l0.2045686,0.2049248", "l0.2057483,0.2074356", "l0.2042081,0.2087099", "l0.2061088,0.2101861", "l0.2059122,0.2113721", "l0.2082880,0.2115361", "l0.2090253,0.2125202", "l0.2134821,0.2115740", "l0.2142522,0.2152707", "l0.2179716,0.2173904", "l0.2169557,0.2199138", "l0.2175620,0.2235096", "l0.2175620,0.2235096", "l0.2167427,0.2232699", "l0.2167919,0.2296793", "l0.2167919,0.2296793", "l0.2168902,0.2315087", "l0.2111226,0.2333634", "l0.2084682,0.2318368", "l0.2085502,0.2299695", "l0.2061579,0.2288970", "l0.2037985,0.2292629", "l0.2011769,0.2249353", "l0.1974411,0.2252507", "l0.1962613,0.2239638", "l0.1936233,0.2242666", "l0.1925911,0.2263610", "l0.1900186,0.2279507", "l0.1923780,0.2299190", "l0.1928696,0.2346125", "l0.1905101,0.2355966", "l0.1890846,0.2340952", "l0.1853488,0.2344737", "l0.1853980,0.2363284", "l0.1825470,0.2381705", "l0.1831368,0.2400378", "l0.1810559,0.2406308", "l0.1804169,0.2378550", "l0.1790078,0.2378929", "l0.1794993,0.2367574", "l0.1765664,0.2330480", "l0.1739120,0.2327578", "l0.1680953,0.2324928", "l0.1660799,0.2349279", "l0.1673744,0.2360760", "l0.1628848,0.2399116", "l0.1612463,0.2389653", "l0.1559867,0.2391167", "l0.1554296,0.2380317", "l0.1535617,0.2401892", "l0.1511531,0.2388770", "l0.1498423,0.2393564", "l0.1489247,0.2421322", "l0.1467783,0.2430280", "l0.1417316,0.2397350", "l0.1387004,0.2394952", "l0.1370947,0.2375775", "l0.1345550,0.2391420", "l0.1346205,0.2415266", "l0.1323594,0.2421069", "l0.1346041,0.2462327", "l0.1333752,0.2486677", "l0.1281648,0.2508883", "l0.1285416,0.2534117", "l0.1269359,0.2554430", "l0.1248222,0.2552412", "l0.1243306,0.2579917", "l0.1219384,0.2571716", "l0.1212502,0.2578529", "l0.1212502,0.2591146", "l0.1233311,0.2607674", "l0.1212830,0.2623193", "l0.1226921,0.2637071", "l0.1214796,0.2658646", "l0.1238719,0.2674670", "l0.1239538,0.2699147", "l0.1220203,0.2718703", "l0.1196937,0.2724885", "l0.1171867,0.2712016", "l0.1141719,0.2731067", "l0.1163183,0.2738890", "l0.1172359,0.2749867", "l0.1165313,0.2759077", "l0.1133035,0.2750371", "l0.1106327,0.2761474", "l0.0958861,0.2725137", "l0.0927074,0.2738764", "l0.0919373,0.2758194", "l0.0934283,0.2776362", "l0.0955748,0.2776110", "l0.0930351,0.2797180", "l0.0917243,0.2793774", "l0.0917243,0.2793774", "l0.0918226,0.2774974", "l0.0878246,0.2733465", "l0.0892993,0.2694226", "l0.0852357,0.2692964", "l0.0837939,0.2717063", "l0.0790422,0.2711006", "l0.0705547,0.2738638", "l0.0680150,0.2734222", "l0.0674907,0.2750624", "l0.0648035,0.2738890", "l0.0618050,0.2747596", "l0.0606253,0.2720091", "l0.0552837,0.2724885", "l0.0523016,0.2697002", "l0.0501224,0.2699777", "l0.0475827,0.2670506", "l0.0454199,0.2664955", "l0.0438633,0.2671515", "l0.0388822,0.2645525", "l0.0344910,0.2650445", "l0.0324265,0.2639595", "l0.0314106,0.2599599", "l0.0282155,0.2585342", "l0.0285105,0.2572473", "l0.0257578,0.2552916", "l0.0253809,0.2536010", "l0.0223988,0.2525538", "l0.0228576,0.2472168", "l0.0275437,0.2465102", "l0.0216287,0.2419303", "l0.0197936,0.2373504", "l0.0216451,0.2352055", "l0.0242667,0.2349910", "l0.0262002,0.2335274", "l0.0276420,0.2295152", "l0.0291659,0.2294143", "l0.0275601,0.2263862", "l0.0287235,0.2242035", "l0.0308371,0.2229671", "l0.0383415,0.2233329", "l0.0375550,0.2209610", "l0.0345238,0.2195857", "l0.0336226,0.2155231", "l0.0318858,0.2140595", "l0.0337865,0.2109431", "l0.0323773,0.2095048", "l0.0265115,0.2074230", "l0.0243814,0.2090632", "l0.0204490,0.2084828", "l0.0154024,0.2058459", "l0.0151402,0.2047230", "l0.0109948,0.2034739", "l0.0113225,0.2008496", "l0.0103721,0.2004080", "l0.0121417,0.1984650", "l0.0098478,0.1957145", "l0.0109784,0.1950206", "l0.0104213,0.1935570", "l0.0044735,0.1930397", "l0.0034576,0.1883083", "l0.0019502,0.1879803", "l0.0005083,0.1852172", "l0.0044079,0.1833499", "l0.0050633,0.1819873", "l0.0102574,0.1822144", "l0.0124039,0.1802461", "l0.0190890,0.1824036", "l0.0192365,0.1832111", "l0.0229395,0.1823405", "l0.0229559,0.1794386", "l0.0273635,0.1793125", "l0.0280517,0.1774073", "l0.0320005,0.1747325", "l0.0341142,0.1749975", "l0.0361295,0.1740638", "l0.0377189,0.1754895", "l0.0412253,0.1721839", "l0.0424214,0.1723101", "l0.0432898,0.1689918", "l0.0412089,0.1648535", "l0.0428147,0.1646264", "l0.0434865,0.1626834", "l0.0456493,0.1618128", "l0.0456657,0.1599581", "l0.0476974,0.1576871", "l0.0415694,0.1551510", "l0.0405535,0.1520599", "l0.0405535,0.1520599", "l0.0434537,0.1475683", "l0.0440435,0.1511641", "l0.0455182,0.1503061", "l0.0505484,0.1516562", "l0.0544645,0.1478585", "l0.0590523,0.1477701", "l0.0621327,0.1466472", "l0.0637057,0.1474926", "l0.0695060,0.1439094", "l0.0710298,0.1419285", "l0.0730452,0.1414364", "l0.0760765,0.1420294", "l0.0794846,0.1406037", "l0.0827780,0.1421808", "l0.0829910,0.1432785", "l0.0853013,0.1424458", "l0.0885292,0.1440860", "l0.0923305,0.1436066", "l0.0934447,0.1443762", "l0.1014570,0.1399981", "l0.1057827,0.1397458", "l0.1074376,0.1405659", "l0.1086337,0.1367303", "l0.1105999,0.1364275", "l0.1076178,0.1317214", "l0.1103377,0.1281508", "l0.1097479,0.1266368", "l0.1070935,0.1258798", "l0.1042916,0.1219685", "l0.1054386,0.1155970", "l0.1042916,0.1104745", "l0.1042916,0.1104745", "l0.1054714,0.1096165", "l0.1056352,0.1050366", "l0.1080438,0.1030431", "l0.1148437,0.1031945", "l0.1166624,0.1017183", "l0.1168590,0.0998006", "l0.1187597,0.0987534", "l0.1176619,0.0960912", "l0.1185467,0.0935804", "l0.1246420,0.0924827", "l0.1255595,0.0906785", "l0.1286891,0.0894168", "l0.1284925,0.0875369", "l0.1297869,0.0860986", "l0.1275421,0.0819602", "l0.1251335,0.0796766", "l0.1223317,0.0786672", "l0.1275585,0.0746676", "l0.1299344,0.0752228", "l0.1335227,0.0741251", "l0.1347352,0.0716900", "l0.1378811,0.0706176", "l0.1379303,0.0689143", "l0.1418300,0.0676652", "l0.1426001,0.0657727", "l0.1402242,0.0648895", "l0.1415022,0.0633250", "l0.1431408,0.0632241", "l0.1464014,0.0608016", "c"]}, {"n": "Puglia", "u": "IT-75", "i": ["m0.7893372,0.4657925", "l0.7956454,0.4667388", "l0.8036905,0.4714575", "l0.8025927,0.4734005", "l0.8046572,0.4764160", "l0.8045262,0.4784347", "l0.8038871,0.4809202", "l0.8016588,0.4826361", "l0.7939086,0.4866231", "l0.7934334,0.4879857", "l0.7796863,0.4946096", "l0.7799321,0.5017886", "l0.7840284,0.5077564", "l0.7896976,0.5109233", "l0.8050505,0.5163990", "l0.8099333,0.5193514", "l0.8232052,0.5231996", "l0.8370179,0.5296216", "l0.8532883,0.5336085", "l0.8560082,0.5354127", "l0.8589575,0.5354758", "l0.8596949,0.5364221", "l0.8612351,0.5359048", "l0.8616447,0.5368258", "l0.8685101,0.5391221", "l0.8797339,0.5419483", "l0.8955291,0.5499096", "l0.9014769,0.5554989", "l0.9047539,0.5566470", "l0.9122256,0.5620597", "l0.9315764,0.5680401", "l0.9417352,0.5734654", "l0.9509272,0.5743107", "l0.9527624,0.5766449", "l0.9519595,0.5777173", "l0.9578417,0.5778687", "l0.9573010,0.5792440", "l0.9598571,0.5816790", "l0.9589723,0.5842529", "l0.9626590,0.5877604", "l0.9665586,0.5904983", "l0.9761931,0.5946366", "l0.9915623,0.6073293", "l0.9948393,0.6129564", "l0.9944625,0.6151770", "l0.9970022,0.6197443", "l0.9993289,0.6208420", "l0.9984932,0.6214476", "l0.9994599,0.6235294", "l0.9966417,0.6255229", "l0.9958388,0.6285257", "l0.9925782,0.6302668", "l0.9902187,0.6342664", "l0.9887768,0.6400197", "l0.9888260,0.6475899", "l0.9870073,0.6495581", "l0.9850247,0.6499619", "l0.9787492,0.6462273", "l0.9703927,0.6448772", "l0.9598571,0.6382786", "l0.9554004,0.6322982", "l0.9573830,0.6316673", "l0.9570880,0.6292070", "l0.9536799,0.6277939", "l0.9561541,0.6263934", "l0.9568259,0.6232392", "l0.9492723,0.6160097", "l0.9498130,0.6135999", "l0.9481417,0.6108368", "l0.9440127,0.6081998", "l0.9291514,0.6065218", "l0.9147653,0.6073797", "l0.9096039,0.6045031", "l0.9051800,0.6041372", "l0.8909577,0.5978035", "l0.8891225,0.5978413", "l0.8896141,0.5966932", "l0.8927600,0.5956334", "l0.8931205,0.5937660", "l0.8909085,0.5916969", "l0.8871563,0.5918357", "l0.8862060,0.5897917", "l0.8815362,0.5884417", "l0.8752771,0.5891609", "l0.8695423,0.5915581", "l0.8636928,0.5955450", "l0.8602028,0.5999736", "l0.8602028,0.5999736", "l0.8589248,0.5976268", "l0.8560574,0.5957721", "l0.8554675,0.5937282", "l0.8525673,0.5923782", "l0.8497819,0.5929333", "l0.8483727,0.5917347", "l0.8499457,0.5891104", "l0.8480450,0.5880001", "l0.8487660,0.5869781", "l0.8471930,0.5857038", "l0.8478976,0.5820575", "l0.8489298,0.5814772", "l0.8474224,0.5788781", "l0.8488971,0.5743234", "l0.8468981,0.5725444", "l0.8485694,0.5719009", "l0.8437849,0.5690999", "l0.8429165,0.5700462", "l0.8409994,0.5691630", "l0.8407209,0.5679140", "l0.8390824,0.5687214", "l0.8363133,0.5678004", "l0.8361331,0.5699958", "l0.8347403,0.5683177", "l0.8331510,0.5686457", "l0.8332657,0.5710303", "l0.8299231,0.5679140", "l0.8242047,0.5730112", "l0.8216978,0.5724813", "l0.8204361,0.5702859", "l0.8096711,0.5626653", "l0.8048539,0.5545148", "l0.8015768,0.5536947", "l0.7980868,0.5561676", "l0.7954816,0.5542624", "l0.7863223,0.5512596", "l0.7853392,0.5498339", "l0.7878133,0.5501746", "l0.7907627,0.5475881", "l0.7902547,0.5456325", "l0.7913034,0.5443203", "l0.7882885,0.5424278", "l0.7872890,0.5429577", "l0.7862895,0.5399927", "l0.7842250,0.5396142", "l0.7838318,0.5383273", "l0.7809807,0.5379487", "l0.7772122,0.5358670", "l0.7748855,0.5369394", "l0.7735583,0.5365735", "l0.7738532,0.5375324", "l0.7711169,0.5380749", "l0.7713627,0.5392735", "l0.7686100,0.5404343", "l0.7662178,0.5390969", "l0.7621051,0.5402324", "l0.7544860,0.5392483", "l0.7513073,0.5397277", "l0.7490953,0.5412796", "l0.7496360,0.5428315", "l0.7496360,0.5428315", "l0.7437374,0.5405605", "l0.7411649,0.5407371", "l0.7377240,0.5384660", "l0.7349386,0.5400936", "l0.7303016,0.5385922", "l0.7284992,0.5397277", "l0.7252058,0.5379109", "l0.7240097,0.5355263", "l0.7214372,0.5345548", "l0.7227808,0.5320440", "l0.7260906,0.5305300", "l0.7246979,0.5275272", "l0.7273359,0.5262402", "l0.7252713,0.5244360", "l0.7226169,0.5248398", "l0.7209129,0.5229724", "l0.7153092,0.5231491", "l0.7149651,0.5204112", "l0.7100987,0.5190738", "l0.7090828,0.5157682", "l0.7104592,0.5142920", "l0.7121960,0.5140649", "l0.7113112,0.5125509", "l0.7126548,0.5115667", "l0.7123599,0.5105574", "l0.7076901,0.5095480", "l0.7047244,0.5059648", "l0.7047244,0.5059648", "l0.7014638,0.5030629", "l0.6989077,0.5022176", "l0.7000874,0.4951773", "l0.6985800,0.4941554", "l0.7006281,0.4922376", "l0.7059369,0.4941301", "l0.7080997,0.4910895", "l0.7115242,0.4899413", "l0.7115734,0.4888941", "l0.7128350,0.4898656", "l0.7139492,0.4879731", "l0.7173246,0.4866862", "l0.7142769,0.4856263", "l0.7126384,0.4837338", "l0.7138509,0.4830777", "l0.7122288,0.4815384", "l0.7138017,0.4795324", "l0.7124582,0.4758356", "l0.7159482,0.4719748", "l0.7156041,0.4678491", "l0.7156041,0.4678491", "l0.7326938,0.4686566", "l0.7347419,0.4699435", "l0.7399688,0.4700949", "l0.7562392,0.4677608", "l0.7617610,0.4689594", "l0.7685281,0.4686944", "l0.7893372,0.4657925", "c"]}, {"n": "Sardegna", "u": "IT-88", "i": ["m0.1470896,0.7062208", "l0.1479908,0.7074320", "l0.1516938,0.7066119", "l0.1551674,0.7111161", "l0.1532995,0.7182068", "l0.1507435,0.7193298", "l0.1461556,0.7125797", "l0.1452381,0.7089839", "l0.1470896,0.7062208", "c", "m0.1418627,0.7005053", "l0.1416497,0.7073941", "l0.1389953,0.7078736", "l0.1367833,0.7066750", "l0.1368653,0.7045427", "l0.1343420,0.7033946", "l0.1383399,0.7005684", "l0.1418627,0.7005053", "c", "m0.2614741,0.5543634", "l0.2623753,0.5550068", "l0.2582954,0.5570129", "l0.2574270,0.5564956", "l0.2619493,0.5536316", "l0.2614741,0.5543634", "c", "m0.1351121,0.5494554", "l0.1341945,0.5501746", "l0.1340962,0.5489129", "l0.1351121,0.5494554", "c", "m0.1429933,0.5372800", "l0.1434357,0.5387058", "l0.1454674,0.5397530", "l0.1442713,0.5406866", "l0.1439928,0.5431595", "l0.1395196,0.5415572", "l0.1359477,0.5453801", "l0.1370291,0.5451404", "l0.1383727,0.5471843", "l0.1376026,0.5489129", "l0.1338340,0.5485470", "l0.1354561,0.5454306", "l0.1344239,0.5453170", "l0.1346860,0.5439039", "l0.1371110,0.5431217", "l0.1385365,0.5411030", "l0.1401095,0.5409642", "l0.1392247,0.5385039", "l0.1429933,0.5372800", "c", "m0.2397310,0.5267701", "l0.2411402,0.5287005", "l0.2391084,0.5313249", "l0.2405175,0.5316150", "l0.2367490,0.5320566", "l0.2385349,0.5266061", "l0.2397310,0.5267701", "c", "m0.2287039,0.5259500", "l0.2302932,0.5267197", "l0.2285564,0.5279057", "l0.2287039,0.5259500", "c", "m0.2194135,0.5253697", "l0.2235425,0.5279814", "l0.2223137,0.5303534", "l0.2240505,0.5317538", "l0.2280648,0.5315393", "l0.2285072,0.5299244", "l0.2305554,0.5297477", "l0.2314402,0.5320440", "l0.2323741,0.5322333", "l0.2356184,0.5322585", "l0.2340126,0.5338609", "l0.2360772,0.5341384", "l0.2375518,0.5358796", "l0.2372733,0.5395637", "l0.2397147,0.5367123", "l0.2392559,0.5352613", "l0.2433358,0.5354380", "l0.2438437,0.5339870", "l0.2453511,0.5355515", "l0.2444336,0.5359679", "l0.2460393,0.5360436", "l0.2455969,0.5375955", "l0.2477761,0.5375198", "l0.2482022,0.5389329", "l0.2465636,0.5408506", "l0.2456625,0.5400053", "l0.2450234,0.5404721", "l0.2454986,0.5422890", "l0.2441386,0.5429451", "l0.2428770,0.5467049", "l0.2441386,0.5466544", "l0.2444172,0.5449511", "l0.2473010,0.5442824", "l0.2464326,0.5471213", "l0.2485954,0.5471970", "l0.2485299,0.5461624", "l0.2492836,0.5465409", "l0.2500864,0.5455441", "l0.2559032,0.5478530", "l0.2547562,0.5487867", "l0.2512006,0.5473862", "l0.2489395,0.5488876", "l0.2498898,0.5501998", "l0.2477761,0.5523825", "l0.2483169,0.5535559", "l0.2438601,0.5530512", "l0.2423691,0.5535685", "l0.2438437,0.5541615", "l0.2473174,0.5542246", "l0.2487265,0.5546662", "l0.2481038,0.5551835", "l0.2496932,0.5566218", "l0.2521182,0.5540353", "l0.2541827,0.5543381", "l0.2517577,0.5567101", "l0.2554280,0.5581106", "l0.2545596,0.5598265", "l0.2572959,0.5593597", "l0.2607368,0.5611891", "l0.2595407,0.5618957", "l0.2579021,0.5614415", "l0.2572304,0.5626653", "l0.2581643,0.5636368", "l0.2567224,0.5642172", "l0.2564930,0.5658069", "l0.2603599,0.5687593", "l0.2600978,0.5721911", "l0.2633748,0.5753579", "l0.2623753,0.5785879", "l0.2634239,0.5818052", "l0.2664388,0.5839753", "l0.2668976,0.5862590", "l0.2696175,0.5875711", "l0.2644726,0.5991409", "l0.2580168,0.6033802", "l0.2527081,0.6103699", "l0.2527081,0.6146975", "l0.2549528,0.6198074", "l0.2582626,0.6232266", "l0.2616380,0.6247406", "l0.2616052,0.6268350", "l0.2577219,0.6341781", "l0.2579841,0.6368529", "l0.2599994,0.6372440", "l0.2603435,0.6381903", "l0.2573451,0.6405244", "l0.2585576,0.6445240", "l0.2563128,0.6504161", "l0.2570501,0.6562956", "l0.2543630,0.6613802", "l0.2552314,0.6683321", "l0.2531832,0.6739340", "l0.2543630,0.6773154", "l0.2503158,0.6867781", "l0.2508238,0.6894402", "l0.2532488,0.6909669", "l0.2506927,0.6916230", "l0.2489395,0.6936921", "l0.2473010,0.6995338", "l0.2486937,0.7011488", "l0.2469241,0.7049086", "l0.2452528,0.7049086", "l0.2437454,0.7063343", "l0.2439584,0.7079745", "l0.2423199,0.7069147", "l0.2423199,0.7050852", "l0.2407633,0.7046310", "l0.2367981,0.7056656", "l0.2249353,0.6981333", "l0.2176603,0.6969599", "l0.2141703,0.6985875", "l0.2133838,0.7007450", "l0.2091892,0.6981459", "l0.2056992,0.6993319", "l0.2015373,0.7033189", "l0.2014554,0.7085549", "l0.2038640,0.7111414", "l0.2018159,0.7171092", "l0.2009147,0.7164152", "l0.1997186,0.7168821", "l0.1881015,0.7258906", "l0.1860370,0.7258275", "l0.1843985,0.7241747", "l0.1833335,0.7252471", "l0.1812362,0.7226732", "l0.1766811,0.7206671", "l0.1764026,0.7219793", "l0.1718803,0.7228373", "l0.1723554,0.7241494", "l0.1705695,0.7248433", "l0.1713887,0.7265214", "l0.1699796,0.7268873", "l0.1704548,0.7243513", "l0.1670958,0.7244901", "l0.1682919,0.7203265", "l0.1641301,0.7174120", "l0.1634255,0.7120372", "l0.1607056,0.7108259", "l0.1559212,0.7107502", "l0.1566749,0.7084161", "l0.1555115,0.7064605", "l0.1544629,0.7057035", "l0.1526605,0.7064479", "l0.1525950,0.7027763", "l0.1468930,0.6980702", "l0.1467291,0.6968338", "l0.1516283,0.6933010", "l0.1524967,0.6915599", "l0.1512350,0.6881407", "l0.1489739,0.6875225", "l0.1486462,0.6853650", "l0.1473026,0.6845070", "l0.1505468,0.6805579", "l0.1504649,0.6790691", "l0.1480235,0.6778327", "l0.1483676,0.6765710", "l0.1539549,0.6702120", "l0.1554460,0.6655690", "l0.1536436,0.6628564", "l0.1543646,0.6603077", "l0.1533487,0.6588820", "l0.1541843,0.6568633", "l0.1533651,0.6526619", "l0.1544793,0.6516021", "l0.1573958,0.6554755", "l0.1586739,0.6553998", "l0.1592309,0.6527881", "l0.1618853,0.6493058", "l0.1625407,0.6439057", "l0.1600502,0.6404108", "l0.1561014,0.6402216", "l0.1529718,0.6426945", "l0.1493835,0.6400828", "l0.1489739,0.6344178", "l0.1506615,0.6306958", "l0.1476794,0.6293584", "l0.1498095,0.6279958", "l0.1506288,0.6288790", "l0.1541352,0.6280463", "l0.1571500,0.6255733", "l0.1572811,0.6236682", "l0.1543810,0.6174606", "l0.1565602,0.6081998", "l0.1546267,0.6053484", "l0.1513825,0.6038974", "l0.1481874,0.6037587", "l0.1478924,0.6019418", "l0.1497603,0.5977025", "l0.1474173,0.5909146", "l0.1444516,0.5901071", "l0.1412729,0.5824865", "l0.1368325,0.5831678", "l0.1366031,0.5843286", "l0.1332605,0.5843917", "l0.1332278,0.5821711", "l0.1344566,0.5815150", "l0.1326707,0.5800767", "l0.1297050,0.5836725", "l0.1287874,0.5834454", "l0.1283122,0.5796729", "l0.1316712,0.5784869", "l0.1334408,0.5744748", "l0.1308847,0.5736294", "l0.1273455,0.5705257", "l0.1302129,0.5675607", "l0.1297541,0.5651130", "l0.1319825,0.5636242", "l0.1349974,0.5572400", "l0.1310649,0.5530260", "l0.1333588,0.5499979", "l0.1361771,0.5515624", "l0.1357675,0.5551709", "l0.1425345,0.5607602", "l0.1475320,0.5615298", "l0.1512678,0.5610503", "l0.1544465,0.5628420", "l0.1633600,0.5618326", "l0.1745510,0.5548681", "l0.1827600,0.5539344", "l0.1895434,0.5479918", "l0.1893632,0.5463390", "l0.1944098,0.5440049", "l0.2011441,0.5369646", "l0.2038476,0.5358417", "l0.2049127,0.5367628", "l0.2091564,0.5361319", "l0.2101559,0.5343782", "l0.2129086,0.5342898", "l0.2142522,0.5331291", "l0.2130069,0.5307192", "l0.2141047,0.5279688", "l0.2119910,0.5276912", "l0.2122368,0.5265052", "l0.2139573,0.5274010", "l0.2163167,0.5264295", "l0.2164150,0.5275902", "l0.2194135,0.5253697", "c", "m0.2352743,0.5245369", "l0.2376665,0.5275145", "l0.2369620,0.5289655", "l0.2321120,0.5295459", "l0.2313746,0.5279561", "l0.2337996,0.5265430", "l0.2335866,0.5251552", "l0.2347172,0.5260888", "l0.2352743,0.5245369", "c"]}, {"n": "Sicilia", "u": "IT-82", "i": ["m0.4964531,0.9968139", "l0.5044982,0.9974574", "l0.5050225,0.9995644", "l0.4952242,0.9975331", "l0.4964531,0.9968139", "c", "m0.4482481,0.8921186", "l0.4520822,0.8936327", "l0.4530653,0.8931658", "l0.4563587,0.8953107", "l0.4565554,0.8982883", "l0.4542450,0.9003827", "l0.4511646,0.9002187", "l0.4457248,0.8950836", "l0.4458723,0.8931154", "l0.4482481,0.8921186", "c", "m0.4895386,0.8107647", "l0.4879984,0.8066263", "l0.4901612,0.8057305", "l0.4895386,0.8107647", "c", "m0.4779052,0.8017309", "l0.4791996,0.8036109", "l0.4810511,0.8030936", "l0.4828371,0.8040777", "l0.4828207,0.8055286", "l0.4816246,0.8057557", "l0.4800844,0.8044688", "l0.4760536,0.8048221", "l0.4746937,0.8030557", "l0.4779052,0.8017309", "c", "m0.4574074,0.7986524", "l0.4595866,0.8022608", "l0.4555067,0.8013146", "l0.4543597,0.7985893", "l0.4574074,0.7986524", "c", "m0.7508649,0.7734185", "l0.7548301,0.7754625", "l0.7593196,0.7762952", "l0.7547973,0.7772541", "l0.7523232,0.7788312", "l0.7510615,0.7824775", "l0.7524379,0.7822630", "l0.7456872,0.7918393", "l0.7296953,0.8079006", "l0.7296462,0.8099824", "l0.7269262,0.8114081", "l0.7272539,0.8125689", "l0.7218468,0.8179437", "l0.7212242,0.8193568", "l0.7224203,0.8215269", "l0.7207490,0.8260438", "l0.7187501,0.8280120", "l0.7188648,0.8324532", "l0.7137526,0.8361752", "l0.7112293,0.8397962", "l0.7121960,0.8531702", "l0.7176686,0.8557819", "l0.7201428,0.8562613", "l0.7212570,0.8554160", "l0.7255827,0.8594912", "l0.7246815,0.8604501", "l0.7231249,0.8596174", "l0.7228136,0.8617244", "l0.7220599,0.8593651", "l0.7201756,0.8598697", "l0.7196349,0.8639198", "l0.7212734,0.8668721", "l0.7235181,0.8663044", "l0.7244521,0.8673516", "l0.7231577,0.8669352", "l0.7225350,0.8676418", "l0.7236328,0.8696983", "l0.7259759,0.8707203", "l0.7288269,0.8706194", "l0.7289908,0.8744802", "l0.7272212,0.8739629", "l0.7270737,0.8759690", "l0.7282207,0.8765241", "l0.7298100,0.8758049", "l0.7321695,0.8789465", "l0.7292365,0.8779372", "l0.7271229,0.8785933", "l0.7259267,0.8813185", "l0.7215355,0.8821260", "l0.7168002,0.8861508", "l0.7119502,0.8953612", "l0.7157352,0.9045589", "l0.7149815,0.9060099", "l0.7136543,0.9053790", "l0.7107377,0.9075113", "l0.7054945,0.9032341", "l0.7004315,0.9039407", "l0.6967448,0.9015182", "l0.6936972,0.9009126", "l0.6855866,0.9030701", "l0.6824242,0.9017327", "l0.6779511,0.9017201", "l0.6735435,0.8985028", "l0.6694145,0.8972411", "l0.6614349,0.8964462", "l0.6585347,0.8940364", "l0.6571912,0.8896457", "l0.6519315,0.8823784", "l0.6420677,0.8746820", "l0.6338915,0.8717170", "l0.6258464,0.8703418", "l0.6172278,0.8704932", "l0.6119846,0.8715656", "l0.6095105,0.8710231", "l0.6050865,0.8675535", "l0.5990404,0.8671371", "l0.5914704,0.8635287", "l0.5899139,0.8608539", "l0.5825897,0.8562235", "l0.5800992,0.8567155", "l0.5788539,0.8556557", "l0.5737745,0.8555421", "l0.5698257,0.8523627", "l0.5631406,0.8498141", "l0.5609777,0.8478332", "l0.5588804,0.8477196", "l0.5571436,0.8447042", "l0.5498850,0.8392789", "l0.5424134,0.8383074", "l0.5376453,0.8391780", "l0.5327953,0.8335634", "l0.5290267,0.8325667", "l0.5174588,0.8322513", "l0.5086600,0.8339293", "l0.5030563,0.8273685", "l0.4995008,0.8256274", "l0.4956994,0.8258167", "l0.4920619,0.8225741", "l0.4917506,0.8189278", "l0.4877526,0.8142974", "l0.4909477,0.8128843", "l0.4928156,0.8083296", "l0.4904889,0.8056169", "l0.4938807,0.8019580", "l0.4935530,0.7994220", "l0.4955847,0.7987281", "l0.4931597,0.7967094", "l0.4956339,0.7962299", "l0.4999923,0.7924196", "l0.5027614,0.7928108", "l0.5056943,0.7919150", "l0.5076769,0.7903883", "l0.5074803,0.7889752", "l0.5117077,0.7891014", "l0.5139197,0.7866411", "l0.5121009,0.7838780", "l0.5134281,0.7825406", "l0.5139852,0.7836130", "l0.5165740,0.7833859", "l0.5166560,0.7856696", "l0.5184256,0.7870070", "l0.5183600,0.7890257", "l0.5202115,0.7915617", "l0.5276832,0.7960155", "l0.5350565,0.7944510", "l0.5425609,0.7908551", "l0.5404636,0.7866915", "l0.5420693,0.7864014", "l0.5431507,0.7848242", "l0.5424953,0.7839663", "l0.5451497,0.7822378", "l0.5521298,0.7841429", "l0.5555870,0.7830579", "l0.5563080,0.7813420", "l0.5591754,0.7816700", "l0.5627473,0.7796513", "l0.5638287,0.7817709", "l0.5668928,0.7831840", "l0.5677284,0.7858967", "l0.5665159,0.7873350", "l0.5682363,0.7891897", "l0.5736270,0.7903505", "l0.5773137,0.7896565", "l0.5787720,0.7882434", "l0.5812134,0.7887733", "l0.5812625,0.7925584", "l0.5838022,0.7948042", "l0.5959927,0.7998762", "l0.6005478,0.8004188", "l0.6086257,0.7987281", "l0.6157040,0.7955108", "l0.6220287,0.7945519", "l0.6256990,0.7964192", "l0.6292545,0.7967094", "l0.6323513,0.7954982", "l0.6441650,0.7973150", "l0.6513417,0.7965958", "l0.6558640,0.7946402", "l0.6603207,0.7951575", "l0.6737893,0.7918393", "l0.6829650,0.7842943", "l0.6865041,0.7854425", "l0.6948933,0.7837266", "l0.6969087,0.7821368", "l0.7016604,0.7853542", "l0.7078540,0.7853668", "l0.7092303,0.7873602", "l0.7124418,0.7878649", "l0.7188156,0.7851649", "l0.7225022,0.7819476", "l0.7243702,0.7779354", "l0.7229446,0.7756265", "l0.7243210,0.7755508", "l0.7254680,0.7774812", "l0.7245832,0.7801434", "l0.7282698,0.7809382", "l0.7376749,0.7789574", "l0.7479975,0.7735952", "l0.7508649,0.7734185", "c", "m0.7005953,0.7636404", "l0.7036921,0.7654699", "l0.7041837,0.7676274", "l0.7024796,0.7678545", "l0.6996942,0.7664792", "l0.6987602,0.7641703", "l0.7004806,0.7624670", "l0.7013163,0.7630979", "l0.7005953,0.7636404", "c", "m0.7007756,0.7551618", "l0.7008083,0.7576095", "l0.7022994,0.7584296", "l0.7002021,0.7589595", "l0.7000382,0.7619119", "l0.6953029,0.7580763", "l0.6966629,0.7553259", "l0.7007756,0.7551618", "c", "m0.6503422,0.7524618", "l0.6502439,0.7542534", "l0.6488184,0.7543165", "l0.6486217,0.7528656", "l0.6503422,0.7524618", "c", "m0.6889291,0.7501024", "l0.6931401,0.7502538", "l0.6930910,0.7538749", "l0.6917965,0.7541020", "l0.6867663,0.7518814", "l0.6876675,0.7500898", "l0.6889291,0.7501024", "c", "m0.6660064,0.7499258", "l0.6683330,0.7502791", "l0.6697749,0.7523735", "l0.6664488,0.7521212", "l0.6652526,0.7506324", "l0.6660064,0.7499258", "c", "m0.7103445,0.7450178", "l0.7101970,0.7463174", "l0.7086732,0.7467085", "l0.7089026,0.7451945", "l0.7103445,0.7450178", "c", "m0.5522608,0.7393781", "l0.5529654,0.7397439", "l0.5517529,0.7408290", "l0.5489510,0.7410183", "l0.5495245,0.7394790", "l0.5512122,0.7387977", "l0.5522608,0.7393781", "c", "m0.7229119,0.7313663", "l0.7243702,0.7321990", "l0.7218632,0.7346089", "l0.7197168,0.7329687", "l0.7229119,0.7313663", "c"]}, {"n": "Toscana", "u": "IT-52", "i": ["m0.3104001,0.4308688", "l0.3118092,0.4331399", "l0.3105639,0.4340609", "l0.3089090,0.4338464", "l0.3086469,0.4311338", "l0.3104001,0.4308688", "c", "m0.3584576,0.4273992", "l0.3616855,0.4299604", "l0.3613250,0.4337707", "l0.3580972,0.4306922", "l0.3567536,0.4305282", "l0.3584576,0.4273992", "c", "m0.2907707,0.4073635", "l0.2925403,0.4100257", "l0.2914753,0.4118930", "l0.2878378,0.4106565", "l0.2901808,0.4098112", "l0.2907707,0.4073635", "c", "m0.3191661,0.3855741", "l0.3213453,0.3873404", "l0.3200837,0.3900278", "l0.3206080,0.3933966", "l0.3164790,0.3951125", "l0.3204933,0.3972573", "l0.3195921,0.3996293", "l0.3155450,0.3986200", "l0.3140376,0.3951756", "l0.3127759,0.3947087", "l0.3107769,0.3950115", "l0.3108916,0.3971186", "l0.3094170,0.3950998", "l0.3080570,0.3971943", "l0.3044031,0.3959452", "l0.3040426,0.3980270", "l0.2995859,0.3970933", "l0.2968823,0.3974214", "l0.2971937,0.3980901", "l0.2942280,0.3966896", "l0.2925403,0.3944816", "l0.2927041,0.3924881", "l0.2957190,0.3907092", "l0.3003888,0.3906208", "l0.3045506,0.3925765", "l0.3048291,0.3915797", "l0.3065823,0.3912265", "l0.3059925,0.3905073", "l0.3070575,0.3899143", "l0.3060580,0.3888545", "l0.3120058,0.3899521", "l0.3107605,0.3911760", "l0.3138737,0.3916050", "l0.3182485,0.3852839", "l0.3191661,0.3855741", "c", "m0.2698797,0.3682258", "l0.2710102,0.3707239", "l0.2680118,0.3737772", "l0.2665043,0.3720992", "l0.2673400,0.3691973", "l0.2693553,0.3675571", "l0.2698797,0.3682258", "c", "m0.4715641,0.3025799", "l0.4716952,0.3027818", "l0.4716952,0.3027818", "l0.4721868,0.3041696", "l0.4686148,0.3055953", "l0.4663700,0.3035892", "l0.4668124,0.3021761", "l0.4713511,0.3022014", "l0.4713511,0.3022014", "l0.4715641,0.3025799", "c", "m0.2573287,0.2525538", "l0.2632273,0.2499168", "l0.2688146,0.2431541", "l0.2775807,0.2424097", "l0.2815786,0.2435074", "l0.2823979,0.2450719", "l0.2841183,0.2453495", "l0.2832335,0.2486677", "l0.2850851,0.2502575", "l0.2920979,0.2539669", "l0.2960959,0.2533234", "l0.3053207,0.2608431", "l0.3092203,0.2593417", "l0.3128087,0.2608936", "l0.3154303,0.2609314", "l0.3202639,0.2647669", "l0.3230002,0.2644011", "l0.3249992,0.2652464", "l0.3249173,0.2669875", "l0.3277683,0.2690062", "l0.3281615,0.2709619", "l0.3337653,0.2748100", "l0.3365016,0.2742801", "l0.3363869,0.2725894", "l0.3380254,0.2710376", "l0.3471519,0.2712016", "l0.3552953,0.2762862", "l0.3590311,0.2769297", "l0.3601453,0.2780778", "l0.3596210,0.2792764", "l0.3607024,0.2796549", "l0.3686656,0.2727661", "l0.3693210,0.2739142", "l0.3683215,0.2752264", "l0.3708612,0.2766773", "l0.3753835,0.2770811", "l0.3808561,0.2752516", "l0.3859191,0.2763745", "l0.3900809,0.2761727", "l0.3896713,0.2748100", "l0.3848704,0.2726651", "l0.3850507,0.2714792", "l0.3915883,0.2713025", "l0.3953242,0.2686908", "l0.3956519,0.2673408", "l0.3997318,0.2670128", "l0.4037625,0.2639973", "l0.4059417,0.2655240", "l0.4064988,0.2682366", "l0.4087927,0.2687160", "l0.4116274,0.2712016", "l0.4136100,0.2715296", "l0.4152976,0.2702679", "l0.4195577,0.2709366", "l0.4198855,0.2722488", "l0.4175096,0.2748983", "l0.4218681,0.2753526", "l0.4308307,0.2739647", "l0.4302736,0.2773586", "l0.4269474,0.2801218", "l0.4262429,0.2826325", "l0.4234902,0.2834400", "l0.4238179,0.2848153", "l0.4227201,0.2847017", "l0.4223104,0.2861526", "l0.4258660,0.2887770", "l0.4253253,0.2908335", "l0.4283074,0.2923728", "l0.4278650,0.2962336", "l0.4337309,0.2987570", "l0.4370079,0.3017976", "l0.4446598,0.3020626", "l0.4455118,0.3037028", "l0.4477238,0.3039299", "l0.4477238,0.3039299", "l0.4480679,0.3051537", "l0.4507550,0.3064785", "l0.4507550,0.3064785", "l0.4524918,0.3059486", "l0.4548841,0.3070841", "l0.4563915,0.3067687", "l0.4563915,0.3067687", "l0.4582102,0.3083711", "l0.4610285,0.3072355", "l0.4610285,0.3072355", "l0.4633552,0.3074374", "l0.4657146,0.3064281", "l0.4682543,0.3093426", "l0.4696143,0.3068570", "l0.4729569,0.3073365", "l0.4756440,0.3062136", "l0.4756440,0.3062136", "l0.4759226,0.3063776", "l0.4759226,0.3063776", "l0.4794454,0.3074626", "l0.4831976,0.3113487", "l0.4797567,0.3113739", "l0.4802482,0.3141244", "l0.4787408,0.3140487", "l0.4777413,0.3093552", "l0.4770204,0.3132917", "l0.4750050,0.3141244", "l0.4726128,0.3137711", "l0.4729405,0.3147931", "l0.4714003,0.3161179", "l0.4676153,0.3171651", "l0.4699912,0.3199786", "l0.4699912,0.3199786", "l0.4659276,0.3239277", "l0.4646660,0.3271955", "l0.4610776,0.3269684", "l0.4601765,0.3276750", "l0.4598979,0.3298955", "l0.4641744,0.3317629", "l0.4640106,0.3324694", "l0.4605206,0.3336049", "l0.4588657,0.3357498", "l0.4570797,0.3353208", "l0.4542778,0.3375162", "l0.4548185,0.3387779", "l0.4583249,0.3385003", "l0.4585052,0.3418564", "l0.4608483,0.3411751", "l0.4619133,0.3419321", "l0.4635682,0.3448214", "l0.4626015,0.3469789", "l0.4632569,0.3481144", "l0.4669107,0.3491742", "l0.4683854,0.3463606", "l0.4709087,0.3479504", "l0.4599798,0.3532243", "l0.4563751,0.3516724", "l0.4550315,0.3521392", "l0.4558508,0.3538172", "l0.4542287,0.3572617", "l0.4457412,0.3611098", "l0.4449383,0.3627753", "l0.4463802,0.3658538", "l0.4458395,0.3673931", "l0.4471339,0.3693739", "l0.4485103,0.3680491", "l0.4505912,0.3697651", "l0.4466260,0.3821927", "l0.4484119,0.3831390", "l0.4486577,0.3854227", "l0.4465604,0.3855236", "l0.4433653,0.3884760", "l0.4433653,0.3884760", "l0.4393018,0.3882993", "l0.4366474,0.3896493", "l0.4358118,0.3921853", "l0.4346648,0.3905199", "l0.4326986,0.3899269", "l0.4307979,0.3930054", "l0.4369915,0.3967400", "l0.4352875,0.3997176", "l0.4332721,0.3997050", "l0.4339439,0.4030107", "l0.4356643,0.4036163", "l0.4357954,0.4049789", "l0.4335015,0.4061397", "l0.4312567,0.4058999", "l0.4297657,0.4086000", "l0.4276520,0.4082845", "l0.4251942,0.4096850", "l0.4248665,0.4110477", "l0.4220155,0.4121579", "l0.4206883,0.4118678", "l0.4195905,0.4129907", "l0.4177226,0.4116659", "l0.4167067,0.4120822", "l0.4174441,0.4143028", "l0.4151993,0.4167505", "l0.4197708,0.4191603", "l0.4199182,0.4234879", "l0.4087763,0.4235889", "l0.4057451,0.4288249", "l0.4057451,0.4288249", "l0.3920307,0.4263646", "l0.3901137,0.4251660", "l0.3856405,0.4260744", "l0.3858536,0.4279417", "l0.3842314,0.4285473", "l0.3838546,0.4300866", "l0.3808725,0.4302759", "l0.3786441,0.4281310", "l0.3759897,0.4274875", "l0.3752688,0.4242323", "l0.3768745,0.4226805", "l0.3782672,0.4237781", "l0.3819375,0.4235384", "l0.3835924,0.4209393", "l0.3841003,0.4170028", "l0.3812657,0.4124986", "l0.3783819,0.4129528", "l0.3767762,0.4093191", "l0.3749738,0.4079691", "l0.3753179,0.4067327", "l0.3685345,0.4044995", "l0.3670107,0.3998060", "l0.3633896,0.3969167", "l0.3561309,0.3946709", "l0.3505764,0.3941662", "l0.3455298,0.3916176", "l0.3485446,0.3901919", "l0.3487740,0.3855867", "l0.3502323,0.3839591", "l0.3491509,0.3821044", "l0.3462179,0.3804137", "l0.3409747,0.3785338", "l0.3362886,0.3781427", "l0.3301769,0.3788745", "l0.3295379,0.3811077", "l0.3257529,0.3801236", "l0.3247862,0.3751525", "l0.3275553,0.3741431", "l0.3293904,0.3663080", "l0.3283090,0.3522780", "l0.3263920,0.3486191", "l0.3228528,0.3457676", "l0.3198543,0.3388914", "l0.3180847,0.3387653", "l0.3162004,0.3347783", "l0.3119075,0.3322801", "l0.3092531,0.3268170", "l0.3097774,0.3238394", "l0.3067298,0.3140991", "l0.3077129,0.3129889", "l0.3073033,0.3079295", "l0.3042884,0.2969149", "l0.2960303,0.2872125", "l0.2892797,0.2826073", "l0.2857405,0.2812951", "l0.2857405,0.2812951", "l0.2893943,0.2780904", "l0.2898367,0.2763493", "l0.2859535,0.2744946", "l0.2830369,0.2763871", "l0.2838398,0.2748353", "l0.2822996,0.2730815", "l0.2819883,0.2701039", "l0.2755489,0.2702805", "l0.2775807,0.2677824", "l0.2788096,0.2677067", "l0.2764009,0.2664198", "l0.2729928,0.2686277", "l0.2736974,0.2651833", "l0.2723702,0.2643001", "l0.2722227,0.2610576", "l0.2679790,0.2597202", "l0.2613758,0.2557711", "l0.2597209,0.2525159", "l0.2573287,0.2525538", "c"]}, {"n": "Trentino-Alto Adige", "u": "IT-32", "i": ["m0.4689917,0.0008964", "l0.4718263,0.0026123", "l0.4699256,0.0036469", "l0.4690408,0.0063848", "l0.4641744,0.0067759", "l0.4620116,0.0083783", "l0.4634043,0.0131727", "l0.4660260,0.0150905", "l0.4638959,0.0175129", "l0.4676153,0.0180555", "l0.4699748,0.0209826", "l0.4722195,0.0196326", "l0.4751033,0.0201499", "l0.4776922,0.0242125", "l0.4758406,0.0265467", "l0.4757423,0.0294738", "l0.4816737,0.0302939", "l0.4839185,0.0356687", "l0.4921766,0.0393402", "l0.4921766,0.0393402", "l0.4881459,0.0405010", "l0.4854095,0.0428604", "l0.4839677,0.0426080", "l0.4845903,0.0442861", "l0.4837547,0.0448664", "l0.4816901,0.0449421", "l0.4804776,0.0438192", "l0.4755785,0.0450052", "l0.4735959,0.0440463", "l0.4681232,0.0473898", "l0.4679430,0.0445384", "l0.4654033,0.0433019", "l0.4640434,0.0436678", "l0.4576040,0.0397944", "l0.4580956,0.0427342", "l0.4556214,0.0461155", "l0.4558999,0.0479954", "l0.4518692,0.0529413", "l0.4509189,0.0519698", "l0.4490182,0.0520455", "l0.4470848,0.0535343", "l0.4445123,0.0531305", "l0.4365327,0.0562343", "l0.4363361,0.0583035", "l0.4413663,0.0588334", "l0.4423495,0.0605871", "l0.4385809,0.0640189", "l0.4381385,0.0686367", "l0.4368113,0.0677031", "l0.4329444,0.0695073", "l0.4377125,0.0725858", "l0.4386628,0.0743522", "l0.4375650,0.0767494", "l0.4388594,0.0776326", "l0.4423986,0.0770018", "l0.4431196,0.0794495", "l0.4441682,0.0789322", "l0.4461508,0.0796766", "l0.4448564,0.0821621", "l0.4488380,0.0849631", "l0.4478385,0.0869818", "l0.4460361,0.0864266", "l0.4432342,0.0914103", "l0.4363689,0.0932524", "l0.4327150,0.0929496", "l0.4314861,0.0939337", "l0.4304047,0.0929622", "l0.4259152,0.0940599", "l0.4258988,0.0966085", "l0.4274226,0.0985389", "l0.4240473,0.0993085", "l0.4252598,0.1001665", "l0.4240637,0.1011884", "l0.4259316,0.1037370", "l0.4244405,0.1060964", "l0.4175424,0.1057179", "l0.4166576,0.1021725", "l0.4135608,0.1014155", "l0.4100380,0.1017814", "l0.4055485,0.1046455", "l0.3996171,0.1043553", "l0.4002397,0.1079511", "l0.3981260,0.1081530", "l0.3970118,0.1100960", "l0.3975853,0.1113451", "l0.3935218,0.1096544", "l0.3934071,0.1086703", "l0.3934399,0.1103862", "l0.3894747,0.1101591", "l0.3880655,0.1163540", "l0.3842150,0.1199246", "l0.3851982,0.1229022", "l0.3826585,0.1227129", "l0.3828715,0.1272550", "l0.3787752,0.1315069", "l0.3761536,0.1312420", "l0.3729912,0.1289204", "l0.3703041,0.1300307", "l0.3695831,0.1285546", "l0.3665683,0.1318980", "l0.3657654,0.1305859", "l0.3633076,0.1327181", "l0.3608662,0.1315448", "l0.3619313,0.1301064", "l0.3585723,0.1288321", "l0.3549840,0.1288195", "l0.3585723,0.1237349", "l0.3572943,0.1218297", "l0.3593916,0.1204419", "l0.3550004,0.1183475", "l0.3550004,0.1183475", "l0.3485119,0.1173759", "l0.3478728,0.1184736", "l0.3457919,0.1172245", "l0.3392215,0.1182465", "l0.3384350,0.1209592", "l0.3352071,0.1210349", "l0.3316843,0.1227255", "l0.3295215,0.1225615", "l0.3288497,0.1214638", "l0.3299803,0.1197101", "l0.3262936,0.1184989", "l0.3254416,0.1130610", "l0.3269327,0.1104114", "l0.3248026,0.1079006", "l0.3250648,0.1053394", "l0.3222137,0.1049357", "l0.3221318,0.1036740", "l0.3230658,0.1013651", "l0.3250320,0.1001665", "l0.3244421,0.0977692", "l0.3298984,0.0926341", "l0.3314222,0.0870575", "l0.3296854,0.0850514", "l0.3334048,0.0798027", "l0.3325691,0.0771153", "l0.3312419,0.0765223", "l0.3326838,0.0749200", "l0.3317007,0.0723714", "l0.3273751,0.0707690", "l0.3316188,0.0675643", "l0.3348467,0.0674129", "l0.3372881,0.0654447", "l0.3359117,0.0637035", "l0.3362886,0.0609278", "l0.3346009,0.0592119", "l0.3302752,0.0569787", "l0.3240980,0.0566002", "l0.3222301,0.0532062", "l0.3222301,0.0532062", "l0.3238686,0.0520833", "l0.3253269,0.0456865", "l0.3215911,0.0430622", "l0.3178389,0.0434533", "l0.3164626,0.0388482", "l0.3189859,0.0364383", "l0.3177570,0.0342304", "l0.3213453,0.0320350", "l0.3193463,0.0287925", "l0.3217058,0.0277831", "l0.3240980,0.0225597", "l0.3259332,0.0236952", "l0.3305210,0.0234429", "l0.3299148,0.0245532", "l0.3398933,0.0209700", "l0.3421217,0.0219415", "l0.3421053,0.0232158", "l0.3472994,0.0248434", "l0.3480367,0.0258653", "l0.3451693,0.0291962", "l0.3473649,0.0294864", "l0.3500357,0.0284518", "l0.3523296,0.0303696", "l0.3542630,0.0297514", "l0.3583266,0.0315808", "l0.3610465,0.0304831", "l0.3696487,0.0311897", "l0.3711889,0.0275812", "l0.3749411,0.0260672", "l0.3739252,0.0229887", "l0.3762683,0.0196831", "l0.3760389,0.0174120", "l0.3775135,0.0157718", "l0.3796600,0.0159989", "l0.3815934,0.0148886", "l0.3818228,0.0124283", "l0.3838710,0.0119615", "l0.3853784,0.0127311", "l0.3948326,0.0099175", "l0.3962253,0.0106493", "l0.3979785,0.0100563", "l0.4018946,0.0125166", "l0.4049586,0.0115199", "l0.4082356,0.0080881", "l0.4130365,0.0107629", "l0.4199182,0.0079367", "l0.4236540,0.0098545", "l0.4275865,0.0099302", "l0.4290120,0.0117218", "l0.4306996,0.0120877", "l0.4336162,0.0100059", "l0.4381876,0.0098418", "l0.4447744,0.0059306", "l0.4474125,0.0058297", "l0.4497555,0.0043787", "l0.4534094,0.0046184", "l0.4550479,0.0032306", "l0.4580464,0.0034703", "l0.4599143,0.0016535", "l0.4616675,0.0021455", "l0.4672057,0.0003413", "c"]}, {"n": "Umbria", "u": "IT-55", "i": ["m0.4879820,0.3217072", "l0.4871300,0.3209754", "l0.4871300,0.3209754", "l0.4868187,0.3208997", "l0.4868187,0.3208997", "l0.4872119,0.3200417", "l0.4882933,0.3204328", "l0.4882933,0.3204328", "l0.4884572,0.3211015", "l0.4884572,0.3211015", "l0.4879820,0.3217072", "c", "m0.4699092,0.3198399", "l0.4710726,0.3213160", "l0.4761356,0.3212656", "l0.4767091,0.3219721", "l0.4801172,0.3198525", "l0.4831976,0.3197011", "l0.4823619,0.3206852", "l0.4831484,0.3225020", "l0.4783639,0.3259086", "l0.4805923,0.3277002", "l0.4829354,0.3267792", "l0.4850163,0.3289619", "l0.4873430,0.3263250", "l0.4889651,0.3264890", "l0.4903251,0.3282806", "l0.4918325,0.3283437", "l0.4923077,0.3272586", "l0.4937987,0.3277885", "l0.5042197,0.3369863", "l0.5077097,0.3353587", "l0.5113636,0.3363933", "l0.5135264,0.3329993", "l0.5169345,0.3337059", "l0.5163283,0.3362419", "l0.5178029,0.3373017", "l0.5148536,0.3394339", "l0.5149355,0.3404938", "l0.5186550,0.3442284", "l0.5192776,0.3478999", "l0.5182617,0.3487831", "l0.5213421,0.3504738", "l0.5224399,0.3547888", "l0.5247175,0.3556593", "l0.5244881,0.3593182", "l0.5218337,0.3612739", "l0.5229315,0.3632169", "l0.5263232,0.3637468", "l0.5272571,0.3659043", "l0.5268639,0.3693992", "l0.5280928,0.3720613", "l0.5266673,0.3728940", "l0.5282075,0.3753544", "l0.5272899,0.3772343", "l0.5316975,0.3792656", "l0.5320252,0.3803633", "l0.5338440,0.3805273", "l0.5340406,0.3856245", "l0.5360232,0.3839086", "l0.5360560,0.3817511", "l0.5381860,0.3827226", "l0.5404799,0.3809689", "l0.5454119,0.3838708", "l0.5495081,0.3888419", "l0.5538830,0.3880722", "l0.5559311,0.3857759", "l0.5582414,0.3903433", "l0.5578318,0.3926395", "l0.5563244,0.3950368", "l0.5557017,0.3940653", "l0.5525558,0.3950494", "l0.5521461,0.3975728", "l0.5521461,0.3975728", "l0.5509173,0.4031999", "l0.5487380,0.4048149", "l0.5460837,0.4040074", "l0.5460017,0.4049915", "l0.5414139,0.4071616", "l0.5380386,0.4057990", "l0.5368752,0.4077294", "l0.5315500,0.4076789", "l0.5302556,0.4089028", "l0.5269622,0.4076537", "l0.5260119,0.4091299", "l0.5270278,0.4123472", "l0.5236033,0.4131925", "l0.5205720,0.4152491", "l0.5172131,0.4151229", "l0.5169345,0.4168010", "l0.5119207,0.4179113", "l0.5141654,0.4204851", "l0.5092663,0.4229707", "l0.5073001,0.4230337", "l0.5058418,0.4206996", "l0.5038920,0.4208005", "l0.5035315,0.4256959", "l0.4964367,0.4299352", "l0.4950112,0.4286735", "l0.4950932,0.4265539", "l0.4891290,0.4272226", "l0.4907183,0.4254310", "l0.4869661,0.4244342", "l0.4869989,0.4218351", "l0.4881131,0.4215449", "l0.4869006,0.4206870", "l0.4873102,0.4183402", "l0.4849016,0.4181384", "l0.4816246,0.4201823", "l0.4796092,0.4185926", "l0.4765452,0.4188701", "l0.4776758,0.4182898", "l0.4751852,0.4172804", "l0.4764141,0.4164351", "l0.4747101,0.4153626", "l0.4750542,0.4129023", "l0.4723178,0.4119182", "l0.4714167,0.4062784", "l0.4686803,0.4036794", "l0.4660260,0.4028214", "l0.4637648,0.4043228", "l0.4626670,0.4040579", "l0.4624704,0.4050041", "l0.4608155,0.4036541", "l0.4547858,0.4053069", "l0.4480023,0.4020770", "l0.4458886,0.3994148", "l0.4489199,0.3981027", "l0.4505748,0.3956045", "l0.4460197,0.3933461", "l0.4433653,0.3884507", "l0.4433653,0.3884507", "l0.4465604,0.3854984", "l0.4486577,0.3853974", "l0.4484119,0.3831138", "l0.4466260,0.3821675", "l0.4505912,0.3697398", "l0.4485103,0.3680239", "l0.4471339,0.3693487", "l0.4458559,0.3673678", "l0.4463966,0.3658286", "l0.4449547,0.3627627", "l0.4457576,0.3610972", "l0.4542450,0.3572491", "l0.4558836,0.3538046", "l0.4550643,0.3521392", "l0.4564243,0.3516850", "l0.4600290,0.3532369", "l0.4709579,0.3479630", "l0.4684346,0.3463733", "l0.4669599,0.3491868", "l0.4633060,0.3481270", "l0.4626670,0.3469915", "l0.4636337,0.3448340", "l0.4619788,0.3419447", "l0.4609138,0.3411877", "l0.4585871,0.3418690", "l0.4584069,0.3385129", "l0.4549005,0.3387905", "l0.4543597,0.3375288", "l0.4571616,0.3353334", "l0.4589476,0.3357624", "l0.4606025,0.3336175", "l0.4640925,0.3324820", "l0.4642564,0.3317755", "l0.4599798,0.3299082", "l0.4602584,0.3276876", "l0.4611596,0.3269810", "l0.4647479,0.3272081", "l0.4660096,0.3239404", "l0.4699092,0.3198399", "c"]}, {"n": "Valle d'Aosta", "u": "IT-23", "i": ["m0.0804021,0.1040272", "l0.0813525,0.1055034", "l0.0876116,0.1048221", "l0.0891026,0.1066894", "l0.0912655,0.1073707", "l0.0923141,0.1098058", "l0.0949357,0.1083548", "l0.0989829,0.1103862", "l0.1008999,0.1095535", "l0.1042916,0.1104745", "l0.1042916,0.1104745", "l0.1054386,0.1155970", "l0.1042916,0.1219685", "l0.1070935,0.1258798", "l0.1097479,0.1266368", "l0.1103377,0.1281508", "l0.1076178,0.1317214", "l0.1105999,0.1364275", "l0.1086337,0.1367303", "l0.1074376,0.1405659", "l0.1057827,0.1397458", "l0.1014570,0.1399981", "l0.0934447,0.1443762", "l0.0923305,0.1436066", "l0.0885292,0.1440860", "l0.0853013,0.1424458", "l0.0829910,0.1432785", "l0.0827780,0.1421808", "l0.0794846,0.1406037", "l0.0760765,0.1420294", "l0.0730452,0.1414364", "l0.0710298,0.1419285", "l0.0695060,0.1439094", "l0.0637057,0.1474926", "l0.0621327,0.1466472", "l0.0590523,0.1477701", "l0.0544645,0.1478585", "l0.0505484,0.1516562", "l0.0455182,0.1503061", "l0.0440435,0.1511641", "l0.0434537,0.1475683", "l0.0405535,0.1520599", "l0.0405535,0.1520599", "l0.0360968,0.1515678", "l0.0365392,0.1495113", "l0.0319677,0.1485524", "l0.0315909,0.1421682", "l0.0300343,0.1409065", "l0.0319513,0.1361247", "l0.0291003,0.1347999", "l0.0248402,0.1350270", "l0.0239882,0.1331976", "l0.0199738,0.1320368", "l0.0158448,0.1283653", "l0.0164510,0.1268513", "l0.0152057,0.1231293", "l0.0168606,0.1179059", "l0.0188105,0.1174769", "l0.0204326,0.1182844", "l0.0216287,0.1167830", "l0.0245616,0.1175652", "l0.0270030,0.1169722", "l0.0278714,0.1156727", "l0.0316564,0.1146507", "l0.0321807,0.1120516", "l0.0355561,0.1098563", "l0.0407338,0.1159124", "l0.0449447,0.1139568", "l0.0479924,0.1158493", "l0.0500241,0.1131871", "l0.0535141,0.1131114", "l0.0565126,0.1100581", "l0.0642464,0.1123796", "l0.0715378,0.1088469", "l0.0714722,0.1075978", "l0.0736842,0.1062730", "l0.0773217,0.1068030", "l0.0778133,0.1041156", "c"]}, {"n": "Veneto", "u": "IT-34", "i": ["m0.4979442,0.1986542", "l0.4957322,0.1996257", "l0.4972724,0.1983010", "l0.4957977,0.1978341", "l0.4984193,0.1976070", "l0.4979442,0.1986542", "c", "m0.4952570,0.1960047", "l0.4972068,0.1971402", "l0.4933236,0.1978089", "l0.4943394,0.1956009", "l0.4952570,0.1960047", "c", "m0.4946508,0.0394538", "l0.4993041,0.0419141", "l0.5083815,0.0412075", "l0.5117732,0.0421412", "l0.5132315,0.0435164", "l0.5132315,0.0435164", "l0.5129202,0.0457875", "l0.5145095,0.0478819", "l0.5133626,0.0507459", "l0.5148045,0.0522095", "l0.5106263,0.0522852", "l0.5049570,0.0550357", "l0.5047604,0.0562217", "l0.5067757,0.0572310", "l0.5074312,0.0594264", "l0.5044491,0.0584423", "l0.5027450,0.0594390", "l0.4997138,0.0584423", "l0.4971413,0.0600194", "l0.4964695,0.0594769", "l0.4940445,0.0620507", "l0.4935857,0.0642587", "l0.4903087,0.0664792", "l0.4908330,0.0682330", "l0.4898499,0.0678923", "l0.4901448,0.0686494", "l0.4871464,0.0698227", "l0.4866057,0.0723714", "l0.4834761,0.0720307", "l0.4817721,0.0730905", "l0.4818376,0.0756013", "l0.4788883,0.0779859", "l0.4823619,0.0815817", "l0.4857700,0.0815691", "l0.4861960,0.0835626", "l0.4892109,0.0834364", "l0.4897025,0.0861238", "l0.4936677,0.0885841", "l0.4929303,0.0931010", "l0.4881786,0.0955739", "l0.4852785,0.0991192", "l0.4867859,0.1001286", "l0.4879492,0.1034090", "l0.4879820,0.1077871", "l0.4903251,0.1078375", "l0.4920455,0.1097427", "l0.4944705,0.1097553", "l0.4965350,0.1154708", "l0.4988126,0.1170605", "l0.4984685,0.1185746", "l0.5017455,0.1198993", "l0.5028597,0.1178806", "l0.5048915,0.1187133", "l0.5050881,0.1198489", "l0.5069232,0.1205049", "l0.5070051,0.1225489", "l0.5133626,0.1180194", "l0.5144604,0.1188774", "l0.5177046,0.1162278", "l0.5195561,0.1172876", "l0.5188516,0.1185493", "l0.5198838,0.1194704", "l0.5207850,0.1181582", "l0.5243406,0.1167956", "l0.5253892,0.1168839", "l0.5247338,0.1182718", "l0.5267820,0.1197101", "l0.5292725,0.1185241", "l0.5300754,0.1198993", "l0.5326151,0.1192685", "l0.5318778,0.1174895", "l0.5328445,0.1171867", "l0.5337948,0.1191802", "l0.5337293,0.1195713", "l0.5343847,0.1200381", "l0.5341061,0.1210727", "l0.5354497,0.1215143", "l0.5336637,0.1223218", "l0.5369899,0.1247569", "l0.5361870,0.1250849", "l0.5372521,0.1267251", "l0.5366786,0.1282013", "l0.5382679,0.1273055", "l0.5392019,0.1306742", "l0.5404963,0.1309265", "l0.5398901,0.1319359", "l0.5415450,0.1329579", "l0.5412664,0.1346233", "l0.5428722,0.1344719", "l0.5426755,0.1352415", "l0.5444288,0.1359985", "l0.5444288,0.1359985", "l0.5435112,0.1369701", "l0.5354497,0.1373990", "l0.5355972,0.1364528", "l0.5341061,0.1360112", "l0.5333196,0.1377271", "l0.5284041,0.1382191", "l0.5268475,0.1398467", "l0.5165904,0.1447799", "l0.4905053,0.1541291", "l0.4879984,0.1566146", "l0.4852621,0.1555548", "l0.4821161,0.1588100", "l0.4797567,0.1623553", "l0.4795928,0.1637179", "l0.4809528,0.1642100", "l0.4791832,0.1647147", "l0.4766271,0.1729031", "l0.4788555,0.1734330", "l0.4770859,0.1747830", "l0.4780199,0.1779625", "l0.4801172,0.1797919", "l0.4796420,0.1864789", "l0.4820014,0.1880182", "l0.4845903,0.1919294", "l0.4837547,0.1915004", "l0.4824438,0.1926990", "l0.4839349,0.1934056", "l0.4853440,0.1926107", "l0.4849508,0.1940112", "l0.4857864,0.1941878", "l0.4866876,0.1937967", "l0.4859666,0.1915761", "l0.4867695,0.1916140", "l0.4938151,0.1983893", "l0.4927337,0.2040290", "l0.4909805,0.2052655", "l0.4910460,0.2088613", "l0.4884244,0.2081674", "l0.4889815,0.2045590", "l0.4873102,0.2040038", "l0.4858028,0.2044832", "l0.4845739,0.2066534", "l0.4859994,0.2080286", "l0.4853768,0.2106403", "l0.4866548,0.2114730", "l0.4877199,0.2109053", "l0.4878182,0.2118137", "l0.4856553,0.2116497", "l0.4854751,0.2134665", "l0.4815263,0.2110441", "l0.4815263,0.2110441", "l0.4805432,0.2082936", "l0.4772825,0.2076501", "l0.4762339,0.2064515", "l0.4756932,0.2028052", "l0.4767254,0.2012407", "l0.4753655,0.1998781", "l0.4735959,0.1998907", "l0.4712036,0.2015183", "l0.4676808,0.2013038", "l0.4663537,0.1999790", "l0.4639287,0.2012028", "l0.4601765,0.1973168", "l0.4491984,0.1959668", "l0.4455937,0.1969509", "l0.4353202,0.1968500", "l0.4305358,0.1985659", "l0.4293233,0.2013669", "l0.4240964,0.2025024", "l0.4208030,0.2048996", "l0.4187713,0.2050510", "l0.4176079,0.2047482", "l0.4169034,0.2027043", "l0.4134625,0.2009253", "l0.4041230,0.2014047", "l0.4038608,0.1995248", "l0.4038608,0.1995248", "l0.4034839,0.1982253", "l0.3904086,0.1928252", "l0.3904086,0.1897214", "l0.3880819,0.1907939", "l0.3829534,0.1893303", "l0.3839201,0.1872864", "l0.3832483,0.1860121", "l0.3853292,0.1847251", "l0.3804137,0.1833120", "l0.3788899,0.1854317", "l0.3766615,0.1845106", "l0.3762683,0.1861130", "l0.3743020,0.1858354", "l0.3705007,0.1833751", "l0.3720737,0.1810031", "l0.3706482,0.1803092", "l0.3680102,0.1807130", "l0.3686328,0.1785555", "l0.3673384,0.1770162", "l0.3626358,0.1753760", "l0.3627997,0.1737358", "l0.3598176,0.1731302", "l0.3596374,0.1722722", "l0.3553117,0.1715278", "l0.3534766,0.1685628", "l0.3502651,0.1661404", "l0.3463163,0.1686764", "l0.3454806,0.1674273", "l0.3430392,0.1669479", "l0.3441534,0.1645380", "l0.3425313,0.1626581", "l0.3446614,0.1614343", "l0.3430884,0.1604880", "l0.3446614,0.1572455", "l0.3406306,0.1558197", "l0.3394837,0.1568417", "l0.3381237,0.1566146", "l0.3387955,0.1541165", "l0.3369440,0.1392916", "l0.3551151,0.1184736", "l0.3551151,0.1184736", "l0.3595063,0.1205680", "l0.3574090,0.1219559", "l0.3586706,0.1238737", "l0.3550987,0.1289583", "l0.3586706,0.1289709", "l0.3620296,0.1302578", "l0.3609646,0.1316836", "l0.3634059,0.1328569", "l0.3658473,0.1307247", "l0.3666502,0.1320494", "l0.3696814,0.1286933", "l0.3704024,0.1301695", "l0.3730895,0.1290592", "l0.3762519,0.1313807", "l0.3788735,0.1316457", "l0.3829698,0.1273938", "l0.3827568,0.1228517", "l0.3852965,0.1230410", "l0.3843134,0.1200507", "l0.3881639,0.1164801", "l0.3895894,0.1102979", "l0.3935546,0.1105250", "l0.3935218,0.1088091", "l0.3936365,0.1097932", "l0.3977000,0.1114838", "l0.3971265,0.1102474", "l0.3982407,0.1083044", "l0.4003544,0.1081025", "l0.3997481,0.1045193", "l0.4056796,0.1048095", "l0.4101691,0.1019581", "l0.4136919,0.1015922", "l0.4167887,0.1023492", "l0.4176735,0.1058945", "l0.4245716,0.1062730", "l0.4260626,0.1039137", "l0.4241947,0.1013651", "l0.4253909,0.1003557", "l0.4241947,0.0994978", "l0.4275701,0.0987407", "l0.4260463,0.0967977", "l0.4260626,0.0942491", "l0.4305522,0.0931514", "l0.4316500,0.0941229", "l0.4328625,0.0931514", "l0.4365327,0.0934542", "l0.4433817,0.0916122", "l0.4461836,0.0866285", "l0.4479859,0.0871836", "l0.4489690,0.0851649", "l0.4450038,0.0823640", "l0.4462983,0.0798784", "l0.4443157,0.0791466", "l0.4432670,0.0796639", "l0.4425461,0.0772163", "l0.4390069,0.0778471", "l0.4377125,0.0769639", "l0.4388267,0.0745793", "l0.4378763,0.0728003", "l0.4330919,0.0697344", "l0.4369587,0.0679176", "l0.4382859,0.0688512", "l0.4387283,0.0642334", "l0.4424969,0.0608142", "l0.4415302,0.0590605", "l0.4364836,0.0585306", "l0.4366802,0.0564488", "l0.4446598,0.0533450", "l0.4472322,0.0537614", "l0.4491493,0.0522726", "l0.4510500,0.0521843", "l0.4520003,0.0531558", "l0.4560474,0.0482099", "l0.4557689,0.0463426", "l0.4582594,0.0429487", "l0.4577515,0.0400089", "l0.4642072,0.0438949", "l0.4655672,0.0435291", "l0.4681069,0.0447655", "l0.4682871,0.0476169", "l0.4737597,0.0442734", "l0.4757423,0.0452323", "l0.4806251,0.0440463", "l0.4818540,0.0451693", "l0.4839185,0.0450935", "l0.4847541,0.0445132", "l0.4841315,0.0428477", "l0.4855570,0.0431001", "l0.4882933,0.0407281", "l0.4923405,0.0395673", "l0.4923405,0.0395673", "l0.4946508,0.0394538", "c"]}]} """;
}
